/*------------------------------------------------------------------------
 *  FILE: main.c
 *      $Author: $
 *      $Date: $
 *      $Locker: $
 *      $Revision: $
 *      $Source: $
 *      $State: $
 *
 *      Copyright (c) by SEGA Enterprises Ltd. 1994. All rights reserved.
 *
 *  PURPOSE:
 *		DGT or RGB to 3D Table conversion program
 *
 *  DESCRIPTION:
 *		Main routine
 *
 *  INTERFACE
 *
 *
 *  CAVEATS
 *
 *
 *  AUTHOR(S):
 *		K. Hasuike	(ssdg)
 *
 *  MOD HISTORY:
 *      $Log: $
 * 
 * 
 *------------------------------------------------------------------------
 */

#define	MAIN
#include "dgtto3dt.h"

void main( argc, argv )
	Sint16	argc;
	Sint8	*argv[];
{
	Sint16	i;

	/* Rs[Cg\ */
	printf("DGT to 3D_Table Converter Ver. 1.00\n");
	printf("Copyright (c) by SEGA Enterprises, Ltd. 1994. All right reserved.\n");

	/* R}hCp[^ǂݍ */
	for( i = 1; i < argc; i++ ){
		if( g_dirname == NULL )
			g_dirname = argv[i];
		else if ( g_outname == NULL )
			g_outname = argv[i];
		else
			printUsage();
	}
	if( g_dirname == NULL ) printUsage();
	if( g_outname == NULL ) printUsage();

	/* .ctlt@Cǂݍ */
	ctl_read();

	/* ̓t@Cǂݍ */
	mat_read();

	/* eNX`t@CLoop */
	for ( i = 0; i < g_tex_cnt; i++ ){

		/* ̓t@Cǂݍ */
		if ( g_plt_mod ==  1 ) tex_read( i );
		if ( g_plt_mod ==  2 ) tex_red2( i );
		if ( g_plt_mod ==  3 ) tex_red3( i );

		/* o̓t@CoisNZf[^j */
		pix_wrt( i );

		/* o̓t@Coipbgf[^F[hj */
		if ( g_plt_mod ==  1 ) plt_wrt( i );

	}

	/* o̓t@Coipbgf[^F̃[hj */
	if ( g_plt_mod ==  2 ) plt_wrt2();

	/* o̓t@CoiDRAW/COLORf[^j */
	drw_wrt();

}

void printUsage()
{
	printf("\n");
	printf("Usage: dgtto3dt <input/output directory path> <file_name>\n");
	printf("Release no.: 08\n");
	printf("\n");
	exit(-1);
}
