/*****************************************************************************
 *      \tgEFACu
 *
 *      Copyright (c) 1995 CSK Research Institute Corp.
 *      Copyright (c) 1995 SEGA
 *
 * Library: ĐCu
 * Module : CW[
 * File   : bpl_main.c
 * Date   : 1995-03-31
 * Version: 1.00
 * Auther : T.K
 *
 *****************************************************************************/

/*****************************************************************************
 *      CN[ht@C
 *****************************************************************************/
#include        <string.h>

#include        "sega_bpl.h"
#include        "bpl_def.h"

/*****************************************************************************
 *      萔}N
 *****************************************************************************/
/* Ǐʎq}N */
#define BPL_LOCAL


/*****************************************************************************
 *      }N
 *****************************************************************************/
/* Xg[ʎq͈̔̓`FbN */
#define IS_BSTMID_NG(bstmid) \
        (((bstmid) < 0) || ((bstmid) >= BPD_MNG_BSTMMAX(bpl_mng_ptr)))


/*****************************************************************************
 *      ֐̐錾
 *****************************************************************************/

/* Xg[̃I[v */
BPL_LOCAL Sint32 bpl_openStm(Sint32 bstmid, StmHn *tbl, Sint32 ofs,
                             Sint32 max);

/* ̃Xg[̃I[v */
BPL_LOCAL Sint32 bpl_openNextStm(Sint32 bstmid);

/* ANZXI`FbN */
BPL_LOCAL Sint32 bpl_getAccess(void);

/* ȊO̕N[Y */
BPL_LOCAL void  bpl_closeNextStm(void);

/* ǂݍݒ̃Xg[̋I */
BPL_LOCAL void  bpl_closeCurStm(void);

/* ̃nh݂̃nhƂ */
BPL_LOCAL void  bpl_changeStm(void);

/* ̓]Q[gJ */
BPL_LOCAL void  bpl_openTrGate(void);

/* p[^̏ */
BPL_LOCAL void bpl_initPara(Sint32 bstmmax, Sint32 brmax, Sint32 keymax);

/* Đ̒~ */
BPL_LOCAL void bpl_stopStm(void);

/* ĐԂ̃`FbN */
BPL_LOCAL Sint32 bpl_checkStatus(Sint32 atr);

/* 򏈗̎s */
BPL_LOCAL Sint32 bpl_execBranch(Sint32 stat);


/*****************************************************************************
 *      ϐ̒`
 *****************************************************************************/

/* 򓮉ĐǗ̈ */
BplMng  *bpl_mng_ptr;

/*****************************************************************************
 *      ֐̒`
 *****************************************************************************/

/****************************************************
 * Xg[̃I[v
 * bstmid       : Xg[ʎq
 * tbl          : Xg[nhݒe[u
 * ofs          : ݒJnʒu
 * max          : e[uTCY
 * ֐l       : ݒ
 ****************************************************/
BPL_LOCAL Sint32 bpl_openStm(Sint32 bstmid, StmHn *tbl, Sint32 ofs, Sint32 max)
{
    BplStm      *bs;
    Sint32      keyno;
    Sint32      i;
    Sint32      nkey;

    /* Xg[ʎqs             */
    if (IS_BSTMID_NG(bstmid)) {
        return BPL_ERR_BSTMID;
    }
    bs = BPD_MNG_BSTM(bpl_mng_ptr, bstmid);

    /* Xg[L[̐ݒ肪߂   */
    if (BPD_STM_NKEY(bs) > (max - ofs)) {
        return BPL_ERR_KYOVRFLW;
    }

    tbl += ofs;
    nkey = BPD_STM_NKEY(bs);
    for (i = 0; i < nkey; i++) {
        keyno = BPD_STM_KEYNO(bs, i);
        *tbl = STM_OpenFid(BPD_MNG_GRPHN(bpl_mng_ptr), BPD_STM_FID(bs), 
                         BPD_MNG_KEYPTR(bpl_mng_ptr, keyno), STM_LOOP_NOREAD);
        if (*tbl == NULL) {
            return BPL_ERR_OPNSTM;
        }
        tbl++;
    }
    return i;
}


/****************************************************
 * ̃Xg[̃I[v
 * bstmid       : Xg[ʎq
 * ֐l       : G[R[h
 ****************************************************/
BPL_LOCAL Sint32 bpl_openNextStm(Sint32 bstmid)
{
    BplStm      *bs;
    Sint32      branch;
    Sint32      ofs;
    Sint32      i;
    Sint32      ec;
    Sint32      stmnbr;

    /* Xg[ʎqs             */
    if (IS_BSTMID_NG(bstmid)) {
        return BPL_ERR_BSTMID;
    }

    /* eXg[̃I[v */
    bs = BPD_MNG_BSTM(bpl_mng_ptr, bstmid);
    ofs = 0;
    branch = BPD_STM_BRANCH(bs);
    stmnbr = BPD_STM_NBR(bs);
    for (i = 0; i < stmnbr; i++) {
        if (BPD_MNG_BR(bpl_mng_ptr, branch) >= 0) {
            ec = bpl_openStm(BPD_MNG_BR(bpl_mng_ptr, branch), 
                             BPD_MNG_NEXTSTM(bpl_mng_ptr), ofs, BPL_BLK_NUM);
            if (ec < 0) {
                return ec;
            }
            ofs += ec;
            BPD_MNG_ATR(bpl_mng_ptr) = BPD_ATR_NEXT_OPEN;
        }
        branch++;
    }
    for (i = 0; i < ofs; i++) {
        STM_SetTrGate(BPD_MNG_NEXTSTMHN(bpl_mng_ptr, i), STM_GATE_CLOSE);
    }
    return BPL_ERR_OK;
}


/****************************************************
 * ANZXI`FbN
 * ֐l : ANZX
 ****************************************************/
BPL_LOCAL Sint32 bpl_getAccess(void)
{
    Sint32      i;
    StmHn       stm;
    Sint32      nsct;
    Sint32      fad;
    Sint32      sfad;
    StmFrange   frange;
    Bool        complete;

    nsct = 0;
    complete = TRUE;
    for (i = 0; i < BPL_STMKEY_MAX; i++) {
        stm = BPD_MNG_CURSTMHN(bpl_mng_ptr, i);
        if (stm != NULL) {
            if (STM_IsComplete(stm) == FALSE) {
                complete = FALSE;
            }
            nsct += STM_GetNumCdbuf(stm);
        } else {
            break;
        }
    }
    if ((complete == TRUE) && (nsct == 0)) {
        return BPD_ACCESS_END;
    }
    STM_GetExecStat(BPD_MNG_GRPHN(bpl_mng_ptr), &fad);
    frange = BPD_MNG_FRANGE(bpl_mng_ptr);
    sfad = STM_FRANGE_SFAD(&frange);
    if (fad <= sfad) {
        return BPD_ACCESS_BEFORE;
    }
    if ((fad >= (sfad + STM_FRANGE_FASNUM(&frange))) && (nsct == 0)) {
        return BPD_ACCESS_BEFORE;
    }
    return BPD_ACCESS_DOING;
}


/****************************************************
 * ȊO̕N[Y
 ****************************************************/
BPL_LOCAL void  bpl_closeNextStm(void)
{
    BplStm      *bs;
    Sint32      br;
    Sint32      brno;
    Sint32      nstm;
    Sint32      bstmid;
    Sint32      stmnbr;
    Sint32      stmnkey;
    Sint32      i, j;

    if (BPD_MNG_CURSTMID(bpl_mng_ptr) < 0) {
        return ;
    }
    bs = BPD_MNG_BSTM(bpl_mng_ptr, BPD_MNG_CURSTMID(bpl_mng_ptr));
    br = BPD_STM_BRANCH(bs);
    brno = BPD_MNG_NEXTBRNO(bpl_mng_ptr);
    nstm = 0;
    stmnbr = BPD_STM_NBR(bs);
    for (i = 0; i < stmnbr; i++, br++) {
        bstmid = BPD_MNG_BR(bpl_mng_ptr, br);
        if (bstmid < 0) {
            continue;
        }
        if (i != brno) {        /* ȊǑ̓N[Y       */
            stmnkey = BPD_STM_NKEY(BPD_MNG_BSTM(bpl_mng_ptr, bstmid));
            for (j = 0; j < stmnkey; j++) {
                STM_Close(BPD_MNG_NEXTSTMHN(bpl_mng_ptr, nstm));
                BPD_MNG_NEXTSTMHN(bpl_mng_ptr, nstm) = NULL;
                nstm++;
            }
        } else {
            nstm += BPD_STM_NKEY(BPD_MNG_BSTM(bpl_mng_ptr, bstmid));
        }
    }

    return;
}


/****************************************************
 * ǂݍݒ̃Xg[̋I
 ****************************************************/
BPL_LOCAL void  bpl_closeCurStm(void)
{
#if	0
	/*
	**1995-07-26 q
	**	gĂȂ̂ō폜B
	*/
    BplStm      *bs;
#endif
    StmHn       stm;
    Sint32      i;

    /* ǂݍݒ̃Xg[N[Y     */
    for (i = 0; i < BPL_STMKEY_MAX; i++) {
        stm = BPD_MNG_CURSTMHN(bpl_mng_ptr, i);
        if (stm != NULL) {
            STM_Close(stm);
            BPD_MNG_CURSTMHN(bpl_mng_ptr, i) = NULL;
        }
    }

    return;
}
    


/****************************************************
 * ̃nh݂̃nhƂ
 ****************************************************/
BPL_LOCAL void  bpl_changeStm(void)
{
    BplStm      *bs;
    Sint32      bstmid;
    Sint32      nbr;
    Sint32      brcnt, nxcnt, crcnt, kycnt;
    Sint32      br;
    Sint32      stmnkey;

    /* 悪肵ĂȂꍇ͎słȂ */
    if (BPD_MNG_NEXTBRNO(bpl_mng_ptr) < 0) {
        return;
    }

    bstmid = BPD_MNG_CURSTMID(bpl_mng_ptr);
    bs = BPD_MNG_BSTM(bpl_mng_ptr, bstmid);
    nbr = BPD_STM_NBR(bs);
    nxcnt = crcnt = 0;
    br = BPD_STM_BRANCH(bs);
    for (brcnt = 0; brcnt < nbr; brcnt++, br++) {
        bstmid = BPD_MNG_BR(bpl_mng_ptr, br);
        if (bstmid < 0) {
            continue;
        }
        bs = BPD_MNG_BSTM(bpl_mng_ptr, bstmid);
        stmnkey = BPD_STM_NKEY(bs);
        for (kycnt = 0; kycnt < stmnkey; kycnt++) {
            if (BPD_MNG_NEXTSTMHN(bpl_mng_ptr, nxcnt) != NULL) {
                if (brcnt == BPD_MNG_NEXTBRNO(bpl_mng_ptr)) {
                    /* KvȃXg[͏̃e[uɈړ */
                    BPD_MNG_CURSTMHN(bpl_mng_ptr, crcnt) = 
                        BPD_MNG_NEXTSTMHN(bpl_mng_ptr, nxcnt);
                    STM_SetTrGate(BPD_MNG_CURSTMHN(bpl_mng_ptr, crcnt),
                                  STM_GATE_OPEN);
                    crcnt++;
                }
                BPD_MNG_NEXTSTMHN(bpl_mng_ptr, nxcnt) = NULL;
            }
            nxcnt++;
        }
    }
    BPD_MNG_CURSTMID(bpl_mng_ptr) = BPD_MNG_NEXTSTMID(bpl_mng_ptr);
    BPD_MNG_NEXTBRNO(bpl_mng_ptr) = BPL_BR_NONE;
    BPD_MNG_ATR(bpl_mng_ptr) = BPD_ATR_NEXT_CLOSE;

    return;
}


/****************************************************
 * ̓]Q[gJ
 ****************************************************/
BPL_LOCAL void  bpl_openTrGate(void)
{
    Sint32      i;
    StmHn       stm;

    /* 悪肵ĂȂꍇ͎słȂ */
    if (BPD_MNG_NEXTBRNO(bpl_mng_ptr) < 0) {
        return;
    }
    for (i = 0; i < BPL_BLK_NUM; i++) {
        stm = BPD_MNG_NEXTSTMHN(bpl_mng_ptr, i);
        if (stm != NULL) {
            STM_SetTrGate(stm, STM_GATE_OPEN);
        }
    }

    return;
}


/****************************************************
 * p[^̏
 * bstmmax      : Xg[
 * brmax        : ̑
 * keymax       : Xg[L[
 ****************************************************/
BPL_LOCAL void bpl_initPara(Sint32 bstmmax, Sint32 brmax, Sint32 keymax)
{
    Sint32      i;

    /* Ɨ̈̃NA */
    memset(bpl_mng_ptr, 0, BPL_WORK_SIZE(bstmmax, brmax, keymax));

    /* ̈̊蓖   */
    BPD_MNG_BSTMTBL(bpl_mng_ptr) =
                        (BplStm *)((size_t)bpl_mng_ptr + sizeof(BplMng));
    BPD_MNG_BRTBL(bpl_mng_ptr) =
                        (Sint32 *)(BPD_MNG_BSTMTBL(bpl_mng_ptr) + bstmmax);
    BPD_MNG_KEYTBL(bpl_mng_ptr) =
                        (StmKey *)(BPD_MNG_BRTBL(bpl_mng_ptr) + brmax);

    BPD_MNG_BSTMMAX(bpl_mng_ptr) = bstmmax;
    BPD_MNG_BRMAX(bpl_mng_ptr) = brmax;
    BPD_MNG_KEYMAX(bpl_mng_ptr) = keymax;

    for (i = 0; i < bstmmax; i++) {
        BPD_STM_BRANCH(BPD_MNG_BSTM(bpl_mng_ptr, i)) = BPL_BR_NONE;
    }

    for (i = 0; i < brmax; i++) {
        BPD_MNG_BR(bpl_mng_ptr, i) = BPL_BR_NONE;
    }

    BPD_MNG_CURSTMID(bpl_mng_ptr) = BPL_BR_NONE;
    BPD_MNG_NEXTBRNO(bpl_mng_ptr) = BPL_BR_NONE;

    return;
}


/****************************************************
 * Đ̒~
 ****************************************************/
BPL_LOCAL void bpl_stopStm(void)
{
    Sint32      i;

    /* Xg[O[ṽN[Y */
    STM_CloseGrp(BPD_MNG_GRPHN(bpl_mng_ptr));
    
    /* p[^̏ */
    for (i = 0; i < BPL_STMKEY_MAX; i++) {
        BPD_MNG_CURSTMHN(bpl_mng_ptr, i) = NULL;
    }

    for (i = 0; i < BPL_BLK_NUM; i++) {
        BPD_MNG_NEXTSTMHN(bpl_mng_ptr, i) = NULL;
    }

    BPD_MNG_CURSTMID(bpl_mng_ptr) = BPL_BR_NONE;
    BPD_MNG_NEXTBRNO(bpl_mng_ptr) = BPL_BR_NONE;
    BPD_MNG_ATR(bpl_mng_ptr) = BPD_ATR_NEXT_CLOSE;
    BPD_MNG_GRPHN(bpl_mng_ptr) = NULL;

    return;
}

/****************************************************
 * ĐԂ̃`FbN
 * ֐l       : ݂̏
 ****************************************************/
BPL_LOCAL Sint32 bpl_checkStatus(Sint32 atr)
{
    Sint32      ret;
    Sint32      bstmid;
    BplStm      *bs;

    ret = BPL_SVR_COMPLETED;

    /* ݂̃Xg[I[vĂ邩 */
    bstmid = BPD_MNG_CURSTMID(bpl_mng_ptr);
    if (bstmid >= 0) {
        bs = BPD_MNG_BSTM(bpl_mng_ptr, bstmid);

        /* ₪Ȃ`FbN */
        ret = ((BPD_STM_NBR(bs) == 0) ? BPL_SVR_NOBRN : BPL_SVR_WAITSEL);

        /* BPL_BR_NONEIꂽ */
        if (atr == BPD_ATR_NEXT_END) {
            ret = BPL_SVR_NOBRN;
        }
    }

    /* ̃Xg[I[vĂāA悪IĂ邩 */
    if ((atr == BPD_ATR_NEXT_OPEN) && (BPD_MNG_NEXTBRNO(bpl_mng_ptr) >= 0)) {
        ret = BPL_SVR_SELECT;
    }

    return ret;
}


/****************************************************
 * 򏈗̎s
 * stat         : ݂̏
 * ֐l       : 򏈗̏
 ****************************************************/
BPL_LOCAL Sint32 bpl_execBranch(Sint32 stat)
{
    Sint32      ret;
    Sint32      fid, bn;
    StmKey      key;

    switch(stat) {
    case BPL_SVR_WAITSEL:
    case BPL_SVR_NOBRN:
        bpl_closeCurStm();
        BPD_MNG_CURSTMID(bpl_mng_ptr) = BPL_BR_NONE;
        ret = BPL_SVR_COMPLETED;
        break;
    case BPL_SVR_SELECT:
        bpl_closeCurStm();
        bpl_changeStm();
        STM_GetInfo(BPD_MNG_CURSTMHN(bpl_mng_ptr, 0), &fid,
                    &BPD_MNG_FRANGE(bpl_mng_ptr), &bn, &key);
        ret = BPL_SVR_WAITSEL;
        break;
    default:
        ret = stat;
        break;
    }

    return ret;
}


/*---------------------------------------------------------------------------*/

/****************************************************
 * Đ̏
 * bstmmax      : o^Xg[̍ő吔
 * brmax        : ̍ő吔
 * key_max      : Xg[L[̎ނ̍ő吔
 * work         : Ɨ̈
 * ֐l       : G[R[h
 *****************************************************/
Sint32  BPL_Init(Sint32 bstmmax, Sint32 brmax, Sint32 keymax, void *work)
{
#if	0
	/*
	**1995-07-26 q
	**	gĂȂ̂ō폜B
	*/
    Sint32      i;
#endif

    /* ̈̊蓖   */
    bpl_mng_ptr = work;                         /* Ǘ̈             */

    /* lݒ        */
    bpl_initPara(bstmmax, brmax, keymax);

    return BPL_ERR_OK;
}


/****************************************************
 * Đ̃Zbg
 * ֐l       : G[R[h
 ****************************************************/
Sint32  BPL_Reset(void)
{
#if	0
	/*
	**1995-07-26 q
	**	gĂȂ̂ō폜B
	*/
    Sint32      i;
#endif
    Sint32      bstmmax;
    Sint32      brmax;
    Sint32      keymax;

    /* Xg[O[ṽN[Y */
    STM_CloseGrp(BPD_MNG_GRPHN(bpl_mng_ptr));

    /* ݂̃p[^̃Rs[ */
    bstmmax = BPD_MNG_BSTMMAX(bpl_mng_ptr);
    brmax = BPD_MNG_BRMAX(bpl_mng_ptr);
    keymax = BPD_MNG_KEYMAX(bpl_mng_ptr);

    /* lݒ        */
    bpl_initPara(bstmmax, brmax, keymax);

    return BPL_ERR_OK;
}


/****************************************************
 * Xg[̐ݒ
 * bstmid       : Xg[ʎq(0 <= bstmid < bstmmax)
 * fid          : t@Cʎq
 * nkey         : Xg[L[̐
 * keytbl       : Xg[L[e[u
 * ֐l       : G[R[h
 ****************************************************/
Sint32  BPL_SetStmInfo(Sint32 bstmid, Sint32 fid, Sint32 nkey, StmKey *keytbl)
{
    BplStm      *bs;
    StmKey      *stmkey, *mngkey;
    Sint32      keymax;
    Sint32      key;
    Sint32      i, j;

    /* Xg[ʎqs             */
    if (IS_BSTMID_NG(bstmid)) {
        return BPL_ERR_BSTMID;
    }
    /* Xg[L[ސ߂   */
    if (nkey > BPL_STMKEY_MAX) {
        return BPL_ERR_KYOVRFLW;
    }

    keymax = BPD_MNG_KEYMAX(bpl_mng_ptr);

    /* p[^ݒ                   */
    bs = BPD_MNG_BSTM(bpl_mng_ptr, bstmid);
    BPD_STM_FID(bs) = fid;
    BPD_STM_NKEY(bs) = nkey;
    for (i = 0; i < nkey; i++) {
        stmkey = keytbl + i;

        /* L[ݒς݂ǂ𒲂ׂ   */
        key = BPD_MNG_NKEY(bpl_mng_ptr);
        for (j = 0; j < key; j++) {
            mngkey = BPD_MNG_KEYPTR(bpl_mng_ptr, j);
            if (memcmp(mngkey, stmkey, sizeof(StmKey)) == 0) {
                break;
            }
        }

        /* Xg[̒ǉ */
        if (j == key) {
            if (key >= keymax) {
                return BPL_ERR_KYOVRFLW;
            }
            memcpy(BPD_MNG_KEYPTR(bpl_mng_ptr, j), stmkey, sizeof(StmKey));
            key++;
            BPD_MNG_NKEY(bpl_mng_ptr) = key;
        }
        BPD_STM_KEYNO(bs, i) = j;
    }
    return BPL_ERR_OK;
}


/****************************************************
 * Xg[̎擾
 * bstmid       : Xg[ʎq
 * fid          : t@Cʎq
 * nkey         : Xg[L[̐
 * keytbl       : Xg[L[e[u
 * ֐l       : ݒ肳Ă镪̐
 ****************************************************/
Sint32  BPL_GetStmInfo(Sint32 bstmid, 
                       Sint32 *fid, Sint32 *nkey, StmKey *keytbl)
{
    BplStm      *bs;
    Sint32      keyno;
    Sint32      i;

    /* Xg[ʎqs             */
    if (IS_BSTMID_NG(bstmid)) {
        return BPL_ERR_BSTMID;
    }
    bs = BPD_MNG_BSTM(bpl_mng_ptr, bstmid);
    *fid = BPD_STM_FID(bs);                 /* t@Cʎq       */
    *nkey = BPD_STM_NKEY(bs);               /* Xg[L[̐   */

    /* Xg[L[   */
    for (i = 0; i < *nkey; i++) {
        keyno = BPD_STM_KEYNO(bs, i);
        memcpy(keytbl + i, BPD_MNG_KEYPTR(bpl_mng_ptr, keyno), sizeof(StmKey));
    }
    return BPD_STM_NBR(bs);
}


/****************************************************
 * ̐ݒ
 * bstmid       : Xg[ʎq
 * nbranch      : ̐
 * brtbl        : e[ui򂵂Ȃꍇ̐ݒĺABPL_BR_NONEj
 * ֐l       : G[R[h
 ****************************************************/
Sint32  BPL_SetBranchInfo(Sint32 bstmid, Sint32 nbranch, Sint32 *brtbl)
{
    BplStm      *bs;
    Sint32      branch;
    Sint32      nbr;
    Sint32      bstmmax;
    Sint32      i;

    /* Xg[ʎqs             */
    if (IS_BSTMID_NG(bstmid)) {
        return BPL_ERR_BSTMID;
    }

    /* 悪߂                 */
    nbr = BPD_MNG_NBR(bpl_mng_ptr);
    if ((nbr + nbranch) > BPD_MNG_BRMAX(bpl_mng_ptr)) {
        return BPL_ERR_BROVRFLW;
    }

    /* 򐔂̐ݒ                     */
    bs = BPD_MNG_BSTM(bpl_mng_ptr, bstmid);
    BPD_STM_NBR(bs) = nbranch;
    if (nbranch <= 0) {
        return BPL_ERR_OK;
    }
    BPD_STM_BRANCH(bs) = nbr;

    /* ̐ݒ                     */
    bstmmax = BPD_MNG_BSTMMAX(bpl_mng_ptr);
    for (i = 0; i < nbranch; i++) {
        branch = *(brtbl + i);
        if (branch > bstmmax) {
            return BPL_ERR_BRNO;
        }
        BPD_MNG_BR(bpl_mng_ptr, nbr) = branch;
        nbr++;
        BPD_MNG_NBR(bpl_mng_ptr) = nbr;
    }
    return BPL_ERR_OK;
}



/****************************************************
 * ̎擾
 * bstmid       : Xg[ʎq
 * nbranch      : ̐
 * brtbl        : e[u
 * nelem        : e[u̗vf
 * ֐l       : G[R[h
 ****************************************************/
Sint32  BPL_GetBranchInfo(Sint32 bstmid, Sint32 *nbranch, Sint32 *brtbl,
                                                              Sint32 nelem)
{
    BplStm      *bs;
    Sint32      i;
    Sint32      branch;
    Sint32      brnum;

    /* Xg[ʎqs             */
    if (IS_BSTMID_NG(bstmid)) {
        return BPL_ERR_BSTMID;
    }
    bs = BPD_MNG_BSTM(bpl_mng_ptr, bstmid);
    brnum = BPD_STM_NBR(bs);
    if (nelem > brnum) {
        nelem = brnum;
    }
    branch = BPD_STM_BRANCH(bs);
    for (i = 0; i < nelem; i++) {
        *brtbl = BPD_MNG_BR(bpl_mng_ptr, branch);
        brtbl++;
        branch++;
    }
    *nbranch = brnum;
    return BPL_ERR_OK;
}
    


/****************************************************
 * ĐJnXg[̎w
 * bstmid       : Xg[ʎq
 * ֐l       : G[R[h
 ****************************************************/
Sint32  BPL_SetStart(Sint32 bstmid)
{
#if	0
	/*
	**1995-07-26 q
	**	gĂȂ̂ō폜B
	*/
    Sint32      i;
#endif
    Sint32      fid;
    Sint32      bn;
    StmKey      key;
    Sint32      ec;

    /* Xg[ʎqs             */
    if (bstmid >= BPD_MNG_BSTMMAX(bpl_mng_ptr)) {
        return BPL_ERR_BSTMID;
    }

    /* Đ̒~ */
    if (BPD_MNG_GRPHN(bpl_mng_ptr) != NULL) {
        bpl_stopStm();
    }

    /* Xg[ʎq̏ꍇ͍Đ~̂ݎs */
    if (bstmid < 0) {
        return BPL_ERR_OK;
    }

    BPD_MNG_CURSTMID(bpl_mng_ptr) = bstmid;
    BPD_MNG_NEXTBRNO(bpl_mng_ptr) = BPL_BR_NONE;

    /* Xg[O[ṽI[v     */
    BPD_MNG_GRPHN(bpl_mng_ptr) = STM_OpenGrp();
    if (BPD_MNG_GRPHN(bpl_mng_ptr) == NULL) {
        return BPL_ERR_OPNSTM;
    }
    STM_SetExecGrp(BPD_MNG_GRPHN(bpl_mng_ptr));

    /* Xg[̃I[v         */
    ec = bpl_openStm(bstmid, BPD_MNG_CURSTM(bpl_mng_ptr), 0, BPL_STMKEY_MAX);
    if (ec < 0) {
        return ec;
    }
    STM_GetInfo(BPD_MNG_CURSTMHN(bpl_mng_ptr, 0), &fid, 
                &BPD_MNG_FRANGE(bpl_mng_ptr), &bn, &key);
    return ec;
}


/****************************************************
 * ĐT[o̎s
 * chgsw        : sXCb`
 * ֐l       : Đ
 ****************************************************/
Sint32  BPL_ExecServer(Bool chgsw)
{
    Sint32      stat;
    Sint32      ec;
    Sint32      ret;
    Sint32      atr;

    /* ϐ̐ݒ */
    atr = BPD_MNG_ATR(bpl_mng_ptr);

    /* ݂̏Ԃ`FbN */
    ret = bpl_checkStatus(atr);

    /* Xg[̕򏈗 */
    if (chgsw == ON) {
        ret = bpl_execBranch(ret);
    }

    stat = bpl_getAccess();
    switch(stat) {
    case BPD_ACCESS_DOING:
        if (atr == BPD_ATR_NEXT_CLOSE) {
            /* I[v鏈             */
            ec = bpl_openNextStm(BPD_MNG_CURSTMID(bpl_mng_ptr));
            if (ec < 0) {
                return ec;
            }
        }
        break;
    case BPD_ACCESS_END:
        if (atr == BPD_ATR_NEXT_OPEN) {
            bpl_openTrGate();
        }
        break;
    }

    return ret;
}


/****************************************************
 * ̑I
 * brno         : ԍ
 * ֐l       : G[R[h
 ****************************************************/
Sint32  BPL_SelectBranch(Sint32 brno)
{
    Sint32      bstmid;
    BplStm      *bs;

    /* 悪Ɏw肳Ă       */
    if (BPD_MNG_NEXTBRNO(bpl_mng_ptr) >= 0) {
        return BPL_ERR_BRSPC;
    }
    bstmid = BPD_MNG_CURSTMID(bpl_mng_ptr);
    bs = BPD_MNG_BSTM(bpl_mng_ptr, bstmid);
    if ((brno < 0) || (brno >= BPD_STM_NBR(bs))) {
        return BPL_ERR_BRNO;
    }

    /* ԍ̐ݒ           */      
    if (BPD_MNG_BR(bpl_mng_ptr, BPD_STM_BRANCH(bs) + brno) < 0) {
        /* 悪Ȃꍇ             */
        BPD_MNG_NEXTBRNO(bpl_mng_ptr) = BPL_BR_NONE;
        BPD_MNG_ATR(bpl_mng_ptr) = BPD_ATR_NEXT_END;
    } else {
        BPD_MNG_NEXTBRNO(bpl_mng_ptr) = brno;
    }
    bpl_closeNextStm();
    return BPL_ERR_OK;
}



/****************************************************
 * ݂̃Xg[̎擾
 * nelem        : Xg[nhe[u̗vf
 * stmtbl       : Xg[nhe[u
 * ֐l       : Xg[ʎq
 ****************************************************/
Sint32  BPL_GetCurStm(Sint32 nelem, StmHn *stmtbl)
{
    BplStm      *bs;
#if	0
	/*
	**1995-07-26 q
	**	gĂȂ̂ō폜B
	*/
    Sint32      keyno;
#endif
    Sint32      stmid;
    Sint32      stmnkey;
    Sint32      i;

    /* ݂̃Xg[ID̎擾 */
    stmid = BPD_MNG_CURSTMID(bpl_mng_ptr);
    if (stmid < 0) {
        return BPL_BR_NONE;
    }

    /* Xg[o^̈̎擾 */
    bs = BPD_MNG_BSTM(bpl_mng_ptr, stmid);

    /* o^ĂXg[L[̐擾 */
    stmnkey = BPD_STM_NKEY(bs);
    if (nelem > stmnkey) {
        nelem = stmnkey;
    }

    /* ݂̃Xg[nh̎擾 */
    for (i = 0; i < nelem; i++) {
        *(stmtbl + i) = BPD_MNG_CURSTMHN(bpl_mng_ptr, i);
    }

    return stmid;
}



/****************************************************
 * ̃Xg[̎擾
 * nelem        : Xg[nhe[u̗vf
 * stmtbl       : Xg[nhe[u
 * ֐l       : Xg[ʎq
 ****************************************************/
Sint32  BPL_GetNextStm(Sint32 nelem, StmHn *stmtbl)
{
    BplStm      *bs;
    Sint32      br;
    Sint32      brno;
    Sint32      nstm;
    Sint32      bstmid;
    Sint32      curstmid;
    Sint32      i;

    /* ݂̃Xg[ID̎擾 */
    curstmid = BPD_MNG_CURSTMID(bpl_mng_ptr);

    /* ԍ̎擾 */
    brno = BPD_MNG_NEXTBRNO(bpl_mng_ptr);
    if ((curstmid < 0) || (brno < 0)) {
        return BPL_BR_NONE;
    }

    /* Xg[o^̈̎擾 */
    bs = BPD_MNG_BSTM(bpl_mng_ptr, curstmid);

    /* e[üʒu̎擾 */
    br = BPD_STM_BRANCH(bs);

    /* ̃Xg[o^Ăʒu܂ł */
    /* Xg[L[̐߂ */
    nstm = 0;
    for (i = 0; i < brno; i++) {
        bstmid = BPD_MNG_BR(bpl_mng_ptr, br);
        if (bstmid >= 0) {
            nstm += BPD_STM_NKEY(BPD_MNG_BSTM(bpl_mng_ptr, bstmid));
        }
        br++;
    }

    /* ̃Xg[nh̎擾 */
    bstmid = BPD_MNG_BR(bpl_mng_ptr, br);
    if (bstmid >= 0) {
        bs = BPD_MNG_BSTM(bpl_mng_ptr, bstmid);
        if (nelem > BPD_STM_NKEY(bs)) {
            nelem = BPD_STM_NKEY(bs);
        }
        for (i = 0; i < nelem; i++) {
            *(stmtbl + i) = BPD_MNG_NEXTSTMHN(bpl_mng_ptr, i + nstm);
        }
    } else {
        for (i = 0; i < nelem; i++) {
            *(stmtbl + i) = NULL;
        }
    }

    return bstmid;
}



/****************************************************
 * Xg[O[v̎擾
 * ֐l       : Xg[O[vnh
 ****************************************************/
StmGrpHn  BPL_GetStmGrp(void)
{
    return BPD_MNG_GRPHN(bpl_mng_ptr);
}


/* end of file */
