/*****************************************************************************
 *      \tgEFACu
 *
 *      Copyright (c) 1995 SEGA
 *
 * Library: ĐCu
 * Module : Jpwb_t@C
 * File   : sega_bpl.h
 * Date   : 1995-03-31
 * Version: 1.00
 * Auther : T.K
 *
 *****************************************************************************/
#if     !defined(SEGA_BPL_H)
#define SEGA_BPL_H

/*****************************************************************************
 *      CN[ht@C
 *****************************************************************************/
#include        "sega_xpt.h"
#include        "sega_stm.h"

/*****************************************************************************
 *      萔}N
 *****************************************************************************/

/* e[uTCY       */
#define BPL_STMKEY_MAX  6       /* P̕Xg[Ɏw\ȃL[̐ */
#define BPL_BLK_NUM     24      /* CDobt@̋搔 */

/* 򂵂Ȃꍇ̕e[uݒl   */
#define BPL_BR_NONE     (-1)

/* Đ         */
enum    BplSvrStat {
    BPL_SVR_COMPLETED   = 0x200,        /* ĐI                 */
    BPL_SVR_WAITSEL     = 0x201,        /* I҂               */
    BPL_SVR_SELECT      = 0x202,        /* 挈                   */
    BPL_SVR_NOBRN       = 0x203,        /* Ȃ                   */
    BPL_SVR_END
};


/* G[R[h         */
enum    BplErrCode {
    BPL_ERR_OK          = 0,            /* I                     */
    BPL_ERR_KYOVRFLW    = (-256),       /* Xg[L[ݒ肪 */
    BPL_ERR_BROVRFLW    = (-255),       /* ̐ݒ肪       */
    BPL_ERR_BSTMID      = (-254),       /* sȃXg[ʎq       */
    BPL_ERR_BRNO        = (-253),       /* sȕԍ               */
    BPL_ERR_BRSPC       = (-252),       /* ɕ悪w肳Ă   */
    BPL_ERR_NOKEY       = (-251),       /* YXg[L[ݒ   */
    BPL_ERR_OPNSTM      = (-250),       /* Xg[I[vG[     */
    BPL_ERR_END
};


/*****************************************************************************
 *      }N
 *****************************************************************************/

/* Ɨ̈̃TCY擾         */
#define BPL_WORK_SIZE(stmmax, brmax, keymax)    (sizeof(BplMng) + \
                                                (sizeof(BplStm) * stmmax) +\
                                                (sizeof(Sint32) * brmax) +\
                                                (sizeof(StmKey) * keymax))


/*****************************************************************************
 *      f[^^̒`
 *****************************************************************************/

/* Xg[̒`     */
typedef struct {
    Sint32      fid;                    /* t@Cʎq               */
    Sint32      nbr;                    /* ̐                   */
    Sint32      branch;                 /* e[üʒu           */
    Sint32      nkey;                   /* gpXg[L[̐   */
    Sint32      keyno[BPL_STMKEY_MAX];  /* Xg[L[ԍe[u   */
} BplStm;

/* 򓮉ĐǗe[u     */
typedef struct {
    BplStm      *bstmtbl;               /* Xg[o^̈       */
    Sint32      bstmmax;                /* Xg[̓o^ő吔   */
    Sint32      *brtbl;                 /* e[u                 */
    Sint32      brmax;                  /* ̓o^ő吔             */
    Sint32      nbr;                    /* e[u̗L         */
    StmKey      *keytbl;                /* Xg[L[o^̈       */
    Sint32      keymax;                 /* Xg[L[̍ő吔       */
    Sint32      nkey;                   /* L[e[u̗L         */
    Sint32      curstmid;               /* ݂̃Xg[ʎq       */
    Sint32      nextbrno;               /* ̕ԍ                 */
    StmGrpHn    grphn;                  /* Xg[O[vnh   */
    StmFrange   frange;                 /* ݂̃Xg[Đ͈     */
    StmHn       curstmhn[BPL_STMKEY_MAX];/* ݂̃Xg[nh    */
    StmHn       nextstmhn[BPL_BLK_NUM]; /* ̃Xg[nh   */
    Uint32      atr;                    /* Agr[g               */
} BplMng;

/*****************************************************************************
 *      ֐̐錾
 *****************************************************************************/

/* Đ̏             */
Sint32  BPL_Init(Sint32 bstmmax, Sint32 brmax, Sint32 keymax, void *work);

/* Đ̃Zbg           */
Sint32  BPL_Reset(void);

/* Xg[̐ݒ     */
Sint32  BPL_SetStmInfo(Sint32 bstmid, Sint32 fid, Sint32 nkey, StmKey *keytbl);

/* Xg[̎擾     */
Sint32  BPL_GetStmInfo(Sint32 bstmid, 
                       Sint32 *fid, Sint32 *nkey, StmKey *keytbl);

/* ̐ݒ             */
Sint32  BPL_SetBranchInfo(Sint32 bstmid, Sint32 nbranch, Sint32 *brtbl);

/* ̎擾             */
Sint32  BPL_GetBranchInfo(Sint32 bstmid, Sint32 *nbranch, Sint32 *brtbl,
                          Sint32 nelem);

/* ĐJnXg[̎w     */
Sint32  BPL_SetStart(Sint32 bstmid);

/* ĐT[o̎s         */
Sint32  BPL_ExecServer(Bool chgsw);

/* ̑I                 */
Sint32  BPL_SelectBranch(Sint32 brno);

/* ݂̃Xg[̎擾       */
Sint32  BPL_GetCurStm(Sint32 nelem, StmHn *stmtbl);

/* ̃Xg[̎擾 */
Sint32  BPL_GetNextStm(Sint32 nelem, StmHn *stmtbl);

/* Xg[O[v̎擾     */
StmGrpHn  BPL_GetStmGrp(void);

#endif

/* end of file */
