/*------------------------------------------------------------------------
 *  FILE:	csh_main.c
 *      $Author: $Y.K
 *      $Date: $1994-05-10
 *      $Locker: $
 *      $Revision: $0.90
 *      $Source: $
 *      $State: $
 *
 *	Copyright(c) 1994 SEGA
 *      Copyright (c) by SEGA Enterprises Ltd. 1994. All rights reserved.
 *
 *  PURPOSE:
 *		CPU Cache Operation function program
 *
 *  DESCRIPTION:
 *
 *
 *  INTERFACE
 *
 *
 *  CAVEATS
 *
 *
 *  AUTHOR(S):
 *		Y.K
 *
 *  MOD HISTORY:
 *      $Log: $
 *
 *
 *------------------------------------------------------------------------
 */
#include "sega_xpt.h"
#include "sega_csh.h"

/****************************************************************************/
/*	֐																*/
/****************************************************************************/

/****************************************************************************/
/*	LbV̏														*/
/****************************************************************************/
void CSH_Init(Uint16 sw)
{
	Uint32 way;									/*	ANZXEFCϐ	*/
	Uint32 i;									/*	ANZXCϐ	*/
	Uint32 *adrs;								/*	ڽڲ̈擪ڽ	*/

	CSH_SET_ENABLE(CSH_DISABLE);				/*	LbVfBZ[u	*/
	for (way = 0; way < 4; way++) {				/*	SEFC[v			*/
		CSH_SET_ACS_WAY(way);					/*	ANZXEFCw		*/
		adrs = (Uint32 *)0x60000000;			/*	ڽڲ̈擪ڽ	*/
		for (i = 0; i < 64; i++) {				/*	64C[v			*/
			*adrs = 0;							/*	PC̏NA	*/
			adrs += 4;							/*	̃Cɐi		*/
		}										/*	end for i				*/
	}											/*	end for way				*/
	CSH_SET_WAY_MODE(sw);						/*	EFC[hݒ		*/
	CSH_SET_CODE_FILL(CSH_CODE_ENABLE);			/*	R[htBCl[u	*/
	CSH_SET_DATA_FILL(CSH_DATA_ENABLE);			/*	f[^tBCl[u	*/
	CSH_SET_ENABLE(CSH_ENABLE);					/*	LbVCl[u	*/
}

/****************************************************************************/
/*	LbV̑SNA													*/
/****************************************************************************/
void CSH_AllClr(void)
{
	Uint32 way;									/*	ANZXEFCϐ	*/
	Uint32 i;									/*	ANZXCϐ	*/
	Uint32 *adrs;								/*	ڽڲ̈擪ڽ	*/

	CSH_SET_ENABLE(CSH_DISABLE);				/*	LbVfBZ[u	*/
	for (way = 0; way < 4; way++) {				/*	SEFC[v			*/
		CSH_SET_ACS_WAY(way);					/*	ANZXEFCw		*/
		adrs = (Uint32 *)0x60000000;			/*	ڽڲ̈擪ڽ	*/
		for (i = 0; i < 64; i++) {				/*	64C[v			*/
			*adrs = 0;							/*	PC̏NA	*/
			adrs += 4;							/*	̃Cɐi		*/
		}										/*	end for i				*/
	}											/*	end for way				*/
	CSH_SET_ENABLE(CSH_ENABLE);					/*	LbVCl[u	*/
}

/****************************************************************************/
/*	Ώ̘ۗ̈Azp[W													*/
/****************************************************************************/
void CSH_Purge(void *adrs, Uint32 P_size)
{
#if	0	/* CE΍ '95-12-13 */
#if	0
	/*
	**1995-07-26	q
	**	킩ɂύX
	*/
	void *ea;									/*	IAhX			*/

	adrs = (void *)((Uint32)adrs
	 & 0x1ffffff0 | 0x40000000);				/*	擪ްıڽ쐬	*/
	ea = (void *)((Uint32)adrs + P_size);		/*	IAhX{PZo	*/
	while ((Uint32)adrs < (Uint32)ea) {			/*	ΏۃCJԂ	*/
		*(Uint32 *)adrs = 0;					/*	Cof[g			*/
		adrs = (void *)((Uint32)adrs + 16);		/*	̏				*/
	}											/*	end	while				*/
#else
	Uint32	( *dest )[4] = ( Uint32 (*)[] )(((Uint32)adrs & 0x1ffffff0 ) | 0x40000000);
	Uint32	i;

	for( i = 0; i < ( P_size / 16L ); i++ ){
		dest[i][0] = 0;
	}
#endif

#else	/* CE΍ '95-12-13 */
	typedef Uint32 Line[0x10/sizeof(Uint32)];	/* C 0x10 oCgP */
	Line *ptr, *end;
	Uint32 zero = 0;

	ptr = (void*)(((Uint32)adrs & 0x1fffffff) | 0x40000000);	/* LbVp[Ẅ */
	end = (void*)((Uint32)ptr + P_size - 0x10);	/* I|C^i-0x10 ̓|XgCNgׁ̈j */
	ptr = (void*)((Uint32)ptr & -sizeof(Line));	/* CACgɐ */
	do {
		(*ptr)[0] = zero;			/* LbVp[W */
	} while (ptr++ < end);			/* |XgCNg̓fBCXbgp̈ */
#endif	/* CE΍ '95-12-13 */
}

/****************************************************************************/
/*	End of File																*/
/****************************************************************************/
