/*-----------------------------------------------------------------------------
 *  FILE: dma_cpu0.c
 *
 *      Copyright(c) 1994 SEGA.
 *
 *  PURPOSE:
 *
 *      CPU DMAᐅB
 *
 *  DESCRIPTION:
 *
 *      CPU DMAᐅ]@\B
 *
 *  INTERFACE:
 *
 *      < FUNCTIONS LIST >
 *          (1) DMA_CpuSetComPrm        -   DMAʓ]p[^ݒ
 *          (2) DMA_CpuSetPrm           -   DMA]p[^ݒ
 *          (3) DMA_CpuStart            -   DMA]Jn
 *          (4) DMA_CpuStop             -   DMA]~
 *          (5) DMA_CpuAllStop          -   DMAS`l]~
 *          (6) DMA_CpuGetComStatus     -   DMAʃXe[^X擾
 *          (7) DMA_CpuGetStatus        -   DMAXe[^X擾
 *
 *  CAVEATS:
 *
 *
 *  AUTHOR(S)
 *
 *      1994-07-05  N.T Ver.1.00
 *      1995-11/14  H.O Ver.1.00a
 *
 *  MOD HISTORY:
 *      '95-11/14 DRDCR0/DRCR1DREQw֎~ւ̑Ή 
 *
 *-----------------------------------------------------------------------------
 */

/*
 * C STANDARD LIBRARY FUNCTIONS/MACROS DEFINES
 */

/*
 * C VIRTUAL TYPES DEFINITIONS
 */
#include "sega_xpt.h"

/*
 * USER SUPPLIED INCLUDE FILES
 */
#include "dma_xpt.h"
#include "dma_cpu0.h"

/*
 * GLOBAL DECLARATIONS
 */

/*
 * LOCAL DEFINES/MACROS
 */

/* 萔 */
/**** DMAWX^AhX ****************************************************/
/******** `l0 **********************************************************/
#define REG_SAR     ((volatile Uint32 *)0xffffff80)  /* \[XAhXWX^        */
#define REG_DAR     ((volatile Uint32 *)0xffffff84)  /* fBXeBl[VAhX- */
                                            /* WX^                      */
#define REG_TCR     ((volatile Uint32 *)0xffffff88)  /* gXt@JEgWX^  */
#define REG_CHCR    ((volatile Uint32 *)0xffffff8C)  /* `lRg[WX^  */
#define REG_DRCR    ((volatile Uint8  *)0xfffffe71)  /* DMAv^I𐧌䃌WX^ */
/******** `lItZbg *************************************************/
#define OFSET0_REG  0x00000004              /* REG_SAR   ItZbg          */
                                            /* REG_DAR                       */
                                            /* REG_TCR                       */
                                            /* REG_CHCR                      */
#define OFSET1_REG  0x00000001              /* REG_DRCR  ItZbg          */
/********  ***************************************************************/
#define REG_DMAOR   ((Uint32 *)0xffffffb0)  /* DMAIy[VWX^     */

/***** DMAWX^}XNrbg ***********************************************/
/******** `lRg[WX^ ***************************************/
#define R_CHCR_DE    (1 << DMA_CHCR_DE)   /* DMACl[urbg             */
#define R_CHCR_TE    (1 << DMA_CHCR_TE)   /* gXt@GhtOrbg  */
#define R_CHCR_IE    (1 << DMA_CHCR_IE)   /* C^vgCl[urbg    */
#define R_CHCR_TA    (1 << DMA_CHCR_TA)   /* gXt@AhX[hrbg*/
#define R_CHCR_TB    (1 << DMA_CHCR_TB)   /* gXt@oX[hrbg    */
#define R_CHCR_DL    (1 << DMA_CHCR_DL)   /* DREQxrbg@@            */
#define R_CHCR_DS    (1 << DMA_CHCR_DS)   /* DREQZNgrbg              */
#define R_CHCR_AL    (1 << DMA_CHCR_AL)   /* ANmbWxrbg        */
#define R_CHCR_AM    (1 << DMA_CHCR_AM)   /* د/ݽ̧Ӱޯ          */
#define R_CHCR_AR    (1 << DMA_CHCR_AR)   /* I[gNGXgrbg          */
#define R_CHCR_TS    (3 << DMA_CHCR_TS)   /* gXt@TCYrbg        */
#define R_CHCR_SM    (3 << DMA_CHCR_SM)   /* \[XAhX[hrbg      */
#define R_CHCR_DM    (3 << DMA_CHCR_DM)   /* ިèȰݱڽӰޯ        */
/******** DMAIy[VWX^ ******************************************/
#define R_DMAOR_DME  (1 << DMA_DMAOR_DME) /* DMA}X^Cl[urbg       */
#define R_DMAOR_NMIF (1 << DMA_DMAOR_NMIF)/* NMItOrbg                 */
#define R_DMAOR_AE   (1 << DMA_DMAOR_AE)  /* AhXG[tOrbg      */
#define R_DMAOR_PR   (1 << DMA_DMAOR_PR)  /* vCIeB[hrbg      */

/*
 * STATIC DECLARATIONS
 */

/*
 * STATIC FUNCTION PROTOTYPE DECLARATIONS
 */


/******************************************************************************
 *
 * NAME:    DMA_CpuSetComPrm()  -   DMAʓ]p[^ݒ
 *
 * PARAMETERS :
 *      (1) DmaCpuComPrm *com_prm   <i>   ʓ]p[^.
 *
 * DESCRIPTION:
 *      w肳ꂽʓ]p[^ݒ肵܂B
 *
 * PRECONDITIONS:
 *      ȂB
 *
 * POSTCONDITIONS:
 *      ȂB
 *
 * CAVEATS:
 *      ȂB
 *
 ******************************************************************************
 */

void DMA_CpuSetComPrm(DmaCpuComPrm *com_prm)
{
    Uint32 work_reg;
    work_reg = DMA_PEEK_L(REG_DMAOR);
                                    /* DMAIy[VWX^̓ǂݍ   */

    if((com_prm->msk & DMA_CPU_M_PR) == DMA_CPU_M_PR){
        work_reg &= ~R_DMAOR_PR;
        work_reg |= com_prm->pr;
                                            /* vCIeB[hZbg    */
    }
    if((com_prm->msk & DMA_CPU_M_DME) == DMA_CPU_M_DME){
        work_reg &= ~R_DMAOR_DME;
        work_reg |= com_prm->dme;
                                            /* DMA}X^Cl[uZbg     */
    }
    if((com_prm->msk & DMA_CPU_M_AE) == DMA_CPU_M_AE){
        
        work_reg &= ~R_DMAOR_AE;            /* AhXG[rbg̃NA  */
    }
    if((com_prm->msk & DMA_CPU_M_NMIF) == DMA_CPU_M_NMIF){
        work_reg &= ~R_DMAOR_NMIF;              /* NMIG[rbg̃NA   */
    }
    
    DMA_POKE_L(REG_DMAOR, work_reg);
                                   /* DMAIy[VWX^̏    */
}

/******************************************************************************
 *
 * NAME:    DMA_CpuSetPrm() -   DMA]p[^ݒ
 *
 * PARAMETERS :
 *      (1) DmaCpuPrm *prm      <i>   ]p[^.
 *      (2) Uint32 ch           <i>   DMA`l.
 *
 * DESCRIPTION:
 *      w肳ꂽDMA`l֓]p[^ݒ肵܂B
 *
 * PRECONDITIONS:
 *      ȂB
 *
 * POSTCONDITIONS:
 *      ȂB
 *
 * CAVEATS:
 *      prm->drcrɐݒ\Ȃ̂DMA_CPU_RXIDMA_CPU_TXÎ݁B
 *
 ******************************************************************************
 */

void DMA_CpuSetPrm(DmaCpuPrm *prm, Uint32 ch)
{
    Uint32 work_reg;

    if((prm->msk & DMA_CPU_M_SAR) == DMA_CPU_M_SAR){
        DMA_POKE_L((REG_SAR + OFSET0_REG * ch), prm->sar);
                                                /* \[XAhXZbg      */
    }
    if((prm->msk & DMA_CPU_M_DAR) == DMA_CPU_M_DAR){
        DMA_POKE_L((REG_DAR + OFSET0_REG * ch), prm->dar);
                                       /* fBXeBl[VAhXZbg */
    }
    if((prm->msk & DMA_CPU_M_TCR) == DMA_CPU_M_TCR){
        DMA_POKE_L((REG_TCR + OFSET0_REG * ch), prm->tcr);
                                       /* gXt@JEgZbg         */
    }


    work_reg = DMA_PEEK_L(REG_CHCR + OFSET0_REG * ch);
                                /* `lRg[WX^̓ǂݍ    */
    
    if((prm->msk & DMA_CPU_M_DM) == DMA_CPU_M_DM){
        work_reg &= ~R_CHCR_DM;
        work_reg |= prm->dm << DMA_CHCR_DM;
                           /* fBXeBl[VAhX[hrbgZbg */
    }
    if((prm->msk & DMA_CPU_M_SM) == DMA_CPU_M_SM){
        work_reg &= ~R_CHCR_SM;
        work_reg |= prm->sm << DMA_CHCR_SM;
                                        /* \[XAhX[hrbgZbg  */
    }
    if((prm->msk & DMA_CPU_M_TS) == DMA_CPU_M_TS){
        work_reg &= ~R_CHCR_TS;
        work_reg |= prm->ts;                    /* gXt@TCYZbg  */
    }
    if((prm->msk & DMA_CPU_M_AR) == DMA_CPU_M_AR){
        work_reg &= ~R_CHCR_AR;
        work_reg |= prm->ar;                /* I[gNGXg[hZbg  */
    }
    work_reg &= ~R_CHCR_TB;                 /* gXt@oX[hZbg  */
                                            /* (TCNX`[[hŒ)  */
    work_reg &= ~R_CHCR_TA;                 /* ݽ̧ڽӰޯľā@@@@*/
                                            /* (fAAhX[hŒ)  */
    if((prm->msk & DMA_CPU_M_IE) == DMA_CPU_M_IE){
        work_reg &= ~R_CHCR_IE;             
        work_reg |= prm->ie;                /* C^vgCl[uZbg  */
    }
    if((prm->msk & DMA_CPU_M_TE) == DMA_CPU_M_TE){
        work_reg &= ~R_CHCR_TE;             /* ݽ̧׸ނ̸ر           */
    }
    DMA_POKE_L((REG_CHCR + OFSET0_REG * ch), work_reg);
                                /* `lRg[WX^̏    */

    if((prm->msk & DMA_CPU_M_DRCR) == DMA_CPU_M_DRCR){
/*
 *  DRDCR0/DRCR1DREQw֎~ւ̑Ή '95-11/14 H.O
 */
#if 0	/*Old Code*/
        DMA_POKE_B((REG_DRCR + OFSET1_REG * ch), prm->drcr);
                                /* DMAv^I𐧌䃌WX^̏   */
#else	/*New Code*/
		if(( prm->drcr == DMA_CPU_RXI ) || ( prm->drcr == DMA_CPU_TXI ) )
	        DMA_POKE_B((REG_DRCR + OFSET1_REG * ch), prm->drcr);
								/* DMAv/I𐧌䃌WX^ݒ */
#endif
    }
}

/******************************************************************************
 *
 * NAME:    DMA_CpuStart()  -   DMA]Jn
 *
 * PARAMETERS :
 *      (1) Uint32 ch           <i>   DMA`l.
 *
 * DESCRIPTION:
 *      w肳ꂽDMA`lDMA]Jn܂B
 *
 * PRECONDITIONS:
 *      ȂB
 *
 * POSTCONDITIONS:
 *      ȂB
 *
 * CAVEATS:
 *      ȂB
 *
 ******************************************************************************
 */

void DMA_CpuStart(Uint32 ch)
{
    Uint32 work_reg;

    work_reg = DMA_PEEK_L(REG_CHCR + OFSET0_REG * ch);
                                /* `lRg[WX^̓ǂݍ    */
    work_reg |= R_CHCR_DE;      /* DMACl[urbg                 */
    DMA_POKE_L((REG_CHCR + OFSET0_REG * ch), work_reg);
                                /* `lRg[WX^̏    */
}

/******************************************************************************
 *
 * NAME:    DMA_CpuStop()   -   DMA]~
 *
 * PARAMETERS :
 *      (1) Uint32 ch           <i>   DMA`l.
 *
 * DESCRIPTION:
 *      w肳ꂽDMA`lDMA]𒆎~܂B
 *
 * PRECONDITIONS:
 *      ȂB
 *
 * POSTCONDITIONS:
 *      ȂB
 *
 * CAVEATS:
 *      ȂB
 *
 ******************************************************************************
 */

void DMA_CpuStop(Uint32 ch)
{
    Uint32 work_reg;

    work_reg = DMA_PEEK_L(REG_CHCR + OFSET0_REG * ch);
                                /* `lRg[WX^̓ǂݍ    */
    work_reg &= ~R_CHCR_DE;     /* DMACl[urbg֎~                 */
    DMA_POKE_L((REG_CHCR + OFSET0_REG * ch), work_reg);
                                /* `lRg[WX^̏    */
}

/******************************************************************************
 *
 * NAME:    DMA_CpuAllStop()    -   DMAS`l]~
 *
 * PARAMETERS :
 *      ȂB
 *
 * DESCRIPTION:
 *      S`lDMA]𒆎~܂B
 *
 * PRECONDITIONS:
 *      ȂB
 *
 * POSTCONDITIONS:
 *      ȂB
 *
 * CAVEATS:
 *      ȂB
 *
 ******************************************************************************
 */

void DMA_CpuAllStop(void)
{
    Uint32 work_reg;
    work_reg = DMA_PEEK_L(REG_DMAOR);
                                    /* DMAIy[VWX^̓ǂݍ   */
    work_reg &= ~R_DMAOR_DME;       /* DMA}X^Cl[urbg֎~       */
    DMA_POKE_L(REG_DMAOR, work_reg);
                                   /* DMAIy[VWX^̏    */
}

/******************************************************************************
 *
 * NAME:    DMA_CpuGetComStatus()   -   DMAʃXe[^X擾
 *
 * PARAMETERS :
 *      (1) DmaCpuComStatus *status     <o>   ʃXe[^X|C^.
 *
 * DESCRIPTION:
 *      ʃXe[^X擾܂B
 *
 * PRECONDITIONS:
 *      ȂB
 *
 * POSTCONDITIONS:
 *      ȂB
 *
 * CAVEATS:
 *      ȂB
 *
 ******************************************************************************
 */

void DMA_CpuGetComStatus(DmaCpuComStatus *status)
{
    Uint32 work_reg;
    
    work_reg = DMA_PEEK_L(REG_DMAOR);
                                    /* DMAIy[VWX^̓ǂݍ   */
    status->ae = work_reg & R_DMAOR_AE; /* ڽӰ޴װ׸ނ̎擾            */
    status->nmif = work_reg & R_DMAOR_NMIF; /* NMItO̎擾               */
}

/******************************************************************************
 *
 * NAME:    DMA_CpuGetStatus()  -   DMAXe[^X擾
 *
 * PARAMETERS :
 *      (1) Uint32 ch       <o>   DMA`l.
 *
 * DESCRIPTION:
 *      Xe[^X擾܂B
 *
 * PRECONDITIONS:
 *      ȂB
 *
 * POSTCONDITIONS:
 *      (1) DmaCpuStatus    <o>   Xe[^X|C^.
 *
 * CAVEATS:
 *      ȂB
 *
 ******************************************************************************
 */

DmaCpuStatus DMA_CpuGetStatus(Uint32 ch)
{
    Uint32 work_reg;
    
    work_reg = DMA_PEEK_L(REG_CHCR + OFSET0_REG * ch);
                                        /* DMAٺ۰ڼ޽̓ǂݍ      */
    return(work_reg & R_CHCR_TE);       /* ݽ̧׸ނ̎擾              */
}
