/*-----------------------------------------------------------------------------  *  FILE: dma_cpu3.c
 *
 *      Copyright(c) 1994 SEGA.
 *
 *  PURPOSE:
 *
 *      CPU DMAB
 *
 *  DESCRIPTION:
 *
 *      CPU DMA]@\B
 *
 *  INTERFACE:
 *
 *      < FUNCTIONS LIST >
 *          (3) DMA_CpuMemCopy4         -   f[^](O[hP)
 *
 *  CAVEATS:
 *
 *
 *  AUTHOR(S)
 *
 *      1994-07-05  N.T Ver.1.00
 *
 *  MOD HISTORY:
 *
 *-----------------------------------------------------------------------------
 */

/*
 * C STANDARD LIBRARY FUNCTIONS/MACROS DEFINES
 */

/*
 * C VIRTUAL TYPES DEFINITIONS
 */
#include "sega_xpt.h"

/*
 * USER SUPPLIED INCLUDE FILES
 */
#include "dma_cpu0.h"
#include "dma_cpum.h"

/*
 * GLOBAL DECLARATIONS
 */

/*
 * LOCAL DEFINES/MACROS
 */

/*
 * STATIC DECLARATIONS
 */
extern void *dma_cpu_dis_adr;                   /* ߰ޑΏިèȰݱڽ */
extern Uint32 dma_cpu_cnt;                      /* ߰ޑΏިèȰݶ  */

/*
 * STATIC FUNCTION PROTOTYPE DECLARATIONS
 */


/******************************************************************************
 *
 * NAME:    DMA_CpuMemCopy4()   -   f[^](O[hP)
 *
 * PARAMETERS :
 *      (1) void *dst       <i>   fBXeBl[VAhX.
 *      (2) void *src       <i>   \[XAhX.
 *      (3) Uint32 cnt      <i>   ](0`16777215)
 *
 * DESCRIPTION:
 *      srcAhXdstAhXփO[hf[^cnt񐔕]܂B
 *
 * PRECONDITIONS:
 *      ȂB
 *
 * POSTCONDITIONS:
 *      ȂB
 *
 * CAVEATS:
 *      ȂB
 *
 ******************************************************************************
 */

void DMA_CpuMemCopy4(void *dst, void *src, Uint32 cnt)
{
    DmaCpuComPrm com_prm;                       /* ʓ]p[^        */
    DmaCpuPrm prm;                              /* ]p[^            */
                                                /*****************************/
    DMA_CpuStop(DMA_CPU_CH0);                   /* DMA]~               */

    com_prm.pr = DMA_CPU_FIX;                   /* D揇ʐݒ(׳)   */
    com_prm.dme = DMA_CPU_ENA;                  /* DMAϽȰِݒ()    */
    com_prm.msk = DMA_CPU_M_PR |                /* }XNݒ(ײèӰ)  */
                  DMA_CPU_M_AE |                /* (AhXG[tO)    */
                  DMA_CPU_M_NMIF |              /* (NMItO)               */
                  DMA_CPU_M_DME;                /* (DMA}X^Cl[u)     */

    DMA_CpuSetComPrm(&com_prm);                 /* DMAʓ]p[^ݒ */

    prm.sar = (Uint32)src;                      /* \[XAhXݒ        */
    prm.dar = (Uint32)dst;                      /* ިèȰݱڽݒ      */
    prm.tcr = cnt;                              /* gXt@JEgݒ  */
    prm.dm = DMA_CPU_AM_ADD;                    /* ިèȰݱڽӰސݒ  */
    prm.sm = DMA_CPU_AM_ADD;                    /* ڽӰސݒ          */
    prm.ts = DMA_CPU_4;                         /* ݽ̧ސݒ            */
    prm.ar = DMA_CPU_AUTO;                      /* ظӰސݒ          */
    prm.ie = DMA_CPU_INT_DIS;                   /* ĲȰِݒ         */
    
    prm.msk = DMA_CPU_M_SAR |                   /* }XNݒ                */
              DMA_CPU_M_DAR |
              DMA_CPU_M_TCR |
              DMA_CPU_M_DM  |
              DMA_CPU_M_SM  |
              DMA_CPU_M_TS  |
              DMA_CPU_M_AR  |
              DMA_CPU_M_IE  |
              DMA_CPU_M_TE;                     /* ݽ̧ޯẴNAw*/

    DMA_CpuSetPrm(&prm, DMA_CPU_CH0);           /* DMA]p[^ݒ     */
    
    DMA_CpuStart(DMA_CPU_CH0);                  /* DMA]Jn               */
    dma_cpu_dis_adr = dst;
    dma_cpu_cnt = cnt * 4;
}
