/*-----------------------------------------------------------------------------  *  FILE: dma_cpu1.c
 *
 *      Copyright(c) 1994 SEGA.
 *
 *  PURPOSE:
 *
 *      CPU DMAB
 *
 *  DESCRIPTION:
 *
 *      CPU DMA]@\B
 *
 *  INTERFACE:
 *
 *      < FUNCTIONS LIST >
 *          (1) DMA_CpuMemCopy1         -   f[^](oCgP)
 *          (2) DMA_CpuMemCopy2         -   f[^]([hP)
 *          (3) DMA_CpuMemCopy4         -   f[^](O[hP)
 *          (4) DMA_CpuMemCopy16        -   f[^](16oCgP)
 *          (5) DMA_CpuResult           -   f[^]I`FbN
 *
 *  CAVEATS:
 *
 *
 *  AUTHOR(S)
 *
 *      1994-07-05  N.T Ver.1.00
 *
 *  MOD HISTORY:
 *
 *-----------------------------------------------------------------------------
 */

/*
 * C STANDARD LIBRARY FUNCTIONS/MACROS DEFINES
 */

/*
 * C VIRTUAL TYPES DEFINITIONS
 */
#include "sega_xpt.h"

/*
 * USER SUPPLIED INCLUDE FILES
 */
#include "dma_cpu0.h"
#include "dma_cpum.h"

/*
 * GLOBAL DECLARATIONS
 */

/*
 * LOCAL DEFINES/MACROS
 */

/*
 * STATIC DECLARATIONS
 */
extern void *dma_cpu_dis_adr;                   /* ߰ޑΏިèȰݱڽ */
extern Uint32 dma_cpu_cnt;                      /* ߰ޑΏިèȰݶ  */

/*
 * STATIC FUNCTION PROTOTYPE DECLARATIONS
 */


/******************************************************************************
 *
 * NAME:    DMA_CpuMemCopy1()   -   f[^](oCgP)
 *
 * PARAMETERS :
 *      (1) void *dst       <i>   fBXeBl[VAhX.
 *      (2) void *src       <i>   \[XAhX.
 *      (3) Uint32 cnt      <i>   ](0`16777215)
 *
 * DESCRIPTION:
 *      srcAhXdstAhXփoCgf[^cnt񐔕]܂B
 *
 * PRECONDITIONS:
 *      ȂB
 *
 * POSTCONDITIONS:
 *      ȂB
 *
 * CAVEATS:
 *      ȂB
 *
 ******************************************************************************
 */

void DMA_CpuMemCopy1(void *dst, void *src, Uint32 cnt)
{
    DmaCpuComPrm com_prm;                       /* ʓ]p[^        */
    DmaCpuPrm prm;                              /* ]p[^            */
                                                /*****************************/
    DMA_CpuStop(DMA_CPU_CH0);                   /* DMA]~               */

    com_prm.pr = DMA_CPU_FIX;                   /* D揇ʐݒ(׳)   */
    com_prm.dme = DMA_CPU_ENA;                  /* DMAϽȰِݒ()    */
    com_prm.msk = DMA_CPU_M_PR |                /* }XNݒ(ײèӰ)  */
                  DMA_CPU_M_AE |                /* (AhXG[tO)    */
                  DMA_CPU_M_NMIF |              /* (NMItO)               */
                  DMA_CPU_M_DME;                /* (DMA}X^Cl[u)     */

    DMA_CpuSetComPrm(&com_prm);                 /* DMAʓ]p[^ݒ */

    prm.sar = (Uint32)src;                      /* \[XAhXݒ        */
    prm.dar = (Uint32)dst;                      /* ިèȰݱڽݒ      */
    prm.tcr = cnt;                              /* gXt@JEgݒ  */
    prm.dm = DMA_CPU_AM_ADD;                    /* ިèȰݱڽӰސݒ  */
    prm.sm = DMA_CPU_AM_ADD;                    /* ڽӰސݒ          */
    prm.ts = DMA_CPU_1;                         /* ݽ̧ސݒ            */
    prm.ar = DMA_CPU_AUTO;                      /* ظӰސݒ          */
    prm.ie = DMA_CPU_INT_DIS;                   /* ĲȰِݒ         */
    
    prm.msk = DMA_CPU_M_SAR |                   /* }XNݒ                */
              DMA_CPU_M_DAR |
              DMA_CPU_M_TCR |
              DMA_CPU_M_DM  |
              DMA_CPU_M_SM  |
              DMA_CPU_M_TS  |
              DMA_CPU_M_AR  |
              DMA_CPU_M_IE  |
              DMA_CPU_M_TE;                     /* ݽ̧ޯẴNAw*/

    DMA_CpuSetPrm(&prm, DMA_CPU_CH0);           /* DMA]p[^ݒ     */
    
    DMA_CpuStart(DMA_CPU_CH0);                  /* DMA]Jn               */

    dma_cpu_dis_adr = dst;
    dma_cpu_cnt = cnt;

}

/******************************************************************************
 *
 * NAME:    DMA_CpuMemCopy2()   -   f[^]([hP)
 *
 * PARAMETERS :
 *      (1) void *dst       <i>   fBXeBl[VAhX.
 *      (2) void *src       <i>   \[XAhX.
 *      (3) Uint32 cnt      <i>   ](0`16777215)
 *
 * DESCRIPTION:
 *      srcAhXdstAhXփ[hf[^cnt񐔕]܂B
 *
 * PRECONDITIONS:
 *      ȂB
 *
 * POSTCONDITIONS:
 *      ȂB
 *
 * CAVEATS:
 *      ȂB
 *
 ******************************************************************************
 */

void DMA_CpuMemCopy2(void *dst, void *src, Uint32 cnt)
{
    DmaCpuComPrm com_prm;                       /* ʓ]p[^        */
    DmaCpuPrm prm;                              /* ]p[^            */
                                                /*****************************/
    DMA_CpuStop(DMA_CPU_CH0);                   /* DMA]~               */

    com_prm.pr = DMA_CPU_FIX;                   /* D揇ʐݒ(׳)   */
    com_prm.dme = DMA_CPU_ENA;                  /* DMAϽȰِݒ()    */
    com_prm.msk = DMA_CPU_M_PR |                /* }XNݒ(ײèӰ)  */
                  DMA_CPU_M_AE |                /* (AhXG[tO)    */
                  DMA_CPU_M_NMIF |              /* (NMItO)               */
                  DMA_CPU_M_DME;                /* (DMA}X^Cl[u)     */

    DMA_CpuSetComPrm(&com_prm);                 /* DMAʓ]p[^ݒ */

    prm.sar = (Uint32)src;                      /* \[XAhXݒ        */
    prm.dar = (Uint32)dst;                      /* ިèȰݱڽݒ      */
    prm.tcr = cnt;                              /* gXt@JEgݒ  */
    prm.dm = DMA_CPU_AM_ADD;                    /* ިèȰݱڽӰސݒ  */
    prm.sm = DMA_CPU_AM_ADD;                    /* ڽӰސݒ          */
    prm.ts = DMA_CPU_2;                         /* ݽ̧ސݒ            */
    prm.ar = DMA_CPU_AUTO;                      /* ظӰސݒ          */
    prm.ie = DMA_CPU_INT_DIS;                   /* ĲȰِݒ         */
    
    prm.msk = DMA_CPU_M_SAR |                   /* }XNݒ                */
              DMA_CPU_M_DAR |
              DMA_CPU_M_TCR |
              DMA_CPU_M_DM  |
              DMA_CPU_M_SM  |
              DMA_CPU_M_TS  |
              DMA_CPU_M_AR  |
              DMA_CPU_M_IE  |
              DMA_CPU_M_TE;                     /* ݽ̧ޯẴNAw*/

    DMA_CpuSetPrm(&prm, DMA_CPU_CH0);           /* DMA]p[^ݒ     */
    
    DMA_CpuStart(DMA_CPU_CH0);                  /* DMA]Jn               */
    dma_cpu_dis_adr = dst;
    dma_cpu_cnt = cnt * 2;
}

/******************************************************************************
 *
 * NAME:    DMA_CpuMemCopy4()   -   f[^](O[hP)
 *
 * PARAMETERS :
 *      (1) void *dst       <i>   fBXeBl[VAhX.
 *      (2) void *src       <i>   \[XAhX.
 *      (3) Uint32 cnt      <i>   ](0`16777215)
 *
 * DESCRIPTION:
 *      srcAhXdstAhXփO[hf[^cnt񐔕]܂B
 *
 * PRECONDITIONS:
 *      ȂB
 *
 * POSTCONDITIONS:
 *      ȂB
 *
 * CAVEATS:
 *      ȂB
 *
 ******************************************************************************
 */

void DMA_CpuMemCopy4(void *dst, void *src, Uint32 cnt)
{
    DmaCpuComPrm com_prm;                       /* ʓ]p[^        */
    DmaCpuPrm prm;                              /* ]p[^            */
                                                /*****************************/
    DMA_CpuStop(DMA_CPU_CH0);                   /* DMA]~               */

    com_prm.pr = DMA_CPU_FIX;                   /* D揇ʐݒ(׳)   */
    com_prm.dme = DMA_CPU_ENA;                  /* DMAϽȰِݒ()    */
    com_prm.msk = DMA_CPU_M_PR |                /* }XNݒ(ײèӰ)  */
                  DMA_CPU_M_AE |                /* (AhXG[tO)    */
                  DMA_CPU_M_NMIF |              /* (NMItO)               */
                  DMA_CPU_M_DME;                /* (DMA}X^Cl[u)     */

    DMA_CpuSetComPrm(&com_prm);                 /* DMAʓ]p[^ݒ */

    prm.sar = (Uint32)src;                      /* \[XAhXݒ        */
    prm.dar = (Uint32)dst;                      /* ިèȰݱڽݒ      */
    prm.tcr = cnt;                              /* gXt@JEgݒ  */
    prm.dm = DMA_CPU_AM_ADD;                    /* ިèȰݱڽӰސݒ  */
    prm.sm = DMA_CPU_AM_ADD;                    /* ڽӰސݒ          */
    prm.ts = DMA_CPU_4;                         /* ݽ̧ސݒ            */
    prm.ar = DMA_CPU_AUTO;                      /* ظӰސݒ          */
    prm.ie = DMA_CPU_INT_DIS;                   /* ĲȰِݒ         */
    
    prm.msk = DMA_CPU_M_SAR |                   /* }XNݒ                */
              DMA_CPU_M_DAR |
              DMA_CPU_M_TCR |
              DMA_CPU_M_DM  |
              DMA_CPU_M_SM  |
              DMA_CPU_M_TS  |
              DMA_CPU_M_AR  |
              DMA_CPU_M_IE  |
              DMA_CPU_M_TE;                     /* ݽ̧ޯẴNAw*/

    DMA_CpuSetPrm(&prm, DMA_CPU_CH0);           /* DMA]p[^ݒ     */
    
    DMA_CpuStart(DMA_CPU_CH0);                  /* DMA]Jn               */
    dma_cpu_dis_adr = dst;
    dma_cpu_cnt = cnt * 4;
}

/******************************************************************************
 *
 * NAME:    DMA_CpuMemCopy16()  -   f[^](16oCgP)
 *
 * PARAMETERS :
 *      (1) void *dst       <i>   fBXeBl[VAhX.
 *      (2) void *src       <i>   \[XAhX.
 *      (3) Uint32 cnt      <i>   ](0`16777215)
 *
 * DESCRIPTION:
 *      srcAhXdstAhX16oCgf[^cnt񐔕]܂B
 *
 * PRECONDITIONS:
 *      ȂB
 *
 * POSTCONDITIONS:
 *      ȂB
 *
 * CAVEATS:
 *      ȂB
 *
 ******************************************************************************
 */

void DMA_CpuMemCopy16(void *dst, void *src, Uint32 cnt)
{
    DmaCpuComPrm com_prm;                       /* ʓ]p[^        */
    DmaCpuPrm prm;                              /* ]p[^            */
                                                /*****************************/
    DMA_CpuStop(DMA_CPU_CH0);                   /* DMA]~               */

    com_prm.pr = DMA_CPU_FIX;                   /* D揇ʐݒ(׳)   */
    com_prm.dme = DMA_CPU_ENA;                  /* DMAϽȰِݒ()    */
    com_prm.msk = DMA_CPU_M_PR |                /* }XNݒ(ײèӰ)  */
                  DMA_CPU_M_AE |                /* (AhXG[tO)    */
                  DMA_CPU_M_NMIF |              /* (NMItO)               */
                  DMA_CPU_M_DME;                /* (DMA}X^Cl[u)     */

    DMA_CpuSetComPrm(&com_prm);                 /* DMAʓ]p[^ݒ */

    prm.sar = (Uint32)src;                      /* \[XAhXݒ        */
    prm.dar = (Uint32)dst;                      /* ިèȰݱڽݒ      */
    prm.tcr = cnt;                              /* gXt@JEgݒ  */
    prm.dm = DMA_CPU_AM_ADD;                    /* ިèȰݱڽӰސݒ  */
    prm.sm = DMA_CPU_AM_ADD;                    /* ڽӰސݒ          */
    prm.ts = DMA_CPU_16;                        /* ݽ̧ސݒ            */
    prm.ar = DMA_CPU_AUTO;                      /* ظӰސݒ          */
    prm.ie = DMA_CPU_INT_DIS;                   /* ĲȰِݒ         */
    
    prm.msk = DMA_CPU_M_SAR |                   /* }XNݒ                */
              DMA_CPU_M_DAR |
              DMA_CPU_M_TCR |
              DMA_CPU_M_DM  |
              DMA_CPU_M_SM  |
              DMA_CPU_M_TS  |
              DMA_CPU_M_AR  |
              DMA_CPU_M_IE  |
              DMA_CPU_M_TE;                     /* ݽ̧ޯẴNAw*/

    DMA_CpuSetPrm(&prm, DMA_CPU_CH0);           /* DMA]p[^ݒ     */
    
    DMA_CpuStart(DMA_CPU_CH0);                  /* DMA]Jn               */
    dma_cpu_dis_adr = dst;
    dma_cpu_cnt = cnt * 4;
}

/******************************************************************************
 *
 * NAME:    DMA_CpuResult()     -   f[^]I`FbN
 *
 * PARAMETERS :
 *      (2) void *src       <i>   \[XAhX.
 *      (3) Uint32 cnt      <i>   ](0`16777215)
 *
 * DESCRIPTION:
 *      srcAhXdstAhX16oCgf[^cnt񐔕]܂B
 *
 * PRECONDITIONS:
 *      ȂB
 *
 * POSTCONDITIONS:
 *      Uint32 DMA_CpuMemCopy1,2,4,16()̌.
 *
 * CAVEATS:
 *      ȂB
 *
 ******************************************************************************
 */

Uint32 DMA_CpuResult(void)
{
    DmaCpuComStatus com_status;             /* ʃXe[^X                */
    DmaCpuStatus status;                    /* Xe[^X                    */
                                            /*********************************/
    DMA_CpuGetComStatus(&com_status);       /* ʃXe[^X擾            */
    if(com_status.ae == DMA_CPU_ADR_ERR){   /* ڽװꍇ        */
        return(DMA_CPU_FAIL);               /* ُI^[            */
    }
    status = DMA_CpuGetStatus(DMA_CPU_CH0); /* Xe[^X擾                */
    if(status == DMA_CPU_TE_MV){            /* 쒆łꍇ              */
        return(DMA_CPU_BUSY);               /* s^[              */
    }
    CSH_Purge(dma_cpu_dis_adr, dma_cpu_cnt);
    return(DMA_CPU_END);                    /* I^[            */
}

