/*-----------------------------------------------------------------------------
 *  FILE: dma_scu0.c
 *
 *      Copyright(c) 1994 SEGA.
 *
 *  PURPOSE:
 *
 *      SCU DMAᐅB
 *
 *  DESCRIPTION:
 *
 *      SCU DMAᐅ]@\B
 *
 *  INTERFACE:
 *
 *      < FUNCTIONS LIST >
 *          (1) DMA_ScuSetPrm           -   DMA]p[^ݒ
 *          (2) DMA_ScuStart            -   DMA]Jn
 *          (3) DMA_ScuGetStatus        -   DMAXe[^X擾
 *
 *  CAVEATS:
 *
 *
 *  AUTHOR(S)
 *
 *      1994-07-05  N.T Ver.1.00
 *
 *  MOD HISTORY:
 *
 *      1994-10-12  N.T Ver.1.04
 *
 *-----------------------------------------------------------------------------
 */

/*
 * C STANDARD LIBRARY FUNCTIONS/MACROS DEFINES
 */

/*
 * C VIRTUAL TYPES DEFINITIONS
 */
#include "sega_xpt.h"
#include "sega_int.h"
#include <machine.h>

/*
 * USER SUPPLIED INCLUDE FILES
 */
#include "dma_xpt.h"
#include "dma_scu0.h"

/*
 * GLOBAL DECLARATIONS
 */

/*
 * LOCAL DEFINES/MACROS
 */

/* 萔 */
/****  *******************************************************************/
#define MAX_CHANEL  3                       /* DMA`l                 */
/**** DMAWX^AhX ****************************************************/
/******** `l0 **********************************************************/
#ifndef _DEB
#define REG_DXR     ((volatile Uint32 *)0x25fe0000)  /* ǂݍ݃AhX              */
#define REG_DXW     ((volatile Uint32 *)0x25fe0004)  /* oAhX              */
#define REG_DXC     ((volatile Uint32 *)0x25fe0008)  /* ]oCg@@@            */
#define REG_DXAD    ((volatile Uint32 *)0x25fe000C)  /* ZlWX^@@            */
#define REG_DXEN    ((volatile Uint32 *)0x25fe0010)  /* DMAWX^ @            */
#define REG_DXMD    ((volatile Uint32 *)0x25fe0014)  /* DMAӰށAڽXVANv@*/
#else
#define REG_DXR   ((volatile Uint32 *)0x06060000)  /* ǂݍ݃AhX              */
#define REG_DXW   ((volatile Uint32 *)0x06060004)  /* oAhX              */
#define REG_DXC   ((volatile Uint32 *)0x06060008)  /* ]oCg@@@            */
#define REG_DXAD  ((volatile Uint32 *)0x0606000C)  /* ZlWX^@@            */
#define REG_DXEN  ((volatile Uint32 *)0x06060010)  /* DMAWX^ @            */
#define REG_DXMD  ((volatile Uint32 *)0x06060014)  /* DMAӰށAڽXVANv@*/
#endif /* _DEB */
/******** `lItZbg *************************************************/
#define OFSET0_REG  0x00000008              /* REG_DXR   ItZbg          */
                                            /* REG_DXW                       */
                                            /* REG_DXC                       */
                                            /* REG_DXAD                      */
                                            /* REG_DXEN                      */
                                            /* REG_DXMD                      */
/********  ***************************************************************/
#ifndef _DEB
#define REG_DSTP    ((Uint32 *)0x25fe0060)  /* DMA~WX^         @*/
#else
#define REG_DSTP   ((Uint32 *)0x06060060)  /* DMA~WX^         @*/
#endif /* _DEB */

/***** DMAWX^}XNrbg ***********************************************/
/******** ZlWX^ *****************************************************/
#define R_DXAD_DXRAD (1 << DMA_DXAD_DXRAD)      /* ǂݍ݃AhXZl    */
#define R_DXAD_DXWAD (3 << DMA_DXAD_DXWAD)      /* ݃AhXZl    */
/******** DMAWX^ ****************************************************/
#define R_DXEN_DXGO  (1 << DMA_DXEN_DXGO)       /* DMANrbg             */
#define R_DXEN_DXEN  (1 << DMA_DXEN_DXEN)       /* DMArbg             */
/******** DMA[hAAhXXVANvWX^ **************************/
#define R_DXMD_DXMOD ( 1 << DMA_DXMD_DXMOD)     /* [hrbg              */
#define R_DXMD_DXRUP ( 1 << DMA_DXMD_DXRUP)     /* ǂݍ݃AhXXVrbg*/
#define R_DXMD_DXWUP ( 1 << DMA_DXMD_DXWUP)     /* oAhXXVrbg*/
#define R_DXMD_DXFT  ( 7 << DMA_DXMD_DXFT )     /* NvIrbg        */

/******************************************************************************
 *
 * NAME:    STOP_COM()  -   DMAIʏ
 *
 * PARAMETERS :
 *      (1) Uint32  ch  -   <i> DMA`l.
 *
 * DESCRIPTION:
 *      w肳ꂽDMA`lDMAIs܂B
 *
 * PRECONDITIONS:
 *      ȂB
 *
 * POSTCONDITIONS:
 *      ȂB
 *
 * CAVEATS:
 *      ȂB
 *
 ******************************************************************************
 */
#define STOP_COM(ch, vector_num)\
    do{\
        INT_SetScuFunc((vector_num), dma_scu_vector[(ch)]);\
        INT_SetFunc((vector_num), dma_vector[(ch)]);\
        dma_int_status[(ch)] = DMA_SCU_NO_MV;\
    }while(FALSE)

/******************************************************************************
 *
 * NAME:    STOP_COM_CHANEL()   -   DMA`lʏIʏ
 *
 * PARAMETERS :
 *      (1) Uint32  ch  -   <i> DMA`l.
 *
 * DESCRIPTION:
 *      w肳ꂽDMA`lDMAIs܂B
 *
 * PRECONDITIONS:
 *      ȂB
 *
 * POSTCONDITIONS:
 *      ȂB
 *
 * CAVEATS:
 *      ȂB
 *
 ******************************************************************************
 */
#define STOP_COM_CHANEL(ch, vector_num)\
    do{\
        if(dma_int_status[(ch)] == DMA_SCU_MV){\
            switch((ch)){\
                case DMA_SCU_CH0:\
                    *(vector_num) = INT_SCU_DMA0;\
                    break;\
                case DMA_SCU_CH1:\
                    *(vector_num) = INT_SCU_DMA1;\
                    break;\
                case DMA_SCU_CH2:\
                    *(vector_num) = INT_SCU_DMA2;\
                    break;\
            }\
            STOP_COM((ch), *(vector_num));\
        }\
    }while(FALSE)\

/******************************************************************************
 *
 * NAME:    INTR_FUNC()         -   DMA`lʏI荞ݏ
 *
 * PARAMETERS :
 *      ch `l
 *      vector_num xN^ԍ
 *
 * DESCRIPTION:
 *      DMA`lDMAI荞ݏs܂B
 *
 * PRECONDITIONS:
 *      ȂB
 *
 * POSTCONDITIONS:
 *      ȂB
 *
 * CAVEATS:
 *      ȂB
 *
 ******************************************************************************
 */
#define INTR_FUNC(ch, vector_num)\
    do{\
        Uint32 msk;\
        msk = get_imask();\
        set_imask(15);\
        dma_int_status[(ch)] = DMA_SCU_NO_MV;\
        STOP_COM((ch), (vector_num));           /* DMAIʏ          */\
        set_imask(msk);                                     /* 荞POP  */\
    }while(FALSE)

/*
 * STATIC DECLARATIONS
 */

static void (*dma_scu_vector[MAX_CHANEL])(void);/* xN^L̈(SCU)       */
static void (*dma_vector[MAX_CHANEL])(void);    /* xN^L̈            */

static Uint8 dma_int_status[MAX_CHANEL];        /* 荞݃Xe[^X        */

/*
 * STATIC FUNCTION PROTOTYPE DECLARATIONS
 */

void DMA_ScuIntFunc0(void);
void DMA_ScuIntFunc1(void);
void DMA_ScuIntFunc2(void);

/******************************************************************************
 *
 * NAME:    DMA_ScuSetPrm() -   DMA]p[^ݒ
 *
 * PARAMETERS :
 *      (1) DmaScuPrm   *prm  - <i>   ]p[^.
 *      (2) Uint32      ch    - <i>   DMA`l..
 *
 * DESCRIPTION:
 *      w肳ꂽDMA`l֓]p[^̒lݒ肵܂B
 *
 * PRECONDITIONS:
 *      ȂB
 *
 * POSTCONDITIONS:
 *      ȂB
 *
 * CAVEATS:
 *      ȂB
 *
 ******************************************************************************
 */

void DMA_ScuSetPrm(DmaScuPrm *prm, Uint32 ch)
{
#if	0
	/*
	**1995-07-26	q
	**	gĂȂ̂ō폜
	*/
    Uint32 work_reg;
#endif
    
    if((prm->msk & DMA_SCU_M_DXR) == DMA_SCU_M_DXR){
        DMA_POKE_L((REG_DXR + OFSET0_REG * ch), prm->dxr);
    }

    if((prm->msk & DMA_SCU_M_DXW) == DMA_SCU_M_DXW){
        DMA_POKE_L((REG_DXW + OFSET0_REG * ch), prm->dxw);
    }

    DMA_POKE_L((REG_DXC + OFSET0_REG * ch), prm->dxc);
    
    DMA_POKE_L((REG_DXAD + OFSET0_REG * ch), (prm->dxad_r | prm->dxad_w));
                                                        /* Zlڽڼ޽  */
    DMA_POKE_L((REG_DXMD + OFSET0_REG * ch), (prm->dxmod | 
               (prm->dxrup << DMA_DXMD_DXRUP )|
               (prm->dxwup << DMA_DXMD_DXWUP )| prm->dxft));
                                          /* [hAAhXXVANv  */
}

/******************************************************************************
 *
 * NAME:    DMA_ScuStart()  -   DMA]Jn
 *
 * PARAMETERS :
 *      (1) Uint32  ch  -   <i> DMA`l.
 *
 * DESCRIPTION:
 *      w肳ꂽDMA`lDMA]Jn܂B
 *
 * PRECONDITIONS:
 *      ȂB
 *
 * POSTCONDITIONS:
 *      ȂB
 *
 * CAVEATS:
 *      ȂB
 *
 ******************************************************************************
 */

void DMA_ScuStart(Uint32 ch)
{
    Uint32 msk;
    Uint32 now_vector_num;
    void (*intr_func)(void);

    msk = get_imask();
    set_imask(15);
    /* 荞݃xN^o^ (start)*********************************************/
    switch(ch){
        case DMA_SCU_CH0:
            now_vector_num = INT_SCU_DMA0;
            intr_func = DMA_ScuIntFunc0;
            break;
        case DMA_SCU_CH1:
            now_vector_num = INT_SCU_DMA1;
            intr_func = DMA_ScuIntFunc1;
            break;
        case DMA_SCU_CH2:
            now_vector_num = INT_SCU_DMA2;
            intr_func = DMA_ScuIntFunc2;
            break;
    }
    dma_scu_vector[ch] = INT_GetScuFunc(now_vector_num);
                                                        /* xN^ҔSCU     */
    dma_vector[ch] = INT_GetFunc(now_vector_num);
                                                        /* xN^Ҕ        */
    dma_int_status[ch] = DMA_SCU_MV;
    INT_SetScuFunc(now_vector_num, intr_func);        /* xN^o^        */
    INT_SetFunc(now_vector_num, NULL);          /* SCU荞݊֐̍ēo^   */

    /* 荞݃xN^o^ (end)***********************************************/

    DMA_POKE_L((REG_DXEN + OFSET0_REG * ch), (R_DXEN_DXGO | R_DXEN_DXEN));
                                                /* DMAڼ޽              */

    set_imask(msk);                                         /* 荞POP   */
}
/******************************************************************************
 *
 * NAME:    DMA_ScuGetStatus() -   DMAXe[^X擾
 *
 * PARAMETERS :
 *      (1) Uint32  ch              -   <i> DMA`l.
 *      (2) DmaScuStatus *status    -   <o> Xe[^X|C^.
 *
 * DESCRIPTION:
 *      w肳ꂽDMA`l̃Xe[^X擾܂B
 *
 * PRECONDITIONS:
 *      ȂB
 *
 * POSTCONDITIONS:
 *      ȂB
 *
 * CAVEATS:
 *      ȂB
 *
 ******************************************************************************
 */

void DMA_ScuGetStatus(DmaScuStatus *status, Uint32 ch)
{
    Uint32 msk;
    msk = get_imask();
    set_imask(15);

    status->dxmv = (Uint32)dma_int_status[ch];

    set_imask(msk);                                         /* 荞POP   */
}

/******************************************************************************
 *
 * NAME:    DMA_ScuIntFunc0()     -   DMA0荞ݏ
 *
 * PARAMETERS :
 *
 * DESCRIPTION:
 *      DMA0̏I荞݃[`łB
 *
 * PRECONDITIONS:
 *      ȂB
 *
 * POSTCONDITIONS:
 *      ȂB
 *
 * CAVEATS:
 *      ȂB
 *
 ******************************************************************************
 */

void DMA_ScuIntFunc0(void){
    INTR_FUNC(DMA_SCU_CH0, INT_SCU_DMA0);   /* DMA`lʏI荞ݏ */
}

/******************************************************************************
 *
 * NAME:    DMA_ScuIntFunc1()     -   DMA1荞ݏ
 *
 * PARAMETERS :
 *
 * DESCRIPTION:
 *      DMA1̏I荞݃[`łB
 *
 * PRECONDITIONS:
 *      ȂB
 *
 * POSTCONDITIONS:
 *      ȂB
 *
 * CAVEATS:
 *      ȂB
 *
 ******************************************************************************
 */

void DMA_ScuIntFunc1(void){
    INTR_FUNC(DMA_SCU_CH1, INT_SCU_DMA1);   /* DMA`lʏI荞ݏ */
}

/******************************************************************************
 *
 * NAME:    DMA_ScuIntFunc2()     -   DMA2荞ݏ
 *
 * PARAMETERS :
 *
 * DESCRIPTION:
 *      DMA2̏I荞݃[`łB
 *
 * PRECONDITIONS:
 *      ȂB
 *
 * POSTCONDITIONS:
 *      ȂB
 *
 * CAVEATS:
 *      ȂB
 *
 ******************************************************************************
 */

void DMA_ScuIntFunc2(void){
    INTR_FUNC(DMA_SCU_CH2, INT_SCU_DMA2);   /* DMA`lʏI荞ݏ */
}
