/*-----------------------------------------------------------------------------
 *  FILE: dma_scu0.h
 *
 *      Copyright(c) 1994 SEGA.
 *
 *  PURPOSE:
 *
 *      SCU DMAᐅwb_t@CB
 *
 *  DESCRIPTION:
 *
 *      SCU DMAᐅ]@\B
 *
 *  AUTHOR(S)
 *
 *      1994-05-09  N.T Ver.0.90
 *
 *  MOD HISTORY:
 *
 *      1994-10-12  N.T Ver.1.01
 *
 *-----------------------------------------------------------------------------
 */

#ifndef DMA_SCU0_H
#define DMA_SCU0_H

/*
 * C VIRTUAL TYPES DEFINITIONS
 */
#include "sega_xpt.h"

/*
 * GLOBAL DEFINES/MACROS DEFINES
 */

/* 萔 */
/*****************************************************************************/
/**** DMA`l ************************************************************/
/*****************************************************************************/
#define DMA_SCU_CH0 0x0                         /* `l0                 */
#define DMA_SCU_CH1 0x1                         /* `l1                 */
#define DMA_SCU_CH2 0x2                         /* `l2                 */

/**** DMAWX^rbgʒu **************************************************/
/******** ZlWX^ *****************************************************/
#define DMA_DXAD_DXRAD  8                       /* ǂݍ݃AhXZl    */
#define DMA_DXAD_DXWAD  0                       /* ݃AhXZl    */
/******** DMAWX^ ****************************************************/
#define DMA_DXEN_DXGO   0                       /* DMANrbg             */
#define DMA_DXEN_DXEN   8                       /* DMArbg             */
/******** DMA[hAAhXXVANvWX^ **************************/
#define DMA_DXMD_DXMOD  24                      /* [hrbg              */
#define DMA_DXMD_DXRUP  16                      /* ǂݍ݃AhXXVrbg*/
#define DMA_DXMD_DXWUP   8                      /* oAhXXVrbg*/
#define DMA_DXMD_DXFT    0                      /* NvIrbg        */


/*****************************************************************************/
/**** (DmaScuPrm)]p[^ **********************************************/
/*****************************************************************************/
/******** (dxad_r)ǂݍ݃AhXZl *************************************/
#define DMA_SCU_R0  (0x0 << DMA_DXAD_DXRAD)     /* ZȂ                */
#define DMA_SCU_R4  (0x1 << DMA_DXAD_DXRAD)     /* 4oCgZ           */
/******** (dxad_w)݃AhXZl *************************************/
#define DMA_SCU_W0     (0x0 << DMA_DXAD_DXWAD)  /* ZȂ                */
#define DMA_SCU_W2     (0x1 << DMA_DXAD_DXWAD)  /* 2oCgZ           */
#define DMA_SCU_W4     (0x2 << DMA_DXAD_DXWAD)  /* 4oCgZ           */
#define DMA_SCU_W8     (0x3 << DMA_DXAD_DXWAD)  /* 8oCgZ           */
#define DMA_SCU_W16    (0x4 << DMA_DXAD_DXWAD)  /* 16oCgZ          */
#define DMA_SCU_W32    (0x5 << DMA_DXAD_DXWAD)  /* 32oCgZ          */
#define DMA_SCU_W64    (0x6 << DMA_DXAD_DXWAD)  /* 64oCgZ          */
#define DMA_SCU_W128   (0x7 << DMA_DXAD_DXWAD)  /* 128oCgZ         */
/******** (dxmod)[hrbg ************************************************/
#define DMA_SCU_DIR    (0x0 << DMA_DXMD_DXMOD)  /* ڃ[h                */
#define DMA_SCU_IN_DIR (0x1 << DMA_DXMD_DXMOD)  /* Ԑڃ[h                */
/******** (dxrup)ǂݍ݃AhXXVrbg **********************************/
/******** (dxwup)oAhXXVrbg **********************************/
#define DMA_SCU_KEEP    0x0                     /* ێ                  */
#define DMA_SCU_REN     0x1                     /* XV                  */

/******** (dxft)NvIrbg *******************************************/
#define DMA_SCU_F_VBLK_IN  (0x0 << DMA_DXMD_DXFT)/* V-uN-IN            */
#define DMA_SCU_F_VBLK_OUT (0x1 << DMA_DXMD_DXFT)/* V-uN-OUT           */
#define DMA_SCU_F_HBLK_IN  (0x2 << DMA_DXMD_DXFT)/* H-uN-IN            */
#define DMA_SCU_F_TIM0     (0x3 << DMA_DXMD_DXFT)/* ^C}0                  */
#define DMA_SCU_F_TIM1     (0x4 << DMA_DXMD_DXFT)/* ^C}1                  */
#define DMA_SCU_F_SND      (0x5 << DMA_DXMD_DXFT)/* TEh-Req             */
#define DMA_SCU_F_SPR      (0x6 << DMA_DXMD_DXFT)/* XvCg`           */
#define DMA_SCU_F_DMA      (0x7 << DMA_DXMD_DXFT)/* DMANvrbg̃Zbg*/
/******** (msk)}XNrbg *************************************************/
#define DMA_SCU_M_DXR      (1 << 0)             /* ǂݍ݃AhX          */
#define DMA_SCU_M_DXW      (1 << 1)             /* oAhX          */

/*****************************************************************************/
/**** (DmaScuStatus)Xe[^X ***********************************************/
/*****************************************************************************/
/******** (dxbkr)DMA쒆tO *********************************************/
/******** (ddmv)DSPDMA쒆tO *****************************************/
#define DMA_SCU_MV      0x1                     /* 쒆                    */
#define DMA_SCU_NO_MV   0x0                     /* 쒆łȂ              */

/*
 * STRUCTURE DECLARATIONS
 */

/*
 * TYPEDEFS
 */
typedef struct {
    Uint32 dxr;                                 /* ǂݍ݃AhX          */
    Uint32 dxw;                                 /* oAhX          */
    Uint32 dxc;                                 /* ]oCg              */
    Uint32 dxad_r;                              /* ǂݍ݃AhXZl    */
    Uint32 dxad_w;                              /* ݃AhXZl    */
    Uint32 dxmod;                               /* [hrbg              */
    Uint32 dxrup;                               /* ǂݍ݃AhXXVrbg*/
    Uint32 dxwup;                               /* ݃AhXXVrbg*/
    Uint32 dxft;                                /* NvIrbg        */
    Uint32 msk;                                 /* }XNrbg              */
}DmaScuPrm;                                     /* ]p[^            */

typedef struct {
    Uint32 dxmv;                            /* DMA쒆tO               */
}DmaScuStatus;                              /* Xe[^X                    */

/*
 * EXTERNAL VARIABLE DECLARATIONS
 */

/*
 * EXTERNAL FUNCTION PROTOTYPE  DECLARATIONS
 */
void DMA_ScuSetPrm(DmaScuPrm *, Uint32);    /* DMA]p[^             */
void DMA_ScuStart(Uint32);                  /* DMA]Jn                   */
void DMA_ScuGetStatus(DmaScuStatus *, Uint32);/* DMAXe[^X擾           */

#endif  /* ifndef DMA_SCU0_H */
