/*****************************************************************************
 *      \tgEFACu
 *
 *      Copyright (c) 1994,1995,1996 SEGA
 *
 * Library:t@CVXe
 * Module :fBNg
 * File   :gfs_dir.c
 * Date   :1996-02-01
 * Version:2.10
 * Author :H.T.
 *
 *****************************************************************************/
/* SGL̏ꍇRpCIvVɂ`邱
 * #define USE_SGL
 */

/*****************************************************************************
 *      CN[ht@C
 *****************************************************************************/
#include    <string.h>

#include    "sega_gfs.h"
#include    "gfs_def.h"
#include    "gfs_mmc.h"
#include    "gfs_dir.h"
#include    "gfs_cdc.h"

#if defined(DEBUG_LIB)
#include    "gfs_scsi.h"
#endif

/*****************************************************************************
 *      萔}N
 *****************************************************************************/
#define SECT_BUF_SIZ    2048            /* ZN^obt@̑傫 */

#define MF_OVW      0x01        /* t@Cbct@C㏑ */

/* ʈfBNg */
#define GFDR_CURRENT_DIR_ID     0       /* JgfBNgID */
#define GFDR_PARENT_DIR_ID      1       /* efBNgID */

#define GFDR_BASE_MAX   8               /* t@C̒̍ő */
#define GFDR_EXT_MAX    3               /* gq̒̍ő */

/* ȈՓ̓Xg[̃obt@Ƀf[^ǂݍ܂ĂȂ */
#define GFDR_FILE_UNREAD    -1

/*****************************************************************************
 *      񋓒萔
 *****************************************************************************/

/*****************************************************************************
 *      }N
 *****************************************************************************/
#define LSN2FAD(lsn)    ((lsn) + 150)
#define FAD2LSN(fad)    ((fad) - 150)

/* L^tB[h̒ioCgj */
#define RECORDING_DATE_LEN      7

#define GFS_DIR_DIRREC(rec)     ((rec)->dirrec)

/* padding fieldKv */
#define NEEDS_PADDING(n)   ((n + 1) & 1)

/*****************************************************************************
 *      f[^^̒`
 *****************************************************************************/
/* CD ROM XÃfBNĝgp */
typedef struct {
    Uint32      pos;            /* GNXeg̈ʒu */
    Uint32      len;            /* f[^ */
    Uint8       rsize;          /* fBNgR[h̑傫 */
    Uint8       atr;            /* t@C̑ */
    Uint8       unitsize;
    Uint8       gapsize;
    Sint8       fname[GFS_FNAME_LEN + 1]; /* t@C(+1͏I[0) */
    Uint8       fn;             /* t@Cԍ */
} XaDirEnt;

#define XA_DIR_RSIZE(dir)       ((dir)->rsize)
#define XA_DIR_POS(dir)         ((dir)->pos)
#define XA_DIR_LEN(dir)         ((dir)->len)
#define XA_DIR_ATR(dir)         ((dir)->atr)
#define XA_DIR_USIZE(dir)       ((dir)->unitsize)
#define XA_DIR_GSIZE(dir)       ((dir)->gapsize)
#define XA_DIR_FNAME(dir)       ((dir)->fname)
#define XA_DIR_FN(dir)          ((dir)->fn)

#define XA_ATR_DIR              0x80
#define XA_ATR_INTLV            0x20
#define XA_ATR_FORM2            0x10
#define XA_ATR_FORM1            0x08
#define XA_ATR_ERR              0x0080  /* t@CKiɂĂȂ */

/* ȈՓ̓Xg[\ */
/* GfsHnoCgPʂ̓͂\ɂ */
typedef struct {
    GfsHn   gfs;
    Uint8   *buf;                       /* PZN^̃obt@ */
    Sint32  rp;                         /* buf ̎̓ǂވʒu(PʁFoCg) */
    Sint32 ap;                          /* ݂̃ZN^ʒu */
    Sint32 nsct;                        /* fBNgt@C̑傫 */
} GfdrFile;

#define GFDR_FILE_GFS(fp)       ((fp)->gfs)
#define GFDR_FILE_BUF(fp)       ((fp)->buf)
#define GFDR_FILE_RP(fp)        ((fp)->rp)
#define GFDR_FILE_AP(fp)        ((fp)->ap)
#define GFDR_FILE_NSCT(fp)      ((fp)->nsct)

/*****************************************************************************
 *      ϐ̐錾
 *****************************************************************************/

/*****************************************************************************
 *      ֐̐錾
 *****************************************************************************/

/* fBNgR[he[u쐬 */
GFS_LOCAL Sint32 gfdr_setupDirIdTbl(GfsHn gfs, GfsDirId *rectbl, Sint32 nrec);

/* fBNgR[he[u쐬 */
GFS_LOCAL Sint32 gfdr_setupDirNameTbl(GfsHn gfs, GfsDirName *rectbl, Sint32 nrec);

/* ȈՓ̓Xg[̏ */
GFS_LOCAL void gfdr_open(GfdrFile *fp, GfsHn gfs);

/* w肳ꂽoCgobt@ɓǂݍ */
GFS_LOCAL Sint32 gfdr_read(GfdrFile *fp, void *buf, Uint32 size);

/* 1 byteǂݍ */
GFS_LOCAL Uint8 gfdr_readByte(GfdrFile *fp, Sint32 *ec);

/* 2 byteǂݍ */
GFS_LOCAL Uint16 gfdr_readWord(GfdrFile *fp, Sint32 *ec);

/* NB^2 byteǂݍ */
GFS_LOCAL Uint16 gfdr_readWordNB(GfdrFile *fp, Sint32 *ec);

/* NB^4 byteǂݍ */
GFS_LOCAL Uint32 gfdr_readLongNB(GfdrFile *fp, Sint32 *ec);

/* NM^4 byteǂݍ */
GFS_LOCAL Uint32 gfdr_readLongNM(GfdrFile *fp, Sint32 *ec);

/* ̃fBNgR[hobt@ɋlߍ */
GFS_LOCAL Sint32 gfdr_setNextRec(GfdrFile *fp, Sint32 *ec);

/* CDfBNgGg̕Kvȏǂݍ */
GFS_LOCAL Sint32 gfdr_readDirEnt(GfdrFile *fp, XaDirEnt *dir);

/* CD̃fBNgݒ */
GFS_LOCAL void gfdr_setDirrecCd(CdcFile *rec, XaDirEnt *dir);

#if defined(DEBUG_LIB)
/* SIMMt@C̃fBNgݒ */
GFS_LOCAL void gfdr_setDirrecMem(CdcFile *rec, Sint32 fid, Sint32 len);

/* SCSIt@C̃fBNgݒ */
GFS_LOCAL void gfdr_setDirrecScsi(CdcFile *rec, Sint32 fid, Sint32 len);

/* t@CSCSIt@CT */
GFS_LOCAL Bool gfdr_getScsiFinfo(Sint8 *fname, Sint32 *fid, Sint32 *len);

/* w肳ꂽfidSCSIt@Co^Ă邩ׂ */
GFS_LOCAL Bool gfdr_findScsiFile(GfsDirId *rec, GfsDirId *recend, Sint32 fid);

/* t@CŁit@CjfBNgR[he[u猟 */
GFS_LOCAL GfsDirName *gfdr_findFile(GfsDirName *rectbl, Sint32 n_dirent,
                                 Sint8 *fname);

/* t@CRSVrbgSNA */
GFS_LOCAL void gfdr_clearMemRsv(Sint32 n_memfile);
#endif


/*****************************************************************************
 *      ϐ̒`
 *****************************************************************************/

/*****************************************************************************
 *      ֐̒`
 *****************************************************************************/

/*****************************************************************************
 *  fBNge[uǂݍ
 *ḿn
 *  gfs         fBNgt@C̃nh
 *  dirtbl      fBNgݒ̈
 *  nsct        fBNgt@C̑傫iPʁFZN^j
 *món
 *  
 *m֐ln
 *  ǂݍ񂾃fBNg
 *m@\n
 *  
 *mln
 *  gfs == NULL ̂ƂACD̓fBNg擾ȂB
 *****************************************************************************/
Sint32 GFDR_SetupDirTbl(GfsHn gfs, GfsDirTbl *dirtbl, Sint32 nsct)
{
    Sint32      ndir, atr, ec;

#if !defined(DEBUG_LIB)
    if (gfs != NULL) {
        GFS_GetFileInfo(gfs, NULL, NULL, NULL, &atr);
        if ((atr & GFS_ATR_DIR) == 0) {
            return GFS_ERR_DIR;
        }
        ec = GFS_NwCdRead(gfs, nsct);
        if (ec != GFS_ERR_OK) {
            return ec;
        }
    }
#endif
    if (GFS_DIRTBL_TYPE(dirtbl) == GFS_DIR_ID) {
        ndir = gfdr_setupDirIdTbl(gfs, GFS_DIRTBL_DIRID(dirtbl),
                                  GFS_DIRTBL_NDIR(dirtbl));
    } else {
        ndir = gfdr_setupDirNameTbl(gfs, GFS_DIRTBL_DIRNAME(dirtbl),
                                    GFS_DIRTBL_NDIR(dirtbl));
    }
    return ndir;
}



/*****************************************************************************
 * t@Ct@Cʎq擾 
 *ḿn
 *  
 *món
 *  
 *m֐ln
 *  t@Cʎq
 *m@\n
 *  
 *mln
 *  
 *****************************************************************************/
Sint32 GFDR_NameToId(GfsDirName *rectbl, Sint8 *fname, Sint32 max)
{
    Sint32      i;

    for (i = 0; i < max; ++i, ++rectbl) {
        if (XSTRNCMP(fname, GFS_DIR_FNAME(rectbl), GFS_FNAME_LEN) == 0) {
            return i;
        }
        if (GFS_DIR_ATR(rectbl) & GFS_ATR_END_TBL) {
            break;
        }
    }
    return -1;
}


/* fBNgR[he[ȕ擾 */
GfsDirId *GFDR_GetInfoDirId(Sint32 fid, GfsDirId *rectbl)
{
    return &rectbl[fid];
}


/* fBNgR[he[ȕ擾 */
GfsDirName *GFDR_GetInfoDirName(Sint32 fid, GfsDirName *rectbl)
{
    return &rectbl[fid];
}


/* t@C̑擾 */
Sint32 GFDR_GetAtrDirId(Sint32 fid, GfsDirId *rectbl)
{
    return GFS_DIR_ATR(&rectbl[fid]);
}


/* t@C擾 */
Sint32 GFDR_GetAtrDirName(Sint32 fid, GfsDirName *rectbl)
{
    return GFS_DIR_ATR(&rectbl[fid]);
}


/*****************************************************************************
 *  CDBFSŃ[gfBNgɈړ
 *ḿn
 *  
 *món
 *  
 *m֐ln
 *  fBNǧԂBG[Ȃ-1ԂB
 *m@\n
 *  CDubÑJgfBNg[gfBNgɕύX
 *mln
 *  IɃfBNgړ͏IĂBAB
 *****************************************************************************/
Sint32 GFDR_ChgRoot(void)
{
    return GFDR_ChgDir(CDC_NUL_FID);
}


/*****************************************************************************
 *  CDBFSŃJgfBNgύX
 *ḿn
 *  
 *món
 *  
 *m֐ln
 *  fBNǧԂBG[Ȃ畉̃G[R[hԂB
 *m@\n
 *  
 *mln
 *  IɃfBNgړ͏IĂBAB
 *****************************************************************************/
Sint32 GFDR_ChgDir(Sint32 fid)
{
    Sint32 err, ndir;

    /* ChgDirs */
    GFCD_SetTimer(GFCD_TMOUT_COUNT);
    do {
        err = GFCD_ChgDir(fid, GFCD_SYS_SEL, &ndir);
        if (err == GFCD_ERR_INUSE) {
            return GFS_ERR_CDBFS;       /* CDBFSgp錾ĂȂ */
        }
        err = GFCD_ExecServer();
        if (err == GFCD_ERR_TMOUT) {
            return GFS_ERR_TMOUT;
        } else if (err == GFCD_ERR_FATAL) {
            return GFS_ERR_FATAL;
        }
    } while (err != GFCD_ERR_OK);
    /* ChgDiȑ҂ */
    err = GFCD_WaitServer();
    if (err == GFCD_ERR_FATAL) {
        return GFS_ERR_FATAL;
    } else if (err != GFCD_SVR_COMPLETED) {
        return GFS_ERR_CDRD;
    }
    return ndir;                        /* CDBFSێĂ鐔 */
}

/*---------------------------------------------------------------------------
 * J֐
 *---------------------------------------------------------------------------*/


/* fBNgR[he[u쐬 */
GFS_LOCAL Sint32 gfdr_setupDirIdTbl(GfsHn gfs, GfsDirId *rectbl, Sint32 nrec)
{
    GfsDirId    *r = rectbl;
    Sint32      n_dirent, ec;
    GfdrFile    fp;
    XaDirEnt    dir_ent;    /* ڂĂfBNgGg */
#if defined(DEBUG_LIB)
    Sint32      n_memfile = GFMC_GetNumFile();
    Sint32      i, n_scsifile;
    Uint8       *dummy1;
    Sint32      dummy2, len;
    GfsdInfo    info;
#endif

#if defined(DEBUG_LIB)
    for (i = 0; i < n_memfile; ++i) {
        GFMC_SetRsv(i, 0);
    }
#endif
    gfdr_open(&fp, gfs);
    for (n_dirent = 0; nrec > 0; ++r, ++n_dirent, --nrec) {
        ec = gfdr_readDirEnt(&fp, &dir_ent);
        if (ec != GFS_ERR_OK) {
            return ec;
        }
        /* fBNgR[h̖`FbN */
        if (XA_DIR_RSIZE(&dir_ent) == 0) {  /* fBNgR[h̑傫 */
            break;
        }
#if defined(DEBUG_LIB)
        /* t@Cɑ݂邩 */
        for (i = 0; i < n_memfile; ++i) {
            if (XSTRNCPY(XA_DIR_FNAME(&dir_ent), GFMC_GetFname(i),
                        GFS_FNAME_LEN) == 0) {
                GFMC_GetFileInfo(i, (void **)&dummy1, &len, &dummy2);
                gfdr_setDirrecMem(&GFS_DIR_DIRREC(r), i, len);
                break;
            }
        }
        if (i == n_memfile) {
            /* ̃t@C݂͑Ȃ */
            if (gfdr_getScsiFinfo(XA_DIR_FNAME(&dir_ent), &i, &len) == TRUE) {
                gfdr_setDirrecScsi(&GFS_DIR_DIRREC(r), i, len);
            } else {
                /* SCSIt@C݂Ȃ */
#endif
                gfdr_setDirrecCd(&GFS_DIR_DIRREC(r), &dir_ent);
#if defined(DEBUG_LIB)
            }
        }
#endif
    }
#if defined(DEBUG_LIB)
    /* t@C̖o^R[ho^ */
    for (i = 0; (i < n_memfile)&&(nrec > 0); ++i) {
        if (GFMC_GetRsv(i) != MF_OVW) {
            --nrec;
            GFMC_GetFileInfo(i, (void **)&dummy1, &len, &dummy2);
            gfdr_setDirrecMem(&GFS_DIR_DIRREC(r), i, len);
            ++r;
            ++n_dirent;
        }
    }
    gfdr_clearMemRsv(n_memfile);
    if (MNG_SCSICON(gfs_mng_ptr)) {
        /* o^SCSIt@CR[ho^ */
        GFSD_GetFileNum(&n_scsifile);
        for (i = 0; (i < n_scsifile)&&(nrec > 0); ++i) {
            if (gfdr_findScsiFile(rectbl, r, i) != TRUE) {
                GFSD_GetFileInfo(i, &info);
                gfdr_setDirrecScsi(&GFS_DIR_DIRREC(r), i, GFSD_INFO_LENGTH(&info));
            }
            ++r;
            ++n_dirent;
        }
    }
#endif
    --r;
    GFS_DIR_ATR(r) |= GFS_ATR_END_TBL;
    return n_dirent;
}


/* fBNgR[he[u쐬 */
GFS_LOCAL Sint32 gfdr_setupDirNameTbl(GfsHn gfs, GfsDirName *rectbl, Sint32 nrec)
{
    GfsDirName  *r = rectbl;
    Sint32      n_dirent, ec;
    GfdrFile   fp;
    XaDirEnt    dir_ent;    /* ڂĂfBNgGg */
#if defined(DEBUG_LIB)
    Sint32      n_memfile;
    Uint8       *dummy1;
    Sint32      dummy2, len, i, n_scsifile, n_new_scsi, n_new_memf;
    GfsdInfo    info;
#endif

    /* CD̃fBNgR[hǂݍ */
    gfdr_open(&fp, gfs);
    for (n_dirent = 0; nrec > 0; ++r, ++n_dirent, --nrec) {
        ec = gfdr_readDirEnt(&fp, &dir_ent);
        if (ec != GFS_ERR_OK) {
            return ec;
        }
        /* fBNgR[h̖`FbN */
        if (XA_DIR_RSIZE(&dir_ent) == 0) {  /* fBNgR[h̑傫 */
            break;
        }
        /* Õt@CƓȂfBNgR[ĥĂ */
        if ((n_dirent > 2)&&
            (XSTRNCMP(GFS_DIR_FNAME(&r[-1]), XA_DIR_FNAME(&dir_ent), 
                                                GFS_FNAME_LEN) == 0)) {
            continue;
        }
        gfdr_setDirrecCd(&GFS_DIR_DIRREC(r), &dir_ent);
        XSTRNCPY(GFS_DIR_FNAME(r), XA_DIR_FNAME(&dir_ent), GFS_FNAME_LEN);
    }
#if defined(DEBUG_LIB)
    if (MNG_SCSICON(gfs_mng_ptr)) {
        /* SCSIt@C̃fBNgR[h㏑ */
        GFSD_GetFileNum(&n_scsifile);
        n_new_scsi = 0;
        for (i = 0; (i < n_scsifile)&&(n_new_scsi < nrec); ++i) {
            GFSD_GetFileInfo(i, &info);
            r = gfdr_findFile(rectbl, n_dirent, GFSD_INFO_FNAME(&info));
            if (r == NULL) {
                /* ȂΖɒǉ */
                r = &rectbl[n_dirent + n_new_scsi];
                gfdr_setDirrecScsi(&GFS_DIR_DIRREC(r), i, GFSD_INFO_LENGTH(&info));
                XSTRNCPY(GFS_DIR_FNAME(r), GFSD_INFO_FNAME(&info), GFS_FNAME_LEN);
                ++n_new_scsi;
            } else {
                gfdr_setDirrecScsi(&GFS_DIR_DIRREC(r), i, GFSD_INFO_LENGTH(&info));
            }
        }
        n_dirent += n_new_scsi;
    }
    /* t@C̃fBNgR[h㏑ */
    n_memfile = GFMC_GetNumFile();
    n_new_memf = 0;
    /* t@C̖o^R[ho^ */
    for (i = 0; (i < n_memfile)&&(n_new_memf < nrec); ++i) {
        r = gfdr_findFile(rectbl, n_dirent, GFMC_GetFname(i));
        GFMC_GetFileInfo(i, (void **)&dummy1, &len, &dummy2);
        if (r == NULL) {
            /* ȂΖɒǉ */
            r = &rectbl[n_dirent + n_new_memf];
            gfdr_setDirrecMem(&GFS_DIR_DIRREC(r), i, len);
            XSTRNCPY(GFS_DIR_FNAME(r), GFMC_GetFname(i), GFS_FNAME_LEN);
            ++n_new_memf;
        } else {
            gfdr_setDirrecMem(&GFS_DIR_DIRREC(r), i, len);
        }
    }
    gfdr_clearMemRsv(n_memfile);
    n_dirent += n_new_memf;
    r = &rectbl[n_dirent];
#endif
    --r;
    GFS_DIR_ATR(r) |= GFS_ATR_END_TBL;
    return n_dirent;
}


/* ȈՓ̓Xg[̏ */
GFS_LOCAL void gfdr_open(GfdrFile *fp, GfsHn gfs)
{
    GfsFinfo    *finfo = &GFS_FLW_FINFO(&GFS_FILE_FLOW(gfs));

    GFDR_FILE_GFS(fp) = gfs;
    GFDR_FILE_BUF(fp) = MNG_SECTBUF(gfs_mng_ptr);
    GFDR_FILE_RP(fp) = GFDR_FILE_UNREAD;
    GFDR_FILE_NSCT(fp) = GFS_FI_NSCT(finfo);
    GFDR_FILE_AP(fp) = 0;
}


/* w肳ꂽoCgobt@ɓǂݍ */
/* G[R[hԂ */
GFS_LOCAL Sint32 gfdr_read(GfdrFile *fp, void *buf, Uint32 size)
{
    Sint32  i, ret;

    /* t@C炾ǂގ */
    if (GFDR_FILE_GFS(fp) == NULL) {
        memset(buf, 0, size);
        return GFS_ERR_OK;
    }
    if ((GFDR_FILE_RP(fp) == GFDR_FILE_UNREAD) ||
        (GFDR_FILE_RP(fp) >= SECT_BUF_SIZ)) {
        ret = GFS_Fread(GFDR_FILE_GFS(fp), 1, GFDR_FILE_BUF(fp), SECT_BUF_SIZ);
        if (ret != SECT_BUF_SIZ) {
            if (ret < GFS_ERR_OK) {
                return ret;
            }
            return GFS_ERR_CDRD;
        }
        GFDR_FILE_RP(fp) = 0;
    }
    /* ǂݍރf[^̂obt@ɂ̂̑傫 */
    i = SECT_BUF_SIZ - GFDR_FILE_RP(fp);
    i = MIN(i, size);
    memcpy(buf, GFDR_FILE_BUF(fp) + GFDR_FILE_RP(fp), i);
    GFDR_FILE_RP(fp) += i;
    if (i < size) {
        size -= i;
        ret = GFS_Fread(GFDR_FILE_GFS(fp), 1, GFDR_FILE_BUF(fp), SECT_BUF_SIZ);
        if (ret != SECT_BUF_SIZ) {
            if (ret < GFS_ERR_OK) {
                return ret;
            }
            return GFS_ERR_CDRD;
        }
        memcpy((Uint8 *)buf + i, GFDR_FILE_BUF(fp), size);
        GFDR_FILE_RP(fp) = size;
    }
    return GFS_ERR_OK;
}


/* 1 byteǂݍ */
GFS_LOCAL Uint8 gfdr_readByte(GfdrFile *fp, Sint32 *ec)
{
    Uint8   tmp;

    *ec = gfdr_read(fp, &tmp, sizeof(tmp));
    return tmp;
}


/* 2 byteǂݍ */
GFS_LOCAL Uint16 gfdr_readWord(GfdrFile *fp, Sint32 *ec)
{
    Uint16  tmp;

    *ec = gfdr_read(fp, &tmp, sizeof(tmp));
    return tmp;
}


/* NB^2 byteǂݍ */
GFS_LOCAL Uint16 gfdr_readWordNB(GfdrFile *fp, Sint32 *ec)
{
    Uint16  tmp, dummy;

    /* LSBF\L̓ǂݎ̂ */
    *ec = gfdr_read(fp, &dummy, sizeof(dummy));
    if (*ec != GFS_ERR_OK) {
        return 0;
    }
    /* MSBF\L̓ǂݍ */
    *ec = gfdr_read(fp, &tmp, sizeof(tmp));
    if (*ec != GFS_ERR_OK) {
        return 0;
    }
    return tmp;
}


/* NB^4 byteǂݍ */
GFS_LOCAL Uint32 gfdr_readLongNB(GfdrFile *fp, Sint32 *ec)
{
    Uint32  tmp, dummy;

    /* LSBF\L̓ǂݎ̂ */
    *ec = gfdr_read(fp, &dummy, sizeof(dummy));
    if (*ec != GFS_ERR_OK) {
        return 0;
    }
    /* MSBF\L̓ǂݍ */
    *ec = gfdr_read(fp, &tmp, sizeof(tmp));
    if (*ec != GFS_ERR_OK) {
        return 0;
    }
    return tmp;
}


/* NM^4 byteǂݍ */
GFS_LOCAL Uint32 gfdr_readLongNM(GfdrFile *fp, Sint32 *ec)
{
    Uint32  tmp;

    *ec = gfdr_read(fp, &tmp, sizeof(tmp));
    return tmp;
}


/* ̃fBNgR[hobt@ɋlߍ */
GFS_LOCAL Sint32 gfdr_setNextRec(GfdrFile *fp, Sint32 *ec)
{
    Sint32 rsize, ret;

    rsize = gfdr_readByte(fp, ec);
    if (*ec != GFS_ERR_OK) {
        return 0;
    }
    if (rsize != 0) {
        return rsize;
    }

    /* ǂݍ߂Ȃꍇ */
    ++GFDR_FILE_AP(fp);
    if (GFDR_FILE_AP(fp) >= GFDR_FILE_NSCT(fp)) {
        return rsize;
    }
    ret = GFS_Fread(GFDR_FILE_GFS(fp), 1, GFDR_FILE_BUF(fp), SECT_BUF_SIZ);
    if (ret != SECT_BUF_SIZ) {
        if (ret > 0) {
            *ec = GFS_ERR_CDRD;
        } else {
            *ec = ret;
        }
        return 0;
    }
    GFDR_FILE_RP(fp) = 0;
    rsize = gfdr_readByte(fp, ec);
    if (*ec != GFS_ERR_OK) {
        return 0;
    }
    return rsize;
}


/* CDfBNgGg̕Kvȏǂݍ */
GFS_LOCAL Sint32 gfdr_readDirEnt(GfdrFile *fp, XaDirEnt *dir)
{
    Sint32      ec, i, rdsz, fn_err = FALSE;
    Uint8       fn_len, file_flg;
    Sint8       ch, *fn_buf, *ext_pos;

    if (GFDR_FILE_GFS(fp) == NULL) {
        XA_DIR_RSIZE(dir) = 0;
        return GFS_ERR_OK;
    }
    XA_DIR_RSIZE(dir) = gfdr_setNextRec(fp, &ec);
    if (ec != GFS_ERR_OK) {
        return ec;
    }
    if (XA_DIR_RSIZE(dir) == 0) {
        return GFS_ERR_OK;
    }
    gfdr_readByte(fp, &ec);             /* gR[hǂݎ̂ */
    if (ec != GFS_ERR_OK) {
        return ec;
    }
    XA_DIR_POS(dir) = LSN2FAD(gfdr_readLongNB(fp, &ec));
    if (ec != GFS_ERR_OK) {
        return ec;
    }
    XA_DIR_LEN(dir) = gfdr_readLongNB(fp, &ec);
    if (ec != GFS_ERR_OK) {
        return ec;
    }
    /* tf[^ǂݎ̂ */
    for (i =0; i < RECORDING_DATE_LEN; ++i) {
        gfdr_readByte(fp, &ec);
        if (ec != GFS_ERR_OK) {
            return ec;
        }
    }
    file_flg = gfdr_readByte(fp, &ec);
    if (ec != GFS_ERR_OK) {
        return ec;
    }
    XA_DIR_USIZE(dir) = gfdr_readByte(fp, &ec); /* File Unit Size */
    if (ec != GFS_ERR_OK) {
        return ec;
    }
    XA_DIR_GSIZE(dir) = gfdr_readByte(fp, &ec); /* interleave gap size */
    if (ec != GFS_ERR_OK) {
        return ec;
    }
    gfdr_readWordNB(fp, &ec);           /* {[ԍǂݎ̂ */
    if (ec != GFS_ERR_OK) {
        return ec;
    }
    fn_len = gfdr_readByte(fp, &ec);
    if (ec != GFS_ERR_OK) {
        return ec;
    }
    /* ܂ŌŒ蒷 */
    rdsz = 33 + fn_len;
    fn_buf = XA_DIR_FNAME(dir);
    i = 0;
    while (i < MIN(GFDR_BASE_MAX, fn_len)) {
        /* t@C */
        ch = gfdr_readByte(fp, &ec), ++i;
        if (ec != GFS_ERR_OK) {
            return ec;
        }
        if (ch == ';') {
            break;
        }
        *fn_buf++ = ch;
        if (ch == '.') {
            ext_pos = fn_buf;           /* gq̊Jnʒuۑ */
            break;
        }
    }
    if (ch == ';') {
        /* gqȂAo[Wԍǂݎ̂ */
        while (i < fn_len) {
            gfdr_readByte(fp, &ec), ++i;
            if (ec != GFS_ERR_OK) {
                return ec;
            }
        }
    } else if (ch != '.') {
        /* ߂t@Cǂݎ̂ */
        while (i < fn_len) {
            ch = gfdr_readByte(fp, &ec), ++i;
            if (ec != GFS_ERR_OK) {
                return ec;
            }
            if (ch == '.') {
                *fn_buf++ = ch;
                ext_pos = fn_buf;       /* gq̊Jnʒuۑ */
                break;
            }
            fn_err = TRUE;
        }
    }
    while (i < fn_len) {
        /* gq */
        ch = gfdr_readByte(fp, &ec), ++i;
        if (ec != GFS_ERR_OK) {
            return ec;
        }
        if (ch == ';') {
            /* o[Wԍǂݎ̂ */
            while (i < fn_len) {
                gfdr_readByte(fp, &ec), ++i;
                if (ec != GFS_ERR_OK) {
                    return ec;
                }
            }
            break;
        }
        if (fn_buf - ext_pos > GFDR_EXT_MAX) {
            fn_err = TRUE;
            continue;
        }
        if (fn_buf - XA_DIR_FNAME(dir) < GFS_FNAME_LEN) {
            *fn_buf++ = ch;
        }
    }
    if (fn_buf - XA_DIR_FNAME(dir) < GFS_FNAME_LEN) {
        *fn_buf = '\0';
    }
    /* lߍ݂OXLbv */
    if (NEEDS_PADDING(fn_len)) {
        gfdr_readByte(fp, &ec);
        if (ec != GFS_ERR_OK) {
            return ec;
        }
        ++rdsz;
    }
    /* ȃt@C̕ϊ */
    if (XA_DIR_FNAME(dir)[0] == GFDR_CURRENT_DIR_ID) {
        XSTRCPY(XA_DIR_FNAME(dir), ".");
    } else if (XA_DIR_FNAME(dir)[0] == GFDR_PARENT_DIR_ID) {
        XSTRCPY(XA_DIR_FNAME(dir), "..");
    }
    /* VXe񂪂Γǂ */
    if (rdsz < XA_DIR_RSIZE(dir)) {
        gfdr_readLongNM(fp, &ec);       /* skip Owner ID */
        if (ec != GFS_ERR_OK) {
            return ec;
        }
        XA_DIR_ATR(dir) = gfdr_readByte(fp, &ec) &
            (GFS_ATR_DIR|GFS_ATR_CDDA|GFS_ATR_INTLV|
             GFS_ATR_FORM2|GFS_ATR_FORM1);
        if (ec != GFS_ERR_OK) {
            return ec;
        }
        gfdr_readByte(fp, &ec);         /* ʂPoCgǂݎ̂ */
        if (ec != GFS_ERR_OK) {
            return ec;
        }
        gfdr_readWord(fp, &ec);         /* "XA"ǂ */
        if (ec != GFS_ERR_OK) {
            return ec;
        }
        XA_DIR_FN(dir) = gfdr_readByte(fp, &ec);
        if (ec != GFS_ERR_OK) {
            return ec;
        }
        /* c̃fBNgR[hǂݎ̂ */
        for (i = rdsz + 9; i < XA_DIR_RSIZE(dir); ++i) {
            gfdr_readByte(fp, &ec);
            if (ec != GFS_ERR_OK) {
                return ec;
            }
        }
    } else {
        /* VXe񂪂ȂȂ */
        /* t@CtOăfBNgf */
        XA_DIR_ATR(dir) = (file_flg & 2)? XA_ATR_DIR: 0;
        XA_DIR_FN(dir) = 0;             /* t@CԍȂ */
    }
    return GFS_ERR_OK;
}


/* CD̃fBNgݒ */
GFS_LOCAL void gfdr_setDirrecCd(CdcFile *rec, XaDirEnt *dir)
{
    CDC_FILE_FAD(rec) = XA_DIR_POS(dir);
    CDC_FILE_SIZE(rec) = XA_DIR_LEN(dir);
    CDC_FILE_FN(rec) = XA_DIR_FN(dir);
    CDC_FILE_ATR(rec) = XA_DIR_ATR(dir);
    CDC_FILE_UNIT(rec) = XA_DIR_USIZE(dir);
    CDC_FILE_GAP(rec) = XA_DIR_GSIZE(dir);
}


#if defined(DEBUG_LIB)
/* SIMMt@C̃fBNgݒ */
GFS_LOCAL void gfdr_setDirrecMem(CdcFile *rec, Sint32 fid, Sint32 len)
{
    CDC_FILE_FAD(rec) = fid;
    CDC_FILE_SIZE(rec) = len;
    CDC_FILE_FN(rec) = 0;
    CDC_FILE_ATR(rec) = GFS_ATR_MEM_FILE;
    CDC_FILE_UNIT(rec) = 0;
    CDC_FILE_GAP(rec) = 0;
    GFMC_SetRsv(fid, MF_OVW);
}


/* SCSIt@C̃fBNgݒ */
GFS_LOCAL void gfdr_setDirrecScsi(CdcFile *rec, Sint32 fid, Sint32 len)
{
    CDC_FILE_FAD(rec) = fid;
    CDC_FILE_SIZE(rec) = len;
    CDC_FILE_FN(rec) = 0;
    CDC_FILE_ATR(rec) = GFS_ATR_SCSI_FILE;
    CDC_FILE_UNIT(rec) = 0;
    CDC_FILE_GAP(rec) = 0;
}


/* t@CSCSIt@CT */
GFS_LOCAL Bool gfdr_getScsiFinfo(Sint8 *fname, Sint32 *fid, Sint32 *len)
{
    Sint32      i, n_scsi_file;
    GfsdInfo    info;

    if (MNG_SCSICON(gfs_mng_ptr)) {
        GFSD_GetFileNum(&n_scsi_file);
        for (i = 0; i < n_scsi_file; ++i) {
            GFSD_GetFileInfo(i, &info);
            if (XSTRNCMP(fname, GFSD_INFO_FNAME(&info), GFS_FNAME_LEN) == 0) {
                *fid = i;
                *len = GFSD_INFO_LENGTH(&info);
                return TRUE;
            }
        }
    }
    return FALSE;
}


/* w肳ꂽfidSCSIt@Co^Ă邩ׂ */
GFS_LOCAL Bool gfdr_findScsiFile(GfsDirId *rec, GfsDirId *recend, Sint32 fid)
{
    while (rec < recend) {
        if ((GFS_DIR_ATR(rec) == GFS_ATR_SCSI_FILE)&&
            (GFS_DIR_FAD(rec) == fid)) {
            return TRUE;
        }
        ++rec;
    }
    return FALSE;
}


/* t@CŁit@CjfBNgR[he[u猟 */
GFS_LOCAL GfsDirName *gfdr_findFile(GfsDirName *rectbl, Sint32 n_dirent,
                                 Sint8 *fname)
{
    Sint32      i;

    for (i = 0; i < n_dirent; ++i) {
        if (XSTRNCMP(GFS_DIR_FNAME(rectbl), fname, GFS_FNAME_LEN) == 0) {
            return rectbl;
        }
        ++rectbl;
    }
    return NULL;
}


/* t@CRSVrbgSNA */
GFS_LOCAL void gfdr_clearMemRsv(Sint32 n_memfile)
{
    Sint32 i;

    for (i = 0; i < n_memfile; ++i) {
        GFMC_SetRsv(i, 0);
    }
}

#endif /* defined(DEBUG_LIB) */

/* end of file */
