/*****************************************************************************
 *      \tgEFACu
 *
 *      Copyright (c) 1994,1995,1996 SEGA
 *
 * Library:t@CVXe
 * Module :SIMMt@CǗ
 * File   :gfs_mmc.c
 * Date   :1996-02-01
 * Version:2.10
 * Author :H.T.
 *
 *****************************************************************************/
/* SGL̏ꍇRpCIvVɂ`邱
 * #define USE_SGL
 */

/*****************************************************************************
 *      CN[ht@C
 *****************************************************************************/
#include    "sega_gfs.h"
#include    "gfs_def.h"
#include    "gfs_mmc.h"

/*****************************************************************************
 *      萔}N
 *****************************************************************************/
#define GFMC_FNAME_LEN  12              /* t@Cő咷 */

/*****************************************************************************
 *      񋓒萔
 *****************************************************************************/

/*****************************************************************************
 *      }N
 *****************************************************************************/

/* t@Cwb_     */
typedef struct {
    Uint32      fblksiz;                /* ̃t@Cwb_܂ł̃oCg */
    Sint8       fname[GFMC_FNAME_LEN];  /* t@C                       */
    Sint16      version;                /* o[W                       */
    Sint16      ftype;                  /* t@C^Cv                   */
    Sint32      filesiz;                /* TCY                           */
    Uint32      datetime;               /* XV                         */
    Sint16      sctsiz;                 /* ZN^TCY                     */
    Sint16      rsv;                    /* \                             */
} MmcHeader;

#define MMCH_FBLKSIZ(mmch)      DWORD(&((mmch)->fblksiz))
#define MMCH_FNAME(mmch)        ((mmch)->fname)
#define MMCH_VERSION(mmch)      ((mmch)->version)
#define MMCH_FTYPE(mmch)        ((mmch)->ftype)
#define MMCH_FILESIZ(mmch)      ((mmch)->filesiz)
#define MMCH_DATETIME(mmch)     ((mmch)->datetime)
#define MMCH_SCTSIZ(mmch)       ((mmch)->sctsiz)
#define MMCH_RSV(mmch)          ((mmch)->rsv)

#define DWORD(x)    (*((Uint32 *)(x)))
#define WORD(x)     (*((Uint16 *)(x)))

/*****************************************************************************
 *      f[^^̒`
 *****************************************************************************/

/*****************************************************************************
 *      ϐ̐錾
 *****************************************************************************/

/*****************************************************************************
 *      ֐̐錾
 *****************************************************************************/
/*  SIMMt@Cwb_̃AhX擾 */
GFS_LOCAL MmcHeader *gfmc_getHeaderAddr(Sint32 fid);

/*****************************************************************************
 *      ϐ̒`
 *****************************************************************************/

/*****************************************************************************
 *      ֐̒`
 *****************************************************************************/

/* SIMMt@CC[W̃[hAhX擾 */
void *GFMC_GetBase(void)
{
    return (void *)GFMC_base;
}



/*****************************************************************************
 *  SIMMt@C擾
 *ḿn
 *  fid         t@Cʎq
 *món
 *  area        t@Cf[^̃AhX
 *  size        t@CTCY
 *  sct_siz     ZN^TCY
 *m֐ln
 *  
 *m@\n
 *  
 *mln
 *  
 *****************************************************************************/
void GFMC_GetFileInfo(Sint32 fid, void **area, Sint32 *size, Sint32 *sct_siz)
{
    MmcHeader   *hp;
    void        *a;
    Sint32      fsize;
    Sint32      ssize;

    hp = gfmc_getHeaderAddr(fid);
    if (hp == NULL) {                           /* Ȃꍇ */
        a = NULL;
        fsize = ssize = 0;
    } else {                                    /* ꍇ */
        a = (Sint8 *)(hp + 1);
        fsize = DWORD(&(MMCH_FILESIZ(hp)));
        ssize = WORD(&(MMCH_SCTSIZ(hp)));
    }
    if (area != NULL) {
        *area = a;
    }
    if (size != NULL) {
        *size = fsize;
    }
    if (sct_siz != NULL) {
        *sct_siz = ssize;
    }
}


/* SIMMt@C̐擾 */
Sint32 GFMC_GetNumFile(void)
{
    Sint8   *bp;
    Uint32  blksiz;
    Uint32  i;

    bp = GFMC_GetBase();
    if (bp == NULL) {
        return 0;
    }
    for (i = 0; (blksiz = MMCH_FBLKSIZ((MmcHeader *)bp)) != 0L; i++) {
        bp += blksiz;
    }
    return i;
}


/* SIMMt@C擾 */
Sint8 *GFMC_GetFname(Sint32 fid)
{
    MmcHeader   *hp;

    hp = gfmc_getHeaderAddr(fid);
    if (hp == NULL) {
        return NULL;
    } else {
        return MMCH_FNAME(hp);
    }
}


/* U[üݒ肷 */
void GFMC_SetRsv(Sint32 fid, Sint16 rsv)
{
    MmcHeader   *hp;
    
    hp = gfmc_getHeaderAddr(fid);
    if (hp != NULL) {
        MMCH_RSV(hp) = rsv;
    }
}


/* U[ü擾 */
Sint16 GFMC_GetRsv(Sint32 fid)
{
    MmcHeader   *hp;
    
    hp = gfmc_getHeaderAddr(fid);
    if (hp != NULL) {
        return MMCH_RSV(hp);
    } else {
        return MMC_ERROR;
    }
}


/*****************************************************************************
 *  SIMMt@Cwb_̃AhX擾
 *ḿn
 *  fid         t@Cʎq
 *món
 *  
 *m֐ln
 *  t@Cwb_̃AhX
 *m@\n
 *  
 *mln
 *  
 *****************************************************************************/
GFS_LOCAL MmcHeader *gfmc_getHeaderAddr(Sint32 fid)
{
    Sint8       *bp;
    Uint32      blksiz;
    Sint32      i;
    MmcHeader   *hp;

    bp = (Sint8 *)GFMC_GetBase();
    if (bp == NULL) {
        return NULL;
    }
    for (i = 0; i < fid; i++) {
        hp = (MmcHeader *)bp;
        blksiz = MMCH_FBLKSIZ(hp);
        if (blksiz == 0L) {                 /* Ȃꍇ */
            return NULL;
        }
        bp += blksiz;
    }
    return (MmcHeader *)bp;
}

/* end of file */
