/*-----------------------------------------------------------------------------
 *  FILE: sega_dma.h
 *
 *      Copyright(c) 1994 SEGA.
 *
 *  PURPOSE:
 *
 *      DMACuwb_t@CB
 *
 *  DESCRIPTION:
 *
 *  AUTHOR(S)
 *
 *      1994-08-31  N.T Ver.1.01
 *
 *  MOD HISTORY:
 *
 *      1994-10-12  N.T Ver.1.05
 *      1995-11-14  H.O Ver.1.05a
 *         1)}NDMA_CPU_DREQ폜
 *
 *-----------------------------------------------------------------------------
 */

#ifndef SEGA_DMA_H
#define SEGA_DMA_H

/*
 * C VIRTUAL TYPES DEFINITIONS
 */
#include "sega_xpt.h"

/*****************************************************************************/
/* DMA_CPU0.H ****************************************************************/
/*****************************************************************************/
/*
 * GLOBAL DEFINES/MACROS DEFINES
 */

/* 萔 */
/**** DMAWX^rbgʒu **************************************************/
/******** `lRg[WX^ ***************************************/
#define DMA_CHCR_DE     0               /* DMACl[urbg               */
#define DMA_CHCR_TE     1               /* gXt@GhtOrbg    */
#define DMA_CHCR_IE     2               /* C^vgCl[urbg      */
#define DMA_CHCR_TA     3               /* gXt@AhX[hrbg  */
#define DMA_CHCR_TB     4               /* gXt@oX[hrbg      */
#define DMA_CHCR_DL     5               /* DREQxrbg@@              */
#define DMA_CHCR_DS     6               /* DREQZNgrbg                */
#define DMA_CHCR_AL     7               /* ANmbWxrbg          */
#define DMA_CHCR_AM     8               /* د/ݽ̧Ӱޯ            */
#define DMA_CHCR_AR     9               /* I[gNGXgrbg            */
#define DMA_CHCR_TS     10              /* gXt@TCYrbg          */
#define DMA_CHCR_SM     12              /* \[XAhX[hrbg        */
#define DMA_CHCR_DM     14              /* ިèȰݱڽӰޯ          */
/******** DMAIy[VWX^ ******************************************/
#define DMA_DMAOR_DME   0               /* DMA}X^Cl[urbg         */
#define DMA_DMAOR_NMIF  1               /* NMItOrbg                   */
#define DMA_DMAOR_AE    2               /* AhXG[tOrbg        */
#define DMA_DMAOR_PR    3               /* vCIeB[hrbg        */

/*****************************************************************************/
/**** DMA`l ************************************************************/
/*****************************************************************************/
#define DMA_CPU_CH0 0                           /* `l0                 */
#define DMA_CPU_CH1 1                           /* `l1                 */

/*****************************************************************************/
/**** (DmaCpuComPrm)ʓ]p[^ ***************************************/
/*****************************************************************************/
/******** (pr)vCIeB[h  ******************************************/
#define DMA_CPU_FIX (0 << DMA_DMAOR_PR)         /* D揇ʂ͌Œ            */
#define DMA_CPU_ROR (1 << DMA_DMAOR_PR)         /* D揇ʂ̓Ehr- */
                                                /* ɂ                    */
/******** (dme)DMA}X^Cl[u *******************************************/
#define DMA_CPU_DIS     (0 << DMA_DMAOR_DME)    /* S`lDMA]֎~ */
#define DMA_CPU_ENA     (1 << DMA_DMAOR_DME)    /* S`lDMA] */
/******** (msk)}XNrbg **************************************************/
#define DMA_CPU_M_PR    (1 << 0)                /* vCIeB[h@@  */
#define DMA_CPU_M_AE    (1 << 1)                /* AhXG[tO@@  */
#define DMA_CPU_M_NMIF  (1 << 2)                /* NMItO           @@  */
#define DMA_CPU_M_DME   (1 << 3)                /* DMA}X^Cl[u @@  */

/*****************************************************************************/
/**** (DmaCpuPrm)]p[^ **********************************************/
/*****************************************************************************/
/******** (dm)fBXeBl[VAhX[hrbg ***********************/
/******** (sm)\[XAhX[hrbg *************************************/
#define DMA_CPU_AM_NOM  0x0                    /* Œ                      */
#define DMA_CPU_AM_ADD  0x1                    /*                       */
#define DMA_CPU_AM_SUB  0x2                    /*                       */
/******** (ts)gXt@TCY *********************************************/
#define DMA_CPU_1   (0 << DMA_CHCR_TS)          /* oCgP                */
#define DMA_CPU_2   (1 << DMA_CHCR_TS)          /* [h(2oCg)P       */
#define DMA_CPU_4   (2 << DMA_CHCR_TS)          /* O[h(4oCg)P */
#define DMA_CPU_16  (3 << DMA_CHCR_TS)          /* 16oCg]              */
/******** (ar)I[gNGXg[h *****************************************/
#define DMA_CPU_MOD     (0 << DMA_CHCR_AR)      /* W[NGXg      */
#define DMA_CPU_AUTO    (1 << DMA_CHCR_AR)      /* I[gNGXg          */
/******** (ie)C^vgCl[u *****************************************/
#define DMA_CPU_INT_ENA (1 << DMA_CHCR_IE)      /* 荞ݗv        */
#define DMA_CPU_INT_DIS (0 << DMA_CHCR_IE)      /* 荞ݗv֎~(l)*/
/******** (drcr)DMAv^I𐧌 ****************************************/
#if 0
#define DMA_CPU_DREQ    0x0                     /* DREQ(ONGXg)      */
/*
 *  DMAvɊONGXgw肷̂͋֎~('95-11/14 H.O)
 */
#endif
#define DMA_CPU_RXI     0x1                     /* RXI(SCI̎Mf[^-  */
                                                /* t荞ݓ]v)     */
#define DMA_CPU_TXI     0x2                     /* TXI(SCȊMf[^-  */
                                                /* GveB荞ݓ]v*/
/******** (msk)}XNrbg **************************************************/
#define DMA_CPU_M_SAR   (1 << 0)                /* DMA\[XAhX         */
#define DMA_CPU_M_DAR   (1 << 1)                /* DMAfBXeBl[V-  */
                                                /* AhX                  */
#define DMA_CPU_M_TCR   (1 << 2)                /* DMAgXt@JEg   */
#define DMA_CPU_M_DM    (1 << 3)                /* DMAfBXeBl[V-  */
                                                /* AhX[hrbg      */
#define DMA_CPU_M_SM    (1 << 4)                /* DMA\[XAhX[h-  */
                                                /* rbg                    */
#define DMA_CPU_M_TS    (1 << 5)                /* gXt@TCY        */
#define DMA_CPU_M_AR    (1 << 6)                /* I[gNGXg[h    */
#define DMA_CPU_M_IE    (1 << 7)                /* C^vgCl[u    */
#define DMA_CPU_M_DRCR  (1 << 8)                /* DMAv^I𐧌     */
#define DMA_CPU_M_TE    (1 << 9)                /* gXt@GhtO  */

/*****************************************************************************/
/**** (DmaCpuComStatus)ʃXe[^X ****************************************/
/*****************************************************************************/
/******** (ae)AhXG[tO *******************************************/
#define DMA_CPU_ADR_ERR     (1 << DMA_DMAOR_AE) /* DMACɂAhXG[- */
                                                /*                       */
#define DMA_CPU_ADR_NO_ERR  (0 << DMA_DMAOR_AE) /* DMACɂAhXG[- */
                                                /* Ȃ                      */
                                                
/******** (nmif)NMItO ****************************************************/
#define DMA_CPU_NMI_ON  (1 << DMA_DMAOR_NMIF)   /* NMI荞ݔ           */
#define DMA_CPU_NMI_OFF (0 << DMA_DMAOR_NMIF)   /* NMI荞݂Ȃ           */

/*****************************************************************************/
/**** (DmaCpuComStatus)ʃXe[^X ****************************************/
/*****************************************************************************/
#define DMA_CPU_TE_MV   (0 << DMA_CHCR_TE)      /* DMA]܂DMA]f*/
#define DMA_CPU_TE_SP   (1 << DMA_CHCR_TE)      /* DMA]I           */

/*
 * STRUCTURE DECLARATIONS
 */

/*
 * TYPEDEFS
 */
typedef struct {
    Uint32 pr;                                  /* vCIeB[h      */
    Uint32 dme;                                 /* DMA}X^Cl[u       */
    Uint32 msk;                                 /* }XNrbg              */
}DmaCpuComPrm;                                  /* ʓ]p[^        */

typedef struct {
    Uint32 sar;                                 /* DMA\[XAhX         */
    Uint32 dar;                                 /* DMAfBXeBl[V-  */
                                                /* AhX                  */
    Uint32 tcr;                                 /* DMAgXt@JEg   */
    Uint32 dm;                                  /* fBXeBl[VAh- */
                                                /* X[hrbg          */
    Uint32 sm;                                  /* \[XAhX[hrbg*/
    Uint32 ts;                                  /* gXt@TCY        */
    Uint32 ar;                                  /* I[gNGXg[h    */
    Uint32 ie;                                  /* C^vgCl[u    */
    Uint32 drcr;                                /* DMAv^I𐧌     */
    Uint32 msk;                                 /* }XNrbg              */
}DmaCpuPrm;                                     /* ]p[^            */

typedef struct {
    Uint32 ae;                                  /* AhXG[tO      */
    Uint32 nmif;                                /* NMItO                 */
}DmaCpuComStatus;                               /* ʃXe[^X            */

typedef Uint32 DmaCpuStatus;                    /* Xe[^X                */

/*
 * EXTERNAL VARIABLE DECLARATIONS
 */

/*
 * EXTERNAL FUNCTION PROTOTYPE  DECLARATIONS
 */
void DMA_CpuSetComPrm(DmaCpuComPrm *);          /* DMAʓ]p[^ݒ */
void DMA_CpuSetPrm(DmaCpuPrm *, Uint32);        /* DMA]p[^ݒ     */
void DMA_CpuStart(Uint32);                      /* DMA]Jn               */
void DMA_CpuStop(Uint32);                       /* DMA]~               */
void DMA_CpuAllStop(void);                      /* DMAS`l]~     */
void DMA_CpuGetComStatus(DmaCpuComStatus *);    /* DMAʃXe[^X擾     */
DmaCpuStatus DMA_CpuGetStatus(Uint32);          /* DMAXe[^X擾         */

/*****************************************************************************/
/* DMA_CPUM.H ****************************************************************/
/*****************************************************************************/
/*
 * GLOBAL DEFINES/MACROS DEFINES
 */

/* 萔 */
/**** f[^]I`FbN *************************************************/
#define DMA_CPU_END     0                       /* I                  */
#define DMA_CPU_FAIL    1                       /* ُI                  */
#define DMA_CPU_BUSY    2                       /* s                    */

/*
 * STRUCTURE DECLARATIONS
 */

/*
 * TYPEDEFS
 */

/*
 * EXTERNAL VARIABLE DECLARATIONS
 */

/*
 * EXTERNAL FUNCTION PROTOTYPE  DECLARATIONS
 */
void DMA_CpuMemCopy1(void *, void *, Uint32);   /* f[^](oCgP)    */
void DMA_CpuMemCopy2(void *, void *, Uint32);   /* f[^]([hP)    */
void DMA_CpuMemCopy4(void *, void *, Uint32);   /* f[^](O[h-  */
                                                /* P)                     */
void DMA_CpuMemCopy16(void *, void *, Uint32);  /* f[^](16oCgP)  */
Uint32 DMA_CpuResult(void);                     /* f[^]I`FbN    */

/*****************************************************************************/
/* DMA_SCU0.H ****************************************************************/
/*****************************************************************************/
/*
 * GLOBAL DEFINES/MACROS DEFINES
 */

/* 萔 */
/*****************************************************************************/
/**** DMA`l ************************************************************/
/*****************************************************************************/
#define DMA_SCU_CH0 0x0                         /* `l0                 */
#define DMA_SCU_CH1 0x1                         /* `l1                 */
#define DMA_SCU_CH2 0x2                         /* `l2                 */

/**** DMAWX^rbgʒu **************************************************/
/******** ZlWX^ *****************************************************/
#define DMA_DXAD_DXRAD  8                       /* ǂݍ݃AhXZl    */
#define DMA_DXAD_DXWAD  0                       /* ݃AhXZl    */
/******** DMAWX^ ****************************************************/
#define DMA_DXEN_DXGO   0                       /* DMANrbg             */
#define DMA_DXEN_DXEN   8                       /* DMArbg             */
/******** DMA[hAAhXXVANvWX^ **************************/
#define DMA_DXMD_DXMOD  24                      /* [hrbg              */
#define DMA_DXMD_DXRUP  16                      /* ǂݍ݃AhXXVrbg*/
#define DMA_DXMD_DXWUP   8                      /* oAhXXVrbg*/
#define DMA_DXMD_DXFT    0                      /* NvIrbg        */


/*****************************************************************************/
/**** (DmaScuPrm)]p[^ **********************************************/
/*****************************************************************************/
/******** (dxad_r)ǂݍ݃AhXZl *************************************/
#define DMA_SCU_R0  (0x0 << DMA_DXAD_DXRAD)     /* ZȂ                */
#define DMA_SCU_R4  (0x1 << DMA_DXAD_DXRAD)     /* 4oCgZ           */
/******** (dxad_w)݃AhXZl *************************************/
#define DMA_SCU_W0     (0x0 << DMA_DXAD_DXWAD)  /* ZȂ                */
#define DMA_SCU_W2     (0x1 << DMA_DXAD_DXWAD)  /* 2oCgZ           */
#define DMA_SCU_W4     (0x2 << DMA_DXAD_DXWAD)  /* 4oCgZ           */
#define DMA_SCU_W8     (0x3 << DMA_DXAD_DXWAD)  /* 8oCgZ           */
#define DMA_SCU_W16    (0x4 << DMA_DXAD_DXWAD)  /* 16oCgZ          */
#define DMA_SCU_W32    (0x5 << DMA_DXAD_DXWAD)  /* 32oCgZ          */
#define DMA_SCU_W64    (0x6 << DMA_DXAD_DXWAD)  /* 64oCgZ          */
#define DMA_SCU_W128   (0x7 << DMA_DXAD_DXWAD)  /* 128oCgZ         */
/******** (dxmod)[hrbg ************************************************/
#define DMA_SCU_DIR    (0x0 << DMA_DXMD_DXMOD)  /* ڃ[h                */
#define DMA_SCU_IN_DIR (0x1 << DMA_DXMD_DXMOD)  /* Ԑڃ[h                */
/******** (dxrup)ǂݍ݃AhXXVrbg **********************************/
/******** (dxwup)oAhXXVrbg **********************************/
#define DMA_SCU_KEEP    0x0                     /* ێ                  */
#define DMA_SCU_REN     0x1                     /* XV                  */

/******** (dxft)NvIrbg *******************************************/
#define DMA_SCU_F_VBLK_IN  (0x0 << DMA_DXMD_DXFT)/* V-uN-IN            */
#define DMA_SCU_F_VBLK_OUT (0x1 << DMA_DXMD_DXFT)/* V-uN-OUT           */
#define DMA_SCU_F_HBLK_IN  (0x2 << DMA_DXMD_DXFT)/* H-uN-IN            */
#define DMA_SCU_F_TIM0     (0x3 << DMA_DXMD_DXFT)/* ^C}0                  */
#define DMA_SCU_F_TIM1     (0x4 << DMA_DXMD_DXFT)/* ^C}1                  */
#define DMA_SCU_F_SND      (0x5 << DMA_DXMD_DXFT)/* TEh-Req             */
#define DMA_SCU_F_SPR      (0x6 << DMA_DXMD_DXFT)/* XvCg`           */
#define DMA_SCU_F_DMA      (0x7 << DMA_DXMD_DXFT)/* DMANvrbg̃Zbg*/
/******** (msk)}XNrbg *************************************************/
#define DMA_SCU_M_DXR      (1 << 0)             /* ǂݍ݃AhX          */
#define DMA_SCU_M_DXW      (1 << 1)             /* oAhX          */

/*****************************************************************************/
/**** (DmaScuStatus)Xe[^X ***********************************************/
/*****************************************************************************/
/******** (dxbkr)DMA쒆tO *********************************************/
/******** (ddmv)DSPDMA쒆tO *****************************************/
#define DMA_SCU_MV      0x1                     /* 쒆                    */
#define DMA_SCU_NO_MV   0x0                     /* 쒆łȂ              */

/*
 * STRUCTURE DECLARATIONS
 */

/*
 * TYPEDEFS
 */
typedef struct {
    Uint32 dxr;                                 /* ǂݍ݃AhX          */
    Uint32 dxw;                                 /* oAhX          */
    Uint32 dxc;                                 /* ]oCg              */
    Uint32 dxad_r;                              /* ǂݍ݃AhXZl    */
    Uint32 dxad_w;                              /* ݃AhXZl    */
    Uint32 dxmod;                               /* [hrbg              */
    Uint32 dxrup;                               /* ǂݍ݃AhXXVrbg*/
    Uint32 dxwup;                               /* ݃AhXXVrbg*/
    Uint32 dxft;                                /* NvIrbg        */
    Uint32 msk;                                 /* }XNrbg              */
}DmaScuPrm;                                     /* ]p[^            */

typedef struct {
    Uint32 dxmv;                            /* DMA쒆tO               */
}DmaScuStatus;                              /* Xe[^X                    */

/*
 * EXTERNAL VARIABLE DECLARATIONS
 */

/*
 * EXTERNAL FUNCTION PROTOTYPE  DECLARATIONS
 */
void DMA_ScuSetPrm(DmaScuPrm *, Uint32);    /* DMA]p[^             */
void DMA_ScuStart(Uint32);                  /* DMA]Jn                   */
void DMA_ScuGetStatus(DmaScuStatus *, Uint32);/* DMAXe[^X擾           */

/*****************************************************************************/
/* DMA_SCU1.H ****************************************************************/
/*****************************************************************************/
/*
 * GLOBAL DEFINES/MACROS DEFINES
 */
#define DMA_SCU_END     0
#define DMA_SCU_FAIL    1
#define DMA_SCU_BUSY    2

/*
 * STRUCTURE DECLARATIONS
 */

/*
 * TYPEDEFS
 */

/*
 * EXTERNAL VARIABLE DECLARATIONS
 */

/*
 * EXTERNAL FUNCTION PROTOTYPE  DECLARATIONS
 */
void DMA_ScuInit(void);                         /* DMAf[^           */
void DMA_ScuMemCopy(void *, void *, Uint32);    /* DMAf[^]             */
Uint32 DMA_ScuResult(void);                     /* DMAf[^]I`FbN */

#endif  /* ifndef SEGA_DMA_H */
