/******************************************************************************
 *      \tgEFACu
 *
 *      Copyright (c) 1994,1995,1996 SEGA
 *
 * Library:t@CVXe
 * Module :Cuwb_
 * File   :sega_gfs.h
 * Date   :1996-02-01
 * Version:2.10
 * Author :H.T.
 *
 *************************************************************************** */

#if !defined(SEGA_GFS_H)
#define SEGA_GFS_H

/*****************************************************************************
 *      CN[ht@C
 *****************************************************************************/
#include "sega_cdc.h"

/* o[W   */
                            /*             1         2         3         4  */
                            /*    1234567890123456789012345678901234567890  */
                            /*    ++++++++++++++++++++++++++++++++          */
#if defined(USE_SGL)
    #define GFS_VERSION_STR     ("GFS_SGL Version 2.10 1996-02-01")
#else
    #define GFS_VERSION_STR     ("GFS_SBL Version 2.10 1996-02-01")
#endif
#define GFS_VERSION_LEN 32

/*****************************************************************************
 *      萔}N
 *****************************************************************************/
#define GFS_FNAME_LEN   12              /* t@C̒                 */

/* t@C̑ */
#define GFS_ATR_DIR     0x80            /* fBNg                     */
#define GFS_ATR_CDDA    0x40            /* CDDAt@C                     */
#define GFS_ATR_INTLV   0x20            /* C^[[uZN^܂       */
#define GFS_ATR_FORM2   0x10            /* Form2ZN^܂                */
#define GFS_ATR_FORM1   0x08            /* Form1ZN^܂                */
#define GFS_ATR_END_TBL 0x01            /* fBNge[u̍Ō       */

#define GFS_BUFSIZ_INF  -1              /* ǂݍݗ̈TCYɐ͂Ȃ   */
#define GFS_RPARA_DFL   0x7fffffff      /* ǂݍ݃p[^̏l       */

/* ffp   */
#define GFS_DDS_ADDR    0x6000ccc       /* ffQƗ̈̃AhX   */
#define GFS_DDS_EXEC    0x01            /* DDSs                  */
#define GFS_DDS_ID()    (*(Uint8 *)(GFS_DDS_ADDR+0))  /* DDSʎq̒l      */
#define GFS_DDS_TNO()   (*(Uint8 *)(GFS_DDS_ADDR+1))  /* 擪CDDAgbNNo */
#define GFS_DDS_FID()   (*(Uint16 *)(GFS_DDS_ADDR+2)) /* fBNgʎq */
#define GFS_IS_DDS()    (GFS_DDS_ID()==GFS_DDS_EXEC)  /* DDSs̔f    */

/* G[R[h */
#define GFS_ERR_OK              0       /* I                         */
#define GFS_ERR_CDRD            (-1)    /* CD[hG[                   */
#define GFS_ERR_CDNODISC        (-2)    /* CDZbgĂȂ           */
#define GFS_ERR_CDROM           (-3)    /* fBXNCD-ROMłȂ           */
#define GFS_ERR_DIRTBL          (-4)    /* fBNgǗe[us   */
#define GFS_ERR_OPENMAX         (-5)    /* őI[v̒ls         */
#define GFS_ERR_DIR             (-6)    /* wt@C̓fBNgłȂ */
#define GFS_ERR_CDBFS           (-7)    /* CDubNt@CVXe     */
                                        /* gp錾ĂȂ               */
#define GFS_ERR_NONAME          (-8)    /* t@CȂ             */
#define GFS_ERR_NEXIST          (-9)    /* w肳ꂽt@C݂͑Ȃ   */
#define GFS_ERR_FID             (-10)   /* sȃt@Cʎq             */
#define GFS_ERR_HNDL            (-11)   /* t@Cnhs           */
#define GFS_ERR_SEEK            (-12)   /* V[Nʒus                 */
#define GFS_ERR_ORG             (-13)   /* ʒls                   */
#define GFS_ERR_NUM             (-14)   /* oCg                     */
#define GFS_ERR_OFS             (-15)   /* ItZbgs                 */
#define GFS_ERR_FBUSY           (-16)   /* wt@C̏cĂ   */
#define GFS_ERR_PARA            (-17)   /* p[^s                 */
#define GFS_ERR_BUSY            (-18)   /* Cu֐s             */
#define GFS_ERR_NOHNDL          (-19)   /* t@Cnhɋ󂫂Ȃ     */
#define GFS_ERR_PUINUSE         (-20)   /* sbNAbv쒆               */
#define GFS_ERR_ALIGN           (-21)   /* Ɨ̈悪4byteEɂȂ        */
#define GFS_ERR_TMOUT           (-22)   /* ^CAEg                     */
#define GFS_ERR_CDOPEN          (-23)   /* gCJĂ               */
#define GFS_ERR_BFUL            (-24)   /* obt@tœǂݍݒ~       */
#define GFS_ERR_FATAL           (-25)   /* CDFATAL                    */

/*****************************************************************************
 *      񋓒萔
 *****************************************************************************/
/* ANZX[h(GfsFile:amode) */
enum GfsAccessMode {
    GFS_NWSTAT_NOACT = 0,               /* ĂȂ              */
    GFS_NWSTAT_FREAD,                   /* ǂݍݒ                  */
    GFS_NWSTAT_CDREAD                   /* bc[h                */
};


/* V[N[h(GFS_Seek)               */
enum GfsSeekMode {
    GFS_SEEK_SET = 0,                   /* 擪V[N               */
    GFS_SEEK_CUR,                       /* ݂̈ʒuV[N         */
    GFS_SEEK_END                        /* I[V[N               */
};


/* o[h(GFS_SetGmode:gmode) */
enum GfsGetMode {
    GFS_GMODE_ERASE = 0,                /* ]Aobt@폜     */
    GFS_GMODE_RESIDENT                  /* bcobt@ɏ풓           */
};


/* ][h(GFS_SetTmode) */
enum GfsTransMode {
    GFS_TMODE_SCU = 0,                  /* rbtɂcl`]    */
    GFS_TMODE_SDMA0,                    /* cl`TCNX`[]   cn=0 */
    GFS_TMODE_SDMA1,                    /*                              cn=1 */
    GFS_TMODE_CPU,                      /* \tgEFA] */
    GFS_TMODE_STM,                      /* Xg[p] */
    GFS_TMODE_END
};

/* ANZXT[o(GFS_NwExecServer) */
enum GfsServerStatus {
    GFS_SVR_COMPLETED = 0,              /* St@C̃ANZXI     */
    GFS_SVR_BUSY,                       /* t@CANZX           */
    GFS_SVR_CDPAUSE,                    /* bcobt@ẗ׈ꎞ~ */
    GFS_SVR_ERROR                       /* G[ */
};


/* fBNg(GFS_LoadDir, GFS_SetDir)     */
enum GfsDirType {
    GFS_DIR_ID          = 0,            /* t@CɂANZXs */
    GFS_DIR_NAME                        /* t@CɂANZX   */
};


/*****************************************************************************
 *      }N
 *****************************************************************************/
#define GFS_WORK_SIZE(open_max) \
            (sizeof(GfsMng) + ((open_max) - 1) * sizeof(GfsFile))

/*****************************************************************************
 *      \̃ANZX}N
 *****************************************************************************/

/* fBNgR[h\  */
#define GFS_DIR_REC(rec)        ((rec)->dirrec)
#define GFS_DIR_FAD(rec)        CDC_FILE_FAD(&GFS_DIR_REC(rec))
#define GFS_DIR_SIZE(rec)       CDC_FILE_SIZE(&GFS_DIR_REC(rec))
#define GFS_DIR_UNIT(rec)       CDC_FILE_UNIT(&GFS_DIR_REC(rec))
#define GFS_DIR_GAP(rec)        CDC_FILE_GAP(&GFS_DIR_REC(rec))
#define GFS_DIR_FN(rec)         CDC_FILE_FN(&GFS_DIR_REC(rec))
#define GFS_DIR_ATR(rec)        CDC_FILE_ATR(&GFS_DIR_REC(rec))
#define GFS_DIR_FNAME(rec)      ((rec)->fname)


/* fBNgǗ\ */
#define GFS_DIRTBL_TYPE(dirtbl)         ((dirtbl)->type)
#define GFS_DIRTBL_NDIR(dirtbl)         ((dirtbl)->ndir)
#define GFS_DIRTBL_DIRID(dirtbl)        ((dirtbl)->dir.dir_i)
#define GFS_DIRTBL_DIRNAME(dirtbl)      ((dirtbl)->dir.dir_n)


/* G[ */
#define GFS_ERR_FUNC(err)       ((err)->func)
#define GFS_ERR_OBJ(err)        ((err)->obj)
#define GFS_ERR_CODE(err)       ((err)->code)


/*****************************************************************************
 *      f[^^̒`
 *****************************************************************************/

typedef Sint32 (*GfsTransFunc)(void *obj, Sint32 nsct);

     /* t@C */
typedef struct {
    Sint32      fid;                    /* t@Cʎq */
    CdcFile     finfo;
    Sint32      sctsz;                  /* ZN^ */
    Sint32      nsct;                   /* ZN^ */
    Sint32      lstrm;                  /* ŏIZN^̖f[^   */
} GfsFinfo;


/* CDobt@̎Ǘ */
typedef struct {
    Sint32      bufno;                  /* obt@ԍ */
    Sint32      sctsz;                  /* bcobt@̃ZN^TCY   */
    Sint32      flt;                    /* iԍ */
    CdcSubh     subh;                   /* Tuwb_ */
    Sint32      fmode;                  /* i胂[h */
    Sint32      puid;                   /* 擾sbNAbṽ[UID */
    Sint32      filepos;                /* 擪f[^̃t@C̈ʒu */
    Sint32      sctpos;                 /* ]ʒu */
    /* Đ͈ */
    Sint32      sfad;                   /* JnFAD */
    Sint32      efad;                   /* IFAD */
} GfsCdRsrc;


/* SCSIt@C̉zCDobt@Ǘ */
typedef struct {
    Sint32      fid;                    /* SCSIt@Cʎq   */
    Sint32      filepos;                /* 擪f[^̃t@C̈ʒu */
    Sint32      sctpos;                 /* obt@̃ZN^ʒu */
    Sint32      sctnum;                 /* obt@̃ZN^ */
} GfsScsiRsrc;


/* t@C̉zCDobt@Ǘ */
typedef struct {
    void        *data;                  /* f[^̈           */
    Sint32      filepos;                /* 擪f[^̃t@C̈ʒu */
    Sint32      sctpos;                 /* obt@̃ZN^ʒu */
    Sint32      sctnum;                 /* obt@̃ZN^ */
} GfsMemRsrc;


/* ǂݍ݌Ǘ */
typedef struct {
    /* ǂݍ݌Ǘ */
    Sint32      ftype;                  /* t@C         */
    union {
        GfsCdRsrc       cd;             /* CD̎             */
        GfsScsiRsrc     scsi;           /* SCSIt@C̎   */
        GfsMemRsrc      mem;            /* t@C̎ */
    } rsrc;
} GfsDtsrc;


/* CD̓ǂݍ݂Ǘ */
typedef struct {
    GfsFinfo    finfo;                  /* t@C         */
    GfsDtsrc    dtsrc;                  /* ǂݍ݌           */
    Sint32      gmode;                  /* o[h       */
    Sint32      stat;                   /* s             */
    /* flow inǗ */
    Sint32      sct;                    /* ǂݍ݃ZN^     */
    Sint32      sctcnt;                 /* ǂݍ݃JE^     */
    Sint32      sctmax;                 /* ǂݍݍőZN^ */
} GfsFlow;


/* f[^pbN\ */
typedef struct {
    void        *data;                  /* f[^̈           */
    Sint32      adlt;                   /* AhX̑     */
    Sint32      len;                    /* ]oCg         */
    Sint32      nsct;                   /* ]ZN^         */
    Bool        use;                    /* gptO           */
} GfsDataPack;


typedef GfsDataPack *GfdpHn;

/* ]Ǘ */
/* CDobt@̓]Ǘ */
typedef struct {
    void        *buf;                   /* ]AhX */
    Sint32      size;                   /* f[^̈̃TCY */
    Sint32      wp;                     /* ݃ItZbg */
    /* ]Ǘ */
    GfdpHn      dps;                    /* ]̃f[^pbN */
    GfdpHn      dpd;                    /* ]悩̃f[^pbN */
    Sint32      tsctmax;                /* P̓]̍őZN^ */
    Sint32      tsct;                   /* ]ڕWZN^ */
    Sint32      tsctcnt;                /* ݂܂œ]ZN^ */
    Sint32      tbytcnt;                /* ZN^̓]oCg */
    /* ]֐ */
    void        *obj;                   /* ]֐ւ̑P */
    GfsTransFunc tfunc;                 /* ]֐ */
    Sint32      unit;                   /* ]P */
    Bool        active;                 /* 쒆tO */
    Sint32      stat;                   /*  */
    Sint32      mode;                   /* ][h */
} GfsTrans;


typedef GfsTrans *GftrHn;


/* I[vt@CǗ */
typedef struct {
    Bool        used;                   /* ̍\̂gpǂ */
    Sint32      amode;                  /* ANZX[h */
    Sint32      astat;                  /* ANZX */
    GfsFlow     flow;
    GfsTrans    trans;
} GfsFile;


/* t@Cnh */
typedef GfsFile *GfsHn;


/* [Uo^]֐ */
typedef Sint32 (*GfsTrFunc)(GfsHn gfs, Sint32 nsct);
     

/* fBNgR[h\(t@CȂ)   */
typedef struct {
    CdcFile     dirrec;
} GfsDirId;


/* fBNgR[h\(t@C)   */
typedef struct {
    CdcFile     dirrec;
    Sint8       fname[GFS_FNAME_LEN];   /* t@C */
} GfsDirName;


/* fBNgǗ\ */
typedef struct {
    Sint32      type;                   /*  */
    Sint32      ndir;                   /* ővf */
    union {
        GfsDirId *dir_i;                /* t@CȂfBNg */
        GfsDirName *dir_n;              /* t@CfBNg */
    } dir;
} GfsDirTbl;


/* G[֐ */
typedef void (*GfsErrFunc)(void *obj, Sint32 ec);

/* G[ */
typedef struct {
    GfsErrFunc  func;                   /* G[̌Ăяo֐   */
    void        *obj;                   /* Ăяo֐ɓn   */
    Sint32      code;                   /* G[R[h                 */
} GfsErrStat;


/*****************************************************************************
 *      ֐̐錾
 *****************************************************************************/

/* t@CVXȅ */
Sint32 GFS_Init(Sint32 open_max, void *work, GfsDirTbl *dirtbl);

/* fBNgR[h̓ǂݍ */
Sint32 GFS_LoadDir(Sint32 fid, GfsDirTbl *dirtbl);

/* JgfBNgR[h̐ݒ */
Sint32 GFS_SetDir(GfsDirTbl *dirtbl);

/* Ot@Cʎqւ̕ϊ */
Sint32 GFS_NameToId(Sint8 *fname);

/* t@Cʎqt@Cւ̕ϊ */
Sint8 *GFS_IdToName(Sint32 fid);

/* t@CʎqfBNgR[h擾 */
Sint32 GFS_GetDirInfo(Sint32 fid, GfsDirId *dirrec);

/*  t@CVXẽZbg  */
void    GFS_Reset(void);

/* t@Cnh̊ */
GfsHn GFS_Open(Sint32 fid);

/* t@Cnh̊ĉ */
void GFS_Close(GfsHn gfs);

/* ANZX|C^̈ړ */
Sint32 GFS_Seek(GfsHn gfs, Sint32 ofs, Sint32 org);

/* ANZX|C^̎擾 */
Sint32 GFS_Tell(GfsHn gfs);

/* t@CĨ`FbN */
Bool GFS_IsEof(GfsHn gfs);

/* oCgTCYZN^TCYւ̕ϊ */
Sint32 GFS_ByteToSct(GfsHn gfs, Sint32 nbyte);

/* t@CTCYɊւ̎擾 */
void GFS_GetFileSize(GfsHn gfs, Sint32 *sctsz, Sint32 *nsct, Sint32 *lstsz);

/* t@C̎擾 */
void GFS_GetFileInfo(GfsHn gfs, Sint32 *fid, Sint32 *fn, Sint32 *fsize,
                     Sint32 *atr);

/*  CDobt@̃ZN^̎擾      */
Sint32 GFS_GetNumCdbuf(GfsHn gfs);

/* ꊇǂݍ */
Sint32 GFS_Load(Sint32 fid, Sint32 ofs, void *buf, Sint32 bsize);

/* A^ǂݍ */
Sint32 GFS_Fread(GfsHn gfs, Sint32 nsct, void *buf, Sint32 bsize);

/* A^ǂݍ */
Sint32 GFS_NwFread(GfsHn gfs, Sint32 nsct, void *buf, Sint32 bsize);

/* A^bcobt@ǂݍ */
Sint32 GFS_NwCdRead(GfsHn gfs, Sint32 nsct);

/* ANZX슮`FbN */
Bool GFS_NwIsComplete(GfsHn gfs);

/* ANZX̒~ */
Sint32 GFS_NwStop(GfsHn gfs);

/* ANZXԂ̎擾 */
void GFS_NwGetStat(GfsHn gfs, Sint32 *amode, Sint32 *ndata);

/* t@CPʂł̃ANZX̎s */
Sint32 GFS_NwExecOne(GfsHn gfs);

/* T[oANZX̎s */
Sint32 GFS_NwExecServer(GfsHn *now_gfs);

/* bcobt@̎o[h̐ݒ */
Sint32 GFS_SetGmode(GfsHn gfs, Sint32 gmode);

/* ][h̐ݒ */
Sint32 GFS_SetTmode(GfsHn gfs, Sint32 tmode);

/* \[Xobt@ւ̓ǂݍ݃ZN^̐ݒ */
Sint32 GFS_SetReadPara(GfsHn gfs, Sint32 nsct);

/* \[Xobt@zXgւ̓]ZN^̐ݒ */
Sint32 GFS_SetTransPara(GfsHn gfs, Sint32 tsize);

/* ]֐̓o^       */
void    GFS_SetTrFunc(GfsHn gfs, GfsTrFunc func);

/* ]֐ɂ]Jn     */
Uint32  *GFS_StartTrans(GfsHn gfs, Sint32 *dadr);

/* sbNAbvANZX|C^̈ʒuɈړ */
Sint32 GFS_CdMovePickup(GfsHn gfs);

/* G[֐̓o^ */
void GFS_SetErrFunc(GfsErrFunc func, void *obj);

/* G[Ԃ̎擾 */
void GFS_GetErrStat(GfsErrStat *stat);

/*  gbNԍ̕ϊ      */
Sint32  GFS_ConvTno(Sint32 logtno);

/* fidƃItZbgt[AhX擾 */
Sint32 GFS_GetFad(Sint32 fid, Sint32 ofs);


/*****************************************************************************
 *      VXep
 *****************************************************************************/

/*---萔--------------------------------------------------------------------*/
#define GFS_OPEN_MAX    24              /* őI[vt@C */
#define GFS_TBUF_NR     2               /* ]obt@̐ */
#define GFS_FTYPE_NR    3               /* t@Cʐ */
#define GFS_SCTBUF_SIZ  2048            /* ZN^obt@̑傫 */
#define GFS_CDBBUF_NR   24              /* CDubN̋搔 */
#define GFS_SELQ_MAX    24              /* iݒR}hL[̍ő咷 */
#define GFS_FCONQ_MAX   24              /* ڑR}hL[̍ő咷 */

/*---f[^^----------------------------------------------------------------*/

/* t@Cp֐(Ǘe[u, GfsMng̃o) */
typedef struct {
    Sint32 (*flowin)(GfsFlow *);        /* \[Xobt@ǂݍ݊֐   */
    void (*stopin)(GfsFlow *, Bool);    /* ǂݍݒ~֐             */
    Sint32 (*seek)(GfsFlow *, Sint32);  /* ANZX|C^ݒ֐     */
    Sint32 (*tell)(GfsFlow *);          /* ANZX|C^擾֐     */
} GfsFileFunc;

/* ANZXT[oǗ\(Ǘe[u, GfsMng̃o) */
typedef struct {
    GfsHn   access_file[GFS_OPEN_MAX];  /* ANZX[hwσt@C */
    Sint32  nfile;                      /* o^t@C               */
} GfsSvr;


/* fBNgǗ\(Ǘe[u, GfsMng̃o) */
typedef struct {
    GfsDirTbl   dirtbl;                 /* fBNgǗ */
    Sint32      nfile;                  /* t@C */
} GfsDirMng;


/* iݒR}hL[̗vf(CDubNǗ\, GfsCdbMng̃o) */
typedef struct {
    Uint8 flt;                          /* ݒiԍ */
    Uint8 fmode;                        /* i胂[h */
    CdcSubh subh;                       /* Tuwb_ */
    Sint32 fad;                         /* JnFAD */
    Sint32 snum;                        /* FADZN^ */
} GfcdSelQu;

/* ڑR}hL[̗vf(CDubNǗ\, GfsCdbMng̃o) */
typedef struct {
    Sint32 flt;                         /* ݒi */
    Sint32 buf;                         /* ^o͐ڑobt@ */
    Sint32 flnout;                      /* Uo͐ڑi(̒lgp) */
} GfcdFconQu;    

/* CDubNǗ\(Ǘe[u, GfsMng̃o) */
typedef struct {
    /* Ǘ */
    Sint8 use_buf[GFS_CDBBUF_NR];       /* obt@gp */
    Sint8 use_filt[GFS_CDBBUF_NR];      /* igp */
    Bool use_pu;                        /* sbNAbvgp */
    Sint32 tr_bufno;                    /* f[^]̃obt@   */
    Sint32 puid;                        /* sbNAbv̏LID */
    Sint32 timer;                       /* ^CAEgJE^ */
    CdcStat stat;                       /* CDubN̏ */
    void (*func)(void *);               /* CSCTnh */
    void *obj;                          /* CSCTnḧ */
    /* GFCD_SetFilt^XN */
    struct {
        Sint32 len;                     /* iݒR}hL[̒ */
        Sint32 stat;                    /* R}hL[擪̏ */
        GfcdSelQu selq[GFS_SELQ_MAX];   /* iݒR}hL[ */
    } tsk_setflt;
    /* GFCD_SetFiltCon^XN */
    struct {
        Sint32 len;                     /* ڑR}hL[̒ */
        Sint32 stat;                    /* ^XNItO */
        GfcdFconQu fconq[GFS_FCONQ_MAX]; /* ڑR}hL[ */
    } tsk_fltcon;
    /* GFCD_SetCon^XN */
    struct {
        Sint32 stat;                    /* ^XNItO */
        Sint32 flt;                     /* CDڑi */
    } tsk_setcon;
    /* GFCD_GetLenData^XN */
    struct {
        Sint32 stat;                    /* ^XNItO */
        Sint32 bufno;                   /* Ώۋ */
        Sint32 spos;                    /* 擪ZN^ʒu */
        Sint32 usct;                    /* vZN^ */
        Sint32 cnt;                     /* ^XN̎s */
        Sint32 *nsct;                   /* ZN^i[ */
        Sint32 *nbyte;                  /* oCgi[ */
    }tsk_getlen;
    /* GFCD_ReqData^XN */
    struct {
        Sint32 stat;                    /* ^XNItO */
        Sint32 bufno;                   /* Ώۋ */
        Sint32 sctpos;                  /* ZN^ʒu */
        Sint32 nsct;                    /* vZN^ */
    } tsk_reqdat;
    /* GFCD_DelSctData^XN */
    struct {
        Sint32 stat;                    /* ^XNItO */
        Sint32 bufno;                   /* Ώۋ */
        Sint32 sctpos;                  /* 폜JnZN^ʒu */
        Sint32 nsct;                    /* 폜ZN^ */
    } tsk_delsct;
    /* GFCD_MoveSctData^XN */
    struct {
        Sint32 stat;                    /* ^XNItO */
        Sint32 dst;                     /* ړ */
        Sint32 src;                     /* ړ */
        Sint32 spos;                    /* ړJnZN^ʒu */
        Sint32 snum;                    /* ړZN^ */
        Sint32 fmode;                   /* ړZN^̍i胂[hۑ */
    } tsk_movsct;
    /* GFCD_ChgDir^XN */
    struct {
        Sint32 stat;                    /* ^XNItO */
        Sint16 fid;                     /* ݒt@Cʎq */
        Sint16 work;                    /* ƃobt@ */
        Sint32 *ndir;                   /* ێfBNg */
    } tsk_chgdir;
} GfsCdbMng;

/* Ǘe[u */
typedef struct {
    Sint32      openmax;                /* I[vt@C̍ő吔 */
    GfsFileFunc functbl[GFS_FTYPE_NR];  /* t@Cp֐ */
    GfsSvr      svr;                    /* ANZXT[o */
    GfsDirMng   curdir;                 /* JgfBNg */
    GfsHn       pickup;                 /* sbNAbv䒆t@C */
    Sint32      sfad;                   /* Đ͈:JnFAD */
    Sint32      efad;                   /* Đ͈:IFAD+1 */
    GfsHn       trans;                  /* f[^]t@C */
    GfsErrStat  error;                  /* G[ */
    Uint32      flags;                  /* foCXڑȂ */
    Sint32      timer;                  /* ^CAEgJE^ */
    GfsCdbMng   cdb;                    /* CDubNǗ\ */
    GfsDataPack srcpk;                  /* ]f[^pbN */
    GfsDataPack dstpk;                  /* ]f[^pbN */
    Uint8       sect_buf[GFS_SCTBUF_SIZ]; /* PZN^̓ǂݍݗpobt@ */
    GfsFile     file[1];                /* Snh̔ziϒj */
} GfsMng;

#endif      /* !defined(SEGA_GFS_H) */

/* end of file */
