/******************************************************************************
 *	\tgEFACu
 *
 *	Copyright (c) 1994,1995 SEGA
 *
 * Library	:oblE`coblĐCu
 * Module 	:Cuwb_
 * File		:sega_pcm.h
 * Date		:1995-03-31
 * Version	:1.16
 * Auther	:Y.T
 *
 ****************************************************************************/
#if !defined(SEGA_PCM_H)
#define SEGA_PCM_H

/* from Ver1.10, adpcm function support */
#define ADPCM_FUNCTION

/*-------------------- sCN[ht@Ct --------------------*/
#include "sega_xpt.h"
#include "sega_gfs.h"
#include "sega_stm.h"

/*------------------------- s}N萔t -------------------------*/

/* o[W */
#define PCM_VERSION				("PCM Version 1.16 1995-03-31")
							/*	           1         2         3         4	*/
							/*	  1234567890123456789012345678901234567890	*/
							/*	  ++++++++++++++++++++++++++++++++			*/
#define PCM_VERSION_LEN			(32)

/* nh */
#define PCM_HN_MAX				(32)

/* 1024, 2048, 4096,... */
#define PCM_SIZE_1K				(1024)
#define PCM_SIZE_2K				(2 * PCM_SIZE_1K)
#define PCM_SIZE_3K				(3 * PCM_SIZE_1K)
#define PCM_SIZE_4K				(4 * PCM_SIZE_1K)
#define PCM_SIZE_8K				(8 * PCM_SIZE_1K)

/* tO */
typedef enum {
    PCM_OFF = 0,
    PCM_ON  = 1
} PcmFlag;

/* G[R[h	*/
typedef enum {
	PCM_ERR_OK					= 0x00000000,/* G[͔ĂȂ		*/

	/* PCM_Create ̃G[ */
	PCM_ERR_OUT_OF_HANDLE		= 0x00000101,/* nh؂ 			*/
	PCM_ERR_NO_INIT				= 0x00000103,/* ֐قĂȂ 	*/

	/* PCM_Destroy ̃G[ */
	PCM_ERR_INVALID_HN			= 0x00000201,/* sȃnhŏ		*/
	PCM_ERR_ILL_CREATE_MODE		= 0x00000202,/* Create ̃[hƈႤ		*/

	/* pcm_HeaderProcess ̃G[ */
	PCM_ERR_TOO_LARGE_HEADER	= 0x00000302,/* wb_傷			*/
											/* (obt@TCY)	*/
	PCM_ERR_HEADER_DATA			= 0x00000303,/* wb_f[^G[ 			*/
	PCM_ERR_TOO_SMALL_PCMBUF	= 0x00000304,/* PCMޯ̧ނ	*/
	PCM_ERR_ILL_SIZE_PCMBUF		= 0x00000305,/* PCMޯ̧ޕs 4096*2`16	*/
	PCM_ERR_AFI_NO_COMMON		= 0x00000306,/* CommonChunk  			*/
	PCM_ERR_AFI_COMMPRESS		= 0x00000307,/* Ήk^Cv			*/
	PCM_ERR_NOT_DECLARE_ADPCM	= 0x00000308,/* ADPCMgp錾Ȃ			*/

	/*  */
	PCM_ERR_ILLEGAL_PARA		= 0x00000503,/* ̎w肪ԈĂ 	*/
	PCM_ERR_ILLEGAL_HANDLE		= 0x00000504,/* nhُ 				*/

	/* AĐɊւG[ */
	PCM_ERR_NEXT_HN_STATUS		= 0x00000601,/* AĐnh̏Ԉُ 	*/
	PCM_ERR_NEXT_HN_AUDIO		= 0x00000602,/* I[fBȈvȂ */
	PCM_ERR_CHANGE_NO_ENTRY		= 0x00000605,/* GgȂԂŃ`FW */

	/* |[YɊւG[ */
	PCM_ERR_PAUSE_STATUS		= 0x00000701,/* PCM_STAT_PLAY_TIME, ܂́A
											 * PCM_STAT_PLAY_PAUSE ȊO
											 * ԂŃ|[Y֐R[B
											 */
	PCM_ERR_PAUSE_WORK_NULL		= 0x00000702,/* |[Yp[Nُ		*/
	PCM_ERR_PAUSE_WORK_SIZE		= 0x00000703,/* |[Yp[Nُ		*/
	PCM_ERR_PAUSE_WORK_SET		= 0x00000704,/* |[Yp[Nw肪s*/

	/* DMA]ɊւG[ */
	PCM_ERR_DMA_MODE			= 0x00000801,/* Ή̓] 			*/
	PCM_ERR_DMA_CPU_PCM			= 0x00000802,/* cl`ُI 			*/

	/* t@Cǂݍ݃G[ */
	PCM_ERR_GFS_READ			= 0x00000901,/* fer̓ǂݍ݂Ŏs 		*/

	/* Oobt@ւ̃f[^ɊւG[ */
	PCM_ERR_RING_SUPPLY			= 0x00000a01,/* Đɋ    */
											 /* iԂɍ킷fj*/

	PCM_ERR_END
} PcmErrCode;

/* ĐXe[^X */
typedef enum {
	PCM_STAT_PLAY_ERR_STOP		= -1,		/* ُ~					*/
	PCM_STAT_PLAY_CREATE		= 0,		/* 					*/
	PCM_STAT_PLAY_PAUSE			= 1,		/* ꎞ~		 			*/
	PCM_STAT_PLAY_START			= 2,		/* Jn						*/
	PCM_STAT_PLAY_HEADER		= 3,		/* wb_ݒ@				*/
	PCM_STAT_PLAY_TIME			= 4,		/* Đ(^C}X^[g)		*/
	PCM_STAT_PLAY_END			= 5			/* Đ 				*/
} PcmPlayStatus;

/* t@C^Cv */
typedef enum {
	PCM_FILE_TYPE_NO_HEADER		= 1,	/* wb_ȂB
										 * (PCMײ؂Ήٌ̧`
										 *  ؍Đꍇ܂)
										 */
	PCM_FILE_TYPE_AIFF			= 2,	/* AIFF							*/
	PCM_FILE_TYPE_AIFC			= 3 	/* AIFC							*/
} PcmFileType;
/* [] AIFC͎gpł܂B*/

/* f[^^Cv */
typedef enum {
	PCM_DATA_TYPE_LRLRLR		= 1,	/* PTvÂEE	*/
	PCM_DATA_TYPE_RLRLRL		= 2,	/* PTvÂEE	*/
	PCM_DATA_TYPE_LLLRRR		= 3,	/* ubNPʂōEE	*/
	PCM_DATA_TYPE_RRRLLL		= 4, 	/* ubNPʂŉEE	*/
	PCM_DATA_TYPE_ADPCM_SG		= 5, 	/* ADPCM,޸ٰ߂̘Af[^*/
	PCM_DATA_TYPE_ADPCM_SCT		= 6 	/* ADPCM,118޸ٰ		*/
} PcmDataType;

/* ꎞ~̐R}h */
typedef enum {
	PCM_PAUSE_ON_AT_ONCE,				/* ꎞ~ 			*/
	PCM_PAUSE_OFF						/* ꎞ~ 			*/
} PcmPauseCmd;

/* ؂ւ\`FbNl */
typedef enum {
	PCM_CHANGE_OK_AT_ONCE		= 0,	/* ؂ւ\B			*/
	PCM_CHANGE_NO_DATA			= 1,	/* f[^sB				*/
	PCM_CHANGE_NO_ENTRY			= 2,	/* GgB				*/
	PCM_CHANGE_TOO_LARGE_HEADER	= 3		/* wb_傷B			*/
										/* (obt@TCY)	*/
} PcmChangeStatus;

/* f[^̓] */
typedef enum {
	PCM_TRMODE_CPU = 0,					/* \tgEFA] 			*/
	PCM_TRMODE_SDMA,					/* cl`TCNX`[ 		*/
	PCM_TRMODE_SCU						/* rbt̂cl`				*/
} PcmTrMode;

/* [] 
	Oobt@oblobt@̓]́A\tgEFA]ɌŒłB
*/

/*------------------------- sftHglt -------------------------*/

/* P̃^XNŏʂ̏ [sample/1ch] */
#define PCM_DEFAULT_SAMPLE_1TASK		(PCM_SIZE_1K)

/* ĐJngKTCY[byte] */
#define PCM_DEFAULT_SIZE_START_TRG		(0)

/* ĐJngKTv[sample/1ch] */
#define PCM_DEFAULT_SAMPLE_START_TRG	(PCM_SIZE_4K)

/* Đ~gKTv[sample/1ch] */
#define PCM_DEFAULT_SAMPLE_STOP_TRG		(PCM_SIZE_2K)


/*------------------------- s}Nt -------------------------*/

/* SaxsdR[h Uint32 ^ŕ\B
 *   ('cvid'ȂǂƏܰݸނoĂ܂̂ŁA邽߂)
 */
#define PCM_4BYTE_CHAR(a,b,c,d)					\
	(	((Uint32)((a) & 0x000000FF) << 24) | 	\
		((Uint32)((b) & 0x000000FF) << 16) | 	\
		((Uint32)((c) & 0x000000FF) <<  8) | 	\
		 (Uint32)((d) & 0x000000FF)				\
	)

/* SEGA_PCM conpatible */
#define PCM_PARA_WORK_ADDR(para)	PCM_PARA_WORK(para)
#define PCM_PARA_BUF_ADDR(para)		PCM_PARA_RING_ADDR(para)
#define PCM_PARA_BUF_SIZE(para)		PCM_PARA_RING_SIZE(para)
#define PCM_CreateMemMovie			PCM_CreateMemHandle
#define PCM_DestroyMemMovie			PCM_DestroyMemHandle

/*-------------------- s\̃ANZX}Nt --------------------*/

/* 쐬p[^ւ̃ANZX}N */
#define PCM_PARA_WORK(para)			((para)->work)
#define PCM_PARA_RING_ADDR(para)	((para)->ring_addr)
#define PCM_PARA_RING_SIZE(para)	((para)->ring_size)
#define PCM_PARA_PCM_ADDR(para)		((para)->pcm_addr)
#define PCM_PARA_PCM_SIZE(para)		((para)->pcm_size)

/* Đ̐ݒp[^ւ̃ANZX}N */
#define PCM_INFO_FILE_TYPE(info)		((info)->file_type)
#define PCM_INFO_DATA_TYPE(info)		((info)->data_type)
#define PCM_INFO_FILE_SIZE(info)		((info)->file_size)
#define PCM_INFO_CHANNEL(info)			((info)->channel)
#define PCM_INFO_SAMPLING_BIT(info)		((info)->sampling_bit)
#define PCM_INFO_SAMPLING_RATE(info)	((info)->sampling_rate)
#define PCM_INFO_SAMPLE_FILE(info)		((info)->sample_file)
#define PCM_INFO_COMPRESSION_TYPE(info)	((info)->compression_type)

/* nh([N)̃ANZX */
#define PCM_HN_START_TRG_SIZE(hn)	(((*(PcmWork **)hn))->para.start_trg_size)
#define PCM_HN_START_TRG_SAMPLE(hn)	(((*(PcmWork **)hn))->para.start_trg_sample)
#define PCM_HN_STOP_TRG_SAMPLE(hn)	(((*(PcmWork **)hn))->para.stop_trg_sample)
#define PCM_HN_CNT_LOOP(hn)			(((*(PcmWork **)hn))->status.cnt_loop)


/*-------------------------- sf[^^t --------------------------*/
/* nh */
typedef void *PcmHn;

/* G[o^֐ */
typedef void (*PcmErrFunc)(void *obj, Sint32 err_code);

typedef struct {
	Sint8		command;
	Sint8		resered;
	Uint8		pad[14];				/* P1-14	*/
} PcmCmdBlk;

typedef struct {
	Sint8		command;
	Sint8		resered;
	Sint8		channel_bit_stm_no;		/* P1 		*/
	Sint8		level_pan;				/* P2 		*/
	Sint16		buf_addr;				/* P3-4 	*/
	Sint16		buf_size;				/* P5-6 	*/
	Sint16		pitch_word;				/* P7-8 	*/
	Uint8		effect_r_mono;			/* P9 		*/
	Uint8		effect_l;				/* P10 		*/
	Uint8		pad[4];					/* P11-14 	*/
} PcmStartPcm;

typedef struct {
	Sint8		command;
	Sint8		resered;
	Sint8		stm_no;					/* P1 		*/
	Uint8		pad[13];				/* P2-14	*/
} PcmStopPcm;

typedef struct {
	Sint8		command;
	Sint8		resered;
	Sint8		stm_no;					/* P1 		*/
	Sint8		level_pan;				/* P2 		*/
	Sint16		pitch_word;				/* P3-4 	*/
	Uint8		effect_r_mono;			/* P5 		*/
	Uint8		effect_l;				/* P6 		*/
	Uint8		pad[8];					/* P7-14 	*/
} PcmChangePcmPara;

typedef struct {
	Sint8		command;
	Sint8		resered;
	Sint8		area_no;				/* P1 		*/
	Uint8		pad[13];				/* P2-14 	*/
} PcmChangeMap;

typedef struct {
	Sint8		command;
	Sint8		resered;
	Sint8		total_volume;			/* P1 		*/
	Uint8		pad[13];				/* P2-14 	*/
} PcmTotalVolume;

typedef struct {
	Sint8		command;
	Sint8		resered;
	Sint8		effect_bank_no;			/* P1 		*/
	Uint8		pad[13];				/* P2-14 	*/
} PcmChangeEffect;

typedef struct {
	Sint8		command;
	Sint8		resered;
	Sint8		neiro_bank_no;			/* P1 		*/
	Sint8		mixer_no;				/* P2 		*/
	Uint8		pad[12];				/* P3-14 	*/
} PcmChangeMixer;

typedef struct {
	Sint8		command;
	Sint8		resered;
	Sint8		effect_out_select;		/* P1 		*/
	Sint8		effect_level_pan;		/* P2 		*/
	Uint8		pad[12];				/* P3-14 	*/
} PcmChangeMixerPara;

/* ŌɔseR}h̓e */
typedef struct {
	PcmStartPcm			start_pcm;
	PcmStopPcm			stop_pcm;
	PcmChangePcmPara	change_pcm_para;

/*	PcmChangeMap		change_map;
	PcmTotalVolume		total_volume;
	PcmChangeEffect		change_effect;
	PcmChangeMixer		change_mixer;
	PcmChangeMixerPara	change_mixer_para;
*/
} PcmCommand;

/* Đ */
typedef struct {
	PcmFileType		file_type;			/* t@C^Cv 					*/
	PcmDataType		data_type;			/* f[^^Cv 					*/
	Sint32			file_size;			/* t@CTCY[byte]
										 * ȏݸޯ̧ւ̋
										 * A̕͏ȂB
										 */
	Sint32			channel;			/* `l 						*/
	Sint32			sampling_bit;		/* TvOrbg 			*/
	Sint32			sampling_rate;		/* TvO[g[Hz] 			*/
	Sint32			sample_file;		/* t@C̃Tv[sample/1ch]	*/
	Sint32			compression_type;	/* k^Cv 						*/
} PcmInfo;

/* PCM] */
typedef struct {
	Sint8		*dst1;				/* ]AhX1 						*/
	Sint8		*dst2;				/* ]AhX2 						*/
	Sint8		*src;				/* ]AhX 						*/
	Sint32		size;				/* ]oCg 						*/
} PcmCopyTbl;

/* e퐧 */
typedef struct {
	/* S̐ */
	Sint32			stat_start;		/* 'STAT' Xe[^X̊Jn 				*/
	PcmPlayStatus	play;			/* Đ 							*/
	PcmFlag			ignore_header;	/* 1:wb_񖳎 					*/
	PcmFlag			need_ci;		/* 1:Tuwb_ciǂ 			*/
	Sint32			cnt_loop;		/* [v(JEg_E) 			*/

	/* Đ */
	Sint32		info_start;			/* 'INFO' Đ̊Jn 				*/
	PcmInfo		info;				/* Đ 							*/

	/* Oobt@ */
	Sint32		ring_start;			/* 'RING' Oobt@̊Jn 	*/
	Sint32		ring_write_offset;	/* Oobt@݈ʒu[byte] 	*/
									/*	(ِ̧擪̃ItZbg)			*/
	Sint32		ring_read_offset;	/* Oobt@ǂݍ݃ItZbg 	*/
									/*	(ِ̧擪̃ItZbg)			*/
	Sint8		*ring_end_addr;		/* Oobt@IAhX 			*/
	Sint8		*ring_write_addr;	/* Oobt@݃AhX 		*/
	Sint8		*ring_read_addr;	/* Oobt@ǂݎAhX 		*/
	Sint32		media_offset;		/* t@C擪f[^܂ł̵̾ 	*/

	/* PCMĐ */
	Sint32		pcm_start;			/* 'PCM ' PCMĐ̊Jn 			*/
	Sint8		*pcm2_addr;			/* PCMQكobt@JnAhX 	*/
	Sint32		pcm_bsize;			/* ؂PCMobt@TCY[byte/1ch]*/
	Sint32		pcm_write_offset;	/* PCMobt@݈ʒu[byte]		*/
									/*  (PCMobt@̐擪̃ItZbg)	*/
	Sint32		cnt_4ksample;		/* PCM play address 4kْPʍXV */
	Sint32		sample_write_file;	/* t@C̋Tv[sample/1ch]*/
									/* (t@Č݂܂ł̑)		*/
	Sint32		sample_write;		/* Tv[sample/1ch]			*/
									/* (擪̨т݂̌܂ł̑)	*/
	Sint32		sample_film_start;	/* tBJnTv[sample/1ch]	*/
									/* (擪̨т猻̨ъJn_܂ł)	*/
	Sint32		sample_pause;		/* |[YTv[sample/1ch]		*/
									/* (擪̨тŋ߂̃|[Y_܂ł)	*/
	Sint32		count_start;		/* botNbN^C}Jn 		*/
									/* 						[CPUۯ>>15] 	*/
	Sint32		clock_scale;		/* botNbN^C}̃XP[ 		*/
	PcmFlag		fill_silence;		/* ݒς݃tO					*/
	Sint32		*pwork_addr;		/* |[Yp[N					*/
	Sint32		pwork_size;			/* |[Yp[NTCY[byte] 		*/
									/*  (|[Y@\gpꍇɕKv)	*/
	Sint32		cnt_sg;				/* TEhO[vJE^				*/
	Sint32		onetask_sample;		/* P̃^XNŏ[sample/1ch]	*/
	Sint32		onetask_size;		/* P̃^XNŏ[byte/1ch]	*/
	Sint32		onetask_sg;			/* P̃^XNŏ[sg/1ch]		*/

	/* TEhhCo֘A */
	Sint32		sddrv_start;		/* 'SDRV' TEhhCo֘ÅJn 	*/
	PcmCommand	command;			/* ŌɔseR}h̓e 		*/

	/* PCMf[^]Ɋւ */
	Sint32		copy_start;			/* 'COPY' PCMf[^]֘ÅJn 		*/
	PcmTrMode	copy_mode_pcm;		/* f[^̓] 					*/
	PcmFlag		dma_hold;			/* 1:̃nhDMAێĂ*/
	Uint32		pcm_renew_size;		/* DMAIpcmޯ̧߲XV*/
	Uint32		buf_renew_size;		/* DMAIޯ̧ǂݎ߲XV 	*/
	Sint32		copy_idx;			/* PCM]e[ũCfbNX 	*/
	PcmCopyTbl 	copy_tbl[4];		/* PCM]e[u 					*/

	/* ԊǗ */
	Sint32		vbl_start;			/* 'VBL ' ԊǗ̊Jn 			*/
	Sint32		vbl_film_start;		/* tBJn[vbl] 				*/
	Sint32		vbl_pause;			/* |[YJn[vbl] 					*/
	Sint32		vbl_pcm_start;		/* PCMJn[vbl]
									 * ŏ̍ cnt_4ksample Ķ
									 * ߂Ȃ悤ɁB
									 */

	/* ADPCM؂蕪p֐|C^ */
	void (*audio_process_fp)(PcmHn hn);
									/* PI[fBITv
									 * pcm_AudioProcess      ܂́A
									 * pcm_AudioProcessAdpcm o^
									 * 
									 */

	/* G[ */
	Uint32		err_start;			/* 'ERR ' G[̊Jn 				*/
	Uint32		cnt_load_miss;		/* PCM[h~XJE^ 				*/
	Uint32		cnt_task_call;		/* ^XNR[JE^ 				*/
	Uint32		cnt_over_task_call;	/* ߏ^XNR[JE^ 			*/
	Uint32		cnt_buf_empty;		/* obt@^XNJE^ 			*/
	Uint32		max_late_time;		/* őxꎞ[sample] 				*/
	Uint32		max_late_sample;	/* őxꎞ[sample] 				*/
	Sint32		cnt_fill_silence;	/* ݒJE^						*/
} PcmStatus;

/* t@CANZX֌W */
typedef struct {
	GfsHn		gfs;			/* t@Cnh */
	Sint32		load_sect;		/* ]őZN^ */
	Bool		called_cdread;	/* GFS_NwCdRead R[ TRUE */
	Bool		exec_one_state;	/* ExecOne sȂ TRUE */
	Sint32		exec_load_size;	/* ExecOne œǂݍރoCg */
	Sint32		now_load_size;	/* ExecOne œǂݍłoCg */
	Sint32		load_total_sect;/* ǂݍݑZN^ */
	Sint32		file_sect;		/* t@C̃ZN^ */
	PcmTrMode	tr_mode;		/* ][h */
} PcmFileGfsPara;

typedef struct {
	StmHn		stm;			/* Xg[nh */
	Sint32		load_sect;		/* ]őZN^ */
	Sint32		old_cd_buf_num;	/* Ôbcobt@̐ */
	Bool		dma_state;		/* cl`]ĂȂ TRUE */
	Sint32		dma_sect;		/* cl`]ZN^ */
	Uint32		*write_addr;	/* ރAhX */
	Sint32		buf_bsize;		/* 󂫃obt@̃oCg */
	Sint32		write_bsize;	/* ]oCg */
	Sint32		sect_bsize;		/* PZN^̃oCg */
	Sint32		audio_1st_sect;	/* 擪I[fBIZN^ */
	StmTrFunc	load_func;		/* ]֐ */
} PcmFileStmPara;

typedef struct {
	Sint32		faccess_type;		/* t@CANZX^Cv */
	/* t@C[Jf[^ */
	union	{
		PcmFileGfsPara	gfs;
		PcmFileStmPara	stm;
	} data;
} PcmFilePara;

/* s֐ */
typedef struct {
	void	(*start)(PcmHn pcm);
	void	(*task)(PcmHn pcm);
	Sint32	(*preload_file)(PcmHn pcm, Sint32 size);
	void	(*set_load_num)(PcmHn pcm, Sint32 load_sct);
	void	(*set_trmode)(PcmHn pcm, PcmTrMode mode);
} PcmExecFunc;

/* ݎQƂ̂߂̋錾 */
struct PcmWork;

/* 쐬p[^ */
typedef struct {
	struct PcmWork *work;		/* [ÑAhX 						*/
								/*  (Cugpٖ̍Ɨ̈) */
	Sint8		*ring_addr;		/* t@Ci[obt@̐擪AhX */
								/*  (̃t@C̎͂̃AhX) 	*/
								/*  (CD̃t@C̎ݸޯ̧̱ڽ) 	*/
	Sint32		ring_size;		/* obt@TCY[byte] 					*/
								/*  (̃t@C̎̓t@CTCY) 	*/
								/*  (CD̃t@C̎ݸޯ̧̃TCY 	*/
	Sint8		*pcm_addr;		/* TEhPCMobt@AhX 		*/
	Sint32		pcm_size;		/* TEhPCMobt@TCY[sample]*/
								/*  (1ch̃Tv 4096*1..4096*16) 	*/
} PcmCreatePara;

/* 쐬p[^ */
typedef struct {
	Sint8		*ring_addr;		/* t@Ci[obt@̐擪AhX */
								/*  (̃t@C̎͂̃AhX) 	*/
								/*  (CD̃t@C̎ݸޯ̧̱ڽ) 	*/
	Sint32		ring_size;		/* obt@TCY[byte] 					*/
								/*  (̃t@C̎̓t@CTCY) 	*/
								/*  (CD̃t@C̎ݸޯ̧̃TCY 	*/
	Sint8		*pcm_addr;		/* TEhPCMobt@AhX 		*/
	Sint32		pcm_size;		/* TEhPCMobt@TCY 		*/
								/*  (1ch̃Tv 4096*1..4096*16) 	*/

	Sint32		command_blk_no;		/* R}hubNԍ 				*/
	Sint32		pcm_stream_no;		/* oblXg[Đԍ 			*/
	Sint32		pcm_pan;			/* o`m     [0..31] 					*/
	Sint32		pcm_level;			/* kdudk [0..7] 					*/

	Sint32		start_trg_size;		/* ĐJngKTCY[byte] 			*/
	Sint32		start_trg_sample;	/* ĐJngKTv[sample/1ch] 	*/
	Sint32		stop_trg_sample;	/* Đ~gKTv[sample/1ch] 	*/
} PcmPara;

/* obl[N */
typedef struct {
	Sint32			work_start;		/* 'WORK' [N̊Jn 			*/
	PcmPara 		para;			/* p[^ 					*/
	PcmStatus 		status;			/* e퐧 				*/
	PcmFilePara 	filepara;		/* t@CANZXp[^ 	*/
	PcmExecFunc 	execfunc;		/* s֐ 					*/
} PcmWork;

/*-------------------------- s֐錾t --------------------------*/
/* Cȕ */
Bool PCM_Init(void);

/* CȕI */
void PCM_Finish(void);

/* `coblgp錾 */
void PCM_DeclareUseAdpcm(void);

/* nh̍쐬ij */
PcmHn PCM_CreateMemHandle(PcmCreatePara *para);

/* nh̏ij */
void PCM_DestroyMemHandle(PcmHn pcm);

/* nh̍쐬it@CVXej */
PcmHn PCM_CreateGfsHandle(PcmCreatePara *para, GfsHn gfs);

/* nh̏it@CVXej */
void PCM_DestroyGfsHandle(PcmHn pcm);

/* nh̍쐬iXg[VXej */
PcmHn PCM_CreateStmHandle(PcmCreatePara *para, StmHn stm);

/* nh̏iXg[VXej */
void PCM_DestroyStmHandle(PcmHn pcm);

/* Đ^XN */
void PCM_Task(PcmHn pcm);

/* uuNhm֐ */
void PCM_VblIn(void);

/* ĐJn */
void PCM_Start(PcmHn pcm);

/* Đ~ */
void PCM_Stop(PcmHn pcm);

/* ꎞ~ */
void PCM_Pause(PcmHn pcm, PcmPauseCmd cmd);

/* [v񐔂̎w */
void PCM_SetLoop(PcmHn pcm, Sint32 cnt_loop);

/* ɍĐnh̓o^ */
void PCM_EntryNext(PcmHn pcm);

/* nh̋؂ւ */
void PCM_Change(void);

/* nh̐؂ւԂ̎擾 */
PcmChangeStatus PCM_CheckChange(void);

/* |[Yp[NAhXATCY̐ݒ */
void PCM_SetPauseWork(Sint32 *addr, Sint32 size);

/* ő]ZN^̐ݒ */
void PCM_SetLoadNum(PcmHn pcm, Sint32 read_sct);

/* Đo`m̐ݒ */
void PCM_SetPan(PcmHn pcm, Sint32 pan);

/* Đ{[̐ݒ */
void PCM_SetVolume(PcmHn pcm, Sint32 volume);

/* oblĐp[^̕ύX */
void PCM_ChangePcmPara(PcmHn pcm);

/* oblĐ̐ݒ */
void PCM_SetInfo(PcmHn hn, PcmInfo *info);

/* P̃^XNŏʂ̏̐ݒ [sample/1ch] */
void PCM_Set1TaskSample(PcmHn pcm, Sint32 sample);

/* ĐJngKTCY̐ݒ [byte] */
void PCM_SetStartTrgSize(PcmHn pcm, Sint32 size);

/* ĐJngKTv̐ݒ [sample/1ch] */
void PCM_SetStartTrgSample(PcmHn pcm, Sint32 sample);

/* Đ~gKTv̐ݒ [sample/1ch] */
void PCM_SetStopTrgSample(PcmHn pcm, Sint32 sample);

/* oblR}hubNԍ̐ݒ */
/* void PCM_SetPcmCmdBlockNo(PcmHn pcm, Sint32 blk_no); */

/* oblXg[ԍ̐ݒ */
void PCM_SetPcmStreamNo(PcmHn pcm, Sint32 stream_no);

/* f[^̓]̐ݒibcubNOobt@j */
void PCM_SetTrModeCd(PcmHn pcm, PcmTrMode mode);

/* f[^̓]̐ݒiOobt@oblobt@j */
/* void PCM_SetTrModePcm(PcmHn pcm, PcmTrMode mode); */

/* Đ̎擾 */
Sint32 PCM_GetTime(PcmHn pcm);

/* ĐXe[^X̎擾 */
PcmPlayStatus PCM_GetPlayStatus(PcmHn pcm);

/* ݃obt@AhX̎擾 */
Uint32 *PCM_GetWriteBuf(PcmHn pcm, Sint32 *free_size, Sint32 *free_total);

/* obt@ւ̏݃TCY̒ʒm */
void PCM_NotifyWriteSize(PcmHn pcm, Sint32 write_size);

/* Ƀt@Cǂݍ */
Sint32 PCM_PreloadFile(PcmHn pcm, Sint32 size);

/* Ƀt@Cwb_ǂݍ */
/* Sint32 PCM_PreloadHeader(PcmHn pcm); */

/* G[֐̓o^ */
void PCM_SetErrFunc(PcmErrFunc func, void *obj);

/* G[̎擾 */
PcmErrCode PCM_GetErr(void);

/* J */
Bool PCM_IsDeath(PcmHn pcm);

#endif	/* SEGA_PCM_H */
