/*-----------------------------------------------------------------------------
 *  FILE: sega_snd.h
 *
 *      Copyright (c) by SEGA.
 *
 *  PURPOSE:
 *
 *      TEhI/FCuwb_t@CB
 *
 *  DESCRIPTION:
 *
 *      TEhhCoƂ̃C^tF[XB
 *
 *  AUTHOR(S)
 *
 *      1994-05-18  N.T Ver.0.90
 *
 *  MOD HISTORY:
 *
 *      1994-09-23  N.T Ver.1.04
 *
 *-----------------------------------------------------------------------------
 */

#ifndef SEGA_SND_H
#define SEGA_SND_H

/*
 * C VIRTUAL TYPES DEFINITIONS
 */
#include <machine.h>
#include "sega_xpt.h"
#include "sega_dma.h"
#include "sega_per.h"

/*
 * USER SUPPLIED INCLUDE FILES
 */

/*
 * GLOBAL DEFINES/MACROS DEFINES
 */
/**** 萔 *******************************************************************/
/******** ގs ******************************************************/
#define SND_RET_SET     0                       /* I                     */
#define SND_RET_NSET    1                       /* ُI                     */
/******** ޺۰ِݒ ****************************************************/
#define SND_CTRL_OUTPUT_STEREO  (0 << 7)        /* Sound output mode : STEREO*/
#define SND_CTRL_OUTPUT_MONO    (1 << 7)        /* Sound output mode : MONO  */

/******** Sequence PAN ۰ٽ ********************************************/
#define SND_SEQ_PAN_OFF (0 << 7)                /* Control OFF               */
#define SND_SEQ_PAN_ON  (1 << 7)                /* Control ON                */

/******** ʰ޳Ұ **************************************************/
#define SND_DRAM4           0                   /* DRAM 4Mbit r/w            */
#define SND_DRAM8           1                   /* DRAM 8Mbit r/w            */
#define SND_SCSP_MIDI       2                   /* SCSP MIDI                 */
#define SND_SOUND_SRC_LR    3                   /* o(L/R)            */
#define SND_SOUND_SRC_L     4                   /* o(L)              */
#define SND_SOUND_SRC_R     5                   /* o(R)              */
/******** ʰ޳ð ***************************************************/
#define SND_HARD_OK     0x8000                  /* I                  */
#define SND_HARD_ERR    0x7fff                  /* ُI                  */
/******** 荞݋rbg *************************************************/
#define SND_INT_PCM_ADR     (1 <<  7)           /* PCM play address XV   */
/******** Host荞ݎ *************************************************/
#define SND_FCT_PCM_ADR     0x01                /* PCM play address XV   */
/******** PCMڽXV荞ݽð ******************************************/
#define SND_PCM_PLAY0   (1 <<  0)               /* PCMĐԍ0              */
#define SND_PCM_PLAY1   (1 <<  1)               /* PCMĐԍ1              */
#define SND_PCM_PLAY2   (1 <<  2)               /* PCMĐԍ2              */
#define SND_PCM_PLAY3   (1 <<  3)               /* PCMĐԍ3              */
#define SND_PCM_PLAY4   (1 <<  4)               /* PCMĐԍ4              */
#define SND_PCM_PLAY5   (1 <<  5)               /* PCMĐԍ5              */
#define SND_PCM_PLAY6   (1 <<  6)               /* PCMĐԍ6              */
#define SND_PCM_PLAY7   (1 <<  7)               /* PCMĐԍ7              */

/******** SndSeqStat(V[PXXe[^X) ***********************************/
/************* SND_SEQ_STAT_MODE(song mode) **********************************/
#define SND_MD_STOP     0x000                           /* stop              */
#define SND_MD_PLAY     0x100                           /* play              */
#define SND_MD_FADE     0x200                           /* fade              */
#define SND_MD_PLAY_PS  0x300                           /* play pause        */
#define SND_MD_FADE_PS  0x400                           /* fade pause        */
/******** SndPcmStartPrm(PCMJnp[^) **********************************/
/************* SND_PRM_MODE(ڵɸ+ݸڰ) ***************************/
#define SND_MD_MONO     (0 <<  7)                   /* ɸ                  */
#define SND_MD_STEREO   (1 <<  7)                   /* ڵ                  */
#define SND_MD_16       (0 <<  4)                   /* 16bitPCM              */
#define SND_MD_8        (1 <<  4)                   /* 8bitPCM               */
/******** SND_MoveData(TEhf[^]) ***********************************/
#define SND_KD_TONE         0x0                         /* F              */
#define SND_KD_SEQ          0x1                         /* V[PX        */
#define SND_KD_DSP_PRG      0x2                         /* DSPvO     */
#define SND_KD_DSP_RAM      0x3                         /* DSPܰRAM         */
/**** ANZX}N *********************************************************/
/******** SndIniDt(VXeN) *********************************************/
#define SND_INI_PRG_ADR(sys_ini)    ((sys_ini).prg_adr) /* 68K۸ъi[... */
#define SND_INI_PRG_SZ(sys_ini)     ((sys_ini).prg_sz)  /* 68K۸ѻ... */
#define SND_INI_ARA_ADR(sys_ini)    ((sys_ini).ara_adr) /* ޴رϯߊi[. */
#define SND_INI_ARA_SZ(sys_ini)     ((sys_ini).ara_sz)  /* ޴رϯ߻. */
/******** SndSeqStat(V[PXXe[^X) ***********************************/
#define SND_SEQ_STAT_MODE(status)   ((status).mode)     /* song mode         */
#define SND_SEQ_STAT_STAT(status)   ((status).stat)     /* song status       */
/******** SndPcmStartPrm(PCMJnp[^) **********************************/
#define SND_PRM_MODE(prm)       ((prm).mode)        /* ڵɸ+ݸڰ */
#define SND_PRM_SADR(prm)       ((prm).sadr)        /* PCMذޯ̧ıڽ*/
#define SND_PRM_SIZE(prm)       ((prm).size)        /* PCMذޯ̧   */
#define SND_PRM_OFSET(prm)      ((prm).ofset)       /* PCMذэĐJn̾ */
/******** SndPcmChgPrm(PCMύXp[^) ************************************/
#define SND_PRM_NUM(prm)        ((prm).num)         /* PCMذэĐԍ       */
#define SND_PRM_LEV(prm)        ((prm).lev)         /* ޲ڸĉLevel         */
#define SND_PRM_PAN(prm)        ((prm).pan)         /* ޲ڸĉpan           */
#define SND_PRM_PICH(prm)       ((prm).pich)        /* PICHܰ              */
#define SND_R_EFCT_IN(prm)      ((prm).r_efct_in)   /* Efect in select(E)   */
#define SND_R_EFCT_LEV(prm)     ((prm).r_efct_lev)  /* Efect send Level(E)  */
#define SND_L_EFCT_IN(prm)      ((prm).l_efct_in)   /* Efect in select()   */
#define SND_L_EFCT_LEV(prm)     ((prm).l_efct_lev)  /* Efect send Level()  */
/******** SndPcmPlayAdr(PCMĐڽ) ****************************************/
#define SND_PCM_RADR(prm)       ((prm).radr)        /* Eo(ɸ)          */
#define SND_PCM_LADR(prm)       ((prm).ladr)        /* o                 */
/******** SndCdHzSrVl(gшʽڵ͉) ******************************/
#define SND_CD_LHIGH(hz_vl)     ((hz_vl).high.left) /* o          */
#define SND_CD_LMID(hz_vl)      ((hz_vl).mid.left)  /* o          */
#define SND_CD_LLOW(hz_vl)      ((hz_vl).low.left)  /* o ቹ         */
#define SND_CD_RHIGH(hz_vl)     ((hz_vl).high.right)/* Eo          */
#define SND_CD_RMID(hz_vl)      ((hz_vl).mid.right) /* Eo          */
#define SND_CD_RLOW(hz_vl)      ((hz_vl).low.right) /* Eo ቹ         */

#define SND_POKE_B(adr, data)   (*((volatile Uint8 *)(adr)) = ((Uint8)(data))) /* ޲*/
#define SND_POKE_W(adr, data)   (*((volatile Uint16 *)(adr)) = ((Uint16)(data)))
#define SND_PEEK_B(adr)         (*((volatile Uint8 *)(adr)))                   /* ޲*/

/**** VXeC^tF[X[NItZbg *********************************/
#define SND_ADR_INTR_CTRL_WORD  (0x00)          /* Interrupt control word    */
#define SND_ADR_INTR_MODE       (0x01)          /* Interrupt mode            */
#define SND_ADR_PCM_PLAY_NUM    (0x02)          /* PCM play num              */
#define SND_ADR_SND_CTRL        (0x03)          /* Sound control             */
/**** AhX ***************************************************************/
#define SND_ADR_INTR_RESET  ((volatile Uint16 *)0x25b0042e)  /* SCSP荞ؾڼ޽ */

/*荞 *******************************************************************/
/******************************************************************************
 *
 * NAME:    SND_SET_ENA_INT()       - 荞݋ݒ
 *
 * PARAMETERS :
 *      (1) Uint8 ena_bit   - <i>   荞݋rbg
 *
 * DESCRIPTION:
 *      荞݋ݒ肵܂B
 *
 * PRECONDITIONS:
 *      ȂB
 *
 * POSTCONDITIONS:
 *      Ȃ
 *
 * CAVEATS:
 *      ȂB
 *
 ******************************************************************************
 */

#define SND_SET_ENA_INT(ena_bit)\
    do{\
        snd_msk_work_work = get_imask();           /* ފ荞݂Disable*/\
        set_imask(15);\
        SND_POKE_B(snd_adr_sys_int_work + SND_ADR_INTR_CTRL_WORD, (ena_bit));\
        set_imask(snd_msk_work_work);\
    }while(FALSE)

/******************************************************************************
 *
 * NAME:    SND_GET_ENA_INT()       - 荞݋擾
 *
 * PARAMETERS :
 *      ȂB
 *
 * DESCRIPTION:
 *      荞݋擾܂B
 *
 * PRECONDITIONS:
 *      ȂB
 *
 * POSTCONDITIONS:
 *      (1) Uint8           - <o>   荞݋rbg
 *
 * CAVEATS:
 *      ȂB
 *
 ******************************************************************************
 */

#define SND_GET_ENA_INT()\
        (SND_PEEK_B(snd_adr_sys_int_work + SND_ADR_INTR_CTRL_WORD))

/******************************************************************************
 *
 * NAME:    SND_GET_FCT_INT()       - 荞ݗv擾
 *
 * PARAMETERS :
 *      ȂB
 *
 * DESCRIPTION:
 *      荞ݗv擾܂B
 *
 * PRECONDITIONS:
 *      ȂB
 *
 * POSTCONDITIONS:
 *      (1) Uint8       - <o>   荞ݗv
 *
 * CAVEATS:
 *      ȂB
 *
 ******************************************************************************
 */

#define SND_GET_FCT_INT()\
        (SND_PEEK_B(snd_adr_sys_int_work + SND_ADR_INTR_MODE))

/******************************************************************************
 *
 * NAME:    SND_RESET_INT()     - 荞ؾ
 *
 * PARAMETERS :
 *      ȂB
 *
 * DESCRIPTION:
 *      荞݂ؾĂ܂B
 *
 * PRECONDITIONS:
 *      ȂB
 *
 * POSTCONDITIONS:
 *      Ȃ
 *
 * CAVEATS:
 *      ȂB
 *
 ******************************************************************************
 */

#define SND_RESET_INT()\
        (SND_POKE_W(SND_ADR_INTR_RESET, (1 << 5)))

/******************************************************************************
 *
 * NAME:    SND_GET_INT_STAT()  - PCMsAhXXV荞݃Xe[^X擾
 *
 * PARAMETERS :
 *      ȂB
 *
 * DESCRIPTION:
 *      PCMsAhXXV荞݃Xe[^X擾܂B
 *
 * PRECONDITIONS:
 *      ȂB
 *
 * POSTCONDITIONS:
 *      (1) SndPcmIntStat *     - <o>   PCMsAhXXV荞݃Xe[^X
 *
 * CAVEATS:
 *      ȂB
 *
 ******************************************************************************
 */
 
#define SND_GET_INT_STAT()\
    (SND_PEEK_B(snd_adr_sys_int_work + SND_ADR_PCM_PLAY_NUM))

/*̑ *********************************************************************/
/******************************************************************************
 *
 * NAME:    SND_SET_SND_CTRL        - TEhRg[ݒ
 *
 * PARAMETERS :
 *      (1) Uint8   ctrl_bit   - <i>   荞݋rbg
 *
 * DESCRIPTION:
 *      TEhRg[ݒ肵܂B
 *
 * PRECONDITIONS:
 *      ȂB
 *
 * POSTCONDITIONS:
 *      Ȃ
 *
 * CAVEATS:
 *      ȂB
 *
 ******************************************************************************
 */

#define SND_SET_SND_CTRL(ctrl_bit)\
    do{\
        SND_POKE_B(snd_adr_sys_int_work + SND_ADR_SND_CTRL, (ctrl_bit));\
    }while(FALSE)

/******************************************************************************
 *
 * NAME:    SND_GET_SND_CTRL        - TEhRg[擾
 *
 * PARAMETERS :
 *      ȂB
 *
 * DESCRIPTION:
 *      TEhRg[擾܂B
 *
 * PRECONDITIONS:
 *      ȂB
 *
 * POSTCONDITIONS:
 *      Ȃ
 *
 * CAVEATS:
 *      ȂB
 *
 ******************************************************************************
 */

#define SND_GET_SND_CTRL()\
        (SND_PEEK_B(snd_adr_sys_int_work + SND_ADR_SND_CTRL))

/*
 * STRUCTURE DECLARATIONS
 */

/*
 * TYPEDEFS
 */

/****  *******************************************************************/
typedef struct{
    Uint16 *prg_adr;                        /* 68K۸ъi[擪ڽ       */
    Uint16 prg_sz;                          /* 68K۸ѻ޻           */
    Uint16 *ara_adr;                        /* ޴رϯߊi[擪ڽ     */
    Uint16 ara_sz;                          /* ޴رϯ߻(ܰޒP)    */
}SndIniDt;                                  /* VXeNf[^^          */

typedef Uint8 SndAreaMap;                   /* ޴رϯ߃f[^^          */
typedef Uint8 SndTlVl;                      /* S̉ʃf[^^              */
typedef Uint8 SndEfctBnkNum;                /* Effct bank numberf[^^     */
typedef Uint8 SndToneBnkNum;                /* F bank numberf[^^      */
typedef Uint8 SndMixBnkNum;                 /* Mixer numberf[^^          */
typedef Uint8 SndEfctOut;                   /* Effect out selectf[^^     */
typedef Uint8 SndLev;                       /* Levelf[^^                 */
typedef Sint8 SndPan;                       /* PANf[^^                   */
typedef Uint8 SndRet;                       /* ގsԃf[^^         */
typedef Uint8 SndHardPrm;                   /* ʰ޳Ұf[^^     */
typedef Uint16 SndHardStat;                 /* ʰ޳ðf[^^      */

/**** V[PX *************************************************************/
typedef Uint8 SndSeqNum;                    /* Ǘԍ                  */
typedef Uint8 SndSeqBnkNum;                 /* Sequence bank number          */
typedef Uint8 SndSeqSongNum;                /* Sequence song number          */
typedef Uint8 SndSeqPri;                    /* Priorty level                 */
typedef Uint8 SndSeqVl;                     /* Sequence Volume               */
typedef Uint8 SndFade;                      /* fade Rate                     */
typedef Sint16 SndTempo;                    /* Tempo                         */
typedef struct{
    Uint16 mode;                            /* song mode                     */
    Uint8 stat;                             /* song status                   */
}SndSeqStat;                                /* V[PXXe[^X          */
typedef Uint16 SndSeqPlayPos;               /* ǗԍĐʒu          */

/**** PCM ********************************************************************/
typedef struct{
    Uint8 mode;                             /* ڵɸ+ݸڰ         */
    Uint16 sadr;                            /* PCMذޯ̧ıڽ        */
    Uint16 size;                            /* PCMذޯ̧             */
}SndPcmStartPrm;                            /* PCMJnp[^          */

typedef Uint8 SndPcmNum;                    /* PCMذэĐԍ               */
typedef Uint8 SndEfctIn;                    /* Efect in select               */
typedef struct{
    SndPcmNum num;                          /* PCMذэĐԍ               */
    SndLev lev;                             /* ޲ڸĉLevel                 */
    SndPan pan;                             /* ޲ڸĉpan                   */
    Uint16 pich;                            /* PICHܰ                      */
    SndEfctIn r_efct_in;                    /* Efect in select(Eo)       */
    SndLev r_efct_lev;                      /* Efect send Level(Eo)      */
    SndEfctIn l_efct_in;                    /* Efect in select(o)       */
    SndLev l_efct_lev;                      /* Efect send Level(o)      */
}SndPcmChgPrm;                              /* PCMύXp[^           */

typedef struct{
    Uint8 radr;                             /* Eo(ɸ)                  */
    Uint8 ladr;                             /* o                         */
}SndPcmPlayAdr;                             /* PCMĐڽ               */

typedef Uint8 SndPcmIntStat;                /* PCMڽXV荞ݽð     */

/**** CD *********************************************************************/
typedef Uint16 SndCdVlAnl;                  /* ͉                      */

typedef struct{
    SndCdVlAnl left;                        /* o                        */
    SndCdVlAnl right;                       /* Eo                        */
}SndCdHzVl;                                 /* gшʽڵ͉      */

typedef struct{
    SndCdHzVl high;                         /*                         */
    SndCdHzVl mid;                          /*                         */
    SndCdHzVl low;                          /* ቹ                        */
}SndCdHzSrVl;                               /* gшʉ͉          */

/*
 * EXTERNAL VARIABLE DECLARATIONS
 */
extern Uint8 *snd_adr_sys_int_work;             /*Ѳ̪ܰ擪ڽi[*/
extern Uint32 snd_msk_work_work;                /* sound priority msk        */

/*
 * EXTERNAL FUNCTION PROTOTYPE  DECLARATIONS
 */
void SND_Init(SndIniDt *);
void SND_MoveData(Uint16 *, Uint32, Uint16, Uint16);
SndRet SND_ChgMap(SndAreaMap);
SndRet SND_SetTlVl(SndTlVl);
SndRet SND_ChgEfct(SndEfctBnkNum);
SndRet SND_ChgMix(SndToneBnkNum, SndMixBnkNum);
SndRet SND_ChgMixPrm(SndEfctOut, SndLev, SndPan);
SndRet SND_ChkHard(SndHardStat *, SndHardPrm);
SndRet SND_StopDsp(void);
SndRet SND_OffAllSound(void);
SndRet SND_StartSeq(SndSeqNum, SndSeqBnkNum, SndSeqSongNum, SndSeqPri);
SndRet SND_StopSeq(SndSeqNum);
SndRet SND_PauseSeq(SndSeqNum);
SndRet SND_ContSeq(SndSeqNum);
SndRet SND_SetSeqVl(SndSeqNum, SndSeqVl, SndFade);
SndRet SND_ChgTempo(SndSeqNum, SndTempo);
SndRet SND_CtrlDirMidi(SndSeqNum, SndSeqPri, Uint8, Uint8, Uint8, Uint8);
SndRet SND_SetSeqPan(SndSeqNum, Uint8, Uint8 );
SndRet SND_StartPcm(SndPcmStartPrm *, SndPcmChgPrm *);
SndRet SND_StopPcm(SndPcmNum);
SndRet SND_ChgPcm(SndPcmChgPrm *);
SndRet SND_StartVlAnl(void);
SndRet SND_StopVlAnl(void);
SndRet SND_SetCdDaLev(SndLev, SndLev);
SndRet SND_SetCdDaPan(SndPan, SndPan);
void SND_GetSeqStat(SndSeqStat *, SndSeqNum);
void SND_GetSeqPlayPos(SndSeqPlayPos *, SndSeqNum);
void SND_GetPcmPlayAdr(SndPcmPlayAdr *, SndPcmNum);
void SND_GetAnlTlVl(SndCdVlAnl *, SndCdVlAnl *);
void SND_GetAnlHzVl(SndCdHzSrVl *);

#endif  /* ifndef SEGA_SND_H */
