/*******************************************************************
 *
 *                     T^[pbcCu
 *
 *                         MPEGCu
 *
 *             Copyright (c) 1993 CSK Research Institute Corp.
 *             Copyright (c) 1994 SEGA
 *
 *  Module : ĐW[\[Xt@C
 *  File   : mpg_mve.c
 *  Date   : 1996-01-31
 *  Author : M.Oshimi, H.Take
 *
 *******************************************************************/

/*******************************************************************
 *      CN[ht@C
 *******************************************************************/
#include        <string.h>
#include        "mpg_loc.h"

/*******************************************************************
 *      萔}N
 *******************************************************************/

/* MPEGnh̍ő吔 */
#define MPG_MV_MAX      16

/* Đ̒~҂̃^CAEgJE^iPbj */
#define MSTOP_CNT       7000

/* sN`XVtOOFFł */
#define UPDPIC_OFF      0

/*******************************************************************
*       񋓒萔
*******************************************************************/

/*******************************************************************
 *      }N
 *******************************************************************/

/*******************************************************************
 *      ֐錾
 *******************************************************************/

static MpgMv    createNew(void);
static Sint32   getCdbno(StmHn stm);
static void     initMpHn(MpgMv mpgmv);
static Sint32   waitMovieStop(MpgMv mpgmv);
static void     deleteMpgmv(MpgMv mpgmv);
static Sint32   getVideoStatSub(MpgMv mpgmv, Sint32 *err);
static Sint32   getAudioStatSub(MpgMv mpgmv, Sint32 *err);
static Sint32   outputSub(MpgMv mpgmv, Bool chkupic);

/*******************************************************************
 *      ϐ`
 *******************************************************************/

/* MPEGrfInh */
static MpgMovie mp_movie[MPG_MV_MAX];

/*******************************************************************
 *      ֐`
 *******************************************************************/

/* MPEGnh̐ */
MpgMv   MPG_MvCreate(StmHn vstm, StmHn astm)
{
    MpgMv       mpgmv;

    if ((vstm == NULL) && (astm == NULL)) {
        MPSYS_SetErrCode(MPG_ERR_CREATE);
        return NULL;
    }
    if ((mpgmv = createNew()) == NULL) {
        MPSYS_SetErrCode(MPG_ERR_CREATE);
        return NULL;
    }

    /* obt@ԍ̐ݒ */
    MPG_MV_PMODE(mpgmv) = MPG_PMODE_AV;	/* AV Đ[h */
    MPG_MV_VBNO(mpgmv) = MPG_NOCDB;
    MPG_MV_ABNO(mpgmv) = MPG_NOCDB;
    MPG_MV_VLAY(mpgmv) = MPG_IGNORE;
    MPG_MV_ALAY(mpgmv) = MPG_IGNORE;
    if (vstm != NULL) {
        if (astm == NULL) {
            MPG_MV_PMODE(mpgmv) = MPG_PMODE_V;	/* rfIĐ[h */
        }
        MPG_MV_VBNO(mpgmv) = getCdbno(vstm);
        MPG_MV_VLAY(mpgmv) = MPG_LAY_SYS;
    }
    if (astm != NULL) {
        if (vstm == NULL) {
            MPG_MV_PMODE(mpgmv) = MPG_PMODE_A;	/* I[fBIĐ[h */
        }
        MPG_MV_ABNO(mpgmv) = getCdbno(astm);
        MPG_MV_ALAY(mpgmv) = MPG_LAY_SYS;
    }

    /* MPEGnh̏ */
    initMpHn(mpgmv);

    return mpgmv;
}

/* MPEGnhIuWFNg̐ */
static MpgMv    createNew(void)
{
    Sint32      i;
    MpgMovie    *mvptr;
    
    for (i = 0; i < MPG_MV_MAX; i++) {
        mvptr = &mp_movie[i];
        if (MPG_MV_USEDFLAG(mvptr) == FALSE) {
            MPG_MV_USEDFLAG(mvptr) = TRUE;
            return mvptr;
        }
    }
    return NULL;
}

/* obt@ԍ̎擾 */
static Sint32   getCdbno(StmHn stm)
{
    StmFrange   range;
    StmKey      stmkey;
    Sint32      fid, bn;

    STM_GetInfo(stm, &fid, &range, &bn, &stmkey);
    
    return bn;
}

/* MPEGnh̏ */
static void     initMpHn(MpgMv mpgmv)
{
    Sint32      i;

    /* ɍĐMPEG */
    MPG_MV_NEXTMV(mpgmv) = NULL;

    /* Đ쒆tO */
    MPG_MV_ACTA(mpgmv) = OFF;
    MPG_MV_ACTV(mpgmv) = OFF;
        
    /* I̐ݒ */
    MPG_MV_VCND(mpgmv) = MPG_TCND_SEC;
    MPG_MV_ACND(mpgmv) = MPG_TCND_SEC;
        
    /* ĐItO */
    MPG_MV_ISMVEND(mpgmv) = FALSE;
        
    /* ΃^CR[htO */
    MPG_MV_TCFLAG(mpgmv) = OFF;

    /* o͐̐ݒ */
    MPG_MV_OUTDST(mpgmv) = MPG_OUTDST_DRCT;

    /* fR[h^C~O̐ݒ */
    MPG_MV_DECTMG(mpgmv) = MPG_DECTMG_VSYNC;

    /* `lԍ̐ݒ */
    MPG_MV_ACH(mpgmv) = MPG_IGNORE;
    MPG_MV_VCH(mpgmv) = MPG_IGNORE;

    /* Xg[ID̐ݒ */
    MPG_MV_AID(mpgmv) = MPG_IGNORE;
    MPG_MV_VID(mpgmv) = MPG_IGNORE;

    /* |[Y̐ݒ */
    MPG_MV_PAUTIM(mpgmv) = 1;

    /* t[Y̐ݒ */
    MPG_MV_FRZTIM(mpgmv) = 1;

    /* I[fBĨ~[g̐ݒ */
    MPG_MV_AMUTE(mpgmv) = 0x04;

    /* ŏ̊G̃^CR[h̐ݒ */
    MPG_MV_FTC(mpgmv) = -1;

    /* fBXvCEBhE̐ݒ */
    for (i = 0; i < MPL_FRM_NUM; i++) {
        MPG_MV_MPGWN(mpgmv, i) = NULL;
    }

    /* rfIXg[̏[h */
    MPG_MV_CLRV(mpgmv) = MPG_VCLR_ALL;

    /* I[fBIXg[̏[h */
    MPG_MV_CLRA(mpgmv) = MPG_ACLR_ALL;

    return;
}

/* MPEGnh̏ */
Sint32  MPG_MvDestroy(MpgMv mpgmv)
{
    Sint32      ret;

    MPSYS_SemaIn(FALSE);
    
    /* Đ̒~ */
    ret = MPG_MvStop(mpgmv);

    /* Đ̒~҂ */
    /* Đ̒~֐sʂɂ炸A~҂s */
    /* ɒ~ꍇ́AĐ̒~֐̕Ԃlێ */
    if (waitMovieStop(mpgmv) == MPG_ERR_OK) {
        deleteMpgmv(mpgmv);
    } else {
        ret = MPG_ERR_DESTROY;
    }

    return MPSYS_SemaOut(ret);
}

/* Đ̒~҂ */
static Sint32   waitMovieStop(MpgMv mpgmv)
{
    Sint32      cnt;

    cnt = 0;

    while (TRUE) {
        /* G[STOPԂ̂ŁAnh͎s */
        /* A֐Őݒ肵G[R[h͖ƂȂ\ */
        if ((MPG_MvGetVideoStat(mpgmv) == MPG_VSTAT_STOP) &&
            (MPG_MvGetAudioStat(mpgmv) == MPG_ASTAT_STOP)) {
            break;
        }

        /* ^CAEg̃`FbN */
        if (cnt++ > MSTOP_CNT) {
            return MPG_ERR_NG;
        }
    }
    return MPG_ERR_OK;
}

/* MPEGnhIuWFNg̏ */
static void     deleteMpgmv(MpgMv mpgmv)
{
    if (mpgmv != NULL) {
        MPG_MV_USEDFLAG(mpgmv) = FALSE;
    }
    /* MPEGnhIuWFNĝONA */
    memset(mpgmv, 0, sizeof(MpgMovie));
    
    return;
}

/* ̏I̐ݒ */
void    MPG_MvSetTermCond(MpgMv mpgmv, Sint32 vcnd, Sint32 acnd)
{
    if (vcnd != MPG_IGNORE) {
        MPG_MV_VCND(mpgmv) = vcnd;
    }
    if (acnd != MPG_IGNORE) {
        MPG_MV_ACND(mpgmv) = acnd;
    }
    return;
}

/* ̏o͐̐ݒ */
void    MPG_MvSetVideoDest(MpgMv mpgmv, Sint32 dst)
{
    MPG_MV_OUTDST(mpgmv) = dst;

    return;
}

/* fR[h^C~O̐ݒ */
void    MPG_MvSetDecTim(MpgMv mpgmv, Sint32 tmg)
{
    if (MPG_MV_PMODE(mpgmv) == MPG_PMODE_V) {
        MPG_MV_DECTMG(mpgmv) = tmg;
    }
    return;
}

/* ꎞ~^R}^X[Đ */
void    MPG_MvPause(MpgMv mpgmv, Sint32 cmd, Sint32 itvl)
{
    Sint32      err;
    Sint32      pau;
    
    MPSYS_SemaIn(FALSE);

    err = MPG_ERR_OK;
    if (MPG_MV_PMODE(mpgmv) != MPG_PMODE_A) {
        switch (cmd) {
        case MPG_PAUSE_ON:
            pau = 0;
            break;
        case MPG_PAUSE_OFF:
            pau = 1;
            break;
        default:
            pau = itvl;
            break;
        }
        MPG_MV_PAUTIM(mpgmv) = pau;

        if (MPG_MV_ACTV(mpgmv) == ON) {
            /* fR[h@̐ݒ֐s */
            err = MPSYS_DoSetDec(MPG_IGNORE, pau, MPG_IGNORE);
            if (err == MPG_ERR_OK) {
                /* MPEǦ݂̃|[Y^C~O̐ݒ */
                MPSYS_SetPauTim(pau);
            }
        }
    }
    
    MPSYS_SemaOut(err);

    return;
}

/* t[Y^Xg{Đ */
void    MPG_MvFreeze(MpgMv mpgmv, Sint32 cmd, Sint32 itvl)
{
    Sint32      err;
    Sint32      frz;

    MPSYS_SemaIn(FALSE);

    err = MPG_ERR_OK;
    if (MPG_MV_PMODE(mpgmv) != MPG_PMODE_A) {
        switch (cmd) {
        case MPG_FREEZE_ON:
            frz = 0;
            break;
        case MPG_FREEZE_OFF:
            frz = 1;
            break;
        default:
            frz = itvl;
            break;
        }
        MPG_MV_FRZTIM(mpgmv) = frz;

        if (MPG_MV_ACTV(mpgmv) == ON) {
            /* fR[h@̐ݒ֐s */
            err = MPSYS_DoSetDec(MPG_IGNORE, MPG_IGNORE, frz);
        }
    }
    
    MPSYS_SemaOut(err);

    return;
}

/* ̍E`l̐ݒ */
void    MPG_MvSetPan(MpgMv mpgmv, Bool lsw, Bool rsw)
{
    Sint32      err;
    Sint32      mute;
    
    MPSYS_SemaIn(FALSE);

    err = MPG_ERR_OK;
    if (MPG_MV_PMODE(mpgmv) != MPG_PMODE_V) {
        /* dlƂāARt[~[g͏ɂłȂiŒlj */
        mute = CDC_MPMUT_DFL;
        if (rsw == OFF) {
            mute |= CDC_MPMUT_R;
        }
        if (lsw == OFF) {
            mute |= CDC_MPMUT_L;
        }
        MPG_MV_AMUTE(mpgmv) = mute;

        if (MPG_MV_ACTA(mpgmv) == ON) {
            /* fR[h@̐ݒ֐s */
            err = MPSYS_DoSetDec(mute, MPG_IGNORE, MPG_IGNORE);
        }
    }
    
    MPSYS_SemaOut(err);

    return;
}

/* rfI̓Ԃ̎擾 */
Sint32  MPG_MvGetVideoStat(MpgMv mpgmv)
{
    Sint32      stat;
    Sint32      err;

    MPSYS_SemaIn(TRUE);

    /* rfI̓Ԃ̎擾s */
    stat = getVideoStatSub(mpgmv, &err);

    MPSYS_SemaOut(err);

    return stat;
}

/* rfI̓Ԃ̎擾s */
static Sint32   getVideoStatSub(MpgMv mpgmv, Sint32 *err)
{
    CdcMpStat   mpstat, *msptr;
    Sint32      stat;

    stat = MPG_VSTAT_STOP;
    *err = MPG_ERR_OK;
    if (MPG_MV_ACTV(mpgmv) == OFF) {
        return stat;
    }

    msptr = &mpstat;

    /* ݂MPEGXe[^X̎擾 */
    if (CDC_MpGetCurStat(msptr) != CDC_ERR_OK) {
        *err = MPG_ERR_NG;
        return stat;
    }

    switch (CDC_MPGET_ASTV(msptr)) {
    case CDC_MPASTV_STOP:
        if (MPSYS_IsVbvEmpty(err)) {
            stat = MPG_VSTAT_STOP;
        } else {
            stat = MPG_VSTAT_PLAY;
        }
        break;
    case CDC_MPASTV_PRE1:
    case CDC_MPASTV_PRE2:
        stat = MPG_VSTAT_PREP;
        break;
    case CDC_MPASTV_TRNS:
        if ((CDC_MPSTAT_STV(msptr) & CDC_MPSTV_RDY) == 0) {
            stat = MPG_VSTAT_PREP;
        } else {
            stat = MPG_VSTAT_PLAY;
        }
        break;
    case CDC_MPASTV_CHG:
        stat = MPG_VSTAT_PLAY;
        break;
    case CDC_MPASTV_RCV:
        stat = MPG_VSTAT_ERR;
        break;
    default:
        stat = MPG_VSTAT_PREP;
        break;
    }
    return stat;
}

/* I[fBI̓Ԃ̎擾 */
Sint32  MPG_MvGetAudioStat(MpgMv mpgmv)
{
    Sint32      stat;
    Sint32      err;
    
    MPSYS_SemaIn(TRUE);
    
    /* I[fBI̓Ԃ̎擾s */
    stat = getAudioStatSub(mpgmv, &err);

    MPSYS_SemaOut(err);

    return stat;
}

/* I[fBI̓Ԃ̎擾s */
static Sint32   getAudioStatSub(MpgMv mpgmv, Sint32 *err)
{
    CdcMpStat   mpstat, *msptr;
    Sint32      stat;
    
    stat = MPG_ASTAT_STOP;
    *err = MPG_ERR_OK;
    if (MPG_MV_ACTA(mpgmv) == OFF) {
        return stat;
    }

    msptr = &mpstat;

    /* ݂MPEGXe[^X̎擾 */
    if (CDC_MpGetCurStat(msptr) != CDC_ERR_OK) {
        *err = MPG_ERR_NG;
        return stat;
    }

    switch (CDC_MPGET_ASTA(msptr)) {
    case  CDC_MPASTA_STOP:
        stat = MPG_ASTAT_STOP;
        break;
    case CDC_MPASTA_PRE1:
    case CDC_MPASTA_PRE2:
        stat = MPG_ASTAT_PREP;
        break;
    case CDC_MPASTA_TRNS:
        stat = MPG_ASTAT_PLAY;
        break;
    case CDC_MPASTA_CHG:
        stat = MPG_ASTAT_PLAY;
        break;
    case CDC_MPASTA_RCV:
        stat = MPG_ASTAT_ERR;
        break;
    default:
        stat = MPG_ASTAT_PREP;
        break;
    }
    return stat;
}

/* MPEGEBhE̐ڑ */
void    MPG_MvConnectWin(MpgMv mpgmv, MpgWn mpgwn)
{
    MPSYS_SemaIn(FALSE);
    
    /* gpt[oN͂OŌŒ */
    MPG_WN_FBN(mpgwn) = MPL_FBN_MV;
    
    if (MPG_MV_PMODE(mpgmv) != MPG_PMODE_A) {
        if (MPG_MV_MPGWN(mpgmv, MPL_FBN_MV) == NULL) {
            MPG_MV_MPGWN(mpgmv, MPL_FBN_MV) = mpgwn;
        } else {
            MPWIN_Connect(MPG_MV_MPGWN(mpgmv, MPL_FBN_MV), mpgwn);
        }
        if (MPG_MV_ACTV(mpgmv) == ON) {
            MPG_MvOutput(mpgmv, ON);
        }
    }
    
    MPSYS_SemaOut(MPG_ERR_OK);

    return;
}

/* MPEGEBhE̐؂藣 */
void    MPG_MvDisconnectWin(MpgMv mpgmv, MpgWn mpgwn)
{
    MPSYS_SemaIn(FALSE);
    
    if (MPG_MV_ACTV(mpgmv) == ON) {
        MPG_WnDisp(mpgwn, OFF);
    }
    if (MPG_MV_MPGWN(mpgmv, MPL_FBN_MV) == mpgwn) {
        MPG_MV_MPGWN(mpgmv, MPL_FBN_MV) = NULL;
    } else {
        MPWIN_Disconnect(mpgwn);
    }
    
    MPSYS_SemaOut(MPG_ERR_OK);

    return;
}

/* ̃fR[h̎s */
Sint32  MPG_MvDecNext(MpgMv mpgmv)
{
    Sint32      ret;

    /* rfĨfR[hs */
    /* it[oNԍj͐Î~Đ[hŗL */
    ret = MPMVE_DecNext(mpgmv, 0);

    return ret;
}

/* rfĨfR[hs */
Sint32  MPMVE_DecNext(MpgMv mpgmv, Sint32 bnk)
{
    Sint32      ret;

    MPSYS_SemaIn(FALSE);

    ret = MPG_ERR_ILLSTAT;
    
    if (MPG_MV_ACTV(mpgmv) == ON) {
        /* fR[hM̑o֐s */
        ret= MPSYS_DoOutDsync(bnk);
    }

    return MPSYS_SemaOut(ret);
}

/* ̏o */
Sint32  MPG_MvOutput(MpgMv mpgmv, Bool chkupic)
{
    Sint32      ret;
    
    MPSYS_SemaIn(FALSE);
    
    /* ̏o͎s */
    ret = outputSub(mpgmv, chkupic);

    return MPSYS_SemaOut(ret);
}

/* ̏o͎s */
static Sint32   outputSub(MpgMv mpgmv, Bool chkupic)
{
    Sint32      ret;
    Sint32      upc;
    CdcMpStat   mpstat;
    
    /* MPEǦ݂̏Ԃ̎擾 */
    if (CDC_MpGetCurStat(&mpstat) != CDC_ERR_OK) {
        return MPG_ERR_NG;
    }
    upc = CDC_MPSTV_UPDPIC;
    if (chkupic == ON) {
        upc &= CDC_MPSTAT_STV(&mpstat);
    }

    /* rfȈo */
    ret = MPMVE_Output(mpgmv, upc, 0);

    return ret;
}

/* rfȈo */
Sint32  MPMVE_Output(MpgMv mpgmv, Sint32 upc, Sint32 bnk)
{
    Sint32      ret;
    Sint32      omode;

    ret = MPG_ERR_ILLSTAT;

    if (MPG_MvGetVideoStat(mpgmv) == MPG_VSTAT_PLAY) {
        omode = MPG_MV_OUTDST(mpgmv);
        if ((MPG_MV_ACTV(mpgmv) == ON) &&
            (omode == MPG_OUTDST_HOST) &&
            (upc != UPDPIC_OFF)) {

            /* ڑĂSẴEBhE] */
            MPWIN_OutputAll(MPG_MV_MPGWN(mpgmv, bnk), omode);

            ret = MPG_ERR_OK;
        }
    }
    return ret;
}

/* Xg[̋؂ւ */
Sint32  MPG_MvChange(MpgMv mpgmv)
{
    Bool        vflg, aflg, setflg;
    Sint32      ret;
    Sint32      chg_a, chg_v;
    
    MPSYS_SemaIn(TRUE);

    ret = MPG_ERR_ILLSTAT;
    chg_a = MPG_IGNORE;
    chg_v = MPG_IGNORE;

    vflg = (MPSYS_ReqVideoCon(MPG_STM_CUR) == MPG_MV_VBNO(mpgmv));
    aflg = (MPSYS_ReqAudioCon(MPG_STM_CUR) == MPG_MV_ABNO(mpgmv));

    switch (MPG_MV_PMODE(mpgmv)) {
    case MPG_PMODE_V:
        setflg = vflg;
        chg_v = CDC_MPCOF_CHG;
        break;
    case MPG_PMODE_A:
        setflg = aflg;
        chg_a = CDC_MPCOF_CHG;
        break;
    default:
        setflg = (vflg && aflg);
        chg_a = CDC_MPCOF_CHG;
        chg_v = CDC_MPCOF_CHG;
        break;
    }

    if (setflg) {
        /* MPEGfR[_̐ڑ̐؂ւ֐s */
        ret = MPSYS_DoChgCon(chg_a, chg_v,
                             MPG_MV_CLRA(mpgmv), MPG_MV_CLRV(mpgmv));
    }

    return MPSYS_SemaOut(ret);
}

/* obt@̏@̐ݒ */
void    MPG_MvSetClearMode(MpgMv mpgmv, Sint32 vmode, Sint32 amode)
{
    MPG_MV_CLRV(mpgmv) = vmode;
    MPG_MV_CLRA(mpgmv) = amode;
    
    return;
}

/* Xg[C̐ݒ */
void    MPG_MvSetLay(MpgMv mpgmv, Sint32 vlay, Sint32 alay)
{
    if (vlay != MPG_NOCHG) {
        MPG_MV_VLAY(mpgmv) = vlay;
    }
    if (alay != MPG_NOCHG) {
        MPG_MV_ALAY(mpgmv) = alay;
    }
    return;
}

/* SMPEGnh̏ */
void    MPMVE_InitAllMv(void)
{
    Sint32      i;
    
    for (i = 0; i < MPG_MV_MAX; i++) {
        /* MPEGnhIuWFNg̏ */
        deleteMpgmv(&mp_movie[i]);
    }
    return;
}



