/*******************************************************************
 *
 *                     T^[pbcCu
 *
 *                         MPEGCu
 *
 *             Copyright (c) 1993 CSK Research Institute Corp.
 *             Copyright (c) 1994 SEGA
 *
 *  Module : ĐW[\[Xt@CQ
 *  File   : mpg_mve2.c
 *  Date   : 1996-01-31
 *  Author : M.Oshimi, H.Take
 *
 *******************************************************************/

/*******************************************************************
 *      CN[ht@C
 *******************************************************************/
#include        <machine.h>
#include        <string.h>
#include        "mpg_loc.h"

/*******************************************************************
 *      萔}N
 *******************************************************************/

/* PʎԂ̃sN` */
#define SEC_PICS        30              /* Pb̃sN` */
#define MIN_PICS        (60 * SEC_PICS) /* P̃sN` */
#define HOUR_PICS       (60 * MIN_PICS) /* PԂ̃sN` */

/* MPEG A/VXg[̎ʗp萔 */
#define SID_V           0               /* rfI */
#define SID_A           1               /* I[fBI */

/* Đ̒~̃^CAEgJE^iPbj */
#define MVABT_CNT       200

/* 荞݃}XN */
#define IR_MASK         15

/* I[fBI̒~mF̃^CAEgJE^ */
#define ASTOP_CNT       50

/*******************************************************************
*       񋓒萔
*******************************************************************/

/* MPEGXg[̐ݒID */
enum setstmId {
    SETSTM_CN_V = 0,    /* rfI`l */
    SETSTM_CN_A = 1,    /* I[fBI`l */
    SETSTM_ID_V = 2,    /* rfĨXg[hc */
    SETSTM_ID_A = 3     /* I[fBĨXg[hc */
};

/*******************************************************************
 *      }N
 *******************************************************************/

/* ^^b^sN`獇vsN`߂ */
#define GET_TOTAL(h, m, s, p)   ((((h) * 60 + (m)) * 60 + (s)) * 30 + (p))

/* PTS~bPʂɕϊ */
#define CONV_PTS(pts)           ((pts) / 90)

/*******************************************************************
 *      ֐錾
 *******************************************************************/

static void     setCurStm(MpgMv mpgmv, Sint32 para, Sint32 type);
static Sint32   setStm(MpgMv mpgmv, Sint32 next);
static void     setStmSub(CdcMpStm *sptr, Sint32 ch, Sint32 id);
static Sint32   execMvStart(MpgMv mpgmv, Bool picsch);
static Sint32   setMvCond(MpgMv mpgmv);
static Sint32   setMovie(MpgMv mpgmv);
static Sint32   setConNext(MpgMv mpgmv);
static Sint32   checkAudioStat(MpgMv mpgmv);
static Sint32   chgMpHn(MpgMv mpgmv);
static void     killMovie(MpgMv mpgmv);
static Sint32   checkVideoStat(MpgMv mpgmv);
static void     get1stTc(MpgMv mpgmv, Sint32 *fpic);
static Sint32   getTc(void);
static void     decompTc(Sint32 total,
                         Sint32 *h, Sint32 *m, Sint32 *s, Sint32 *p);
static Sint32   chkVideo(MpgMv mpgmv, Sint32 fpic);
static Sint32   checkAvStat(MpgMv mpgmv);
static Sint32   setConCur(MpgMv mpgmv, Bool picsch);
static Sint32   execMvStop(MpgMv mpgmv);
static Sint32   stopFunc(MpgMv mpgmv, Sint32 avsw);
static Sint32   cancelNext(CdcMpCon *mpcon_a, CdcMpCon *mpcon_v);
static Sint32   doStop(MpgMv mpgmv,
                       Sint32 avsw, CdcMpCon *acptr, CdcMpCon *vcptr);
static Sint32   abortDecode(MpgMv mpgmv,
                            Sint32 avsw, CdcMpCon *acptr, CdcMpCon *vcptr);
static Sint32   forceInit(MpgMv mpgmv);
static Sint32   resetVbv(void);
static Sint32   waitAstaStop(void);
static Sint32   doEntryNext(MpgMv mpgmv, MpgMv nextmv,
                            Bool setflg, Bool nxtflg);

/*******************************************************************
 *      ϐ`
 *******************************************************************/

/*******************************************************************
 *      ֐`
 *******************************************************************/

/* rfI`l̐ݒ */
void    MPG_MvSetVideoChan(MpgMv mpgmv, Sint32 vch)
{
    /* ݂MPEGXg[̐ݒ */
    setCurStm(mpgmv, vch, SETSTM_CN_V);

    return;
}

/* ݂MPEGXg[̐ݒ */
static void     setCurStm(MpgMv mpgmv, Sint32 para, Sint32 type)
{
    Sint32      err;
    Bool        chgflg;

    MPSYS_SemaIn(FALSE);

    err = MPG_ERR_OK;
    chgflg = FALSE;
    switch (type) {
    case SETSTM_CN_V:
        if (MPG_MV_VCH(mpgmv) != para) {
            MPG_MV_VCH(mpgmv) = para;
            chgflg = TRUE;
        }
        break;
    case SETSTM_CN_A:
        if (MPG_MV_ACH(mpgmv) != para) {
            MPG_MV_ACH(mpgmv) = para;
            chgflg = TRUE;
        }
        break;
    case SETSTM_ID_V:
        if (MPG_MV_VID(mpgmv) != para) {
            MPG_MV_VID(mpgmv) = para;
            chgflg = TRUE;
        }
        break;
    case SETSTM_ID_A:
        if (MPG_MV_AID(mpgmv) != para) {
            MPG_MV_AID(mpgmv) = para;
            chgflg = TRUE;
        }
        break;
    default:
        break;
    }
    if (chgflg) {
        err = setStm(mpgmv, MPG_STM_CUR);
    }

    MPSYS_SemaOut(err);

    return;
}

/* MPEGXg[iXg[IDƃ`lj̐ݒ */
static Sint32   setStm(MpgMv mpgmv, Sint32 next)
{
    Sint32      ret;
    CdcMpStm    mpstm_a, mpstm_v;

    /* MPEGXg[̃p[^ݒiI[fBIj */
    setStmSub(&mpstm_a, MPG_MV_ACH(mpgmv), MPG_MV_AID(mpgmv));

    /* MPEGXg[̃p[^ݒirfIj */
    setStmSub(&mpstm_v, MPG_MV_VCH(mpgmv), MPG_MV_VID(mpgmv));

    /* MPEGXg[̐ݒ֐s */
    ret = MPSYS_DoSetStm(next, &mpstm_a, &mpstm_v);

    return ret;
}

/* MPEGXg[̃p[^ݒ */
static void     setStmSub(CdcMpStm *sptr, Sint32 ch, Sint32 id)
{
    /* p[^̏ */
    CDC_MPSTM_SMOD(sptr) = 0;
    CDC_MPSTM_CN(sptr) = 0;
    CDC_MPSTM_ID(sptr) = 0;

    /* `l̐ݒ */
    if (ch != MPG_IGNORE) {
        CDC_MPSTM_SMOD(sptr) |= (CDC_MPSMOD_CNSET | CDC_MPSMOD_CNIDF);
        CDC_MPSTM_CN(sptr) = ch;
    }

    /* ID ̐ݒ */
    if (id != MPG_IGNORE) {
        CDC_MPSTM_SMOD(sptr) |= (CDC_MPSMOD_SNSET | CDC_MPSMOD_SNIDF);
        CDC_MPSTM_ID(sptr) = id;
    }
    
    return;
}

/* I[fBI`l̐ݒ */
void    MPG_MvSetAudioChan(MpgMv mpgmv, Sint32 ach)
{
    /* ݂MPEGXg[̐ݒ */
    setCurStm(mpgmv, ach, SETSTM_CN_A);

    return;
}

/* rfĨXg[hc̐ݒ */
void    MPG_MvSetVideoId(MpgMv mpgmv, Sint32 vid)
{
    /* ݂MPEGXg[̐ݒ */
    setCurStm(mpgmv, vid, SETSTM_ID_V);

    return;
}

/* I[fBĨXg[hc̐ݒ */
void    MPG_MvSetAudioId(MpgMv mpgmv, Sint32 aid)
{
    /* ݂MPEGXg[̐ݒ */
    setCurStm(mpgmv, aid, SETSTM_ID_A);

    return;
}

/* Đ̊Jn */
Sint32  MPG_MvStart(MpgMv mpgmv, Bool picsch)
{
    Sint32      ret;
    
    MPSYS_SemaIn(TRUE);
    
    /* Đ̊Jns */
    ret = execMvStart(mpgmv, picsch);

    return MPSYS_SemaOut(ret);
}

/* Đ̊Jns */
static Sint32   execMvStart(MpgMv mpgmv, Bool picsch)
{
    Sint32      ret;
    Bool        vflg, aflg;

    vflg = (MPSYS_ReqVideoCon(MPG_STM_CUR) != CDC_NUL_SEL);
    aflg = (MPSYS_ReqAudioCon(MPG_STM_CUR) != CDC_NUL_SEL);

    /* ̃Xg[Đۂ̃`FbN */
    switch (MPG_MV_PMODE(mpgmv)) {
    case MPG_PMODE_V:
        if (vflg) {
            return MPG_ERR_PLAYING;
        }
        break;
    case MPG_PMODE_A:
        if (aflg) {
            return MPG_ERR_PLAYING;
        }
        break;
    case MPG_PMODE_AV:
        if (vflg || aflg) {
            return MPG_ERR_PLAYING;
        }
        break;
    default:
        return MPG_ERR_PLAYING;
    }

    if ((MPG_MV_ACTA(mpgmv) == OFF) && (MPG_MV_ACTV(mpgmv) == OFF)) {
        /* MPEG샂[h̐ݒ֐s */
        ret = MPSYS_DoSetMode(MPG_NOCHG, MPG_MV_DECTMG(mpgmv),
                              MPG_MV_OUTDST(mpgmv), MPG_NOCHG);
        if (ret != MPG_ERR_OK) {
            return ret;
        }

        /* Đ̐ݒ */
        if ((ret = setMvCond(mpgmv)) != MPG_ERR_OK) {
            return ret;
        }

        /* Đ̐ݒ */
        if ((ret = setMovie(mpgmv)) != MPG_ERR_OK) {
            return ret;
        }
    }
    /* CDubNւ݂̌̃Xg[̐ݒ */
    if (setConCur(mpgmv, picsch) != MPG_ERR_OK) {
        return MPG_ERR_MCON;
    }
    return MPG_ERR_OK;
}

/* Đ̐ݒ */
static Sint32   setMvCond(MpgMv mpgmv)
{
    Sint32      ret;
    Sint32      omode;
    Sint32      pau;
    Sint32      plymod, tmod_v;
    MpgWn       mpgwn;

    /* ĐԂɂȂ摜o͊Jn */
    if (MPG_MvGetVideoStat(mpgmv) == MPG_VSTAT_PLAY) {
        mpgwn = MPG_MV_MPGWN(mpgmv, MPL_FBN_MV);
        omode = MPG_MV_OUTDST(mpgmv);
        if ((mpgwn != NULL) && (omode == MPG_OUTDST_HOST)) {
            MPWIN_OutputAll(mpgwn, omode);
        }
    }

    /* fR[h@̐ݒ */
    pau = MPG_MV_PAUTIM(mpgmv);
    if ((MPSYS_IsPauseVideo(&ret)) && (pau == 0x0000)) {
        pau = MPG_IGNORE;
    }
    if (ret != MPG_ERR_OK) {
        return ret;
    }
    /* fR[h@̐ݒ֐s */
    ret = MPSYS_DoSetDec(MPG_MV_AMUTE(mpgmv), pau, MPG_MV_FRZTIM(mpgmv));
    if (ret != MPG_ERR_OK) {
        return ret;
    }
    /* MPEǦ݂̃|[Y^C~O̐ݒ */
    MPSYS_SetPauTim(pau);
    
    /* MPEG̍Đ֐s */
    if (MPG_MV_PMODE(mpgmv) == MPG_PMODE_AV) {
        plymod = MPG_AV_SYNC;
    } else {
        plymod = MPG_AV_ASYNC;
    }
    if (MPG_GetVideoMode() == MPG_VMODE_MOVIE) {
        tmod_v = CDC_MPTRN_AUTO;        /* ] */
    } else {
        tmod_v = CDC_MPTRN_FORCE;       /* ] */
    }
    ret = MPSYS_DoPlay(plymod, MPG_IGNORE, tmod_v, MPG_IGNORE);
    if (ret != MPG_ERR_OK) {
        return ret;
    }
    
    ret = setStm(mpgmv, MPG_STM_CUR);
    
    return ret;
}

/* Đ̐ݒ */
/* ACTAACTV͕KOFF̏ԂŌĂ΂ */
static Sint32   setMovie(MpgMv mpgmv)
{
    Sint32      ret;
    MpgMv       nextmv;
    MplEventFunc        eventfunc;

    if (MPG_MV_USEDFLAG(mpgmv) == FALSE) {
        return MPG_ERR_ILLHDL;
    }

    nextmv = MPG_MV_NEXTMV(mpgmv);
    if (nextmv != NULL) {
        /* ɍĐ铮nhĂG[ */
        if (MPG_MV_USEDFLAG(nextmv) == FALSE) {
            return MPG_ERR_ILLHDL;
        }
        /* MPEGXg[̓o^ */
        if ((ret = setStm(nextmv, MPG_STM_NEXT)) != MPG_ERR_OK) {
            return ret;
        }

        /* ̐ڑ̓o^ */
        if ((ret = setConNext(nextmv)) != MPG_ERR_OK) {
            return ret;
        }
    }
    
    /* CxgN֐̓o^ */
    switch (MPG_MV_PMODE(mpgmv)) {
    case MPG_PMODE_A:
        eventfunc = (MplEventFunc)checkAudioStat;
        MPG_MV_ACTA(mpgmv) = ON;
        break;
    case MPG_PMODE_V:
        eventfunc = (MplEventFunc)checkVideoStat;
        MPG_MV_ACTV(mpgmv) = ON;
        break;
    default:
        eventfunc = (MplEventFunc)checkAvStat;
        MPG_MV_ACTA(mpgmv) = ON;
        MPG_MV_ACTV(mpgmv) = ON;
        break;
    }
    MPSYS_EntryEventFunc(eventfunc, mpgmv);
    MPG_MV_ISMVEND(mpgmv) = FALSE;
    
    return MPG_ERR_OK;
}

/* CDubNւ̎̃Xg[̐ݒ */
static Sint32   setConNext(MpgMv mpgmv)
{
    Sint32      ret;
    Sint32      cmod_a, lay_a, bn_a;
    Sint32      cmod_v, lay_v, bn_v;
    CdcMpCon    mpcon_a, mpcon_v, *acptr, *vcptr;

    /* l̐ݒ */
    cmod_a = cmod_v = MPG_IGNORE;
    lay_a = lay_v = MPG_LAY_SYS;
    bn_a = bn_v = MPG_NOCDB;

    if (mpgmv == NULL) {
        /* Xg[̏ꍇ */
        cmod_a = 0x00;
        cmod_v = 0x00;
    } else {
        if (MPG_MV_PMODE(mpgmv) != MPG_PMODE_A) {
            /* Videô݂܂AVĐ̏ꍇ */
            cmod_v = (CDC_MPCMOD_DEL | MPG_MV_VCND(mpgmv));
            lay_v = (MPG_MV_VLAY(mpgmv) | CDC_MPSRCH_OFF);
            bn_v = MPG_MV_VBNO(mpgmv);
        }
        if (MPG_MV_PMODE(mpgmv) != MPG_PMODE_V) {
            /* Audiô݂܂AVĐ̏ꍇ */
            cmod_a = (CDC_MPCMOD_DEL | MPG_MV_ACND(mpgmv));
            lay_a = MPG_MV_ALAY(mpgmv);
            bn_a = MPG_MV_ABNO(mpgmv);
        }
    }

    /* l̐ݒ */
    acptr = &mpcon_a;
    vcptr = &mpcon_v;

    CDC_MPCON_CMOD(acptr) = cmod_a;
    CDC_MPCON_LAY(acptr) = lay_a;
    CDC_MPCON_BN(acptr) = bn_a;
    CDC_MPCON_CMOD(vcptr) = cmod_v;
    CDC_MPCON_LAY(vcptr) = lay_v;
    CDC_MPCON_BN(vcptr) = bn_v;

    /* MPEGfR[_̐ڑ̐ݒ֐s(\tgsN`T[`͖) */
    ret = MPSYS_DoSetCon(CDC_MPSTF_NEXT, acptr, vcptr);

    return ret;
}

/* I[fBĨXe[^X̃`FbN */
static Sint32   checkAudioStat(MpgMv mpgmv)
{
    Sint32      ret;

    /* ݂̐ڑ̃`FbN */
    if (MPSYS_ReqAudioCon(MPG_STM_CUR) != MPG_MV_ABNO(mpgmv)) {
        MPG_MV_ACTA(mpgmv) = OFF;
    }
    
    /* MPEGnh̒~Ɛؑւ */
    ret = chgMpHn(mpgmv);

    return ret;
}

/* MPEGnh̒~Ɛؑւ */
static Sint32   chgMpHn(MpgMv mpgmv)
{
    Sint32      ret;
    MpgMv       nextmv;

    ret = MPG_ERR_OK;
    if ((MPG_MV_ACTA(mpgmv) == OFF) && (MPG_MV_ACTV(mpgmv) == OFF)) {
        /* MPEGnh̓~ */
        killMovie(mpgmv);
        nextmv = MPG_MV_NEXTMV(mpgmv);
        if (nextmv != NULL) {
            ret = setMovie(nextmv);
        }
    }
    return ret;
}

/* MPEGnh̓~ */
static void     killMovie(MpgMv mpgmv)
{
    MPSYS_KillEventFunc();
    MPG_MV_ISMVEND(mpgmv) = TRUE;
    
    return;
}

/* rfĨXe[^X̃`FbN */
static Sint32   checkVideoStat(MpgMv mpgmv)
{
    Sint32      ret;
    Sint32      fpic;
    Sint32      bn;
    
    /* ŏ̊GȂ^CR[h擾 */
    get1stTc(mpgmv, &fpic);
    
    /* rfĨ`FbN */
    if ((ret = chkVideo(mpgmv, fpic)) != MPG_ERR_OK) {
        return ret;
    }
    
    /* MPEGnh̒~Ɛؑւ */
    ret = chgMpHn(mpgmv);

    return ret;
}

/* ŏ̊GȂ^CR[h擾 */
static void     get1stTc(MpgMv mpgmv, Sint32 *fpic)
{
    Sint32      fpc;
    CdcMpStat   mpstat;
    
    /* ŏ̊GtǑo */
    MPSYS_GetMpgStat(&mpstat);
    fpc = (CDC_MPSTAT_STV(&mpstat) & CDC_MPSTV_1STPIC);
    *fpic = fpc;
    
    /* ŏ̊GȂ΃^CR[h擾 */
    if ((fpc != 0) && (MPG_MV_TCFLAG(mpgmv) == ON)) {
        MPG_MV_FTC(mpgmv) = getTc();
    }
    return;
}

/* ^CR[h̎擾 */
static Sint32   getTc(void)
{
    Sint32      bnk, pictyp, tr;
    CdcMpTc     mptcwk, *mptc;
    Sint32      total;
    Sint32      h1, m1, s1, p1;
    Sint32      h2, m2, s2, p2;

    /* rfĨ^CR[h̎擾֐s */
    mptc = &mptcwk;
    if (MPSYS_DoGetTc(&bnk, &pictyp, &tr, mptc) != MPG_ERR_OK) {
        MPSYS_SetErrCode(MPG_ERR_GETTC);
    }

    /* e|t@X^CR[hւ̕ϊ */
    h1 = CDC_MPTC_HOUR(mptc);
    m1 = CDC_MPTC_MIN(mptc);
    s1 = CDC_MPTC_SEC(mptc);
    p1 = CDC_MPTC_PIC(mptc);
    total = GET_TOTAL(h1, m1, s1, p1) + tr;

    /* ^CR[h̕ */
    decompTc(total, &h2, &m2, &s2, &p2);

    /* t[̏C */
    total = total + (m2 - m1)*2 - (m2/10 - m1/10)*2;

    return total;
}

/* ^CR[h̕ */
static void     decompTc(Sint32 total,
                         Sint32 *h, Sint32 *m, Sint32 *s, Sint32 *p)
{
    /* Ԃ̌vZ */
    *h = total / HOUR_PICS;
    total -= ((*h) * HOUR_PICS);

    /* ̌vZ */
    *m = total / MIN_PICS;
    total -= ((*m) * MIN_PICS);

    /* b̌vZ */
    *s = total / SEC_PICS;
    total -= ((*s) * SEC_PICS);

    /* sN`̌vZ */
    *p = total;

    return;
}

/* rfĨ`FbN */
static Sint32   chkVideo(MpgMv mpgmv, Sint32 fpic)
{
    Sint32      ret;
    Sint32      bn;

    ret = MPG_ERR_OK;

    /* ݂̐ڑ̃`FbN */
    if ((bn = MPSYS_ReqVideoCon(MPG_STM_CUR)) != MPG_MV_VBNO(mpgmv)) {
        if (bn == CDC_NUL_SEL) {
            /* VBVGveB`FbN */
            if (MPSYS_IsVbvEmpty(&ret)) {
                MPG_MV_ACTV(mpgmv) = OFF;
            }
        } else {
            /* Pڂ̊GtO`FbN */
            if (fpic != 0) {
                MPG_MV_ACTV(mpgmv) = OFF;
            }
        }
    }
    return ret;
}

/* I[fBIƃrfĨXe[^X̃`FbN */
static Sint32   checkAvStat(MpgMv mpgmv)
{
    Sint32      ret;
    Sint32      fpic;
    Sint32      bn;
    
    /* ŏ̊GȂ^CR[h擾 */
    get1stTc(mpgmv, &fpic);
    
    /* I[fBĨ`FbN */
    if ((bn = MPSYS_ReqAudioCon(MPG_STM_CUR)) != MPG_MV_ABNO(mpgmv)) {
        MPG_MV_ACTA(mpgmv) = OFF;
    }
    
    /* rfĨ`FbN */
    if ((ret = chkVideo(mpgmv, fpic)) != MPG_ERR_OK) {
        return ret;
    }
    
    /* MPEGnh̒~Ɛؑւ */
    ret = chgMpHn(mpgmv);

    return ret;
}

/* CDubNւ݂̌̃Xg[̐ݒ */
static Sint32   setConCur(MpgMv mpgmv, Bool picsch)
{
    Bool        vflg, aflg;
    Sint32      ret;
    Sint32      cmod_a, lay_a, bn_a;
    Sint32      cmod_v, lay_v, bn_v;
    CdcMpCon    mpcon_a, mpcon_v, *acptr, *vcptr;
    
    /* l̐ݒ */
    vflg = aflg = TRUE;
    ret = MPG_ERR_NG;
    cmod_a = cmod_v = MPG_IGNORE;
    lay_a = lay_v = MPG_LAY_SYS;
    bn_a = bn_v = MPG_NOCDB;

    if (MPG_MV_PMODE(mpgmv) != MPG_PMODE_A) {
        /* Videô݂܂AVĐ̏ꍇ */
        vflg = (MPSYS_ReqVideoCon(MPG_STM_CUR) == CDC_NUL_SEL);

        cmod_v = (CDC_MPCMOD_DEL | CDC_MPCMOD_VWCLR | MPG_MV_VCND(mpgmv));
        lay_v = MPG_MV_VLAY(mpgmv);
        if (picsch == ON) {
            if (MPG_MV_PMODE(mpgmv) == MPG_PMODE_V) {
                lay_v |= CDC_MPSRCH_VIDEO;
            } else {
                lay_v |= CDC_MPSRCH_AV;
            }
        }
        bn_v = MPG_MV_VBNO(mpgmv);
    }
    if (MPG_MV_PMODE(mpgmv) != MPG_PMODE_V) {
        /* Audiô݂܂AVĐ̏ꍇ */
        aflg = (MPSYS_ReqAudioCon(MPG_STM_CUR) == CDC_NUL_SEL);

        cmod_a = (CDC_MPCMOD_DEL | MPG_MV_ACND(mpgmv));
        lay_a = MPG_MV_ALAY(mpgmv);
        bn_a = MPG_MV_ABNO(mpgmv);
    }
    if (vflg && aflg) {
        acptr = &mpcon_a;
        vcptr = &mpcon_v;

        CDC_MPCON_CMOD(acptr) = cmod_a;
        CDC_MPCON_LAY(acptr) = lay_a;
        CDC_MPCON_BN(acptr) = bn_a;
        CDC_MPCON_CMOD(vcptr) = cmod_v;
        CDC_MPCON_LAY(vcptr) = lay_v;
        CDC_MPCON_BN(vcptr) = bn_v;

        /* MPEGfR[_̐ڑ̐ݒ֐s */
        ret = MPSYS_DoSetCon(CDC_MPSTF_CUR, acptr, vcptr);
    }
    return ret;
}

/* Đ̒~ */
Sint32  MPG_MvStop(MpgMv mpgmv)
{
    Sint32      ret;
    
    MPSYS_SemaIn(TRUE);
    
    /* Đ̒~s */
    ret = execMvStop(mpgmv);

    return MPSYS_SemaOut(ret);
}

/* Đ̒~s */
static Sint32   execMvStop(MpgMv mpgmv)
{
    Sint32      ret;

    ret = MPG_ERR_OK;
    switch (MPG_MV_PMODE(mpgmv)) {
    case MPG_PMODE_AV:	/* I[fBIɒ~ */
    case MPG_PMODE_A:
        ret = stopFunc(mpgmv, SID_A);
        break;
    }
    if (ret != MPG_ERR_OK) {
        return ret;
    }

    switch (MPG_MV_PMODE(mpgmv)) {
    case MPG_PMODE_AV:
        /* I[fBI̒~mF */
        if ((ret = waitAstaStop()) != MPG_ERR_OK) {
            return ret;
        }
        /* nobreak; */
    case MPG_PMODE_V:
        ret = stopFunc(mpgmv, SID_V);
        break;
    }
    return ret;
}

/* MPEG A/VXg[̒~ */
static Sint32   stopFunc(MpgMv mpgmv, Sint32 avsw)
{
    CdcMpCon    acon, vcon;
    CdcMpCon    *acptr, *vcptr;
    Sint32      ret;

    acptr = &acon;
    vcptr = &vcon;

    CDC_MPCON_LAY(acptr) = CDC_MPCON_LAY(vcptr) = MPG_LAY_SYS;
    CDC_MPCON_BN(acptr) = CDC_MPCON_BN(vcptr) = MPG_NOCDB;

    if (avsw == SID_A) {   /* I[fBI~ */
        if (MPSYS_ReqAudioCon(MPG_STM_CUR) != MPG_MV_ABNO(mpgmv)) {
            return MPG_ERR_OK;
        }
        CDC_MPCON_CMOD(acptr) = 0x00;
        CDC_MPCON_CMOD(vcptr) = 0xff;
    } else {            /* rfI~ */
        if (MPSYS_ReqVideoCon(MPG_STM_CUR) != MPG_MV_VBNO(mpgmv)) {
            return MPG_ERR_OK;
        }
        CDC_MPCON_CMOD(acptr) = 0xff;
        CDC_MPCON_CMOD(vcptr) = 0x00;
    }

    /* Xg[̎ */
    ret = cancelNext(acptr, vcptr);
    if (ret != MPG_ERR_OK) {
        return ret;
    }

    ret = doStop(mpgmv, avsw, acptr, vcptr);

    return ret;
}

/* Xg[̎ */
static Sint32   cancelNext(CdcMpCon *mpcon_a, CdcMpCon *mpcon_v)
{
    /* MPEGfR[_̐ڑ̐ݒ֐s(ݒ̎) */
    return MPSYS_DoSetCon(CDC_MPSTF_NEXT, mpcon_a, mpcon_v);
}

/* ݂̃Xg[̒~ */
static Sint32   doStop(MpgMv mpgmv,
                       Sint32 avsw, CdcMpCon *acptr, CdcMpCon *vcptr)
{
    Sint32      ret;
    Sint32      cnt;

    ret = MPG_ERR_OK;

    cnt = 0;
    while (TRUE) {
        /* fR[h̒~ */
        ret = abortDecode(mpgmv, avsw, acptr, vcptr);
        if (ret != MPG_ERR_WAIT) {
            break;
        }
        if (cnt++ > MVABT_CNT) {
            return MPG_ERR_TMOUT;
        }
    }

    if ((ret == MPG_ERR_OK) && (avsw == SID_V)) {
        /* VBVZbg(VLDZbg) */
        ret = resetVbv();
    }

    return ret;
}

/* fR[h̒~ */
static Sint32   abortDecode(MpgMv mpgmv,
                            Sint32 avsw, CdcMpCon *acptr, CdcMpCon *vcptr)
{
    Sint32      ret, ast;
    Sint32      chg_a, chg_v;
    CdcMpStat   mpstat, *msptr;

    ret = MPG_ERR_OK;
    msptr = &mpstat;
    /* MPEGXe[^X̎擾 */
    if (CDC_MpGetCurStat(msptr) != CDC_ERR_OK) {
        return MPG_ERR_NG;
    }

    if (avsw == SID_A) {
        ast = CDC_MPGET_ASTA(msptr);
    } else {
        ast = CDC_MPGET_ASTV(msptr);
    }

    switch (ast) {
    case CDC_MPASTA_STOP:
    case CDC_MPASTV_STOP:
        break;
    case CDC_MPASTA_PRE1:
    case CDC_MPASTA_PRE2:
    case CDC_MPASTV_PRE1:
    case CDC_MPASTV_PRE2:
        /* MPEGfR[_̐ڑ̐ݒ֐s(ݒ̎) */
        ret = MPSYS_DoSetCon(CDC_MPSTF_CUR, acptr, vcptr);
        break;
    case CDC_MPASTA_TRNS:
    case CDC_MPASTV_TRNS:
        if (avsw == SID_A) {
            chg_a = CDC_MPCOF_ABT;
            chg_v = MPG_IGNORE;
        } else {
            chg_a = MPG_IGNORE;
            chg_v = CDC_MPCOF_ABT;
        }
        /* MPEGfR[_̐ڑ̐؂ւ֐s */
        ret = MPSYS_DoChgCon(chg_a, chg_v, 0, 0);
        break;
    case CDC_MPASTA_CHG:
    case CDC_MPASTV_CHG:
        ret = MPG_ERR_CHG;
        break;
    default:
        /* ̑ij̏ꍇ́AMPEGfR[_ */
        /* iG[R[hƂMPG_ERR_RCVԂj */
        ret = forceInit(mpgmv);
        break;
    }
    return ret;
}

/* MPEGfR[_̋ */
/* iG[R[hƂMPG_ERR_RCVԂj */
static Sint32   forceInit(MpgMv mpgmv)
{
    MpgWn       wnwk;
    Sint32      ret;
    Sint32      intmask;
    Sint32      i;

    /* MPEGfR[_̏ */
    ret = MPSYS_InitMpd(ON);
    if (ret != MPG_ERR_OK) {
        return ret;
    }

    /* MPEGnh̓~ */
    killMovie(mpgmv);

    /* 荞݋֎~ */
    intmask = get_imask();
    set_imask(IR_MASK);

    /* MPEGVXȅԎ擾 */
    MPSYS_CaptSub();

    /* 荞݋֎~ */
    set_imask(intmask);

    /* MPEGEBhẼ`FbN */
    for (i = 0; i < MPL_FRM_NUM; i++) {
        if ((wnwk = MPG_MV_MPGWN(mpgmv, i)) != NULL) {
            if ((MPG_WN_DISPSW(wnwk) == ON) && (MPG_WN_USEFLG(wnwk) == TRUE)) {
                /* \E\̐ݒs */
                MPWIN_DispSub(wnwk, ON);

                break;
            }
        }
    }

    /* nh̖ */
    MPG_MV_ACTV(mpgmv) = OFF;
    MPG_MV_ACTA(mpgmv) = OFF;

    return MPG_ERR_RCV;
}

/* VBVZbg(VLDZbg) */
static Sint32   resetVbv(void)
{
    Sint32      r_sw, reg_no, rdata;
    Sint32      rwsw, wdata;
    
    /* MPEG LSI p[^̎擾 */
    r_sw = 0;
    reg_no = 0x1a;
    if (CDC_MpGetLsi(r_sw, reg_no, &rdata) != CDC_ERR_OK) {
        return MPG_ERR_NG;
    }
    
    /* MPEG LSI ̐ݒ */
    rwsw = 0;
    wdata = (rdata & 0xcfff);
    if (CDC_MpSetLsi(rwsw, reg_no, wdata, &rdata) != CDC_ERR_OK) {
        return MPG_ERR_NG;
    }

    return MPG_ERR_OK;
}

/* I[fBI̒~mF */
static Sint32   waitAstaStop(void)
{
    Sint32      ret, cnt;
    CdcMpStat   mpstat;
    
    cnt = 0;
    while (TRUE) {
        ret = CDC_MpGetCurStat(&mpstat);
        if (ret == CDC_ERR_OK) {
            if (CDC_MPGET_ASTA(&mpstat) == CDC_MPASTA_STOP) {
                break;
            }
        }
        /* ^CAEg̃`FbN */
        if (cnt++ > ASTOP_CNT) {
            return MPG_ERR_NG;
        }
        /* \tgEGA^C} */
        MPSYS_SoftTimer(1000);
    }
    return MPG_ERR_OK;
}

/* rfIĐ̒~ */
Sint32  MPG_MvStopVideo(MpgMv mpgmv)
{
    Sint32      ret;
    
    MPSYS_SemaIn(TRUE);
    
    ret = stopFunc(mpgmv, SID_V);
    
    return MPSYS_SemaOut(ret);
}

/* I[fBIĐ̒~ */
Sint32  MPG_MvStopAudio(MpgMv mpgmv)
{
    Sint32      ret;
    
    MPSYS_SemaIn(TRUE);
    
    ret = stopFunc(mpgmv, SID_A);
    
    return MPSYS_SemaOut(ret);
}

/* ̃^CR[h̎擾 */
void    MPG_MvGetTimeCode(MpgMv mpgmv,
                          Sint32 *hh, Sint32 *mm, Sint32 *ss, Sint32 *pp)
{
    Sint32      total;
    CdcMpStat   mpstat;

    MPSYS_SemaIn(FALSE);

    MPSYS_GetMpgStat(&mpstat);
    
    if ((MPG_MV_ACTV(mpgmv) == OFF) ||
        (CDC_MPGET_ASTV(&mpstat) != CDC_MPASTV_TRNS)) {

        /* mpgmvĐԂłȂƂ͂OԂ */
        *hh = *mm = *ss = *pp = 0;
    } else {
        /* ^CR[h̎擾 */
        total = getTc();
        
        /* ΃^CR[hԂ */
        if (MPG_MV_TCFLAG(mpgmv) == ON) {
            total -= MPG_MV_FTC(mpgmv);
        }

        /* ^CR[h̕ */
        decompTc(total, hh, mm, ss, pp);
    }
    
    MPSYS_SemaOut(MPG_ERR_OK);

    return;
}

/* I[fBI̍ĐԂ̎擾 */
Sint32  MPG_MvGetPlaytime(MpgMv mpgmv)
{
    Sint32      err;
    Sint32      pts;
    
    MPSYS_SemaIn(FALSE);
    
    pts = 0;
    err = MPG_ERR_OK;
    if (MPG_MV_ACTA(mpgmv) == ON) {
        if (CDC_MpGetPts(&pts) != CDC_ERR_OK) {
            err = MPG_ERR_NG;
        }
    }
    
    MPSYS_SemaOut(err);

    /* msecPʂ̒lԂ */
    return CONV_PTS(pts);
}

/* ɍĐMPEGnh̓o^ */
Sint32  MPG_MvEntryNext(MpgMv mpgmv, MpgMv nextmv)
{
    Bool        vflg, aflg, setflg;
    Bool        vnxt, anxt, nxtflg;
    Sint32      ret;

    MPSYS_SemaIn(TRUE);
    
    vflg = (MPSYS_ReqVideoCon(MPG_STM_CUR) == MPG_MV_VBNO(mpgmv));
    aflg = (MPSYS_ReqAudioCon(MPG_STM_CUR) == MPG_MV_ABNO(mpgmv));

    vnxt = FALSE;
    anxt = FALSE;
    if (nextmv != NULL) {
        vnxt = (MPSYS_ReqVideoCon(MPG_STM_NEXT) == MPG_MV_VBNO(nextmv));
        anxt = (MPSYS_ReqAudioCon(MPG_STM_NEXT) == MPG_MV_ABNO(nextmv));
    }

    switch (MPG_MV_PMODE(mpgmv)) {
    case MPG_PMODE_V:
        setflg = vflg;
        nxtflg = vnxt;
        break;
    case MPG_PMODE_A:
        setflg = aflg;
        nxtflg = anxt;
        break;
    default:
        setflg = (vflg && aflg);
        nxtflg = (vnxt && anxt);
        break;
    }

    /* Xg[̓o^s */
    ret = doEntryNext(mpgmv, nextmv, setflg, nxtflg);

    return MPSYS_SemaOut(ret);
}

/* Xg[̓o^s */
static Sint32   doEntryNext(MpgMv mpgmv, MpgMv nextmv,
                            Bool setflg, Bool nxtflg)
{
    Sint32      ret;

    if (setflg && nxtflg) {
        /* nextmvɓo^ς݂̏ꍇ */
        MPG_MV_NEXTMV(mpgmv) = nextmv;
        return MPG_ERR_OK;
    }

    /* 攭Xg[ĐȂ玟Xg[̐ݒsȂ */
    ret = MPG_ERR_ILLSTAT;
    if (setflg) {
        if ((ret = setConNext(nextmv)) != MPG_ERR_OK) {
            ret = MPG_ERR_ENTRYNG;
        }
    }

    switch (ret) {
    case MPG_ERR_OK:
    case MPG_ERR_ILLSTAT:
        MPG_MV_NEXTMV(mpgmv) = nextmv;
        break;
    }

    return ret;
}

/* ΃^CR[h̐ݒ */
void    MPG_MvAdjustTc(MpgMv mpgmv)
{
    /* ΃^CR[htOONɂ */
    MPG_MV_TCFLAG(mpgmv) = ON;
    
    return;
}

/* ĐI̔ */
Bool    MPG_MvIsEnd(MpgMv mpgmv)
{
    return MPG_MV_ISMVEND(mpgmv);
}


