/*******************************************************************
 *
 *                     T^[pbcCu
 *
 *                         MPEGCu
 *
 *             Copyright (c) 1993 CSK Research Institute Corp.
 *             Copyright (c) 1994 SEGA
 *
 *  Module : MPEGVXe䃂W[\[Xt@C
 *  File   : mpg_sys.c
 *  Date   : 1996-02-01
 *  Author : M.Oshimi, H.Take
 *
 *******************************************************************/

/*******************************************************************
 *      CN[ht@C
 *******************************************************************/
#include        <string.h>
#include        "mpg_loc.h"

/*******************************************************************
 *      萔}N
 *******************************************************************/

/* CDubN̏tOi\tgZbgj */
#define CDINIT_FLAG     0x01

/* CDubN̏̃^CAEg */
#define CDINIT_CNT      400000

/* nOAbvoiVSYNCPʁj */
#define HNG_COND        30

/* MPEG荞ݗṽ}XNp^[ */
#define INTREQ_MSK      0x00ffffff

/* MPEGfR[_̏̏I҂ԁiQVSYNCj */
#define MINI_CNT        53000

/* \̑@PALrbg */
#define SCANMODE_PAL    0x02        

/* PALp̃fBXvCEBhEItZbgiP_Pʁj */
#define PL_DOX          150
#define PL_DOY          45

/* SHORT WAITɑ΂郊gC */
#define RTRY_NUM        50

/*******************************************************************
*       񋓒萔
*******************************************************************/

/* MPEG֐̃Z}tHp萔 */
enum SemaCode {
    SEMA_IN  = 1,       /*  */
    SEMA_OUT = -1       /* o */
};

/* MPEG荞ݗvQƗp萔 */
enum MintRef {
    MINT_HNG   = 0,     /* nOAbvop */
    MINT_DSYNC = 1,     /* fR[h̊mFp */
    MINT_USR   = 2,     /* [Up */
    MINT_NUM   = 3
};

/*******************************************************************
 *      }N
 *******************************************************************/

/* MPEG`FbNiAsega_sys.hŒ񋟁j */
#ifndef SYS_CHKMPEG
#define SYS_CHKMPEG(filtno) \
    ((**(Sint32(**)(Sint32))0x6000274)(filtno))
#endif

/*******************************************************************
 *      f[^^̐錾
 *******************************************************************/

/* 荞ݗv`FbN֐ */
typedef Bool (*ReqintFunc)(Sint32 bitpat);

/*******************************************************************
 *      ֐錾
 *******************************************************************/

static Sint32   noactFunc(void *obj);
static Sint32   mpgInitSub(Sint32 dscn);
static Sint32   initCdb(void);
static Sint32   checkMpeg(void);
static Sint32   setMpPara(void);
static Sint32   doInit(Sint32 scnmod);
static void     initStatVal(void);
static void     entryIntreqFunc(ReqintFunc func, Sint32 bitpat);
static Bool     isIntHng(Sint32 bitpat);
static Bool     isGetMpint(Sint32 intref, Sint32 *mpint, Sint32 *err);
static Sint32   updInt(Sint32 intref, Sint32 *intreq);
static void     initErr(void);
static Sint32   doCaptStat(void);
static Bool     isDecReady(Sint32 *err);
static Sint32   resetVld(void);
static Bool     checkHngSub(Sint32 *err);
static Bool     isDecodingVideo(Sint32 *err);
static Sint32   resetMpSub(Bool mpsw);
static void     semaMpg(Sint32 incnt, Bool cptflg);
static Bool     isTimeOut(Sint32 *cnt);

/*******************************************************************
 *      ϐ`
 *******************************************************************/

/* o[W */
const Sint8     mpg_version[MPG_VERSION_LEN] = MPG_VERSION_STR;

/* MPEǦ݂̏ */
static CdcMpStat        mp_stat;

/* MPEǦ݂̐ڑ */
static CdcMpCon mp_con_a1;
static CdcMpCon mp_con_v1;

/* MPEG̎̃Xg[̓o^ */
static CdcMpCon mp_con_a2;
static CdcMpCon mp_con_v2;

/* CxgN֐ */
static MplEventFunc     mp_event_func;

/* CxgNIuWFNg */
static void     *mp_event_obj;

/* 荞ݗv`FbN֐ */
static ReqintFunc       mp_intreq_func;

/* 荞ݗv`FbNrbgp^[ */
static Sint32   mp_intreq_bitpat;

/* nOAbvoJE^iVSYNCPʁj */
static Sint32   hng_cnt;

/* MPG_CaptStat֐stO */
static Bool     exe_capt_flag;

/* MPEGVXȅԂ̎荞ݎstO */
static Bool     mp_capt_flag;

/* MPG֐sJE^iZ}tHj */
/* MPG֐sɁA荞݂MPG_CaptStat֐sȂ悤ɂ */
static Sint32   mp_in_cnt;

/* sN`X^[gotO */
static Bool     pstrt_flag;

/* MPEG荞ݗvϐ */
static Sint32   mp_intval[MINT_NUM];

/* \̑@iC^[X^mC^[X̐ݒj */
static Sint32   scan_mode;

/* MPEǦ݂̃|[Y^C~OinOAbvoɎgpj */
static Sint32   mp_pautim;

/* MPEGrfI샂[h */
static Sint32   mp_vmode;

/* G[ */
static MpgErrStat       mp_err_stat;

/*******************************************************************
 *      ֐`
 *******************************************************************/

/* rfI̐ڑԍ̎擾 */
Sint32  MPSYS_ReqVideoCon(Sint32 next)
{
    CdcMpCon    *ptr;

    if (next == MPG_STM_CUR) {
        ptr = &mp_con_v1;
    } else {
        ptr = &mp_con_v2;
    }
    return CDC_MPCON_BN(ptr);
}

/* I[fBI̐ڑԍ̎擾 */
Sint32  MPSYS_ReqAudioCon(Sint32 next)
{
    CdcMpCon    *ptr;

    if (next == MPG_STM_CUR) {
        ptr = &mp_con_a1;
    } else {
        ptr = &mp_con_a2;
    }
    return CDC_MPCON_BN(ptr);
}

/* rfI|[Yۂ̃`FbN */
Bool    MPSYS_IsPauseVideo(Sint32 *err)
{
    CdcMpStat   mpstat;
    
    *err = MPG_ERR_NG;

    if (CDC_MpGetCurStat(&mpstat) == CDC_ERR_OK) {
        *err = MPG_ERR_OK;
        if ((CDC_MPSTAT_STV(&mpstat) & CDC_MPSTV_PAUSE) != 0) {
            return TRUE;
        }
    }

    return FALSE;
}

/* CxgN֐̓o^ */
void    MPSYS_EntryEventFunc(MplEventFunc func, void *obj)
{
    mp_event_func = func;
    mp_event_obj = obj;
    
    return;
}

/* CxgN֐̖ */
void    MPSYS_KillEventFunc(void)
{
    mp_event_func = noactFunc;
    mp_event_obj = NULL;
    
    return;
}

/* Ȃ֐ */
static Sint32   noactFunc(void *obj)
{
    obj = obj;

    return 0;
}

/* VBVobt@GveBۂ̃`FbN */
/* CDC֐G[ԂVBVGveBƂ݂Ȃ */
Bool    MPSYS_IsVbvEmpty(Sint32 *err)
{
    Sint32      rdata, wdata;
    Sint32      rwsw, reg_no;

    *err = MPG_ERR_NG;

    /* VBVGveB̃`FbN */
    rwsw = 1;
    reg_no = 6;
    wdata = 0;
    if (CDC_MpSetLsi(rwsw, reg_no, wdata, &rdata) == CDC_ERR_OK) {
        *err = MPG_ERR_OK;
        if ((rdata & 0x4000) == 0) {
            return FALSE;
        }
    }

    return TRUE;
}

/* MPEGVXȅ */
Sint32  MPG_Init(Sint32 dscn)
{
    Sint32      ret;

    MPSYS_SemaIn(FALSE);

    /* MPEGVXȅs */
    ret = mpgInitSub(dscn);
    if (ret != MPG_ERR_OK) {
        MPSYS_SetErrCode(ret);
    }

    return MPSYS_SemaOut(ret);
}

/* MPEGVXȅs */
static Sint32   mpgInitSub(Sint32 dscn)
{
    Sint32      ret;

    /* \̑@iC^[X^mC^[X̐ݒj */
    scan_mode = dscn;

    /* CDubN̏i\tgZbgj */
    if ((ret = initCdb()) != MPG_ERR_OK) {
        return ret;
    }
    
    /* MPEG̃`FbN */
    if ((ret = checkMpeg()) != MPG_ERR_OK) {
        return ret;
    }

    /* MPEGfR[_̏ */                  
    if ((ret = MPSYS_InitMpd(ON)) != MPG_ERR_OK) {
        return ret;
    }
    
    /* MPEG̏s */
    ret = doInit(dscn);

    return ret;
}

/* CDubN̏i\tgZbgj */
static Sint32   initCdb(void)
{
    Sint32      ret;
    Sint32      cnt;
    
    /* CDubN̏i\tgZbgj */
    ret = CDC_CdInit(CDINIT_FLAG, CDC_PARA_NOCHG, CDC_PARA_NOCHG,
                     CDC_PARA_NOCHG);
    if (ret != CDC_ERR_OK) {
        return MPG_ERR_CDINIT;
    }
    
    /* I܂ő҂ */
    cnt = 0;
    while ((CDC_GetHirqReq() & CDC_HIRQ_ESEL) == 0) {
        if (cnt++ > CDINIT_CNT) {
            return MPG_ERR_TMOUT;
        }
    }
    return MPG_ERR_OK;
}

/* MPEG̃`FbN */
static Sint32   checkMpeg(void)
{
    Sint32      ret;
    CdcHw       hw;

    /* MPEGJ[gbW̑`FbN */
    ret = CDC_GetHwInfo(&hw);
    if (ret != CDC_ERR_OK) {
        return MPG_ERR_NG;
    }
    if ((CDC_HW_HFLAG(&hw) & CDC_HFLAG_MPEG) == 0) {
        /* ĂȂ */
        return MPG_ERR_NOMC;
    }
    
    /* MPEGgp\ׂ */
    if (CDC_IS_MPEG_ENA(&hw) == FALSE) {
        /* MPEGgps\Ȃ΁AMPEG`FbNs */
        /* isĂQ܂Ŏs݂j */
        if (SYS_CHKMPEG(0) != OK) {
            if (SYS_CHKMPEG(0) != OK) {
                return MPG_ERR_MPNG;
            }
        }
    }
    return MPG_ERR_OK;
}

/* MPEGfR[_̏ */
Sint32  MPSYS_InitMpd(Bool sw)
{
    Sint32      ret, err;
    Sint32      hirqflg;
    Sint32      cnt;

    err = MPG_ERR_OK;
    
    hirqflg = CDC_HIRQ_MPED;
    if (sw == ON) {
        hirqflg |= CDC_HIRQ_MPCM;
    }
    
    /* MPEGfR[_̏ */                  
    ret = CDC_MpInit(sw);
    if (ret != CDC_ERR_OK) {
        return MPG_ERR_MPINIT;
    }

    /* I܂ő҂iŒZQVSYNC͑҂j */
    /* P̃[v18Xe[g, 28MHzŖ0.64us */
    cnt = 0;
    while (((CDC_GetHirqReq() & hirqflg) != hirqflg) || (cnt < MINI_CNT)) {
        if (cnt++ > MPL_INIT_CNT) {
            return MPG_ERR_TMOUT;
        }
    }
    
    if (sw == ON) {
        /* MPEGVXeɑ΂ݒ */
        err = setMpPara();
    }
    return err;
}

/* MPEGVXeɑ΂ݒ */
static Sint32   setMpPara(void)
{
    Sint32      ret;

    /* MPEG荞݃}XN̐ݒ */
    ret = CDC_MpSetIntMsk(CDC_MPINT_PSTRT|CDC_MPINT_SQEND);
    if (ret != CDC_ERR_OK) {
        return MPG_ERR_NG;
    }
    if ((scan_mode & SCANMODE_PAL) != 0) {
        /* fBXvCEBhEItZbg̐ݒ */
        ret = CDC_MpSetWinDofs(TRUE, PL_DOX, PL_DOY);
        if (ret != CDC_ERR_OK) {
            return MPG_ERR_NG;
        }
    }
    return MPG_ERR_OK;
}

/* MPEG̏s */
static Sint32   doInit(Sint32 scnmod)
{
    Sint32      ret;

    /* MPEG샂[h̐ݒ֐s */
    ret = MPSYS_DoSetMode(MPG_NOCHG, MPG_NOCHG, MPG_NOCHG, scnmod);
    if (ret != MPG_ERR_OK) {
        return ret;
    }
    
    /* ێϐ̏ */
    initStatVal();
    
    /* G[Ԃ̏ */
    initErr();

    /* SfBXvCEBhȄ */
    MPWIN_InitAllWn();
    
    /* SMPEGnh̏ */
    MPMVE_InitAllMv();
    
    MPG_CaptStat();
    
    return MPG_ERR_OK;
}

/* ێϐ̏ */
static void     initStatVal(void)
{
    static const CdcMpStat      mpstat_ini = {0, 0, 0, 0, 0, 0};
    static const CdcMpCon       mpcon_ini = {0, 0, CDC_NUL_SEL};
    Sint32      i;
    
    /* MPEGrfI샂[h */
    mp_vmode = MPG_VMODE_MOVIE;
    
    /* MPEǦ݂̏ */
    mp_stat = mpstat_ini;
    
    /* MPEGXg[̐ڑԂƓo^ */
    mp_con_a1 = mpcon_ini;
    mp_con_a2 = mpcon_ini;
    mp_con_v1 = mpcon_ini;
    mp_con_v2 = mpcon_ini;
    
    /* CxgN֐̖ */
    MPSYS_KillEventFunc();
    
    /* nOAbvo荞݃`FbN֐̓o^ */
    entryIntreqFunc(isIntHng, CDC_MPINT_PSTRT|CDC_MPINT_SQEND);

    /* MPEǦ݂̃|[Y^C~O */
    mp_pautim = 1;
    
    /* nOAbvoJE^ */
    hng_cnt = 0;
    
    /* MPG_CaptStat֐stO */
    exe_capt_flag = FALSE;

    /* MPG_CaptStatstO */
    mp_capt_flag = FALSE;
    
    /* MPG֐sJE^ */
    mp_in_cnt = 0;
    
    /* sN`X^[gotO */
    pstrt_flag = FALSE;

    /* MPEG荞ݗvϐ */
    for (i = 0; i < MINT_NUM; i++) {
        mp_intval[i] = 0;
    }
    return;
}

/* 荞ݗv`FbN֐̓o^ */
static void     entryIntreqFunc(ReqintFunc func, Sint32 bitpat)
{
    mp_intreq_func = func;
    mp_intreq_bitpat = bitpat;
    
    return;
}

/* nOAbvop荞݂̃`FbN */
static Bool     isIntHng(Sint32 bitpat)
{
    Bool        chk;
    Sint32      err;
    Sint32      mpint;

    chk = isGetMpint(MINT_HNG, &mpint, &err);
    if (err != MPG_ERR_OK) {
        MPSYS_SetErrCode(err);
        return FALSE;
    }

    /* MPEG荞ݕϐ̎擾 */
    if (chk == TRUE) {
        if ((mpint & bitpat) != 0) {
            return TRUE;
        }
    }

    return FALSE;
}

/* MPEG荞ݕϐ̎擾 */
static Bool     isGetMpint(Sint32 intref, Sint32 *mpint, Sint32 *err)
{
    *err = MPG_ERR_OK;

    /* MPSTtO`FbN */
    if ((CDC_GetHirqReq() & CDC_HIRQ_MPST) != 0) {
        /* MPSTtONA */
        CDC_ClrHirqReq(~CDC_HIRQ_MPST);
        
        /* MPEG荞ݕϐ̍XV */
        *err = updInt(intref, mpint);

        return TRUE;
    }
    return FALSE;
}

/* MPEG荞ݕϐ̍XV */
static Sint32   updInt(Sint32 intref, Sint32 *intreq)
{
    Sint32      i;
    Sint32      inttmp;
    
    /* MPEG荞ݗv̎擾 */
    if (CDC_MpGetInt(&inttmp) != CDC_ERR_OK) {
        return MPG_ERR_NG;
    }

    /* MPEG荞ݕϐ̍XV */
    for (i = 0; i < MINT_NUM; i++) {
        mp_intval[i] |= inttmp;
    }

    *intreq = (mp_intval[intref] & INTREQ_MSK);

    /* MPEG荞ݕϐ̃NA */
    mp_intval[intref] = 0;

    return MPG_ERR_OK;
}

/* G[Ԃ̏ */
static void     initErr(void)
{
    MpgErrStat  *errstat;

    errstat = &mp_err_stat;

    MPG_ERR_FUNC(errstat) = NULL;
    MPG_ERR_OBJ(errstat) = NULL;
    MPG_ERR_CODE(errstat) = MPG_ERR_OK;

    return;
}

/* MPEGVXȅԂ̎荞 */
void    MPG_CaptStat(void)
{
    Sint32      err;

    /* MPG_CaptStat֐sȂ炷ɖ߂ */
    if (exe_capt_flag == TRUE) {
        return;
    }

    /* MPEGVXȅԂ̎荞ݎs */
    exe_capt_flag = TRUE;
    if ((err = doCaptStat()) != MPG_ERR_OK) {
        MPSYS_SetErrCode(err);
    }
    exe_capt_flag = FALSE;

    return;
}

/* MPEGVXȅԂ̎荞ݎs */
static Sint32   doCaptStat(void)
{
    Sint32      ret;

    /* MPG֐sȂ炷ɖ߂ */
    if (mp_in_cnt > 0) {
        mp_capt_flag = TRUE;
        return;
    }

    /* MPEGVXȅԎ擾 */
    ret = MPSYS_CaptSub();

    mp_capt_flag = FALSE;
    
    return ret;
}

/* MPEGVXȅԎ擾 */
Sint32  MPSYS_CaptSub(void)
{
    Sint32      ret;

    /* Ԃ̎荞 */
    CDC_MpGetCurStat(&mp_stat);
    CDC_MpGetCon(CDC_MPSTF_CUR, &mp_con_a1, &mp_con_v1);
    CDC_MpGetCon(CDC_MPSTF_NEXT, &mp_con_a2, &mp_con_v2);

    /* CxgN֐NULL`FbN */
    if (mp_event_func == NULL) {
        return MPG_ERR_OK;
    }

    /* Cxg̔ */
    ret = (*mp_event_func)(mp_event_obj);

    return ret;
}

/* MPEGrfI̓샂[h̐ݒ */
Sint32  MPG_SetVideoMode(Sint32 vmode)
{
    Sint32      ret;

    MPSYS_SemaIn(FALSE);

    /* MPEG샂[h̐ݒ֐s */
    ret = MPSYS_DoSetMode(vmode, MPG_NOCHG, MPG_NOCHG, MPG_NOCHG);
    if (ret == MPG_ERR_OK) {
        mp_vmode = vmode;
    }
    
    return MPSYS_SemaOut(ret);
}

/* MPEGrfI̓샂[h̎擾 */
Sint32  MPG_GetVideoMode(void)
{
    return mp_vmode;
}

/* fR[h̊mF */
Bool    MPG_IsDecReady(Sint32 decpic)
{
    Bool        ret;
    Sint32      err;
    Sint32      dummy;

    MPSYS_SemaIn(FALSE);
    
    ret = FALSE;
    err = MPG_ERR_OK;
    if (decpic == MPG_HDEC_PRE) {
        /* MPSTtONA */
        CDC_ClrHirqReq(~CDC_HIRQ_MPST);

        /* MPEG荞ݗṽNA */
        err = updInt(MINT_DSYNC, &dummy);
    } else {
        /* fR[h̃`FbN */
        ret = isDecReady(&err);
    }
    MPSYS_SemaOut(err);

    return ret;
}

/* fR[h̃`FbN */
static Bool     isDecReady(Sint32 *err)
{
    Bool        chk;
    Sint32      mpint;
    CdcMpStat   mpstat;

    *err = MPG_ERR_OK;

    /* sN`X^[gõ`FbN */
    if (pstrt_flag == FALSE) {
        /* MPEG荞ݕϐ̎擾 */
        chk = isGetMpint(MINT_DSYNC, &mpint, err);
        if (*err != MPG_ERR_OK) {
            return FALSE;
        }
        /* MPEG荞ݗv擾ꍇ */
        if (chk == TRUE) {
            /* PSC܂SQE荞݂̃`FbN */
            if ((mpint & CDC_MPINT_PSTRT) != 0) {
                pstrt_flag = TRUE;
            } else if ((mpint & CDC_MPINT_SQEND) != 0) {
                /* VLDZbg */
                if ((*err = resetVld()) != MPG_ERR_OK) {
                    return FALSE;
                }
            }
        }
    }

    /* ԂłȂƂ̃`FbN */
    if (pstrt_flag == TRUE) {
        if (CDC_MpGetCurStat(&mpstat) != CDC_ERR_OK) {
            *err = MPG_ERR_NG;
            return FALSE;
        }
        if (CDC_MPGET_ASTV(&mpstat) != CDC_MPASTV_RCV) {
            pstrt_flag = FALSE;
            return TRUE;
        }
    }
    return FALSE;
}

/* VLDZbg */
static Sint32   resetVld(void)
{
    Sint32      r_sw, reg_no, rdata;
    Sint32      rwsw, wdata;
    
    /* MPEG LSI p[^̎擾 */
    r_sw = 0;
    reg_no = 0x1a;
    if (CDC_MpGetLsi(r_sw, reg_no, &rdata) != CDC_ERR_OK) {
        return MPG_ERR_NG;
    }
    
    /* MPEG LSI ̐ݒ */
    rwsw = 0;
    wdata = (rdata & 0xdfff);
    if (CDC_MpSetLsi(rwsw, reg_no, wdata, &rdata) != CDC_ERR_OK) {
        return MPG_ERR_NG;
    }
    
    return MPG_ERR_OK;
}

/* nOAbṽZbg */
void    MPG_ResetHng(void)
{
    /* nOAbvoJE^̃Zbg */
    hng_cnt = 0;
    
    /* MPSTtONA */
    CDC_ClrHirqReq(~CDC_HIRQ_MPST);
    
    return;
}

/* nOAbv̌o */
Bool    MPG_CheckHng(void)
{
    Bool        ret;
    Sint32      err;

    MPSYS_SemaIn(FALSE);
    
    /* nOAbv̌os */
    ret = checkHngSub(&err);

    MPSYS_SemaOut(err);
    
    return ret;
}

/* nOAbv̌os */
static Bool     checkHngSub(Sint32 *err)
{
    Bool        inton;
    Bool        vbv, dec, pau;

    /* VBVobt@GveBۂ̃`FbN */
    vbv = MPSYS_IsVbvEmpty(err);
    if (*err != MPG_ERR_OK) {
        return TRUE;
    }

    /* rfIfR[hۂ̃`FbN */
    dec = isDecodingVideo(err);
    if (*err != MPG_ERR_OK) {
        return TRUE;
    }

    /* rfI|[Yۂ̃`FbN */
    pau = MPSYS_IsPauseVideo(err);
    if (*err != MPG_ERR_OK) {
        return TRUE;
    }

    /* 荞ݗv`FbN֐NULL̏ꍇ́AnOAbvƂ݂Ȃ */
    if (mp_intreq_func == NULL) {
        return TRUE;
    }

    if ((vbv == FALSE) && (dec == TRUE) && (pau == FALSE)) {
        /* PTS܂SQẼ`FbN */
        inton = (*mp_intreq_func)(mp_intreq_bitpat);
        
        if (inton) {
            /* oJE^̃Zbg */
            hng_cnt = 0;
        } else {
            hng_cnt++;
            /* ^CAEg̃`FbN */
            if (hng_cnt > (HNG_COND * mp_pautim)) {
                return TRUE;
            }
        }
    } else {
        /* oJE^̃Zbg */
        hng_cnt = 0;
    }
    
    return FALSE;
}

/* rfIfR[hۂ̃`FbN */
static Bool     isDecodingVideo(Sint32 *err)
{
    CdcMpStat   mpstat;

    *err = MPG_ERR_NG;

    if (CDC_MpGetCurStat(&mpstat) == CDC_ERR_OK) {
        *err = MPG_ERR_OK;
        if ((CDC_MPSTAT_STV(&mpstat) & CDC_MPSTV_DEC) != 0) {
            return TRUE;
        }
    }

    return FALSE;
}

/* MPEG|[g̎擾 */
Sint32  MPG_GetReport(Sint32 *actst, Sint32 *vcnt, Sint32 *pict,
                      Sint32 *stat_a, Sint32 *stat_v)
{
    Sint32      ret;
    CdcMpStat   mpstat, *msptr;

    MPSYS_SemaIn(FALSE);

    ret = MPG_ERR_NG;

    /* ݂MPEGXe[^X̎擾 */
    msptr = &mpstat;
    if (CDC_MpGetCurStat(msptr) == CDC_ERR_OK) {
        ret = MPG_ERR_OK;

        *actst = CDC_MPSTAT_AST(msptr);
        *vcnt = CDC_MPSTAT_VCNT(msptr);
        *pict = CDC_MPSTAT_PICT(msptr);
        *stat_a = CDC_MPSTAT_STA(msptr);
        *stat_v = CDC_MPSTAT_STV(msptr);
    }
    
    return MPSYS_SemaOut(ret);
}

/* MPEG荞݂̎擾 */
Sint32  MPG_GetInt(Sint32 *mpint)
{
    Sint32      ret;

    MPSYS_SemaIn(FALSE);
    
    /* MPEG荞ݕϐ̍XV */
    ret = updInt(MINT_USR, mpint);

    return MPSYS_SemaOut(ret);
}

/* MPEG̃Zbg */
Sint32  MPG_ResetMp(Bool mpsw)
{
    Sint32      ret;
    
    MPSYS_SemaIn(FALSE);

    /* MPEG̃Zbgs */
    ret = resetMpSub(mpsw);
    if (ret != MPG_ERR_OK) {
        MPSYS_SetErrCode(ret);
    }

    return MPSYS_SemaOut(ret);
}

/* MPEG̃Zbgs */
static Sint32   resetMpSub(Bool mpsw)
{
    Sint32      ret;

    /* MPEGfR[_̏ */                  
    if ((ret = MPSYS_InitMpd(mpsw)) != MPG_ERR_OK) {
        return ret;
    }

    if (mpsw == OFF) {
        return MPG_ERR_OK;
    }

    /* MPEG̏s */
    ret = doInit(scan_mode);

    return ret;
}

/* G[Ԃ̎擾 */
Sint32  MPG_GetErrStat(MpgErrStat *stat)
{
    *stat = mp_err_stat;

    return MPG_ERR_CODE(stat);
}

/* G[֐̓o^ */
void    MPG_SetErrFunc(MpgErrFunc func, void *obj)
{
    MpgErrStat  *errstat;

    errstat = &mp_err_stat;

    MPG_ERR_FUNC(errstat) = func;
    MPG_ERR_OBJ(errstat) = obj;

    return;
}

/* G[R[h̐ݒiG[Ȃ΃G[֐Ăяoj */
void    MPSYS_SetErrCode(Sint32 errcode)
{
    MpgErrFunc func;

    if (errcode == MPG_ERR_OK) {
        return;
    }

    MPG_ERR_CODE(&mp_err_stat) = errcode;
    func = MPG_ERR_FUNC(&mp_err_stat);
    if (func != NULL) {
        func(MPG_ERR_OBJ(&mp_err_stat), errcode);
    }
    return;
}

/* MPEǦ݂̃|[Y^C~O̐ݒ */
void    MPSYS_SetPauTim(Sint32 pautim)
{
    if (pautim != MPG_IGNORE) {
        /* ϐ̐ݒ */
        mp_pautim = pautim;
    }
    return;
}

/* MPG֐ł̏ */
void    MPSYS_SemaIn(Bool flag)
{
    semaMpg(SEMA_IN, flag);

    return;
}

/* MPG֐̓^ȍiZ}tHj */
static void     semaMpg(Sint32 incnt, Bool cptflg)
{
    if ((incnt == SEMA_IN) && (cptflg == TRUE)) {
        MPG_CaptStat();
    }
    mp_in_cnt += incnt;

    if ((incnt == SEMA_OUT) && (mp_capt_flag == TRUE)) {
        MPG_CaptStat();
    }
    return;
}

/* MPG֐oł̏ */
Sint32  MPSYS_SemaOut(Sint32 err)
{
    if (err != MPG_ERR_OK) {
        MPSYS_SetErrCode(err);
    }
    semaMpg(SEMA_OUT, FALSE);

    return err;
}

/* MPEG샂[h̐ݒ֐s */
Sint32  MPSYS_DoSetMode(Sint32 actmod, Sint32 dectim, Sint32 out,
                        Sint32 scnmod)
{
    Sint32      ret;
    Sint32      i;

    i = 0;
    while (TRUE) {
        ret = CDC_MpSetMode(actmod, dectim, out, scnmod);
        if (ret == CDC_ERR_OK) {
            break;
        }
        if (ret != CDC_ERR_WAIT) {
            return MPG_ERR_NG;
        }
        if (isTimeOut(&i)) {
            return MPG_ERR_WAIT;
        }
    }
    return MPG_ERR_OK;
}

/* MPSYS_Do`֐Ń^CAEgH */
static Bool     isTimeOut(Sint32 *cnt)
{
    if ((*cnt)++ > RTRY_NUM) {
        return TRUE;
    }

    /* \tgEGA^C} */
    MPSYS_SoftTimer(100);

    return FALSE;
}

/* \tgEFA^C}i1̃[v8Xe[gF26MHzŖ0.3ʂj*/
void    MPSYS_SoftTimer(Sint32 cnt)
{
    volatile Sint32     tmpval;
    tmpval = cnt;
    while (tmpval > 0) {
        tmpval--;
    }
    return;
}

/* MPEG̍Đ֐s */
Sint32  MPSYS_DoPlay(Sint32 plymod, Sint32 tmod_a, Sint32 tmod_v,
                     Sint32 dec_v)
{
    Sint32      ret;
    Sint32      i;

    i = 0;
    while (TRUE) {
        ret = CDC_MpPlay(plymod, tmod_a, tmod_v, dec_v);
        if (ret == CDC_ERR_OK) {
            break;
        }
        if (ret != CDC_ERR_WAIT) {
            return MPG_ERR_NG;
        }
        if (isTimeOut(&i)) {
            return MPG_ERR_WAIT;
        }
    }
    return MPG_ERR_OK;
}

/* fR[h@̐ݒ֐s */
Sint32  MPSYS_DoSetDec(Sint32 mute, Sint32 pautim, Sint32 frztim)
{
    Sint32      ret;
    Sint32      i;

    i = 0;
    while (TRUE) {
        ret = CDC_MpSetDec(mute, pautim, frztim);
        if (ret == CDC_ERR_OK) {
            break;
        }
        if (ret != CDC_ERR_WAIT) {
            return MPG_ERR_NG;
        }
        if (isTimeOut(&i)) {
            return MPG_ERR_WAIT;
        }
    }
    return MPG_ERR_OK;
}

/* fR[hM̑o֐s */
Sint32  MPSYS_DoOutDsync(Sint32 fbn)
{
    Sint32      ret;
    Sint32      i;

    i = 0;    
    while (TRUE) {
        ret = CDC_MpOutDsync(fbn);
        if (ret == CDC_ERR_OK) {
            break;
        }
        if (ret != CDC_ERR_WAIT) {
            return MPG_ERR_NG;
        }
        if (isTimeOut(&i)) {
            return MPG_ERR_WAIT;
        }
    }
    return MPG_ERR_OK;
}

/* rfĨ^CR[h̎擾֐s */
Sint32  MPSYS_DoGetTc(Sint32 *bnk, Sint32 *pictyp, Sint32 *tr, CdcMpTc *mptc)
{
    Sint32      ret;
    Sint32      i;

    i = 0;    
    while (TRUE) {
        ret = CDC_MpGetTc(bnk, pictyp, tr, mptc);
        if (ret == CDC_ERR_OK) {
            break;
        }
        if (ret != CDC_ERR_WAIT) {
            return MPG_ERR_NG;
        }
        if (isTimeOut(&i)) {
            return MPG_ERR_WAIT;
        }
    }
    return MPG_ERR_OK;
}

/* MPEGfR[_̐ڑ̐ݒ֐s */
Sint32  MPSYS_DoSetCon(Sint32 next, CdcMpCon *mpcon_a, CdcMpCon *mpcon_v)
{
    Sint32      ret;
    Sint32      i;

    i = 0;    
    while (TRUE) {
        ret = CDC_MpSetCon(next, mpcon_a, mpcon_v);
        if (ret == CDC_ERR_OK) {
            break;
        }
        if (ret != CDC_ERR_WAIT) {
            return MPG_ERR_NG;
        }
        if (isTimeOut(&i)) {
            return MPG_ERR_WAIT;
        }
    }
    return MPG_ERR_OK;
}

/* MPEGfR[_̐ڑ̐؂ւ֐s */
Sint32  MPSYS_DoChgCon(Sint32 chg_a, Sint32 chg_v,
                       Sint32 clr_a, Sint32 clr_v)
{
    Sint32      ret;
    Sint32      i;
    
    i = 0;
    while (TRUE) {
        ret = CDC_MpChgCon(chg_a, chg_v, clr_a, clr_v);
        if (ret == CDC_ERR_OK) {
            break;
        }
        if (ret != CDC_ERR_WAIT) {
            return MPG_ERR_NG;
        }
        if (isTimeOut(&i)) {
            return MPG_ERR_WAIT;
        }
    }
    return MPG_ERR_OK;
}

/* MPEGXg[̐ݒ֐s */
Sint32  MPSYS_DoSetStm(Sint32 next, CdcMpStm *mpstm_a, CdcMpStm *mpstm_v)
{
    Sint32      ret;
    Sint32      i;

    i = 0;
    while (TRUE) {
        ret = CDC_MpSetStm(next, mpstm_a, mpstm_v);
        if (ret == CDC_ERR_OK) {
            break;
        }
        if (ret != CDC_ERR_WAIT) {
            return MPG_ERR_NG;
        }
        if (isTimeOut(&i)) {
            return MPG_ERR_WAIT;
        }
    }
    return MPG_ERR_OK;
}

/* 摜̕\֐s */
Sint32  MPSYS_DoDisp(Bool dswsw, Sint32 fbn)
{
    Sint32      ret;
    Sint32      i;

    i = 0;    
    while (TRUE) {
        ret = CDC_MpDisp(dswsw, fbn);
        if (ret == CDC_ERR_OK) {
            break;
        }
        if (ret != CDC_ERR_WAIT) {
            return MPG_ERR_NG;
        }
        if (isTimeOut(&i)) {
            return MPG_ERR_WAIT;
        }
    }
    return MPG_ERR_OK;
}

/* tF[h̐ݒ֐s */ 
Sint32  MPSYS_DoSetFade(Sint32 gain_y, Sint32 gain_c)
{
    Sint32      ret;
    Sint32      i;

    i = 0;    
    while (TRUE) {
        ret = CDC_MpSetFade(gain_y, gain_c);
        if (ret == CDC_ERR_OK) {
            break;
        }
        if (ret != CDC_ERR_WAIT) {
            return MPG_ERR_NG;
        }
        if (isTimeOut(&i)) {
            return MPG_ERR_WAIT;
        }
    }
    return MPG_ERR_OK;
}

/* ʓʂ̐ݒ֐s */ 
Sint32  MPSYS_DoSetVeff(CdcMpVef *mpvef)
{
    Sint32      ret;
    Sint32      i;

    i = 0;    
    while (TRUE) {
        ret = CDC_MpSetVeff(mpvef);
        if (ret == CDC_ERR_OK) {
            break;
        }
        if (ret != CDC_ERR_WAIT) {
            return MPG_ERR_NG;
        }
        if (isTimeOut(&i)) {
            return MPG_ERR_WAIT;
        }
    }
    return MPG_ERR_OK;
}

/* MPEǦ݂̏Ԃ̎擾 */
void    MPSYS_GetMpgStat(CdcMpStat *mpstat)
{
    /* ێϐ̎擾 */
    *mpstat = mp_stat;
    
    return;
}

