/*******************************************************************
 *
 *                     T^[pbcCu
 *
 *                         MPEGCu
 *
 *             Copyright (c) 1993 CSK Research Institute Corp.
 *             Copyright (c) 1994 SEGA
 *
 *  Module : \̐䃂W[\[Xt@C
 *  File   : mpg_win.c
 *  Date   : 1996-01-18
 *  Author : H.Take
 *
 *******************************************************************/

/*******************************************************************
 *      CN[ht@C
 *******************************************************************/
#include        "sega_dma.h"
#include        "sega_csh.h"
#include        "mpg_loc.h"

/*******************************************************************
 *      fobOp萔}N
 *******************************************************************/

/*******************************************************************
 *      萔}N
 *******************************************************************/

/* {̏li{j */
#define RAT_DFL         1000

/* {̋t߂邽߂̌W */
#define RECIP_COEF      1000000L

/* MPEGEBhE̍ő */
#define MPGWN_NUM       16

/* EBhE̊g嗦p[^̃e[uvf */
#define FR_NUM          1000

/* {̃e[uvf */
#define RAT_NUM         16

/* ftHg]֐ł̓]I҂^CAEg */
#define TRNFIN_CNT      1700000

/* ʓʃp[^ID */
#define SET_WN_INTPOL   0x01            /* ԃ[h */
#define SET_WN_MOZAIC   0x02            /* UCN */
#define SET_WN_SOFT     0x04            /* ڂ */
#define SET_WN_LUMIKEY  0x08            /* ~lbZXL[ */

/*******************************************************************
 *      }N
 *******************************************************************/

/* t[obt@EBhEʒup[^߂ */
#define GET_FPOS(fz, dl, rat)   ((fz) + (dl) * (rat) / RAT_DFL)

/* g嗦̐߂ */
#define GET_INTEG(rat)          ((rat) / RAT_DFL)

/* g嗦̏߂ */
#define GET_FRAC(rat, p)        ((rat) - (p) * RAT_DFL)

/* t߂ */
#define GET_RECIP(rat)          (RECIP_COEF / (rat))

/* xb{߂ */
#define GET_YCRAT(ycrat)        ((Sint8)(ycrat) - 8)

/*******************************************************************
 *      ֐錾
 *******************************************************************/

static void     initWinPara(MpgWn mpgwn);
static Sint32   ratToFr(Uint32 ratio);
static Sint32   trnsScuDmaBbus(void *dst, void *src, Sint32 nbyte);
static Sint32   setWn(MpgWn mpgwn);
static Sint32   doSetWnEffect(MpgWn mpgwn, Sint32 id);
static Sint32   setOfstSub(Sint32 dpx, Sint32 dpy,
                           Sint32 fpx, Sint32 fpy);
static Uint32   frToRat(Sint32 fr);
static Sint32   setRatioSub(Sint32 frx, Sint32 fry,
                            Sint32 fpx, Sint32 fpy);
static Sint32   doTrans(MpgWn mpgwn);

/*******************************************************************
 *      ϐ`
 *******************************************************************/

/* MPEGEBhE */
static MpgWin   mp_win[MPGWN_NUM];

/* EBhE̊g嗦p[^̃e[u */
static const Uint8      fr_tbl[FR_NUM] = {
    0x01, 0x01, 0x01, 0x01, 0x01, 0x01, 0x01, 0x01,
    0x01, 0x01, 0x01, 0x01, 0x01, 0x01, 0x01, 0x01,
    0x01, 0x01, 0x01, 0x01, 0x01, 0x01, 0x01, 0x01,
    0x01, 0x01, 0x01, 0x01, 0x01, 0x01, 0x01, 0x01,
    0x01, 0x01, 0x01, 0x01, 0x01, 0x01, 0x01, 0x01,     /* 40 */
    0x01, 0x01, 0x01, 0x01, 0x01, 0x01, 0x01, 0x01,
    0x01, 0x01, 0x01, 0x01, 0x01, 0x01, 0x01, 0x01,
    0x01, 0x01, 0x01, 0x01, 0x01, 0x01, 0x01, 0x01,
    0x01, 0x01, 0x01, 0x01, 0x01, 0x01, 0x01, 0x01,
    0x0f, 0x0f, 0x0f, 0x0f, 0x0f, 0x0f, 0x0f, 0x0f,     /* 80 */
    0x0f, 0x0f, 0x0f, 0x0f, 0x0f, 0x0f, 0x0f, 0x0f,
    0x0f, 0x0f, 0x0f, 0x0f, 0x0f, 0x0f, 0x0f, 0x0f,
    0x0f, 0x0f, 0x0f, 0x0f, 0x0f, 0x0f, 0x0f, 0x0f,
    0x0f, 0x0f, 0x0f, 0x0f, 0x0f, 0x0f, 0x0f, 0x0f,
    0x0f, 0x0f, 0x0f, 0x0f, 0x0f, 0x0f, 0x0f, 0x0f,     /* 120 */
    0x0f, 0x0f, 0x0f, 0x0f, 0x0f, 0x0f, 0x0f, 0x0f,
    0x0f, 0x0f, 0x0f, 0x0f, 0x0f, 0x0f, 0x0f, 0x0f,
    0x0f, 0x0f, 0x0f, 0x0f, 0x0f, 0x0f, 0x0f, 0x0f,
    0x0f, 0x0f, 0x0f, 0x0f, 0x0f, 0x0f, 0x0f, 0x0f,
    0x0f, 0x0f, 0x0f, 0x0e, 0x0e, 0x0e, 0x0e, 0x0e,     /* 160 */
    0x0e, 0x0e, 0x0e, 0x0e, 0x0e, 0x0e, 0x0e, 0x0e,
    0x0e, 0x0e, 0x0e, 0x0e, 0x0e, 0x0e, 0x0e, 0x0e,
    0x0e, 0x0e, 0x0e, 0x0e, 0x0e, 0x0e, 0x0e, 0x0e,
    0x0d, 0x0d, 0x0d, 0x0d, 0x0d, 0x0d, 0x0d, 0x0d,
    0x0d, 0x0d, 0x0d, 0x0d, 0x0d, 0x0d, 0x0d, 0x0d,     /* 200 */
    0x0d, 0x0d, 0x0d, 0x0d, 0x0d, 0x0d, 0x0d, 0x0d,
    0x0d, 0x0d, 0x0d, 0x0d, 0x0d, 0x0d, 0x0d, 0x0d,
    0x0d, 0x0d, 0x0d, 0x0d, 0x0d, 0x0d, 0x0d, 0x0d,
    0x0d, 0x0d, 0x0c, 0x0c, 0x0c, 0x0c, 0x0c, 0x0c,
    0x0c, 0x0c, 0x0c, 0x0c, 0x0c, 0x0c, 0x0c, 0x0c,     /* 240 */
    0x0c, 0x0c, 0x0c, 0x0c, 0x0c, 0x0c, 0x0c, 0x0c,
    0x0c, 0x0c, 0x0c, 0x0c, 0x0c, 0x0c, 0x0c, 0x0c,
    0x0c, 0x0c, 0x0c, 0x0c, 0x0c, 0x0c, 0x0c, 0x0c,
    0x0c, 0x0c, 0x0c, 0x0c, 0x0c, 0x0c, 0x0c, 0x0c,
    0x0c, 0x0c, 0x0c, 0x0c, 0x0c, 0x0c, 0x0c, 0x0c,     /* 280 */
    0x0c, 0x0c, 0x0c, 0x0c, 0x0c, 0x0c, 0x0c, 0x0c,
    0x0c, 0x0c, 0x0c, 0x0c, 0x0b, 0x0b, 0x0b, 0x0b,
    0x0b, 0x0b, 0x0b, 0x0b, 0x0b, 0x0b, 0x0b, 0x0b,
    0x0b, 0x0b, 0x0b, 0x0b, 0x0b, 0x0b, 0x0b, 0x0b,
    0x0b, 0x0b, 0x0b, 0x0b, 0x0b, 0x0b, 0x0b, 0x0b,     /* 320 */
    0x0b, 0x0b, 0x0b, 0x0b, 0x0b, 0x0b, 0x0b, 0x0b,
    0x0b, 0x0b, 0x0b, 0x0b, 0x0b, 0x0b, 0x0b, 0x0b,
    0x0b, 0x0b, 0x0b, 0x0b, 0x0b, 0x0b, 0x0b, 0x0b,
    0x0b, 0x0b, 0x0b, 0x0b, 0x0b, 0x0b, 0x0b, 0x0b,
    0x0b, 0x0b, 0x0b, 0x0b, 0x0b, 0x0b, 0x0b, 0x0b,     /* 360 */
    0x0b, 0x0b, 0x0b, 0x0b, 0x0b, 0x0b, 0x0b, 0x0b,
    0x0b, 0x0b, 0x0b, 0x0b, 0x0b, 0x0b, 0x0b, 0x0b,
    0x0b, 0x0b, 0x0b, 0x0b, 0x0b, 0x0b, 0x0b, 0x0b,
    0x0b, 0x0b, 0x0b, 0x0b, 0x0b, 0x0b, 0x0b, 0x0b,
    0x0b, 0x0b, 0x0b, 0x0b, 0x0b, 0x0b, 0x0b, 0x0b,     /* 400 */
    0x0b, 0x0b, 0x0b, 0x0b, 0x0b, 0x0b, 0x0b, 0x0b,
    0x0b, 0x0b, 0x0b, 0x0b, 0x0b, 0x0b, 0x0b, 0x0b,
    0x0b, 0x02, 0x02, 0x02, 0x02, 0x02, 0x02, 0x02,
    0x02, 0x02, 0x02, 0x02, 0x02, 0x02, 0x02, 0x02,
    0x02, 0x02, 0x02, 0x02, 0x02, 0x02, 0x02, 0x02,     /* 440 */
    0x02, 0x02, 0x02, 0x02, 0x02, 0x02, 0x02, 0x02,
    0x02, 0x02, 0x02, 0x02, 0x02, 0x02, 0x02, 0x02,
    0x02, 0x02, 0x02, 0x02, 0x02, 0x02, 0x02, 0x02,
    0x02, 0x02, 0x02, 0x02, 0x02, 0x02, 0x02, 0x02,
    0x02, 0x02, 0x02, 0x02, 0x02, 0x02, 0x02, 0x02,     /* 480 */
    0x02, 0x02, 0x02, 0x02, 0x02, 0x02, 0x02, 0x02,
    0x02, 0x02, 0x02, 0x02, 0x02, 0x02, 0x02, 0x02,
    0x02, 0x02, 0x02, 0x02, 0x02, 0x02, 0x02, 0x02,
    0x02, 0x02, 0x02, 0x02, 0x02, 0x02, 0x02, 0x02,
    0x02, 0x02, 0x02, 0x02, 0x02, 0x02, 0x02, 0x02,     /* 520 */
    0x02, 0x02, 0x02, 0x02, 0x02, 0x02, 0x02, 0x02,
    0x02, 0x02, 0x02, 0x02, 0x02, 0x02, 0x02, 0x02,
    0x02, 0x02, 0x02, 0x02, 0x02, 0x02, 0x02, 0x02,
    0x02, 0x02, 0x02, 0x02, 0x02, 0x02, 0x02, 0x02,
    0x02, 0x02, 0x02, 0x02, 0x02, 0x02, 0x02, 0x02,     /* 560 */
    0x02, 0x02, 0x02, 0x02, 0x02, 0x02, 0x02, 0x02,
    0x02, 0x02, 0x02, 0x02, 0x02, 0x02, 0x02, 0x02,
    0x02, 0x02, 0x02, 0x02, 0x02, 0x02, 0x02, 0x02,
    0x03, 0x03, 0x03, 0x03, 0x03, 0x03, 0x03, 0x03,
    0x03, 0x03, 0x03, 0x03, 0x03, 0x03, 0x03, 0x03,     /* 600 */
    0x03, 0x03, 0x03, 0x03, 0x03, 0x03, 0x03, 0x03,
    0x03, 0x03, 0x03, 0x03, 0x03, 0x03, 0x03, 0x03,
    0x03, 0x03, 0x03, 0x03, 0x03, 0x03, 0x03, 0x03,
    0x03, 0x03, 0x03, 0x03, 0x03, 0x03, 0x03, 0x03,
    0x03, 0x03, 0x03, 0x03, 0x03, 0x03, 0x03, 0x03,     /* 640 */
    0x03, 0x03, 0x03, 0x03, 0x03, 0x03, 0x03, 0x03,
    0x03, 0x03, 0x03, 0x03, 0x03, 0x03, 0x03, 0x03,
    0x03, 0x03, 0x03, 0x03, 0x03, 0x03, 0x03, 0x03,
    0x03, 0x03, 0x03, 0x03, 0x03, 0x03, 0x03, 0x03,
    0x03, 0x03, 0x03, 0x03, 0x03, 0x03, 0x03, 0x03,     /* 680 */
    0x03, 0x03, 0x03, 0x03, 0x03, 0x03, 0x03, 0x03,
    0x03, 0x03, 0x03, 0x03, 0x03, 0x03, 0x03, 0x03,
    0x03, 0x03, 0x03, 0x03, 0x03, 0x03, 0x03, 0x03,
    0x03, 0x03, 0x03, 0x03, 0x03, 0x04, 0x04, 0x04,
    0x04, 0x04, 0x04, 0x04, 0x04, 0x04, 0x04, 0x04,     /* 720 */
    0x04, 0x04, 0x04, 0x04, 0x04, 0x04, 0x04, 0x04,
    0x04, 0x04, 0x04, 0x04, 0x04, 0x04, 0x04, 0x04,
    0x04, 0x04, 0x04, 0x04, 0x04, 0x04, 0x04, 0x04,
    0x04, 0x04, 0x04, 0x04, 0x04, 0x04, 0x04, 0x04,
    0x04, 0x04, 0x04, 0x04, 0x04, 0x04, 0x04, 0x04,     /* 760 */
    0x04, 0x04, 0x04, 0x04, 0x04, 0x04, 0x04, 0x04,
    0x04, 0x04, 0x04, 0x04, 0x04, 0x04, 0x04, 0x04,
    0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05,
    0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05,
    0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05,     /* 800 */
    0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05,
    0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05,
    0x05, 0x06, 0x06, 0x06, 0x06, 0x06, 0x06, 0x06,
    0x06, 0x06, 0x06, 0x06, 0x06, 0x06, 0x06, 0x06,
    0x06, 0x06, 0x06, 0x06, 0x06, 0x06, 0x06, 0x06,     /* 840 */
    0x06, 0x06, 0x06, 0x06, 0x06, 0x06, 0x07, 0x07,
    0x07, 0x07, 0x07, 0x07, 0x07, 0x07, 0x07, 0x07,
    0x07, 0x07, 0x07, 0x07, 0x07, 0x07, 0x07, 0x07,
    0x07, 0x07, 0x07, 0x07, 0x07, 0x07, 0x07, 0x07,
    0x07, 0x07, 0x07, 0x07, 0x07, 0x07, 0x07, 0x07,     /* 880 */
    0x07, 0x07, 0x07, 0x07, 0x07, 0x07, 0x07, 0x07,
    0x07, 0x07, 0x07, 0x07, 0x07, 0x07, 0x07, 0x07,
    0x07, 0x07, 0x07, 0x07, 0x07, 0x07, 0x07, 0x07,
    0x07, 0x07, 0x07, 0x07, 0x07, 0x07, 0x07, 0x07,
    0x07, 0x07, 0x07, 0x07, 0x07, 0x07, 0x07, 0x07,     /* 920 */
    0x07, 0x07, 0x07, 0x07, 0x07, 0x07, 0x07, 0x07,
    0x07, 0x09, 0x09, 0x09, 0x09, 0x09, 0x09, 0x09,
    0x09, 0x09, 0x09, 0x09, 0x09, 0x09, 0x09, 0x09,
    0x09, 0x09, 0x09, 0x09, 0x09, 0x09, 0x09, 0x09,
    0x09, 0x09, 0x09, 0x09, 0x09, 0x09, 0x09, 0x09,     /* 960 */
    0x09, 0x09, 0x09, 0x09, 0x09, 0x09, 0x09, 0x09,
    0x09, 0x09, 0x09, 0x09, 0x09, 0x09, 0x09, 0x09,
    0x09, 0x09, 0x09, 0x09, 0x09, 0x09, 0x09, 0x09,
    0x09, 0x09, 0x09, 0x09, 0x09, 0x09, 0x09, 0x09,
    0x09, 0x09, 0x09, 0x09, 0x09, 0x09, 0x09, 0x09      /* 1000 */
    };

/* {̃e[u */
static const Uint16     rat_tbl[RAT_NUM] = {
    0xffff,    0,  500,  666,  750,  800,  833,  857,
    0xffff, 1000,  500,  333,  250,  200,  166,  142
    };

/*******************************************************************
 *      ֐`
 *******************************************************************/

/* MPEGEBhE̐ */
MpgWn   MPG_WnCreate(Uint32 dzx, Uint32 dzy, Uint32 dsx, Uint32 dsy)
{
    MpgWn       mpgwn;
    MpgWin      *mwptr;
    Sint32      err;
    Sint32      i;

    MPSYS_SemaIn(FALSE);

    /* ϐ̏ */
    mpgwn = NULL;
    err = MPG_ERR_CREATE;

    /* 󂢂ĂMPEGEBhET */
    for (i = 0; i < MPGWN_NUM; i++) {
        mwptr = &mp_win[i];
        if (MPG_WN_USEFLG(mwptr) == FALSE) {
            mpgwn = mwptr;
            break;
        }
    }
    
    if (mpgwn != NULL) {
        /* MPEGEBhEp[^̏ */
        initWinPara(mpgwn);
        
        /* MPEGEBhE̎gptOTRUEɂ */
        MPG_WN_USEFLG(mpgwn) = TRUE;
        
        /* MPEGEBhEp[^̐ݒ */
        MPG_WN_DZ_X(mpgwn) = dzx;
        MPG_WN_DZ_Y(mpgwn) = dzy;
        MPG_WN_DS_X(mpgwn) = dsx;
        MPG_WN_DS_Y(mpgwn) = dsy;
        MPG_WN_DP_X(mpgwn) = (Sint32)dzx + MPG_WN_DL_X(mpgwn);
        MPG_WN_DP_Y(mpgwn) = (Sint32)dzy + MPG_WN_DL_Y(mpgwn);
        MPG_WN_FZ_X(mpgwn) = dzx;
        MPG_WN_FZ_Y(mpgwn) = dzy;
        MPG_WN_FP_X(mpgwn) = GET_FPOS(MPG_WN_FZ_X(mpgwn), MPG_WN_DL_X(mpgwn),
                                      MPG_WN_RAT_X(mpgwn));
        MPG_WN_FP_Y(mpgwn) = GET_FPOS(MPG_WN_FZ_Y(mpgwn), MPG_WN_DL_Y(mpgwn),
                                      MPG_WN_RAT_Y(mpgwn));

        /* ϐ̐ݒ */
        err = MPG_ERR_OK;
    }
    
    MPSYS_SemaOut(err);

    return mpgwn;
}

/* MPEGEBhEp[^̏ */
static void     initWinPara(MpgWn mpgwn)
{
    /* qMPEGEBhEւ̃|C^ */
    MPG_WN_CHLD(mpgwn) = NULL;
    
    /* eMPEGEBhEւ̃|C^ */
    MPG_WN_PARE(mpgwn) = NULL;
    
    /* gptO */
    MPG_WN_USEFLG(mpgwn) = FALSE;
    
    /* fBXvCEBhE̕\ʒu */
    MPG_WN_DZ_X(mpgwn) = 0;
    MPG_WN_DZ_Y(mpgwn) = 0;
    
    /* fBXvCEBhȆ傫 */
    MPG_WN_DS_X(mpgwn) = 0;
    MPG_WN_DS_Y(mpgwn) = 0;
    
    /* fBXvCEBhẼItZbg */
    MPG_WN_DL_X(mpgwn) = 0;
    MPG_WN_DL_Y(mpgwn) = 0;
    
    /* t[obt@EBhE̔{ */
    MPG_WN_RAT_X(mpgwn) = RAT_DFL;
    MPG_WN_RAT_Y(mpgwn) = RAT_DFL;
    
    /* t[obt@EBhËʒuiY[|Cgj */
    MPG_WN_FZ_X(mpgwn) = 0;
    MPG_WN_FZ_Y(mpgwn) = 0;
    
    /* fBXvCEBhEʒup[^ */
    MPG_WN_DP_X(mpgwn) = 0;
    MPG_WN_DP_Y(mpgwn) = 0;
    
    /* t[obt@EBhEʒup[^ */
    MPG_WN_FP_X(mpgwn) = 0;
    MPG_WN_FP_Y(mpgwn) = 0;
    
    /* t[obt@EBhEg嗦p[^ */
    MPG_WN_FR_X(mpgwn) = ratToFr(RAT_DFL);
    MPG_WN_FR_Y(mpgwn) = ratToFr(RAT_DFL);
    
    /* {[_J[ */
    MPG_WN_BCLR(mpgwn) = 0;
    
    /* xb{ */
    MPG_WN_YCRAT_YR(mpgwn) = 0;
    MPG_WN_YCRAT_CR(mpgwn) = 0;
    
    /* ԃ[h */
    MPG_WN_INTPOL_YH(mpgwn) = 0;
    MPG_WN_INTPOL_YV(mpgwn) = 0;
    MPG_WN_INTPOL_CH(mpgwn) = 0;
    MPG_WN_INTPOL_CV(mpgwn) = 0;
    
    /* UCN */
    MPG_WN_MOZ_H(mpgwn) = 0;
    MPG_WN_MOZ_V(mpgwn) = 0;
    
    /* ڂXCb` */
    MPG_WN_SOFTSW_H(mpgwn) = 0;
    MPG_WN_SOFTSW_V(mpgwn) = 0;
    
    /* ~lbZXL[ */
    MPG_WN_LUMI_YLVL(mpgwn) = 0;
    MPG_WN_LUMI_BDR(mpgwn) = 0;
    
    /* 摜f[^̏o̓[h */
    MPG_WN_OMODE(mpgwn) = MPG_OMODE_DRCT;
    
    /* 摜f[^̓]֐ */
    MPG_WN_TRFUNC(mpgwn) = trnsScuDmaBbus;
    
    /* 摜f[^̓]̈ */
    MPG_WN_BUF(mpgwn) = NULL;
    
    /* \XCb` */
    MPG_WN_DISPSW(mpgwn) = OFF;
    
    return;
}

/* t[obt@EBhEg嗦̍쐬 */
static Sint32   ratToFr(Uint32 ratio)
{
    Sint32      fr;
    Sint32      a, b;
    Sint32      p, r, iv;
    
    if (ratio >= RAT_DFL) {
        fr = 0x8000;
        
        /* ߂ */
        p = GET_INTEG(ratio);
        
        /* ߂ */
        r = GET_FRAC(ratio, p);
        
        a = p;
        b = fr_tbl[r];
    } else if (ratio >= 0) {
        fr = 0x0000;
        
        /* t߂ */
        iv = GET_RECIP(ratio);

        /* ߂ */
        p = GET_INTEG(iv);
        
        /* ߂ */
        r = GET_FRAC(iv, p);
        
        a = p - 1;
        b = fr_tbl[r];
    }
    /* g嗦 */
    fr = (fr | (a << 4) | b);
    
    return fr;
}

/* SCUDMAɂBoXւ̃C[Wf[^] */
static Sint32   trnsScuDmaBbus(void *dst, void *src, Sint32 nbyte)
{
    Sint32      cnt;
    DmaScuPrm   prm;
    DmaScuStatus        stat;
    
    if (dst == NULL) {
        return MPG_ERR_NG;
    }

    prm.dxr = (Uint32)src;
    prm.dxw = (Uint32)dst;
    prm.dxc = nbyte;
    
    /* ]̃AhXZl   */
    prm.dxad_r = DMA_SCU_R0;
    
    /* ]̃AhXZl   */
    prm.dxad_w = DMA_SCU_W2;
    
    prm.dxmod = DMA_SCU_DIR;

    /* AhXXVrbgƃAhXZl̐邽߁A */
    /* DMA_SCU_KEEPƂ */
    prm.dxrup = DMA_SCU_KEEP;
    prm.dxwup = DMA_SCU_KEEP;
    prm.dxft = DMA_SCU_F_DMA;
    prm.msk = (DMA_SCU_M_DXR | DMA_SCU_M_DXW);
    DMA_ScuSetPrm(&prm, DMA_SCU_CH0);
    DMA_ScuStart(DMA_SCU_CH0);
    
    /* ]̃LbVp[W */
    CSH_Purge(dst, nbyte);
    
    cnt = 0;

    /* ]I`FbNi^CAEgԂ͂Qbj */
    do {
        if (cnt++ > TRNFIN_CNT) {
            return MPG_ERR_TMOUT;
        }
        DMA_ScuGetStatus(&stat, DMA_SCU_CH0);
    } while (stat.dxmv == DMA_SCU_MV);
    
    return MPG_ERR_OK;
}

/* MPEGEBhȄ */
void    MPG_WnDestroy(MpgWn mpgwn)
{
    Sint32      dswsw, fbn;
    MpgWn       parep, chldp;
    
    MPSYS_SemaIn(FALSE);
    
    /* \XCb`ONȂ\ɂ */
    if (MPG_WN_DISPSW(mpgwn) == ON) {
        MPG_WnDisp(mpgwn, OFF);
    }
    
    /* mpgwn؂藣 */
    MPWIN_Disconnect(mpgwn);
    
    /* MPEGEBhE̎gptOFALSEɂ */
    MPG_WN_USEFLG(mpgwn) = FALSE;
    
    MPSYS_SemaOut(MPG_ERR_OK);

    return;
}

/* MPEGEBhȄo̓[h̐ݒ */
void    MPG_WnSetOutputMode(MpgWn mpgwn, Sint32 omode, void *buf)
{
    MPSYS_SemaIn(FALSE);
    
    if (omode != MPG_NOCHG) {
        /* 摜f[^̏o̓[h̐ݒ */
        MPG_WN_OMODE(mpgwn) = omode;

        /* 摜f[^̓]̈̐ݒ */
        MPG_WN_BUF(mpgwn) = buf;
    }
    
    MPSYS_SemaOut(MPG_ERR_OK);

    return;
}

/* \E\̐ݒ */
void    MPG_WnDisp(MpgWn mpgwn, Bool sw)
{
    Sint32      err;

    MPSYS_SemaIn(FALSE);
    
    /* \E\̐ݒs */
    err = MPWIN_DispSub(mpgwn, sw);

    MPSYS_SemaOut(err);

    return;
}

/* \E\̐ݒs */
Sint32  MPWIN_DispSub(MpgWn mpgwn, Bool sw)
{
    Sint32      ret;

    ret = MPG_ERR_OK;
    if ((sw == ON) || (MPG_WN_DISPSW(mpgwn) == ON)) {
        /* \XCb`̐ݒ */
        MPG_WN_DISPSW(mpgwn) = sw;
        
        if (sw == ON) {
            /* EBhD̐ݒ */
            if ((ret = setWn(mpgwn)) != MPG_ERR_OK) {
                return ret;
            }
        }
        /* \XCb`ɏ]āA摜\ */
        ret = MPSYS_DoDisp(sw, MPG_WN_FBN(mpgwn));
    }    
    
    return ret;
}

/* EBhD̐ݒ */
static Sint32   setWn(MpgWn mpgwn)
{
    Sint32      ret;
    CdcMpVef    mpvef, *vfptr;
    
    /* t[obt@EBhDʒu̐ݒ */
    if (CDC_MpSetWinFpos(TRUE, MPG_WN_FP_X(mpgwn), MPG_WN_FP_Y(mpgwn)) !=
        CDC_ERR_OK) {
        return MPG_ERR_NG;
    }
    /* t[obt@EBhDg嗦̐ݒ */
    if (CDC_MpSetWinFrat(TRUE, MPG_WN_FR_X(mpgwn), MPG_WN_FR_Y(mpgwn)) !=
        CDC_ERR_OK) {
        return MPG_ERR_NG;
    }
    /* fBXvCEBhDʒu̐ݒ */
    if (CDC_MpSetWinDpos(TRUE, MPG_WN_DP_X(mpgwn), MPG_WN_DP_Y(mpgwn)) !=
        CDC_ERR_OK) {
        return MPG_ERR_NG;
    }
    /* fBXvCEBhDTCY̐ݒ */
    if (CDC_MpSetWinDsiz(TRUE, MPG_WN_DS_X(mpgwn), MPG_WN_DS_Y(mpgwn)) !=
        CDC_ERR_OK) {
        return MPG_ERR_NG;
    }
    /* {[_J[̐ݒ */
    if (CDC_MpSetBcolor(MPG_WN_BCLR(mpgwn)) != CDC_ERR_OK) {
        return MPG_ERR_NG;
    }
    /* tF[h̐ݒ */
    ret = MPSYS_DoSetFade(MPG_WN_YCRAT_YR(mpgwn), MPG_WN_YCRAT_CR(mpgwn));
    if (ret != MPG_ERR_OK) {
        return ret;
    }    
    /* ʓʂݒ肷 */
    ret = doSetWnEffect(mpgwn, SET_WN_INTPOL | SET_WN_MOZAIC | SET_WN_SOFT |
                        SET_WN_LUMIKEY);

    return ret;
}

/* ʓʂݒ肷 */
static Sint32   doSetWnEffect(MpgWn mpgwn, Sint32 id)
{
    /* ʓʂ̏l */
    static const CdcMpVef       mvf_ini = {
        CDC_PARA_NOCHG, CDC_PARA_NOCHG,
        CDC_PARA_NOCHG, CDC_PARA_NOCHG,
        CDC_PARA_NOCHG, CDC_PARA_NOCHG
    };
    Sint32      ret;
    CdcMpVef    mpvef, *vfptr;

    /* ʓʃp[^̐ݒ */
    vfptr = &mpvef;

    /* l̐ݒ */
    *vfptr = mvf_ini;

    if (id & SET_WN_INTPOL) {
        CDC_MPVEF_ITP(vfptr) = ((MPG_WN_INTPOL_YH(mpgwn) << 0) |
                                (MPG_WN_INTPOL_CH(mpgwn) << 1) |
                                (MPG_WN_INTPOL_YV(mpgwn) << 2) |
                                (MPG_WN_INTPOL_CV(mpgwn) << 3));
    }
    if (id & SET_WN_MOZAIC) {
        CDC_MPVEF_MOZH(vfptr) = MPG_WN_MOZ_H(mpgwn);
        CDC_MPVEF_MOZV(vfptr) = MPG_WN_MOZ_V(mpgwn);
    }
    if (id & SET_WN_SOFT) {
        CDC_MPVEF_SOFTH(vfptr) = MPG_WN_SOFTSW_H(mpgwn);
        CDC_MPVEF_SOFTV(vfptr) = MPG_WN_SOFTSW_V(mpgwn);
    }
    if (id & SET_WN_LUMIKEY) {
        CDC_MPVEF_TRP(vfptr) = (MPG_WN_LUMI_YLVL(mpgwn) |
                                (MPG_WN_LUMI_BDR(mpgwn) << 2));
    }

    /* ʓʂ̐ݒ֐s */ 
    ret = MPSYS_DoSetVeff(vfptr);

    return ret;
}

/* \ʒu̕ύX */
void    MPG_WnSetLoc(MpgWn mpgwn, Uint32 dzx, Uint32 dzy)
{
    Sint32      err;
    Sint32      dpx, dpy;
    
    MPSYS_SemaIn(FALSE);

    err = MPG_ERR_OK;
    
    /* fBXvCEBhE̕\ʒu̐ݒ */
    MPG_WN_DZ_X(mpgwn) = dzx;
    MPG_WN_DZ_Y(mpgwn) = dzy;
    
    /* fBXvCEBhËʒǔ */
    dpx = ((Sint32)dzx + MPG_WN_DL_X(mpgwn));
    MPG_WN_DP_X(mpgwn) = dpx;
    dpy = ((Sint32)dzy + MPG_WN_DL_Y(mpgwn));
    MPG_WN_DP_Y(mpgwn) = dpy;
    
    if (MPG_WN_DISPSW(mpgwn) == ON) {
        /* fBXvCEBhEʒu̐ݒ */
        if (CDC_MpSetWinDpos(TRUE, dpx, dpy) != CDC_ERR_OK) {
            err = MPG_ERR_NG;
        }
    }
    
    MPSYS_SemaOut(err);

    return;
}

/* \TCY̕ύX */
void    MPG_WnSetSize(MpgWn mpgwn, Uint32 dsx, Uint32 dsy)
{
    Sint32      err;

    MPSYS_SemaIn(FALSE);

    err = MPG_ERR_OK;
    
    /* fBXvCEBhȆ傫̐ݒ */
    MPG_WN_DS_X(mpgwn) = dsx;
    MPG_WN_DS_Y(mpgwn) = dsy;
    
    if (MPG_WN_DISPSW(mpgwn) == ON) {
        /* fBXvCEBhETCY̐ݒ */
        if (CDC_MpSetWinDsiz(TRUE, dsx, dsy) != CDC_ERR_OK) {
            err = MPG_ERR_NG;
        }
    }
    
    MPSYS_SemaOut(err);

    return;
}

/* \Έʒu̐ݒ */
void    MPG_WnSetDispOfst(MpgWn mpgwn, Sint32 dlx, Sint32 dly)
{
    Sint32      err;
    Sint32      dpx, dpy, fpx, fpy;
    
    MPSYS_SemaIn(FALSE);

    err = MPG_ERR_OK;
    
    /* fBXvCEBhȆΈʒu̐ݒ */
    MPG_WN_DL_X(mpgwn) = dlx;
    MPG_WN_DL_Y(mpgwn) = dly;
    
    /* fBXvCEBhEʒǔ */
    dpx = (MPG_WN_DZ_X(mpgwn) + dlx);
    MPG_WN_DP_X(mpgwn) = dpx;
    dpy = (MPG_WN_DZ_Y(mpgwn) + dly);
    MPG_WN_DP_Y(mpgwn) = dpy;
    
    /* t[obt@EBhEʒǔ */
    fpx = GET_FPOS(MPG_WN_FZ_X(mpgwn), dlx, MPG_WN_RAT_X(mpgwn));
    MPG_WN_FP_X(mpgwn) = fpx;
    fpy = GET_FPOS(MPG_WN_FZ_Y(mpgwn), dly, MPG_WN_RAT_Y(mpgwn));
    MPG_WN_FP_Y(mpgwn) = fpy;
    
    if (MPG_WN_DISPSW(mpgwn) == ON) {
        /* \Έʒu̐ݒs */
        err = setOfstSub(dpx, dpy, fpx, fpy);
    }
    
    MPSYS_SemaOut(err);

    return;
}

/* \Έʒu̐ݒs */
static Sint32   setOfstSub(Sint32 dpx, Sint32 dpy,
                           Sint32 fpx, Sint32 fpy)
{
    /* fBXvCEBhEʒu̐ݒ */
    if (CDC_MpSetWinDpos(TRUE, dpx, dpy) != CDC_ERR_OK) {
        return MPG_ERR_NG;
    }
    /* t[obt@EBhEʒu̐ݒ */
    if (CDC_MpSetWinFpos(TRUE, fpx, fpy) != CDC_ERR_OK) {
        return MPG_ERR_NG;
    }

    return MPG_ERR_OK;
}

/* {̐ݒ */
void    MPG_WnSetDispRatio(MpgWn mpgwn, Uint32 x_rat, Uint32 y_rat)
{
    Sint32      err;
    Sint32      frx, fry, fpx, fpy;
    
    MPSYS_SemaIn(FALSE);
    
    err = MPG_ERR_OK;
    
    /* ̔{܂߂ */
    if (x_rat < 2) {
        x_rat = 2;
    }
    /* ̔{܂߂ */
    if (y_rat < 4) {
        y_rat = 4;
    }
    /* t[obt@EBhEg嗦p[^̍쐬 */
    frx = ratToFr(x_rat);
    MPG_WN_FR_X(mpgwn) = frx;
    fry = ratToFr(y_rat);
    MPG_WN_FR_Y(mpgwn) = fry;
    
    /* g嗦p[^̔{ւ̕ϊ */
    x_rat = frToRat(frx);
    y_rat = frToRat(fry);
    
    /* t[obt@EBhE̔{̐ݒ */
    MPG_WN_RAT_X(mpgwn) = x_rat;
    MPG_WN_RAT_Y(mpgwn) = y_rat;    
    
    /* t[obt@EBhEʒǔ */
    fpx = GET_FPOS(MPG_WN_FZ_X(mpgwn), MPG_WN_DL_X(mpgwn), (Sint32)x_rat);
    MPG_WN_FP_X(mpgwn) = fpx;
    fpy = GET_FPOS(MPG_WN_FZ_Y(mpgwn), MPG_WN_DL_Y(mpgwn), (Sint32)y_rat);
    MPG_WN_FP_Y(mpgwn) = fpy;
    
    if (MPG_WN_DISPSW(mpgwn) == ON) {
        /* {̐ݒs */
        err = setRatioSub(frx, fry, fpx, fpy);
    }
    MPSYS_SemaOut(err);

    return;
}

/* g嗦p[^̔{ւ̕ϊ */
static Uint32   frToRat(Sint32 fr)
{
    Uint32      rat, a;
    Sint32      idx;
    
    a = ((fr >> 4) & 0x03ff);
    idx = (fr & 0x000f);
    
    rat = (a * RAT_DFL) + rat_tbl[idx];

    if ((fr & 0x8000) == 0) {
        rat = GET_RECIP(rat + RAT_DFL);
    }

    return rat;
}

/* {̐ݒs */
static Sint32   setRatioSub(Sint32 frx, Sint32 fry,
                            Sint32 fpx, Sint32 fpy)
{
    /* t[obt@EBhEg嗦̐ݒ */
    if (CDC_MpSetWinFrat(TRUE, frx, fry) != CDC_ERR_OK) {
        return MPG_ERR_NG;
    }
    /* t[obt@EBhEʒu̐ݒ */
    if (CDC_MpSetWinFpos(TRUE, fpx, fpy) != CDC_ERR_OK) {
        return MPG_ERR_NG;
    }

    return MPG_ERR_OK;
}

/* t[EBhËʒu̐ݒ */
void    MPG_WnSetFrmLoc(MpgWn mpgwn, Uint32 fzx, Uint32 fzy)
{
    Sint32      err;
    Sint32      fpx, fpy;
    
    MPSYS_SemaIn(FALSE);

    err = MPG_ERR_OK;

    /* t[obt@EBhËʒuiY[|Cgj̐ݒ */
    MPG_WN_FZ_X(mpgwn) = fzx;
    MPG_WN_FZ_Y(mpgwn) = fzy;
    
    /* t[obt@EBhEʒǔ */
    fpx = GET_FPOS((Sint32)fzx, MPG_WN_DL_X(mpgwn), MPG_WN_RAT_X(mpgwn));
    MPG_WN_FP_X(mpgwn) = fpx;
    fpy = GET_FPOS((Sint32)fzy, MPG_WN_DL_Y(mpgwn), MPG_WN_RAT_Y(mpgwn));
    MPG_WN_FP_Y(mpgwn) = fpy;
    
    if (MPG_WN_DISPSW(mpgwn) == ON) {
        /* t[obt@EBhEʒu̐ݒ */
        if (CDC_MpSetWinFpos(TRUE, fpx, fpy) != CDC_ERR_OK) {
            err = MPG_ERR_NG;
        }
    }
    
    MPSYS_SemaOut(err);

    return;
}

/* zXg̈ւ̓] */
Sint32  MPG_WnTrans(MpgWn mpgwn)
{
    Sint32      ret;

    MPSYS_SemaIn(FALSE);
    
    ret = MPG_ERR_ILLSTAT;

    if ((MPG_WN_DISPSW(mpgwn) == ON) &&
        (MPG_WN_OMODE(mpgwn) == MPG_OMODE_HOST)) {

        /* zXg]̎s */
        ret = doTrans(mpgwn);
    }
    
    return MPSYS_SemaOut(ret);
}

/* zXg]̎s */
static Sint32   doTrans(MpgWn mpgwn)
{
    Sint32      ret;
    Sint32      dwsiz;
    Uint32      *rgbreg;
    Uint16      *buf;
    MpgTrFunc   trfunc;

    /* EBhD̐ݒ */
    if ((ret = setWn(mpgwn)) != MPG_ERR_OK) {
        return ret;
    }

    /* C[Wf[^̎o */
    if (CDC_MpGetImg(&dwsiz) != CDC_ERR_OK) {
        return MPG_ERR_NG;
    }

    /* MPEGRGBWX^̃|C^擾 */
    rgbreg = CDC_GetMpegPtr();

    /* C[Wf[^̓]̈̃|C^擾 */
    buf = MPG_WN_BUF(mpgwn);

    /* ]֐NULL`FbN */
    trfunc = MPG_WN_TRFUNC(mpgwn);
    if (trfunc == NULL) {
        return MPG_ERR_NG;
    }

    /* C[Wf[^̓] */
    ret = (*trfunc)(buf, rgbreg, dwsiz * sizeof(Uint16));

    return ret;
}

/* {[_J[̐ݒ */
void    MPG_WnSetBcolor(MpgWn mpgwn, Uint16 clr)
{
    Sint32      err;

    MPSYS_SemaIn(FALSE);

    err = MPG_ERR_OK;

    /* {[_J[̐ݒ */
    MPG_WN_BCLR(mpgwn) = clr;
    
    if (MPG_WN_DISPSW(mpgwn) == ON) {
        /* {[_J[̐ݒ */
        if (CDC_MpSetBcolor(clr) != CDC_ERR_OK) {
            err = MPG_ERR_NG;
        }
    }
    
    MPSYS_SemaOut(err);

    return;
}

/* xb{̐ݒ */
void    MPG_WnSetYcRatio(MpgWn mpgwn, Uint32 y_rat, Uint32 c_rat)
{
    Sint32      err;
    Sint32      yr, cr;

    MPSYS_SemaIn(FALSE);

    err = MPG_ERR_OK;

    yr = GET_YCRAT(y_rat);
    cr = GET_YCRAT(c_rat);

    /* PxM̔{̐ݒ */
    MPG_WN_YCRAT_YR(mpgwn) = yr;
    
    /* FM̔{̐ݒ */
    MPG_WN_YCRAT_CR(mpgwn) = cr;
    
    if (MPG_WN_DISPSW(mpgwn) == ON) {
        /* tF[h̐ݒ */
        err = MPSYS_DoSetFade(yr, cr);
    }    
    
    MPSYS_SemaOut(err);

    return;
}

/* ԃ[h̐ݒ */
void    MPG_WnSetIntpol(MpgWn mpgwn,
                        Bool sw_yh, Bool sw_yv, Bool sw_ch, Bool sw_cv)
{
    Sint32      err;

    MPSYS_SemaIn(FALSE);

    err = MPG_ERR_OK;

    /* Px̐̕ԃXCb`̐ݒ */
    MPG_WN_INTPOL_YH(mpgwn) = sw_yh;
    
    /* Px̐̕ԃXCb`̐ݒ */
    MPG_WN_INTPOL_YV(mpgwn) = sw_yv;
    
    /* F̐̕ԃXCb`̐ݒ */
    MPG_WN_INTPOL_CH(mpgwn) = sw_ch;
    
    /* F̐̕ԃXCb`̐ݒ */
    MPG_WN_INTPOL_CV(mpgwn) = sw_cv;
    
    if (MPG_WN_DISPSW(mpgwn) == ON) {
        /* ʓʂݒ肷 */
        err = doSetWnEffect(mpgwn, SET_WN_INTPOL);
    }
    
    MPSYS_SemaOut(err);

    return;
}

/* UCN̐ݒ */
void    MPG_WnSetMozaic(MpgWn mpgwn, Sint32 moz_h, Sint32 moz_v)
{
    Sint32      err;

    MPSYS_SemaIn(FALSE);

    err = MPG_ERR_OK;

    /* ̃UCN̊̐ݒ */
    MPG_WN_MOZ_H(mpgwn) = moz_h;
    
    /* ̃UCN̊̐ݒ */
    MPG_WN_MOZ_V(mpgwn) = moz_v;
    
    if (MPG_WN_DISPSW(mpgwn) == ON) {
        /* ʓʂݒ肷 */
        err = doSetWnEffect(mpgwn, SET_WN_MOZAIC);
    }
    
    MPSYS_SemaOut(err);

    return;
}

/* ڂ̐ݒ */
void    MPG_WnSetSoft(MpgWn mpgwn, Bool sof_h, Bool sof_v)
{
    Sint32      err;

    MPSYS_SemaIn(FALSE);

    err = MPG_ERR_OK;

    /* ڂXCb`̐ݒ */
    MPG_WN_SOFTSW_H(mpgwn) = sof_h;
    MPG_WN_SOFTSW_V(mpgwn) = sof_v;
    
    if (MPG_WN_DISPSW(mpgwn) == ON) {
        /* ʓʂݒ肷 */
        err = doSetWnEffect(mpgwn, SET_WN_SOFT);
    }
    
    MPSYS_SemaOut(err);

    return;
}

/* ~lbZXL[̐ݒ */
void    MPG_WnSetLumiKey(MpgWn mpgwn, Sint32 y_lvl, Bool bdr)
{
    Sint32      err;

    MPSYS_SemaIn(FALSE);

    err = MPG_ERR_OK;

    /* PxM̃x̐ݒ */
    MPG_WN_LUMI_YLVL(mpgwn) = y_lvl;
    
    /* MPEGf̋Eg傷邩ۂ̐ݒ */
    MPG_WN_LUMI_BDR(mpgwn) = bdr;
    
    if (MPG_WN_DISPSW(mpgwn) == ON) {
        /* ʓʂݒ肷 */
        err = doSetWnEffect(mpgwn, SET_WN_LUMIKEY);
    }
    
    MPSYS_SemaOut(err);

    return;
}

/* ]֐̓o^ */
void    MPG_WnEntryTrFunc(MpgWn mpgwn, MpgTrFunc trfunc)
{
    if (trfunc == NULL) {
        /* ftHg̓]֐̑ */
        trfunc = trnsScuDmaBbus;
    }
    /* [U]֐̓o^ */
    MPG_WN_TRFUNC(mpgwn) = trfunc;

    return;
}

/* SMPEGEBhȄ */
void    MPWIN_InitAllWn(void)
{
    Sint32      i;
    
    for (i = 0; i < MPGWN_NUM; i++) {
        /* MPEGEBhEp[^̏ */
        initWinPara(&mp_win[i]);
    }
    return;
}

/* mpgwn1̍Ōmpgwn2ڑ */
void    MPWIN_Connect(MpgWn mpgwn1, MpgWn mpgwn2)
{
    MpgWn       mpgwnwk, chld;
    
    mpgwnwk = mpgwn1;

    /* I[T */
    while ((chld = MPG_WN_CHLD(mpgwnwk)) != NULL) {
        mpgwnwk = chld;
    }
    
    /* mpgwn2ڑ */
    MPG_WN_CHLD(mpgwnwk) = mpgwn2;
    MPG_WN_PARE(mpgwn2) = mpgwnwk;
    
    return;
}

/* mpgwn؂藣 */
void    MPWIN_Disconnect(MpgWn mpgwn)
{
    MpgWn       parep, chldp;
    
    /* XĝȂ */
    parep = MPG_WN_PARE(mpgwn);
    chldp = MPG_WN_CHLD(mpgwn);
    if (parep != NULL) {
        MPG_WN_CHLD(parep) = chldp;
    }
    if (chldp != NULL) {
        MPG_WN_PARE(chldp) = parep;
    }
    MPG_WN_PARE(mpgwn) = NULL;
    MPG_WN_CHLD(mpgwn) = NULL;
    
    return;
}

/* mpgwnɐڑĂSẴzXgo̓EBhE] */
void    MPWIN_OutputAll(MpgWn mpgwn, Sint32 omode)
{
    MpgWn       mpgwnwk;
    
    mpgwnwk = mpgwn;
    if (omode == MPG_OMODE_DRCT) {      /* _CNg][h */
        return;
    }
    /* zXg][h̏ꍇA\̃EBhESďo͂ */
    do {
        if (MPG_WN_OMODE(mpgwnwk) == MPG_OMODE_HOST) {
            MPG_WnTrans(mpgwnwk);
        }
        mpgwnwk = MPG_WN_CHLD(mpgwnwk);
    } while (mpgwnwk != NULL);

    return;
}

