/*----------------------------------------------------------------------------
 *  mth_dsps.c -- MTH Cu croɂRcWϊ W[
 *  Copyright(c) 1994 SEGA
 *  Written by H.E on 1994-03-29 Ver.0.80
 *  Updated by H.E on 1994-03-29 Ver.0.80
 *
 *  ̃Cu̓V~[VpcroɂRcWϊW[
 *  ȉ̃[`܂ށB
 *
 *  MTH_PolyDataTransInit     -  Wϊ̏
 *  MTH_PolyDataTransExec     -  Wϊs
 *  MTH_PolyDataTransCheck    -  Wϊ`FbN
 *
 *----------------------------------------------------------------------------
 */

/*
 * USER SUPPLIED INCLUDE FILES
 */
#include "sega_mth.h"
#ifdef _SH
#include <machine.h>
#endif

static MthMatrix *coordMatrix;
static MthXyz    *lightVector;

static void surfaceBright(Uint16 entryCount, MthXyz *surfacePoint,
			  MthXyz *surfaceNormal, Sint32 *surfaceBright);
static void coordTrans(Uint16 entryCount, MthXyz *src, MthXyz *ans);
static void vertBright(Uint16 entryCount, MthXyz *vertNormal,
					  Sint32 *pointBright);



/*************************************************************************
 *
 * NAME : MTH_PolyDataTransInit  -  Initialize Coord Transfer by DSP
 *
 * PARAMETERS
 *
 *     No exist.
 *
 * DESCRIPTION
 *
 *	crȍƍWϊvÕ[hB
 *
 * POSTCONDITIONS
 *
 *     No exist.
 *
 * CAVEATS
 *
 *************************************************************************
 */
void    MTH_PolyDataTransInit(void)
{
	/** BEGIN ************************************************************/
}


/*************************************************************************
 *
 * NAME : MTH_PolyDataTransExec  -  Execute Coord Transfer by DSP
 *
 * PARAMETERS
 *
 *     (1) MthPolyTransParm *polyTransParm  - <i/o>  Wϊp[^e[u
 *
 * DESCRIPTION
 *
 *	RcXvCg\CuŗpĂ|Sf[^
 *      iRcIuWFNgjɂĎ̈ȀcroɂčsB
 *
 *      E|Sʂ̉BʔƋPxvZ
 *      E_̎_Wnւ̕ϊ
 *      EO[[\p_̋PxvZiIvVj
 *      E_̃[hWnւ̕ϊiIvVj
 *
 *
 * POSTCONDITIONS
 *
 *     No exist.
 *
 * CAVEATS
 * 
 *************************************************************************
 */
void    MTH_PolyDataTransExec(MthPolyTransParm *polyTransParm)
{
    /** BEGIN ************************************************************/
    coordMatrix = &polyTransParm->viewLight->viewMatrix;
    lightVector = &polyTransParm->viewLight->lightVector;

    /* ʖ@e[uʋPxe[u𓾂 */
    surfaceBright(polyTransParm->surfCount,
		  polyTransParm->surfPoint,
		  polyTransParm->surfNormal,
		  polyTransParm->surfBright);

    /* _f[^̎_Wϊe[u𓾂 */
    coordTrans(polyTransParm->transViewVertCount,
	       polyTransParm->transViewVertSrc,
	       polyTransParm->transViewVertAns);

    /* O[[p_Pxe[u𓾂  */
    if(polyTransParm->gourVertCount)
	vertBright(polyTransParm->gourVertCount,
		   polyTransParm->vertNormal,
		   polyTransParm->vertBright);

    /* _f[^̃[hWϊe[u𓾂 */
    if(polyTransParm->transWorldVertCount) {
	coordMatrix = &polyTransParm->viewLight->worldMatrix;
	coordTrans(polyTransParm->transWorldVertCount,
		   polyTransParm->transWorldVertSrc,
		   polyTransParm->transWorldVertAns);
    }
}


static void surfaceBright(Uint16 entryCount, MthXyz *surfacePoint,
			  MthXyz *surfaceNormal, Sint32 *surfaceBright)
{
#if	0
	/*
	**1995-07-27	q
	**	gĂȂ̂ō폜
	*/
	Sint32	i,j,color;
#else
	Sint32	i,color;
#endif
	MthXyz  viewVect, tSurfPoint, tSurfNormal, *wSurfPoint;

	wSurfPoint = surfacePoint;
	for(i=0;i<entryCount;i++)
	{
	    MTH_CoordTrans(coordMatrix, wSurfPoint, &tSurfPoint);
	    viewVect.x = - tSurfPoint.x;
	    viewVect.y = - tSurfPoint.y;
	    viewVect.z = - tSurfPoint.z;
	    MTH_NormalTrans(coordMatrix, surfaceNormal++, &tSurfNormal);
	    color = MTH_ComputeBright(&tSurfNormal,lightVector);
	    if (MTH_Product((Fixed32*)&viewVect,
			    (Fixed32*)&tSurfNormal) <= 0)
		color |= 0xffff0000;
	    *surfaceBright++ = color;
	    wSurfPoint++;
	}
}


static void coordTrans(Uint16 entryCount, MthXyz *src, MthXyz *ans)
{
	Sint32	i;

	for(i=0;i<entryCount;i++)
	    MTH_CoordTrans(coordMatrix, src++, ans++);
}


static void vertBright(Uint16 entryCount, MthXyz *vertNormal,
					  Sint32 *pointBright)
{
	Uint16	i;
	MthXyz  ans;
	Sint16  color;

	for(i=0;i<entryCount;i++)
	{
	     MTH_NormalTrans(coordMatrix, vertNormal++, &ans);
	     color = MTH_ComputeBright(&ans,lightVector);
	     *pointBright++ = color;
	}
}


/*************************************************************************
 *
 * NAME : MTH_PolyDataTransCheck  -  Check Coord Transfer Complete
 *
 * PARAMETERS
 *
 *     No exist.
 *
 * DESCRIPTION
 *
 *	croɂWϊ܂ő҂B
 *
 * POSTCONDITIONS
 *
 *     No exist.
 *
 * CAVEATS
 * 
 *************************************************************************
 */
void    MTH_PolyDataTransCheck(void)
{
	/** BEGIN ************************************************************/
}


/*  end of file */
