/******************************************************************************
 *	\tgEFACu
 *
 *	Copyright (c) 1994,1995 SEGA
 *
 * Library	:oblE`coblĐCu
 * Module 	:PCM buffer management, PCM data copy
 * File		:pcm_audi.c
 * Date		:1994-09-29
 * Version	:1.00
 * Auther	:Y.T
 *
 ****************************************************************************/
#include "pcm_msub.h"

/* ݒ肷 */
/* #define FILL_SILENCE */

/* SMOOTH_FILL */
#define PCM_SMOOTH_FILL


/*------------------------- s}Nt -------------------------*/

/* cl`]̋N */
#define COPY_DMA_PCM(st)													\
	DMA_CpuMemCopy4((void *)(st)->dma_pcm_tbl[(st)->idx_dma_pcm_tbl].dst,	\
					(void *)(st)->dma_pcm_tbl[(st)->idx_dma_pcm_tbl].src,	\
					(st)->dma_pcm_tbl[(st)->idx_dma_pcm_tbl].cnt)

#define ENTRY_DMA_PCM(st, idx, dest, srce, size)							\
		(																	\
			(st)->dma_pcm_tbl[(idx)].dst = (Uint32)(dest), 					\
			(st)->dma_pcm_tbl[(idx)].src = (srce), 							\
			(st)->dma_pcm_tbl[(idx)].cnt = (size) >> 2 						\
		)

/* ]XCb` */
#define DST_1ST(d1, d2)		(PCM_IS_LRLRLR(st) ? (d2) : (d1))
#define DST_2ST(d1, d2)		(PCM_IS_LRLRLR(st) ? (d1) : (d2))
#define DST_1(d1, d2)		(PCM_IS_MONORAL(st) ? (d1) : DST_1ST((d1), (d2)))
#define DST_2(d1, d2)		(PCM_IS_MONORAL(st) ? NULL : DST_2ST((d1), (d2)))

#define ENTRY_COPY_TBL(st, idx, d1, d2, srce, bsize)					\
		(																\
			(st)->copy_tbl[(idx)].dst1 = DST_1((d1), (d2)), 				\
			(st)->copy_tbl[(idx)].dst2 = DST_2((d1), (d2)), 				\
			(st)->copy_tbl[(idx)].src = (srce), 						\
			(st)->copy_tbl[(idx)].size = (bsize) 						\
		)

/*******************************************************************
y@@\z
	ItZbg̈ʒũf[^擪ɗ悤Ƀobt@̃f[^]B
					<-- pcm_bsize ---------------------->
					<-- offset -->
		OF	aaaaaaaaaaaaaabbbbbbbbbbbbbbbbbbbbbbb
		F	bbbbbbbbbbbbbbbbbbbbbbbaaaaaaaaaaaaaa
y@z
	addr_pwork		()@|[YƗpobt@
	bsize_pwork		()@|[YƗpobt@TCY[byte]
	pcm_addr		(o)Ώۃobt@(4oCgE)
	pcm_bsize	()	Ώۃobt@TCY[byte](4̔{)
	offset			()	][byte]
y߂lz
	Ȃ
*******************************************************************/
void pcm_RotatePcmbuf(Uint32 addr_pwork, Sint32 bsize_pwork, Uint32 pcm_addr, Sint32 pcm_bsize, Sint32 offset)
{
	Sint32 	bsize_shift;

/* #define DEBUG_PRINT_ROTATE */

	#ifdef DEBUG_PRINT_ROTATE
		Sint32	cnt_rotate = 0;
		
		debug_write_str("Rota-Pcm");
		debug_write_data((Uint32)addr_pwork);
		debug_write_data((Uint32)bsize_pwork);
		debug_write_data((Uint32)pcm_addr);
		debug_write_data((Uint32)pcm_bsize);
		debug_write_data((Uint32)offset);
	#endif

	if (addr_pwork & 3) {
		addr_pwork = (addr_pwork + 3) & 0xFFFFFFFC;
		bsize_pwork -= 4;
	}
	bsize_pwork &= 0xFFFFFFFC;
	while (offset > 0) {
		#ifdef DEBUG_PRINT_ROTATE
			cnt_rotate++;
		#endif
		bsize_shift = MIN(bsize_pwork, offset);
		if (bsize_shift & 3) {
			pcm_RotateByte((Sint8 *)addr_pwork, (Sint8 *)pcm_addr, 
								pcm_bsize, bsize_shift);
		} else {
			pcm_RotateDword((Sint32 *)addr_pwork, (Sint32 *)pcm_addr, 
								pcm_bsize >> 2, bsize_shift >> 2);
		}
		offset -= bsize_shift;
	}

	#ifdef DEBUG_PRINT_ROTATE
		debug_write_data((Uint32)cnt_rotate);
	#endif
}

/*******************************************************************
y@@\z													J֐
	Đ^PCMobt@݃AhX̎擾
y@z
	hn					()@nh
	addr_write1			(o)@PCMobt@݃AhX( or ڵ-R)
	addr_write2			(o)@PCMobt@݃AhX(ڵ-L)
	size_write			(o)@A݉\TCY[byte]
	size_write_total	(o)@܂Ԃ܂߂݉\TCY[byte]
y߂lz
	Ȃ
y@Ӂz
*******************************************************************/
void pcm_GetPcmWrite(PcmHn hn, Sint8 **addr_write1, Sint8 **addr_write2, Sint32 *size_write, Sint32 *size_write_total)
{
	PcmWork		*work 	= *(PcmWork **)hn;
	PcmPara		*para 	= &work->para;
	PcmStatus	*st 	= &work->status;
	Sint32		sample_read_safety;		/* Sȓǂݎ[sample] */

	/* Sȓǂݎʒuust->cnt_4ksamplevɂĐʂ̌vZ */
	sample_read_safety = st->sample_pause + st->cnt_4ksample * 4096;

	/* ݉\g[^TCY */
	*size_write_total = st->pcm_bsize - 
		PCM_SAMPLE2BSIZE(st, st->sample_write - sample_read_safety);

	/* A݉\TCY */
	if (*size_write_total == 0) {
		*size_write = 0;
		*addr_write1 = NULL;
		*addr_write2 = NULL;
	} else {
		if (st->pcm_write_offset + *size_write_total > st->pcm_bsize) {
			*size_write = st->pcm_bsize - st->pcm_write_offset;
		} else {
			*size_write = *size_write_total;
		}
		*addr_write1 = para->pcm_addr + st->pcm_write_offset;
		*addr_write2 = st->pcm2_addr + st->pcm_write_offset;
	}
}

/*******************************************************************
y@@\z													J֐
	Đ^PCMobt@݃AhX̍XV(ݗʂ̕)
y@z
	hn			()@nh
	size_write	()@PCMobt@ݗ[byte/1ch]
y߂lz
	Ȃ
y@Ӂz
*******************************************************************/
void pcm_RenewPcmWrite(PcmHn hn, Sint32 size_write)
{
	PcmWork		*work 	= *(PcmWork **)hn;
	PcmStatus	*st 	= &work->status;
	Sint32		sample;
#ifdef __PCMD
	PcmPara		*para 	= &work->para;
	Sint32 		dwsize;
	static Uint32 *save_addr;

	if (st->sample_write_file == 0) {
		save_addr = (Uint32 *)0x4000000;
	}
#endif

	/* Tv[sample]̍XV				*/
	sample = PCM_BSIZE2SAMPLE(st, size_write);
	st->sample_write_file += sample;	/* t@C̋Tv[sample]*/
	st->sample_write += sample;			/* Tv[sample]			*/

	st->pcm_write_offset   += size_write;
	if (st->pcm_write_offset >= st->pcm_bsize) {
		st->pcm_write_offset -= st->pcm_bsize;

		if (st->pcm_write_offset != 0) {
			VTV_PRINTF((VTV_s, "P:?WritOff %X\n", st->pcm_write_offset));
		}

#ifdef __PCMD
	if ((Uint32)save_addr < 0x4100000) {
		dwsize = st->pcm_bsize >> 2;
		pcm_MemcpyDword(save_addr, (Uint32 *)para->pcm_addr, dwsize);
		save_addr += dwsize;
	}
#endif

	}
	return;
}

#if 0	/* 쐬 */

/*******************************************************************
y@@\z
	Đ^cl`]Ǘ
y@z
	hn			()@nh
y߂lz
	Ȃ
y@Ӂz
*******************************************************************/
STATIC void pcm_CheckDma(PcmHn hn)
{
	PcmWork		*work 	= *(PcmWork **)hn;
	PcmPara		*para 	= &work->para;
	PcmStatus	*st 	= &work->status;
	PcmHeader	*head 	= work->header;
	Uint32 		result;
	Uint32 		start_addr, end_addr;

	if (pcm_copy_mode_pcm != PCM_COPY_MODE_PCM_CPU_DMA) {
		return;
	}

	if (st->dma_hold == PCM_ON) {
		result = DMA_CpuResult();
		switch (result) {
		case DMA_CPU_BUSY:
			return;
		case DMA_CPU_FAIL:
			PCM_MeSetErrCode(PCM_ERR_DMA_CPU_PCM);
			break;
		case DMA_CPU_END:
			break;
		}
#if 1
		/* PCMobt@܂ԂmCYȂ߂ɁB */
		start_addr = st->dma_pcm_tbl[st->idx_dma_pcm_tbl].dst;
		end_addr = start_addr + st->bsize_pcmbuf;
		if ((start_addr == (Uint32)para->addr_pcmbuf)
		 || (start_addr == (Uint32)st->addr_pcmbuf_end)) {
			if (PCM_IS_16BIT_SAMPLING(head)) {
				*(Uint16 *)(end_addr - 2) = *(Uint16 *)start_addr;
			} else {
				*(Uint8 *)(end_addr - 1) = *(Uint8 *)start_addr;
			}
		}
#endif
		if (st->idx_dma_pcm_tbl == 0) {
			/* SĂ̓]Ƃ */
			pcm_RenewPcmWrite(hn, st->pcm_renew_size);
			pcm_RenewRead(hn, st->buf_renew_size);
			st->pcm_renew_size = 0;
			st->buf_renew_size = 0;
			st->dma_hold = PCM_OFF;
			pcm_flag_dma_use = 0;
		} else {
			/* GgĂcl`]N */
			st->idx_dma_pcm_tbl--;
			COPY_DMA_PCM(st);
		}
	}
}

/* DMA]҂ */
void pcm_WaitDmaFinish(PcmHn hn)
{
	PcmWork		*work 	= *(PcmWork **)hn;
	PcmStatus	*st 	= &work->status;

	while (st->dma_hold == PCM_ON) {
		pcm_CheckDma(hn);	/* cl`]Ǘ */
	}
}

/*******************************************************************
y@@\z
	Đ^(ubN)Rs[e[u̐ݒ
y@z
	hn			()@nh
	size_copy	()@1ch̃oCg
y߂lz
	Ȃ
y@lz
	PubN̘A͕ۏ؂Ă̂ƂB
	PCMޯ̧݈ʒuXV܂ށB
*******************************************************************/
void pcm_SetBlockCopyTbl(PcmHn hn, Sint32 size_copy)
{
	PcmWork		*work 	= *(PcmWork **)hn;
	PcmPara		*para 	= &work->para;
	PcmStatus	*st 	= &work->status;
	Sint32		size_write, size_write_total;
	Sint32		size_2nd, 			/* 2ڂpcm[hTCY(1ٕ) */
				size_mono;			/* ިق̂Pٕ̃TCY */
	Sint8 		*addr_write1, *addr_write2;
	Sint8		*addr_sample;

	if (size_mono <= size_write) {
		if (PCM_IS_MONORAL(st)) {/* mf[^ */
			st->idx_dma_pcm_tbl = 0;
			addr_sample = st->ring_read_addr;
			ENTRY_DMA_PCM(st, 0, addr_write1, addr_sample, size_mono);
		} else {/* XeIf[^ */
			st->idx_dma_pcm_tbl = 1;
			ENTRY_DMA_PCM(st, 1, addr_write2, addr_sample, size_mono);
			ENTRY_DMA_PCM(st, 0, addr_write1, addr_sample + size_mono, 
															size_mono);
		}
	} else {	/* ܂Ԃ] */
		if (PCM_IS_MONORAL(st)) {/* mf[^ */
			st->idx_dma_pcm_tbl = 1;
			addr_sample = st->ring_read_addr;
			ENTRY_DMA_PCM(st, 1, addr_write1, addr_sample, size_write);
		} else {/* XeIf[^ */
			st->idx_dma_pcm_tbl = 3;
			ENTRY_DMA_PCM(st, 3, addr_write2, addr_sample, size_write);
			ENTRY_DMA_PCM(st, 2, addr_write1, addr_sample + size_mono, 
														size_write);
		}
		/* Qڂ̃[h */
		size_2nd = size_mono - size_write;
		addr_sample += size_write;
		addr_write1 = para->pcm_addr;
		addr_sample = st->ring_read_addr + size_write;
		pcm_GetPcmWrite(hn, &addr_write1, &addr_write2, 
							&size_write, &size_write_total);
		if (PCM_IS_MONORAL(st)) {/* mf[^ */
			ENTRY_DMA_PCM(st, 0, addr_write1, addr_sample, size_2nd);
		} else {/* XeIf[^ */
			ENTRY_DMA_PCM(st, 1, addr_write2, addr_sample, size_2nd);
			ENTRY_DMA_PCM(st, 0, addr_write1, addr_sample + size_mono, 
															size_2nd);
		}

	}
}

/*******************************************************************
y@@\z
	Đ^kqubNI[fBI
y@z
	hn			()@nh
y߂lz
	Ȃ
y@lz
	PubN̘A͕ۏ؂Ă̂ƂB
*******************************************************************/
STATIC void pcm_AudioBlock(PcmHn hn)
{
	PcmWork		*work 	= *(PcmWork **)hn;
	PcmStatus	*st 	= &work->status;
	Sint32		size_write, size_write_total;
	Sint8 		*addr_write1, *addr_write2;
	Sint32		size_sample, 		/*  */
				size_2nd, 			/* 2ڂpcm[hTCY(1ٕ) */
				size_mono;			/* ިق̂Pٕ̃TCY */

	/* DMA󂫏Ԃ`FbN */
	if ((pcm_copy_mode_pcm == PCM_COPY_MODE_PCM_CPU_DMA)
	 && (pcm_flag_dma_use)) {
		st->cnt_over_task_call++;
		return;
	}

	/* Oobt@̍݌[byte] */
	size_sample = st->ring_write_offset - st->ring_read_offset;

	/*  */
	size_mono = st->ring_write_offset - st->ring_read_offset;

	 = st->ring_write_offset - st->ring_read_offset;



	/* ިق̂Pٕ̃TCY߂  */
	switch (st->info.channel) {
	case 1:	/* 1`limjf[^ */
		size_mono = size_sample;
		break;
	case 2:	/* 2`liXeIjf[^ */
		size_mono = size_sample >> 1;
		break;
	}

	/* I[fBIf[^[hł邩`FbN */
	pcm_GetPcmWrite(hn, &addr_write1, &addr_write2, 
						&size_write, &size_write_total);

	/* t@C̃C^[uK؂łA摜Tv𐳂
	 * ɏĂ΁Aȉ̃`FbN͕svBAI[fBI
	 * TvAP[X̂ł̃`FbN͕KvB
	 */
	if (size_write_total < size_mono) {
		/* S[hł󂫂Ȃ́A[hȂ */
		#ifdef __PCMD
			debug_write_str("LWai");
			debug_write_data((Uint32)st->CntSample);
			debug_write_data((Uint32)size_write_total);
			debug_write_data((Uint32)st->pcm_bsize);
		#endif
		st->cnt_over_task_call++;
		return;
	}
	if (size_write_total > st->pcm_bsize) {
		st->cnt_load_miss++;
		VTV_PRINTF((VTV_s, "P:LMis %d\n buf%X < writ%X\n", 
			st->cnt_load_miss, st->pcm_bsize, size_write_total));
	}

	/* Rs[e[u̐ݒ */
	pcm_SetBlockCopyTbl(hn, size_copy);

	if (pcm_copy_mode_pcm == PCM_COPY_MODE_PCM_CPU_DMA) {
		/* CPU DMA ] */
		st->pcm_renew_size = size_mono;
		st->buf_renew_size = size_sample;
		st->dma_hold = PCM_ON;
		pcm_flag_dma_use = 1;
		COPY_DMA_PCM(st);
	} else {
		/* CPU vO] */
		
		/* Rs[̎s (CPU vO]) */
		pcm_ExecBlockCopyTbl(hn);

		pcm_RenewPcmWrite(hn, size_2nd);
		pcm_RenewRingRead(hn, size_sample);/* ǂݎʒuXV */
	}

	return;
}
#endif

/*******************************************************************
y@@\z
	Đ^(kq)Rs[e[u̐ݒ
y@z
	hn			()@nh
	size_copy	()@1ch̃oCg
y߂lz
	Ȃ
y@lz
	Oobt@ŘAĂ镪B
	PCMޯ̧݈ʒuXV܂ށB
*******************************************************************/
STATIC void pcm_SetMixCopyTbl(PcmHn hn, Sint32 size_copy)
{
	PcmWork		*work 	= *(PcmWork **)hn;
	PcmStatus	*st 	= &work->status;
	Sint32		size_write, size_write_total;
	Sint32		size_2nd; 			/* 2ڂpcm[hTCY(1ٕ) */
	Sint8 		*addr_write1, *addr_write2;
	Sint8		*addr_sample;

	pcm_GetPcmWrite(hn, &addr_write1, &addr_write2, 
						&size_write, &size_write_total);
	if (size_copy <= size_write) {
		st->copy_idx = 0;
		addr_sample = st->ring_read_addr;
		ENTRY_COPY_TBL(st, 0, addr_write1, addr_write2, 
							addr_sample, size_copy);
		pcm_RenewPcmWrite(hn, size_copy);
		#ifdef __PCMD
			debug_write_str("Tbl0");
			debug_write_data((Uint32)addr_write1);
			debug_write_data((Uint32)addr_sample);
			debug_write_data((Uint32)size_copy);
		#endif
	} else {	/* ܂Ԃ] */
		st->copy_idx = 1;
		addr_sample = st->ring_read_addr;
		ENTRY_COPY_TBL(st, 1, addr_write1, addr_write2, 
							addr_sample, size_write);
		pcm_RenewPcmWrite(hn, size_write);
		#ifdef __PCMD
			debug_write_str("Tbl1");
			debug_write_data((Uint32)addr_write1);
			debug_write_data((Uint32)addr_sample);
			debug_write_data((Uint32)size_write);
		#endif
		/* Qڂ̃[h */
		size_2nd = size_copy - size_write;
		addr_sample = st->ring_read_addr + PCM_1CH2NCH(st, size_write);
		pcm_GetPcmWrite(hn, &addr_write1, &addr_write2, 
							&size_write, &size_write_total);
		ENTRY_COPY_TBL(st, 0, addr_write1, addr_write2, 
							addr_sample, size_2nd);
		pcm_RenewPcmWrite(hn, size_2nd);
		#ifdef __PCMD
			debug_write_str("Tbl2");
			debug_write_data((Uint32)addr_write1);
			debug_write_data((Uint32)addr_sample);
			debug_write_data((Uint32)size_2nd);
		#endif
	}
}

STATIC void pcm_MixCopy16bitStereo(PcmHn hn, PcmCopyTbl *stock)
{
	PcmWork				*work 	= *(PcmWork **)hn;
	PcmPara				*para 	= &work->para;
	PcmStatus			*st 	= &work->status;
	register Sint16 	*dst1, *dst2, *src, *src_end;
	register Sint16 	*ring_end_addr = (Sint16 *)st->ring_end_addr;
	register Sint32 	wsize;

	wsize = stock->size >> 1;
	dst1 = (Sint16 *)stock->dst1;
	dst2 = (Sint16 *)stock->dst2;
	src = (Sint16 *)stock->src;
	src_end = src + 2*wsize;

	if (src_end <= (Sint16 *)para->ring_addr) {
		while (src < src_end) {
			*dst1++ = *src++;
			*dst2++ = *src++;
		}
	} else {
		for (; wsize > 0; wsize--) {
			*dst1++ = *src++;
			if (src >= ring_end_addr) src = (Sint16 *)para->ring_addr;
			*dst2++ = *src++;
			if (src >= ring_end_addr) src = (Sint16 *)para->ring_addr;
		}
	}

	/* ܂ԂmCY΍ */
	PCM_CHECK_NOISE16(stock->dst1, para->pcm_addr, st->pcm_bsize);
	PCM_CHECK_NOISE16(stock->dst1, st->pcm2_addr, st->pcm_bsize);
	PCM_CHECK_NOISE16(stock->dst2, para->pcm_addr, st->pcm_bsize);
	PCM_CHECK_NOISE16(stock->dst2, st->pcm2_addr, st->pcm_bsize);
}

STATIC void pcm_MixCopy8bitStereo(PcmHn hn, PcmCopyTbl *stock)
{
	PcmWork				*work 	= *(PcmWork **)hn;
	PcmPara				*para 	= &work->para;
	PcmStatus			*st 	= &work->status;
	register Sint8 		*dst1, *dst2, *src, *src_end;
	register Sint8 		*ring_end_addr = st->ring_end_addr;
	register Sint32 	size;

	size = stock->size;
	dst1 = stock->dst1;
	dst2 = stock->dst2;
	src = stock->src;
	src_end = src + 2*size;

	if (src_end <= para->ring_addr) {
		while (src < src_end) {
			*dst1++ = *src++;
			*dst2++ = *src++;
		}
	} else {
		for (; size > 0; size--) {
			*dst1++ = *src++;
			if (src >= ring_end_addr) src = para->ring_addr;
			*dst2++ = *src++;
			if (src >= ring_end_addr) src = para->ring_addr;
		}
	}

	/* ܂ԂmCY΍ */
	PCM_CHECK_NOISE8(stock->dst1, para->pcm_addr, st->pcm_bsize);
	PCM_CHECK_NOISE8(stock->dst1, st->pcm2_addr, st->pcm_bsize);
	PCM_CHECK_NOISE8(stock->dst2, para->pcm_addr, st->pcm_bsize);
	PCM_CHECK_NOISE8(stock->dst2, st->pcm2_addr, st->pcm_bsize);
}

STATIC void pcm_MixCopy16bitMono(PcmHn hn, PcmCopyTbl *stock)
{
	PcmWork				*work 	= *(PcmWork **)hn;
	PcmPara				*para 	= &work->para;
	PcmStatus			*st 	= &work->status;
	register Sint16 	*dst1, *src, *src_end;
	register Sint16 	*ring_end_addr = (Sint16 *)st->ring_end_addr;
	register Sint32 	wsize;

	wsize = stock->size >> 1;
	dst1 = (Sint16 *)stock->dst1;
	src = (Sint16 *)stock->src;
	src_end = src + wsize;

	if (src_end <= ring_end_addr) {
		while (src < src_end) {
			*dst1++ = *src++;
		}
	} else {
		src_end = src + wsize - (para->ring_size >> 1);
		while (src < ring_end_addr) {
			*dst1++ = *src++;
		}
		src = (Sint16 *)para->ring_addr;
		while (src < src_end) {
			*dst1++ = *src++;
		}
	}

	/* ܂ԂmCY΍ */
	PCM_CHECK_NOISE16(stock->dst1, para->pcm_addr, st->pcm_bsize);
}

STATIC void pcm_MixCopy8bitMono(PcmHn hn, PcmCopyTbl *stock)
{
	PcmWork				*work 	= *(PcmWork **)hn;
	PcmPara				*para 	= &work->para;
	PcmStatus			*st 	= &work->status;
	register Sint8 		*dst1, *src, *src_end;
	register Sint8 		*ring_end_addr = st->ring_end_addr;
	register Sint32 	size;

	size = stock->size;
	dst1 = stock->dst1;
	src = stock->src;
	src_end = src + size;
	if (src_end <= ring_end_addr) {
		while (src < src_end) {
			*dst1++ = *src++;
		}
	} else {
		src_end = src + size - para->ring_size;
		while (src < ring_end_addr) {
			*dst1++ = *src++;
		}
		src = para->ring_addr;
		while (src < src_end) {
			*dst1++ = *src++;
		}
	}

	/* ܂ԂmCY΍ */
	PCM_CHECK_NOISE8(stock->dst1, para->pcm_addr, st->pcm_bsize);
}

STATIC void pcm_ExecMixCopyTbl(PcmHn hn)
{
	PcmWork		*work 	= *(PcmWork **)hn;
	PcmStatus	*st 	= &work->status;
	
	for (; st->copy_idx >= 0; st->copy_idx--) {
		if (PCM_IS_MONORAL(st)) {
			if (PCM_IS_8BIT_SAMPLING(st)) {
				pcm_MixCopy8bitMono(hn, st->copy_tbl + st->copy_idx);
			} else {
				pcm_MixCopy16bitMono(hn, st->copy_tbl + st->copy_idx);
			}
		} else {
			if (PCM_IS_8BIT_SAMPLING(st)) {
				pcm_MixCopy8bitStereo(hn, st->copy_tbl + st->copy_idx);
			} else {
				pcm_MixCopy16bitStereo(hn, st->copy_tbl + st->copy_idx);
			}
		}
	}
}

/*******************************************************************
y@@\z
	Đ^kq݃I[fBI 
y@z
	hn			()@nh
y߂lz
	1ch̏[byte/1ch]
y@lz
	ŏ݌ɂ̓Oobt@ŘAĂۏ؂͂ȂB
	ɁAwb_TCYTvt[oE_łȂꍇA
@Oobt@܂ԂʒuŃTvt[B

		+-------------------------------------------------------+
		|					Oobt@						|
		+-------------------------------------------------------+
										  ..... L R, L R, L R, L 
		 R, L R, L R, .....							 <-->
													Tvt[
*******************************************************************/
STATIC void pcm_AudioMix(PcmHn hn)
{
	PcmWork		*work 	= *(PcmWork **)hn;
	PcmStatus	*st 	= &work->status;
	Sint32		size_write, size_write_total;
	Sint32		stock_bsize, 		/* Oobt@̑݌ [byte] 	*/
				size_mono, 			/* P`l̍݌ [byte/1ch] 	*/
				size_copy; 			/* Rs[TCY [byte/1ch] 		*/
	Sint8 		*addr_write1, *addr_write2;

#ifdef _PCMD
	Sint32 		copy_idx, i;
#endif

	if (st->ring_write_offset > st->info.file_size) {
		/* Oobt@ɂ EOF ȍ~̃S~Ă */
		stock_bsize = st->info.file_size - st->ring_read_offset;
	} else {
		stock_bsize = st->ring_write_offset - st->ring_read_offset;
	}

	/* P`l̍݌ [byte/1ch] */
	if (PCM_IS_MONORAL(st)) {
		size_mono = stock_bsize;
	} else {
		size_mono = stock_bsize >> 1;
	}
	if (PCM_IS_8BIT_SAMPLING(st)) {
		size_mono &= 0xfffffffe;
		size_mono &= 0xfffffffc;
	} else {
		size_mono &= 0xfffffffc;
	}

	size_mono = MIN(size_mono, 
		PCM_SAMPLE2BSIZE(st, st->info.sample_file - st->sample_write_file));

	/* I[fBIf[^[hł邩`FbN */
	pcm_GetPcmWrite(hn, &addr_write1, &addr_write2, 
						&size_write, &size_write_total);

	if (size_write_total > st->pcm_bsize) {
		st->cnt_load_miss++;
		VTV_PRINTF((VTV_s, "P:LMis %d\n buf%X < writ%X\n", 
			st->cnt_load_miss, st->pcm_bsize, size_write_total));
		VTV_PRINTF((VTV_s, " r%X w%X\n", 
			(st)->ring_read_offset, (st)->ring_write_offset));
	}

	/* Rs[TCY [byte/1ch] */
	size_copy = MIN(size_mono, size_write_total);

	if (size_copy == 0) {
		return;
	}

	/* 94.11.21 ^XN֐dlύX
	 *	ĐԂɊւ炸AP̃^XN֐ŏʂ͍őSTvB
	 *		size_copy = MIN(size_copy, PCM_4KSAMPEL_BYTE(st));
	 * 95.01.25 ^XN֐dlύX
	 *	P̃^XNŏʂ̏̓[U߂łB
	 */
	/* P̃^XNŏʂ̏[byte/1ch]	*/
	size_copy = MIN(size_copy, st->onetask_size);

	/* Rs[e[u̐ݒ */
	pcm_SetMixCopyTbl(hn, size_copy);

#ifdef _PCMD
	copy_idx = st->copy_idx;
#endif

	/* Rs[̎s (ɁACPU vO]) */
	pcm_ExecMixCopyTbl(hn);

#ifdef _PCMD

	#define C24BIT(a)			(0x00ffffff & (Sint32)(a))

	if (size_copy & 0x3ff) {
		_VTV_PRINTF((VTV_s, "P:SizCp%d %X %X\n", 
			copy_idx, size_copy, st->sample_write));
	}
	if (st->sample_write >= 3*64*1024 - 1024 &&
		st->sample_write <  3*64*1024 + 1024) {
		for (i = copy_idx; i >= 0; i--) {
			VTV_PRINTF((VTV_s, "dst %6X %6X\nsrc%8X siz%X\n", 
				C24BIT(st->copy_tbl[i].dst1), C24BIT(st->copy_tbl[i].dst2), 
				st->copy_tbl[i].src, st->copy_tbl[i].size));
		}
	}
#endif

	/* ǂݎʒuXV */
	pcm_RenewRingRead(hn, PCM_1CH2NCH(st, size_copy));

	return;
}


/*******************************************************************
y@@\z
	Đ^PI[fBITv
y@z
	hn			()@nh
y߂lz
	Ȃ
y@lz
	֐|C^ st->audio_process_fp ɐݒ肳ăR[
*******************************************************************/
void pcm_AudioProcess(PcmHn hn)
{
	PcmWork		*work 	= *(PcmWork **)hn;
	PcmStatus	*st 	= &work->status;

	if (PCM_IS_LR_MIX(st)) {
		/* kq݃I[fBI */
		pcm_AudioMix(hn);
	} else if (PCM_IS_LR_BLOCK(st)) {
		/* kqubNI[fBI */
		/* pcm_AudioBlock(hn); */
	}
}

#ifdef FILL_SILENCE

#define PCM_PRE_VALUE16(fill_addr, pre, pcm_addr, pcm_bsize)	\
			((((fill_addr) + 2 * (pre)) < (pcm_addr)) ? 	\
				*(Sint16 *)((fill_addr) + 2 * (pre) + (pcm_bsize))	\
			:	\
				*(Sint16 *)((fill_addr) + 2 * (pre))	\
			)

#define PCM_PRE_VALUE8(fill_addr, pre, pcm_addr, pcm_bsize)	\
			((((fill_addr) + (pre)) < (pcm_addr)) ? 	\
				*((fill_addr) + (pre) + (pcm_bsize))	\
			:	\
				*((fill_addr) + (pre))	\
			)

void pcm_Fill16(Sint8 *pcm_addr, Sint32 pcm_bsize, 
				Sint8 *fill_addr, Sint32 fill_bsize)
{
	Sint32		size_1st, size_2nd;
	Sint32		delta, val, pre1_val, pre2_val;
	Sint16		val_set;
	Sint16		*fill_p, *fill_p_end;
	Sint32		fill_cnt;
	

	size_1st = MIN(fill_bsize, pcm_bsize - (fill_addr - pcm_addr));
	size_2nd = fill_bsize - size_1st;

	memset((void *)fill_addr, 0x00, size_1st);
	memset((void *)pcm_addr, 0x00, size_2nd);

#ifdef PCM_SMOOTH_FILL
	pre1_val = (Sint32)PCM_PRE_VALUE16(fill_addr, -1, pcm_addr, pcm_bsize);
	pre2_val = (Sint32)PCM_PRE_VALUE16(fill_addr, -2, pcm_addr, pcm_bsize);
	delta = pre1_val - pre2_val;
	val = pre1_val;
	fill_p = (Sint16 *)fill_addr;
	fill_p_end = (Sint16 *)(pcm_addr + pcm_bsize);
	for (fill_cnt = 0; fill_cnt < fill_bsize/2; fill_cnt++) {
		if (delta == -1) {
			if (val == 0) {
				break;
			} else if (val > 0) {
				delta = -1;
			} else if (val < 0) {
				delta = 0;
			}
		} else {
			delta >>= 1;
			if (delta == 0) {
				if (val == 0) {
					break;
				} else if (val > 0) {
					delta = -1;
				} else if (val < 0) {
					delta = 1;
				}
			}
		}
		val += delta;
		if (val < SHRT_MIN) {
			val_set = SHRT_MIN;
		} else if (val > SHRT_MAX) {
			val_set = SHRT_MAX;
		} else {
			val_set = (Sint16)val;
		}
		*fill_p++ = val_set;
		if (fill_p == fill_p_end) {
			fill_p = (Sint16 *)pcm_addr;
		}
	}
#endif
}

void pcm_Fill8(Sint8 *pcm_addr, Sint32 pcm_bsize, 
				Sint8 *fill_addr, Sint32 fill_bsize)
{
	Sint32		size_1st, size_2nd;
	Sint32		delta, val, pre1_val, pre2_val;
	Sint8		val_set;
	Sint8		*fill_p, *fill_p_end;
	Sint32		fill_cnt;
	

	size_1st = MIN(fill_bsize, pcm_bsize - (fill_addr - pcm_addr));
	size_2nd = fill_bsize - size_1st;

	memset((void *)fill_addr, 0x00, size_1st);
	memset((void *)pcm_addr, 0x00, size_2nd);

#ifdef PCM_SMOOTH_FILL
	pre1_val = (Sint32)PCM_PRE_VALUE8(fill_addr, -1, pcm_addr, pcm_bsize);
	pre2_val = (Sint32)PCM_PRE_VALUE8(fill_addr, -2, pcm_addr, pcm_bsize);
	delta = pre1_val - pre2_val;
	val = pre1_val;
	fill_p = fill_addr;
	fill_p_end = (pcm_addr + pcm_bsize);
	for (fill_cnt = 0; fill_cnt < fill_bsize; fill_cnt++) {
		if (delta == -1) {
			if (val == 0) {
				break;
			} else if (val > 0) {
				delta = -1;
			} else if (val < 0) {
				delta = 0;
			}
		} else {
			delta >>= 1;
			if (delta == 0) {
				if (val == 0) {
					break;
				} else if (val > 0) {
					delta = -1;
				} else if (val < 0) {
					delta = 1;
				}
			}
		}
		val += delta;
		if (val < SCHAR_MIN) {
			val_set = SCHAR_MIN;
		} else if (val > SCHAR_MAX) {
			val_set = SCHAR_MAX;
		} else {
			val_set = (Sint8)val;
		}
		*fill_p++ = val_set;
		if (fill_p == fill_p_end) {
			fill_p = pcm_addr;
		}
	}
#endif
}

/*******************************************************************
y@@\z
	Đ^PCMobt@ɖݒ肷
y@z
	hn			()@nh
y߂lz
	Ȃ
*******************************************************************/
void pcm_FillSilence(PcmHn hn)
{
	PcmWork		*work 	= *(PcmWork **)hn;
	PcmPara		*para 	= &work->para;
	PcmStatus	*st 	= &work->status;
	Sint32		size_write, size_write_total;
	Sint32		size_2nd, 			/* 2ڂpcm[hTCY(1ٕ) */
				size_mono;			/* ިق̂Pٕ̃TCY */
	Sint8  		*addr_write1, *addr_write2;
	Sint32		sample_silence_trig;
	Sint32 		sample_now;
	Sint32 		fill_silence_full;

	if (st->fill_silence == PCM_ON) {	/* ݒς݂ */
		return;
	}

	/* ̎ԂɑoCg */
	size_mono = PCM_SAMPLE2BSIZE(st, PCM_SILENCE_SAMPLE(st, para));
	size_mono &= 0xFFFFFFFC;

	pcm_GetPcmWrite(hn, &addr_write1, &addr_write2, 
						&size_write, &size_write_total);

	if (size_write_total <= 0) {
		/* ͂łȂB */
		return;
	} else if (size_write_total < size_mono) {
		/* ܂Aʂɑ󂫂ȂB */
		size_mono = size_write_total;
		fill_silence_full = 0;
	} else {
		fill_silence_full = 1;
	}

	if (PCM_IS_ADPCM_SCT(st)) {
		if (st->info.sample_file == -1) {
			/* f[^ŏI肷ꍇA֐ŖݒfB */
			sample_silence_trig = PCM_SILENCE_TRIG_SAMPLE(st, para);
			PCM_MeGetTime(hn, &sample_now);
			if (sample_now + sample_silence_trig < st->sample_write_file) {
				/* PCMobt@̍݌ɂɂ܂]T */
				return;
			}
			if (! PCM_IS_RING_EMPTY(st)) {
				/* Oobt@ɍ݌ɂ̂ŁAIł͂Ȃ */
				return;
			}
			VTV_PRINTF((VTV_s, "P:now%X + trg%X\n > write%X\n", 
				sample_now, sample_silence_trig, st->sample_write_file));
		} else {
			if (st->sample_write_file <= st->info.sample_file) {
				/* ܂f[^ */
				return;
			}
		}
	}

	/* 悵AȂ疳ݒł邼B */
	if (fill_silence_full) {
		if (pcm_hn_next != NULL) {
			/* ݒ肹 */
			/* AĐII */
			pcm_EndProcess(hn);
			return;
		}
		st->fill_silence = PCM_ON;	/* ݒς݃tOĂ */
		VTV_PRINTF((VTV_s, "P:fill_silence ON\n"));
	} else {
		VTV_PRINTF((VTV_s, "P:fill_silence PART\n"));
	}
	st->cnt_fill_silence++;

	VTV_PRINTF((VTV_s, " hn%d cnt%d bsiz%X\n", 
		PCM_MeGetHandleNo(hn), st->cnt_fill_silence, size_mono));

	if (PCM_IS_16BIT_SAMPLING(st)) {
		if (PCM_IS_MONORAL(st)) {
			pcm_Fill16(para->pcm_addr, st->pcm_bsize, addr_write1, size_mono);
		} else {
			pcm_Fill16(para->pcm_addr, st->pcm_bsize, addr_write1, size_mono);
			pcm_Fill16(st->pcm2_addr, st->pcm_bsize, addr_write2, size_mono);
		}
	} else {
		if (PCM_IS_MONORAL(st)) {
			pcm_Fill8(para->pcm_addr, st->pcm_bsize, addr_write1, size_mono);
		} else {
			pcm_Fill8(para->pcm_addr, st->pcm_bsize, addr_write1, size_mono);
			pcm_Fill8(st->pcm2_addr, st->pcm_bsize, addr_write2, size_mono);
		}
	}
	return;
}
#endif
