/******************************************************************************
 *	\tgEFACu
 *
 *	Copyright (c) 1994,1995 SEGA
 *
 * Library	:oblE`coblĐCu
 * Module 	:t@CANZX
 * File		:pcm_gfs.h
 * Date		:1994-10-04
 * Version	:1.00
 * Auther	:Y.T
 *
 ****************************************************************************/
/*-------------------- sCN[ht@Ct --------------------*/
#include <sega_xpt.h>
#include "pcm_gfs.h"
#include "pcm_mem.h"
#include "pcm_lib.h"

/* #define	PCM_DEBUG 1 */

#ifdef PCM_DEBUG
#include "play.h"
#endif

/*------------------------- s}N萔t -------------------------*/
/* P̃^XNœ]őZN^ */
#define		LOAD_SECT_NUM		20

/* ExecOne ̃gC */
#define		RETRY_CNT		10


/*------------------------- s}Nt -------------------------*/
#ifdef PCM_DEBUG
#else
#define 	PL_DEBUG_PRINTNUM(a, b, c)
#define		PL_DEBUG_PRINT(a, b, c)
#define		PL_DEBUG_START_TIME()
#define		PL_DEBUG_PRINT_TIME(str)
#endif

/* fer̃[Jf[^ */
#define	PCMGFS_FILE_PARA(pcm) \
			(PCMLIB_FILEPARA(pcm).data.gfs)

/* Xg[nh */
#define	PCMGFS_HANDLE(pcm) \
			(PCMGFS_FILE_PARA(pcm).gfs)

/* ő]ZN^ */
#define	PCMGFS_LOAD_SECT(pcm) \
			(PCMGFS_FILE_PARA(pcm).load_sect)

/* GFS_NwCdRead R[ TREU */
#define PCMGFS_CALLED_CDREAD(pcm) \
			(PCMGFS_FILE_PARA(pcm).called_cdread)

/* ExecOne sȂ TREU */
#define PCMGFS_EXEC_ONE_STATE(pcm) \
			(PCMGFS_FILE_PARA(pcm).exec_one_state)

/* ExecOne œǂݍރoCg */
#define	PCMGFS_EXEC_LOAD_SIZE(pcm)	\
			(PCMGFS_FILE_PARA(pcm).exec_load_size)

/* ExecOne œǂݍłoCg */
#define	PCMGFS_NOW_LOAD_SIZE(pcm)	\
			(PCMGFS_FILE_PARA(pcm).now_load_size)

/* ǂݍݑZN^ */
#define	PCMGFS_LOAD_TOTAL_SECT(pcm) \
			(PCMGFS_FILE_PARA(pcm).load_total_sect)

/* t@CZN^ */
#define	PCMGFS_FILE_SECT(pcm) \
			(PCMGFS_FILE_PARA(pcm).file_sect)

/* ][h */
#define	PCMGFS_TR_MODE(pcm) \
			(PCMGFS_FILE_PARA(pcm).tr_mode)


/*-------------------------- sf[^^t --------------------------*/
/*-------------------------- s֐錾t --------------------------*/
STATIC void pcmgfs_loadBuf(PcmHn pcm);

/*-------------------------- sϐ`t --------------------------*/

/*-------------------------- s֐`t --------------------------*/
/********************************************************************/
/* nh̍쐬it@CVXej								*/
/* []															*/
/*    para : 쐬p[^											*/
/*    gfs  : t@Cnh										*/
/* [֐l]															*/
/*    nhi쐬łȂꍇ NULL)							*/
/********************************************************************/
PcmHn PCM_CreateGfsHandle(PcmCreatePara *para, GfsHn gfs)
{
	PcmHn   	pcm;
	Sint32		sctsize, nsct, lastsize;

	if (gfs == NULL) {
		PCM_MeSetErrCode(PCM_ERR_ILLEGAL_PARA);
		return NULL;
	}

	/* 쐬p[^̃`FbN */
	PCMLIB_CHK_CREATE_PARA(para);

	pcm =  PCM_GfsCreate(gfs, 
						 (PcmWork *)PCM_PARA_WORK(para), 
						 PCM_PARA_RING_ADDR(para), PCM_PARA_RING_SIZE(para),
						 PCM_PARA_PCM_ADDR(para), PCM_PARA_PCM_SIZE(para));
	if (pcm != NULL) {
		PCMLIB_FACCESS_TYPE(pcm) = PCMLIB_FACCESS_GFS;

		/* s֐̐ݒ */
		PCMLIB_SET_START_FUNC(pcm, PCM_GfsStart);
		PCMLIB_SET_TASK_FUNC(pcm, PCM_GfsTask);
		PCMLIB_SET_PRELOAD_FILE_FUNC(pcm, PCM_GfsPreloadFile);
		PCMLIB_SET_SET_LOAD_NUM_FUNC(pcm, PCM_GfsSetLoadNum);
		PCMLIB_SET_SET_TRMODE_FUNC(pcm, PCM_GfsSetTrMode);

		/* [Jf[^̏ */
		/* t@CTCY̎擾 */
		GFS_GetFileSize(gfs, &sctsize, &nsct, &lastsize);
		PCMGFS_FILE_SECT(pcm) = nsct;
		PCMGFS_CALLED_CDREAD(pcm) = FALSE;
		PCMGFS_EXEC_ONE_STATE(pcm) = FALSE;
		PCMGFS_LOAD_TOTAL_SECT(pcm) = 0;

		/* t@Cnh̐ݒ */
		PCMGFS_HANDLE(pcm) = gfs;

		/* ő]ZN^̐ݒ */
		PCMGFS_LOAD_SECT(pcm) = LOAD_SECT_NUM;
		GFS_SetTransPara(PCMGFS_HANDLE(pcm), PCMGFS_LOAD_SECT(pcm));

		/* ][h̐ݒ */
		PCMGFS_TR_MODE(pcm) = GFS_TMODE_SDMA1;
		GFS_SetTmode(PCMGFS_HANDLE(pcm), PCMGFS_TR_MODE(pcm));

	}
	return pcm;
}

/********************************************************************/
/* nh̏it@CVXej								*/
/* []															*/
/*    pcm  : nh												*/
/********************************************************************/
void PCM_DestroyGfsHandle(PcmHn pcm)
{
	/* nh`FbN */
	PCMLIB_CHK_HANDLE(pcm);

	if (PCMLIB_FACCESS_TYPE(pcm) != PCMLIB_FACCESS_GFS) {
		PCM_MeSetErrCode(PCM_ERR_ILL_CREATE_MODE);
	}

	PCM_MeDestroy(pcm);
}


/********************************************************************/
/* nh̃Zbg												*/
/*																	*/
/* []															*/
/*    pcm : nh												*/
/* [֐l]															*/
/* @Ȃ															*/
/********************************************************************/
void PCM_GfsReset(PcmHn pcm)
{
	GFS_Seek(PCMGFS_HANDLE(pcm), 0, GFS_SEEK_SET);
	PCMGFS_CALLED_CDREAD(pcm) = FALSE;
	PCMGFS_LOAD_TOTAL_SECT(pcm) = 0;
	PCM_MeReset(pcm);
}

/********************************************************************/
/* nh𐶐												*/
/*   t@Cnh́At@CVXeɂ\ߎ擾邱		*/
/*																	*/
/* []															*/
/*    gfs : t@Cnh										*/
/*    work : [NAhX											*/
/*    buf : obt@AhX										*/
/*    bufsize : obt@̃oCg									*/
/*    pcmbuf:obl̃EF[uq`l̐擪AhX					*/
/*    pcmsize:obl̃EF[uq`l̃oCg						*/
/* [֐l]															*/
/*    nh														*/
/*    NULL ̏ꍇ̓G[											*/
/********************************************************************/
PcmHn PCM_GfsCreate(GfsHn gfs, PcmWork *work, 
							   void *buf, Sint32 bufsize, 
							   void *pcmbuf, Sint32 pcmsize)
{
	PcmPara		para;

	/* Oobt@ */
	para.ring_addr = buf;
	para.ring_size = bufsize;

	/* gKTCY */
	para.start_trg_size 	= PCM_DEFAULT_SIZE_START_TRG;
	para.start_trg_sample 	= PCM_DEFAULT_SAMPLE_START_TRG;
	para.stop_trg_sample 	= PCM_DEFAULT_SAMPLE_STOP_TRG;

	/* TEhhCoR}hubNԍ */
	para.command_blk_no = PCMLIB_COMMAND_BLK_NO;

	/* oblXg[Đԍ */
	para.pcm_stream_no = PCMLIB_PCM_STREAM_NO;

	/* oblobt@ */
	para.pcm_addr = pcmbuf;
	para.pcm_size = pcmsize;

	/* o`mƃ{[ */
	para.pcm_pan = PCMLIB_PCM_PAN;
	para.pcm_level = PCMLIB_PCM_LEVEL;

	/* nh̍쐬 */
	return PCM_MeCreate(work, &para);
}


/********************************************************************/
/* bcobt@̍ő]ZN^ݒ肷						*/
/* []															*/
/*    pcm  : nh												*/
/*    load_sct : ő]ZN^									*/
/********************************************************************/
void PCM_GfsSetLoadNum(PcmHn pcm, Sint32 load_sct)
{
	PCMGFS_LOAD_SECT(pcm) = load_sct;

	/* ]ZN^ݒ肷 */
	GFS_SetTransPara(PCMGFS_HANDLE(pcm), PCMGFS_LOAD_SECT(pcm));
}

/********************************************************************/
/* bcobt@ւ̐ǂݗv										*/
/*																	*/
/* []															*/
/*    pcm : nh												*/
/********************************************************************/
static void pcmgfs_NwCdRead(PcmHn pcm)
{
	Sint32	nsct;
	Sint32	ret;

	nsct = PCMGFS_FILE_SECT(pcm) - PCMGFS_LOAD_TOTAL_SECT(pcm);
	if (nsct > 0) {
		ret = GFS_NwCdRead(PCMGFS_HANDLE(pcm), nsct);
		if (ret < 0) {
			PCM_MeSetErrCode(PCM_ERR_GFS_READ);
			return;
		}
    }
}

/********************************************************************/
/* Đ擪Jn											*/
/*																	*/
/* []															*/
/*    pcm : nh												*/
/********************************************************************/
void PCM_GfsStart(PcmHn pcm)
{
	/* bcobt@ւ̐ǂݗv */
	/* pcmgfs_NwCdRead(pcm); */
	/* ŐǂݗvĂAۂɂ͐ǂ݂łAG[B */

	PCM_MeStart(pcm);
}

/********************************************************************/
/* Đ^XN														*/
/*   Đ͒Iɂ̊֐Ă									*/
/*   ĂԊԊu͂oblobt@̔̍ĐԈȉŒIɌĂ		*/
/*   Kvpx菭ȂƍĐ								*/
/*																	*/
/* []															*/
/*    pcm : nh												*/
/*     NULL w肳ꂽ͌݃I[vĂnh   	 */
/*     ׂĂ̍Đ									*/
/********************************************************************/
void PCM_GfsTask(PcmHn pcm)
{
	if (PCMGFS_CALLED_CDREAD(pcm) == FALSE) {

		/* bcobt@ւ̐ǂݗv */
		pcmgfs_NwCdRead(pcm);

		PCMGFS_CALLED_CDREAD(pcm) = TRUE;
	}

	/* bcobt@烊Oobt@փf[^] */
	pcmgfs_loadBuf(pcm);

	/* ^XN */
	PCM_MeTask(pcm);

	/* [vĐ */
	if (PCM_GetPlayStatus(pcm) == PCM_STAT_PLAY_END) {

		VTV_PRINTF((VTV_s, "P:Play %X Loop %X\n", 
			PCM_STAT_PLAY_END, PCM_HN_CNT_LOOP(pcm)));

		VTV_PRINTF((VTV_s, "P:exec_one_state %X\n", 
			PCMGFS_EXEC_ONE_STATE(pcm)));


		if (--PCM_HN_CNT_LOOP(pcm) > 0) {

			PCM_GfsReset(pcm);

			VTV_PRINTF((VTV_s, "P:GfsReset %X\n", pcm));

			PCM_GfsStart(pcm);

			VTV_PRINTF((VTV_s, "P:GfsStart %X\n", pcm));
		}
	}
}


/********************************************************************/
/* bcobt@̃Oobt@Ƀf[^]			*/
/*																	*/
/* []															*/
/*    pcm : nh												*/
/********************************************************************/
STATIC void pcmgfs_loadBuf(PcmHn pcm)
{
	Uint32		write_addr32;
	Sint32		write_size, total_size;
	Sint32		load_sct, load_size;
	Sint32		gfs_ret;
	Sint32		stat, ndata;
	Sint32		delta_size;
#ifdef _PCMD
	Sint32 		fread_this_call = 0;
#endif

	if (PCMGFS_LOAD_TOTAL_SECT(pcm) >= PCMGFS_FILE_SECT(pcm)) {
		/* t@Cׂēǂݍ */
		return;
	}

	if (PCMGFS_EXEC_ONE_STATE(pcm) == FALSE) {
		/* VlpbÑobt@̋󂫃oCg𓾂 */
		PCM_MeGetRingWrite(pcm, 
			(Sint8 **)&write_addr32, &write_size, &total_size);

		if (write_size >= PCMLIB_SECT_SIZE) {
			/* bcobt@VlpbÑobt@ւ̓]Jn */
			if (write_size >= PCMGFS_LOAD_SECT(pcm) * PCMLIB_SECT_SIZE) {
				load_size = PCMGFS_LOAD_SECT(pcm) * PCMLIB_SECT_SIZE;
			} else {
				load_size = write_size;
			}
			load_sct = load_size / PCMLIB_SECT_SIZE;
			load_size = load_sct * PCMLIB_SECT_SIZE;

			_VTV_PRINTF((VTV_s, "P:NwFread %X\n", load_sct));

			gfs_ret = GFS_NwFread(PCMGFS_HANDLE(pcm), load_sct, 
											(void *)write_addr32, load_size);
			if (gfs_ret < 0) { 
				PCM_MeSetErrCode(PCM_ERR_GFS_READ);
				return;
			}

			PCMGFS_EXEC_LOAD_SIZE(pcm) = load_size;
			PCMGFS_EXEC_ONE_STATE(pcm) = TRUE;
			PCMGFS_NOW_LOAD_SIZE(pcm) = 0;

#ifdef _PCMD
			fread_this_call = 1;
#endif
		}
	}

	if (PCMGFS_EXEC_ONE_STATE(pcm) == TRUE) {

		_VTV_PRINTF((VTV_s, "P:Call NwExecOne\n"));

		/* bcobt@VlpbNւ̃obt@] */
		gfs_ret = GFS_NwExecOne(PCMGFS_HANDLE(pcm));
		if (gfs_ret < 0) {
			PCM_MeSetErrCode(PCM_ERR_GFS_READ);
			return;
		}

		_VTV_PRINTF((VTV_s, "P:Retn NwExecOne %d\n", gfs_ret));

		/* zXg̈ɓ]oCg𓾂 */
		GFS_NwGetStat(PCMGFS_HANDLE(pcm), &stat, &ndata);
		if (ndata > 0) {
			delta_size = ndata - PCMGFS_NOW_LOAD_SIZE(pcm);
			PCMGFS_NOW_LOAD_SIZE(pcm) = ndata;
			if (delta_size > 0) {
				PCM_MeRenewRingWrite(pcm, delta_size);
			}
		}

		if (ndata >= PCMGFS_EXEC_LOAD_SIZE(pcm) ||
							 (gfs_ret == GFS_SVR_COMPLETED)) {
			/* zXg̈ւ̓]I */
			PCMGFS_EXEC_ONE_STATE(pcm) = FALSE;
		}
#ifdef _PCMD
		else {
			Sint32 snum;
			CDC_GetSctNum(0, &snum);/* obt@O̾𓾂 */
			if (fread_this_call == 0) {	/* łȂȑO̺ق fread  */
				if (PCMGFS_EXEC_LOAD_SIZE(pcm) / 2048 < snum) {
					/* bcobt@Ƀf[^̂ɓ]łȂ */
					VTV_PRINTF((VTV_s, "C:Yet? %2X<%2X %X\n",
						ndata / 2048, PCMGFS_EXEC_LOAD_SIZE(pcm) / 2048, 
						snum));
				}
			}
		}
#endif

	}
}


/********************************************************************/
/* bc烊Oobt@Ƀt@Cǂݍ						*/
/*																	*/
/* []															*/
/*    pcm : nh												*/
/*    size : ǂݍރoCg										*/
/*           Oobt@ǂݍ݃oCg菬	*/
/*           obt@TCYɂȂB									*/
/*           ǂݍރoCg̓ZN^PʁiQOSW̔{jɂȂB	*/
/* [֐l]															*/
/*    ۂɓǂݍ񂾃oCg										*/
/********************************************************************/
Sint32 PCM_GfsPreloadFile(PcmHn pcm, Sint32 size)
{
	Uint32		write_addr32;
	Sint32		write_size, total_size;
	Sint32		load_sct, load_size;

	load_size = 0;
	/* Oobt@̋󂫃oCg𓾂 */
	PCM_MeGetRingWrite(pcm, (Sint8 **)&write_addr32, &write_size, &total_size);
	if (write_size >= PCMLIB_SECT_SIZE) {
		/* bcobt@烊Oobt@ւ̓]Jn */
		if (size > write_size) {
			load_size = write_size;
		} else {
			load_size = size;
		}
		load_sct = load_size / PCMLIB_SECT_SIZE;
		load_size = load_sct * PCMLIB_SECT_SIZE;
		if (load_sct > 0) {
			GFS_SetTransPara(PCMGFS_HANDLE(pcm), load_sct);
			load_size = GFS_Fread(PCMGFS_HANDLE(pcm), load_sct, 
										(void *)write_addr32, load_size);
			if (load_size < 0) { 
				PCM_MeSetErrCode(PCM_ERR_GFS_READ);
				return load_size;
			}
			PCM_MeRenewRingWrite(pcm, load_size);
			PCMGFS_LOAD_TOTAL_SECT(pcm) += load_sct;
		}
	}
	return load_size;
}

/********************************************************************/
/* f[^̓]̐ݒ											*/
/* []															*/
/*    pcm   : [rnh										*/
/*    mode  : ]												*/
/*      PCM_TRMODE_CPU : \tgEFA]							*/
/*      PCM_TRMODE_SDMA : cl`TCNX`[					*/
/*      PCM_TRMODE_SCU  : rbt̂cl`							*/
/********************************************************************/
void PCM_GfsSetTrMode(PcmHn pcm, PcmTrMode mode)
{
	Sint32	tmode;

	switch(mode) {
	case PCM_TRMODE_CPU:
	default:
		tmode = GFS_TMODE_CPU;
		break;
	case PCM_TRMODE_SDMA:
		tmode = GFS_TMODE_SDMA1;
		break;
	case PCM_TRMODE_SCU:
		tmode = GFS_TMODE_SCU;
		break;
	}

	/* ][h̐ݒ */
	PCMGFS_TR_MODE(pcm) = tmode;
	GFS_SetTmode(PCMGFS_HANDLE(pcm), PCMGFS_TR_MODE(pcm));
}

