/******************************************************************************
 *	\tgEFACu
 *
 *	Copyright (c) 1994,1995 SEGA
 *
 * Library	:oblE`coblĐCu
 * Module 	:Đ
 * File		:pcm_mp.c
 * Date		:1994-10-04
 * Version	:1.00
 * Auther	:Y.T
 *
 ****************************************************************************/
#include <machine.h>
#include <string.h>
#include <sega_sys.h>
#include <sega_dma.h>
#include "pcm_msub.h"
#include "pcm_time.h"
#include "pcm_drv.h"
#include "pcm_aif.h"


/*------------------------- s}N萔t -------------------------*/

/* VXeԒl */
#define PCM_SYSTEM_STATUS_ON		(0x12345678)
#define PCM_SYSTEM_STATUS_OFF		(-1)


/*----------------------- sO[oϐt -----------------------*/

/* o[W */
Sint8 pcm_version[PCM_VERSION_LEN];

/* VXeŜ̏ */
Sint32 pcm_system_status;

/* nhǗϐ */
STATIC PcmHn pcm_hn_tbl[PCM_HN_MAX];		/* nhe[u		*/
STATIC Uint32 pcm_hn_mask;

/* Vlb-In 荞݃JE^ */
Sint32 pcm_cnt_vbl_in;

/* ɍĐ郀[r[ */
STATIC PcmHn pcm_hn_next;

/* oblf[^][h */
/* static PcmCopyModePcm pcm_copy_mode_pcm; */

/* DMAgptO */
static Uint32 pcm_flag_dma_use;

/* |[Yp[NAhXATCY */
static Sint32 *pcm_pwork_addr;
static Sint32 pcm_pwork_size;

/* G[Ǘϐ */
STATIC PcmErrCode pcm_err_code;			/* G[R[h 		*/
STATIC PcmErrFunc pcm_err_func;			/* G[֐ 			*/
STATIC void *pcm_err_obj;				/* G[֐object 	*/

/* vg^Cv */
void pcm_SetInfoAdpcmUnlink(PcmHn hn);

/*--------------------- sO[o֐|C^t --------------------*/

/* PCM_SetInfo ADPCMΉ^Ή */
void (*pcm_set_info_adpcm_fp)(PcmHn hn);

/*******************************************************************
y@@\z
	Đ^G[Ǘϐ̏
y@z
	Ȃ
y߂lz
	Ȃ
*******************************************************************/
static void pcm_InitErr(void)
{
	pcm_err_code = PCM_ERR_OK;
	pcm_err_func = NULL;
	pcm_err_obj = NULL;
}

/*******************************************************************
y@@\z													J֐
	Đ^G[R[h̐ݒBG[֐̃R[B
y@z
	err		() G[R[hB
y߂lz
	Ȃ
*******************************************************************/
void PCM_MeSetErrCode(PcmErrCode err)
{
	_VTV_PRINTF((VTV_s, "P:pcm_err_code %X\n", err));

	pcm_err_code = err;
	if (pcm_err_func != NULL) {
		pcm_err_func(pcm_err_obj, err);
	}
}

/*******************************************************************
y@@\z													J֐
	Đ^G[R[h̎擾
y@z
	Ȃ
y߂lz
	Ȃ
*******************************************************************/
PcmErrCode PCM_MeGetErrCode(void)
{
	return pcm_err_code;
}

/*******************************************************************
y@@\z													J֐
	Đ^G[֐AG[֐IuWFNg̐ݒ
y@z
	func	() G[֐|C^BG[ɃR[B
	obj		() G[֐IuWFNgBɂăG[֐
					R[B
y߂lz
	Ȃ
*******************************************************************/
void PCM_MeSetErrFunc(PcmErrFunc func, void *obj)
{
	pcm_err_func = func;
	pcm_err_obj = obj;
}

void pcm_InitPcm(void)
{
	return;
}

/*******************************************************************
y@@\z													J֐
	Đ^P̃^XNŏʂ̏̐ݒ 
y@z
	hn			()@nh
	sample		()  1ch̃Tv[sample/1ch]
y߂lz
	Ȃ
*******************************************************************/
void PCM_MeSet1TaskSample(PcmHn hn, Sint32 sample)
{
	PcmWork		*work 	= *(PcmWork **)hn;
	PcmStatus	*st 	= &work->status;

	st->onetask_sample = sample;

	/* P̃^XNŏʂ̏[byte/1ch]	*/
	st->onetask_size = PCM_SAMPLE2BSIZE(st, st->onetask_sample);

	/* P̃^XNŏʂ̏[sg/1ch]	*/
	st->onetask_sg = PCM_SAMPLE2SG(st->onetask_sample);
}

/*******************************************************************
y@@\z													J֐
	Đ^ĐJngKTCY̐ݒ
y@z
	hn			()@nh
	size		()  Oobt@ւ̋[byte]
y߂lz
	Ȃ
*******************************************************************/
void PCM_MeSetStartTrgSize(PcmHn hn, Sint32 size)
{
	PCM_HN_START_TRG_SIZE(hn) = size;
}

/*******************************************************************
y@@\z													J֐
	Đ^ĐJngKTv̐ݒ
y@z
	hn			()@nh
	sample		()  oblobt@ւ̋[sample/1ch]
y߂lz
	Ȃ
*******************************************************************/
void PCM_MeSetStartTrgSample(PcmHn hn, Sint32 sample)
{
	PCM_HN_START_TRG_SAMPLE(hn) = sample;
}

/*******************************************************************
y@@\z													J֐
	Đ^Đ~gKTv̐ݒ
y@z
	hn			()@nh
	sample		()  Đ~gKTv[sample/1ch]
y߂lz
	Ȃ
*******************************************************************/
void PCM_MeSetStopTrgSample(PcmHn hn, Sint32 sample)
{
	PCM_HN_STOP_TRG_SAMPLE(hn) = sample;
}


/*******************************************************************
y@@\z													J֐
	Đ^|[Yp[NAhXATCY̐ݒ
y@z
	addr 		()@|[Yp[NAhX
	size 		()@|[Yp[NTCY[byte]
y߂lz
	Ȃ
y@lz
	TCÝASTvxł悢B
	|[Y@\gpꍇɎw肷B
	|[YN钼OɃX^bNtĂǂB
*******************************************************************/
void PCM_MeSetPauseWork(Sint32 *addr, Sint32 size)
{
	pcm_pwork_addr = (Sint32 *)(((Uint32)addr + 3) & 0xfffffffc);
	if (pcm_pwork_addr == addr) {
		pcm_pwork_size = size & 0xfffffffc;
	} else {
		pcm_pwork_size = (size - 4) & 0xfffffffc;
	}

	if ((pcm_pwork_addr == NULL) || (pcm_pwork_size == 0)) {
		PCM_MeSetErrCode(PCM_ERR_PAUSE_WORK_SET);
	}
}

/*******************************************************************
y@@\z													J֐
	Đ^f[^̓]̐ݒiOobt@oblobt@j
y@z
	hn			()@nh
	mode		() 	f[^̓]
y߂lz
	Ȃ
y@Ӂz
	NGCgA^XNR[OɎw肷邱ƁB
*******************************************************************/
#if 0
void PCM_MeSetTrModePcm(PcmHn hn, PcmTrMode mode)
{
	PcmWork		*work 	= *(PcmWork **)hn;
	PcmStatus	*st 	= &work->status;

	if (mode == PCM_TRMODE_SCU) {
		PCM_MeSetErrCode(PCM_ERR_DMA_MODE);
	}
	st->copy_mode_pcm = mode;
}
#endif

/*******************************************************************
y@@\z													J֐
	Đ^VXeŜ̏
y@z
	Ȃ
y߂lz
	Ȃ
*******************************************************************/
void PCM_MeInit(void)
{
	Sint32 i;

	pcm_hn_mask = 0;
	pcm_cnt_vbl_in = 0;
	pcm_hn_next = NULL;
/*	pcm_copy_mode_pcm = PCM_COPY_MODE_PCM_CPU_DMA; CPU DMAPCMް߰ */
	pcm_flag_dma_use = 0;
	pcm_pwork_addr = NULL;
	pcm_pwork_size = 0;
	pcm_InitClock();
	pcm_InitPcm();
	pcm_InitErr();
	strncpy(pcm_version, PCM_VERSION, PCM_VERSION_LEN);
	for (i = 0; i < PCM_HN_MAX; i++) {
		pcm_hn_tbl[i] = (PcmHn)((i << 24) | (i << 16) | (i << 8) | i);
	}
	pcm_system_status = PCM_SYSTEM_STATUS_ON;


	/* ADPCM֘Å֐|C^̓o^ (ftHgADPCMΉ) */

	/* `obl`N (ADPCMΉ) */
	pcm_chunk_adpcm_fp = pcm_ChunkAdpcmUnlink;

	/* PCM_SetInfo ADPCMΉ */
	pcm_set_info_adpcm_fp = pcm_SetInfoAdpcmUnlink;

	return;
}

/*******************************************************************
y@@\z													J֐
	Đ^VXeŜ̏I
y@z
	Ȃ
y߂lz
	Ȃ
yT  vz
	VXe̋xɁAspӂ PCM_MeSndRequest Ȃǂ̊荞݊֐A
@^XN֐R[Ă邱ƂȂ悤ɁASẴnh
@ɏIB
*******************************************************************/
void PCM_MeFinish(void)
{
	PcmHn 		hn;
	Uint32		i;

	for (i = 0; i < PCM_HN_MAX; i++) {
		if (pcm_hn_mask & pcm_bit_msk[i]) {
			hn = pcm_hn_tbl + i;
			PCM_MeDestroy(hn);
		}
	}
	pcm_hn_mask = 0;
	pcm_system_status = PCM_SYSTEM_STATUS_OFF;
	return;
}

/*******************************************************************
y@@\z													J֐
	Đ^uhW[i[UɃR[Ă炤j
y@z
	Ȃ
y߂lz
	Ȃ
*******************************************************************/
void PCM_MeVblIn(void)
{
	int			imask;

    imask = get_imask();
    set_imask(15);

	if (pcm_system_status == PCM_SYSTEM_STATUS_ON) {

		pcm_cnt_vbl_in++;

		pcm_GetCount();	/* pɂɃR[ȂƐɓ삵Ȃ̂ */

		PCM_DrvPolling();	/* STvXV|[OŋN */

	}
    set_imask(imask);
}

/*******************************************************************
y@@\z													J֐
	Đ^nh̃Zbg
y@z
	work, 		() [NAhX
	work_size, 	() [NTCY
	para		() Np[^
y߂lz
	@F@nhl
	s@F@NULL
*******************************************************************/
void PCM_MeReset(PcmHn hn)
{
	PcmWork		*work 	= *(PcmWork **)hn;
	PcmPara		*para 	= &work->para;
	PcmStatus	*st 	= &work->status;

	st->play = PCM_STAT_PLAY_CREATE;		/* 						*/

	/* Oobt@ */
	st->ring_write_offset = 0;				/* obt@݈ʒu[byte] 	*/
	st->ring_read_offset = 0;				/* obt@ǂݎʒu[byte] 	*/
	st->ring_write_addr = para->ring_addr;	/* obt@݈ʒu[byte] 	*/
	st->ring_read_addr = para->ring_addr;	/* obt@ǂݎʒu[byte] 	*/

	/* PCMĐ */
	st->pcm_write_offset = 0;
	st->cnt_4ksample = 0;
	st->fill_silence = PCM_OFF;
	st->cnt_fill_silence = 0;
	st->sample_write_file = 0;		/* t@C̋Tv[sample]	*/
	st->sample_write = 0;			/* Tv[sample]				*/
	st->sample_film_start = 0;		/* tBJnTv[sample]		*/
	st->sample_pause = 0;			/* |[YTv[sample]			*/
	st->cnt_sg = 0;					/* TEhO[vJE^ 			*/
}

/* KCh̐ݒ */
void pcm_SetGuide(PcmHn hn)
{
	PcmWork		*work 	= *(PcmWork **)hn;
	PcmStatus	*st 	= &work->status;

	work->work_start 	= PCM_4BYTE_CHAR('W','O','R','K');
	st->stat_start 		= PCM_4BYTE_CHAR('S','T','A','T');
	st->info_start 		= PCM_4BYTE_CHAR('I','N','F','O');
	st->ring_start 		= PCM_4BYTE_CHAR('R','I','N','G');
	st->pcm_start 		= PCM_4BYTE_CHAR('P','C','M',' ');
	st->sddrv_start 	= PCM_4BYTE_CHAR('S','D','R','V');
	st->copy_start 		= PCM_4BYTE_CHAR('C','O','P','Y');
	st->vbl_start 		= PCM_4BYTE_CHAR('V','B','L',' ');
	st->err_start 		= PCM_4BYTE_CHAR('E','R','R',' ');
}

/*******************************************************************
y@@\z													J֐
	Đ^nh쐬
y@z
	work, 		() [NAhX
	work_size, 	() [NTCY
	para		() Np[^
y߂lz
	@F@nhl
	s@F@NULL
*******************************************************************/
PcmHn PCM_MeCreate(PcmWork *work, PcmPara *para)
{
	PcmHn		hn;
	PcmStatus	*st = &work->status;
	Uint32		i;
	Uint32 		pcm_block;

	/* VXeԃ`FbN */
	PCM_CHK_SYSTEM_STATUS_RET(NULL);

	for (i = 0; i < PCM_HN_MAX; i++) {
		if ((pcm_hn_mask & pcm_bit_msk[i]) == 0) break;
	}
	if (i == PCM_HN_MAX) {
		PCM_MeSetErrCode(PCM_ERR_OUT_OF_HANDLE);
		return NULL;
	}

	/* oblobt@TCY S̔{ */
	if (para->pcm_size & 0x00000fff) {
		PCM_MeSetErrCode(PCM_ERR_ILL_SIZE_PCMBUF);
		return NULL;
	}
	/* oblobt@TCY 4096*2 ` 4096*16 */
	pcm_block = para->pcm_size >> 12;
	if (pcm_block < 2) {
		PCM_MeSetErrCode(PCM_ERR_TOO_SMALL_PCMBUF);
		return NULL;
	}
	if (pcm_block > 16) {
		PCM_MeSetErrCode(PCM_ERR_ILL_SIZE_PCMBUF);
		return NULL;
	}

	pcm_hn_mask |= pcm_bit_msk[i];
	hn = pcm_hn_tbl + i;
	*(PcmWork **)hn = work;

	/* Ɨ̈̃NA */
	memset((void *)work, 0, sizeof(PcmWork));

	/* nh쐬p[^̂܂ܕێ */
	work->para = *para;

	/* KCh̐ݒ */
	pcm_SetGuide(hn);

	/************************************/
	/* ̑̍Ɨ̈̏ 		*/
	/************************************/

	st->play = PCM_STAT_PLAY_CREATE;		/* 						*/
	st->ignore_header = PCM_OFF;
	st->need_ci = PCM_OFF;
	st->cnt_loop = 1;

	st->info.file_type = PCM_FILE_TYPE_AIFF;
	st->info.data_type = PCM_DATA_TYPE_LRLRLR;

	/* Oobt@ */
	st->ring_write_offset = 0;				/* obt@݈ʒu[byte] 	*/
	st->ring_read_offset = 0;				/* obt@ǂݎʒu[byte] 	*/
	st->ring_write_addr = para->ring_addr;	/* obt@݈ʒu[byte] 	*/
	st->ring_read_addr = para->ring_addr;	/* obt@ǂݎʒu[byte] 	*/
	st->ring_end_addr = para->ring_addr + para->ring_size;

	/* PCMĐ */
	st->pcm_write_offset = 0;
	st->cnt_4ksample = 0;
	st->fill_silence = PCM_OFF;
	st->cnt_fill_silence = 0;
	st->sample_write_file = 0;		/* t@C̋Tv[sample]	*/
	st->sample_write = 0;			/* Tv[sample]				*/
	st->sample_film_start = 0;		/* tBJnTv[sample]		*/
	st->sample_pause = 0;			/* |[YTv[sample]			*/
	st->cnt_sg = 0;					/* TEhO[vJE^ 			*/

	st->cnt_load_miss = 0;			/* PCM[h~XJE^ 				*/
	st->cnt_task_call = 0;			/* ^XNR[JE^ 				*/
	st->cnt_over_task_call = 0;		/* ߏ^XNR[JE^ 			*/
	st->cnt_buf_empty = 0;			/* obt@^XNJE^ 			*/
	st->max_late_time = 0;			/* őxꎞ 						*/

	/* I[fBI֐|C^̐ݒ */
	st->audio_process_fp = pcm_AudioProcess;

	/* P̃^XNŏʂ̏̐ݒ */
	PCM_MeSet1TaskSample(hn, PCM_DEFAULT_SAMPLE_1TASK);

	return hn;
}

Bool PCM_MeIsCreate(PcmHn pcm)
{
	Uint32		i;

	i = (Uint32)(((Sint32)pcm - (Sint32)pcm_hn_tbl) >> 2);

#if	0
	/*
	**1995-07-27	q
	**	i  unsigned Ȃ̂ŁA 0 ȏ
	*/
	if ((i >= 0) && (i < PCM_HN_MAX)) {
#else
	if( i < PCM_HN_MAX ){
#endif
		if (pcm_hn_mask & pcm_bit_msk[i]) {
			/* ̃nh́ANGCgĂB */
			return TRUE;
		} 
	}
	/* ̃nh́ANGCgĂȂB */
	return FALSE;
}

/*******************************************************************
y@@\z													J֐
	Đ^nh̏
y@z
	hn@	íj@nh
y߂lz
	Ȃ
*******************************************************************/
void PCM_MeDestroy(PcmHn hn)
{
	Uint32	i = (Uint32)(((Sint32)hn - (Sint32)pcm_hn_tbl) >> 2);

	/* VXeԃ`FbN */
	PCM_CHK_SYSTEM_STATUS;

	if ((pcm_hn_mask & pcm_bit_msk[i]) == 0) {
		PCM_MeSetErrCode(PCM_ERR_INVALID_HN);
		return;
	}
	PCM_MeStop(hn);
	pcm_hn_mask &= ~pcm_bit_msk[i];
	if (pcm_hn_mask == 0) {
		/* NGCgꂽ[r[ɃJE^ZbgB */
		pcm_cnt_vbl_in = 0;
	}
	return;
}

/*******************************************************************
y@@\z
	Đ^PCM_SetInfo ADPCMΉ
y@z
	hn@	íj@nh
y߂lz
	Ȃ
y@lz
	֐|C^ pcm_set_info_adpcm_fp ɐݒ肳ăR[
*******************************************************************/
void pcm_SetInfoAdpcmUnlink(PcmHn hn)
{
	/* ADPCMgp錾Ȃ̂APCM`t@CłȂ */
	PCM_MeSetErrCode(PCM_ERR_NOT_DECLARE_ADPCM);
}

/*******************************************************************
y@@\z													J֐
	Đ^Đ̐ݒ
y@z
	hn			()@nh
	info 		()@Đ
y߂lz
	Ȃ
y@lz
	wb_Ȃt@CĐꍇA܂́Awb_̏ɂ炸
@̎wɂĐꍇɎgpB
	nh쐬AX^[gGglNXgOɃR[B
*******************************************************************/
void PCM_MeSetInfo(PcmHn hn, PcmInfo *info)
{
	PcmWork		*work 	= *(PcmWork **)hn;
	PcmPara		*para 	= &work->para;
	PcmStatus	*st 	= &work->status;
#if	0
	/*
	**1995-07-27	q
	**	gĂȂ̂ō폜
	*/
	PcmFilePara *filepara = &work->filepara;
#endif

	/* wb_͖̏ */
	st->ignore_header = PCM_ON;

	/* Đ */
	st->info = *info;

	if (PCM_IS_ADPCM_SCT(st)) {
		(*pcm_set_info_adpcm_fp)(hn);
	}
	st->pcm_bsize = PCM_SAMPLE2BSIZE(st, para->pcm_size);
	st->pcm2_addr = para->pcm_addr + st->pcm_bsize;
}


Sint32 PCM_MeGetRingSize(PcmHn hn)
{
	PcmWork		*work = *(PcmWork **)hn;
	PcmPara		*para 	= &work->para;

	return para->ring_size;
}

/*******************************************************************
y@@\z													J֐
	Đ^
	Oobt@ւ̏݃AhXA݉\TCY̎擾
	@ÄƂď߂TCY𓾂BOobt@̐擪֖߂
	ꍇ́AꂼɕʂɁA擾AݎsA񍐂sB
	@PCM_MeRenewRingWrite QƁB
y@z
	hn@			()@nh
	ring_write_addr (o) 	݃AhX
							݉\TCY[̏ꍇ́AOݒ肷B
	write_size	 	(o) 	A݉\TCY [byte]
							ꂪAOobt@I܂ł̃TCYłꍇ
							́AɌ㑱̃f[^߂B
	total_write_size (o) ݉\g[^TCY [byte]
							t@Č̂߂̏B
y߂lz
	Ȃ
*******************************************************************/
void PCM_MeGetRingWrite(PcmHn hn, Sint8 **ring_write_addr, Sint32 *write_size, Sint32 *total_write_size)
{
	PcmWork		*work = *(PcmWork **)hn;
	PcmPara		*para 	= &work->para;
	PcmStatus	*st = &work->status;

	/* ݉\g[^TCY */
	*total_write_size = para->ring_size + st->ring_read_offset 
						- st->ring_write_offset;
	
	/* A݉\TCY */
	if (*total_write_size <= 0) {
		*write_size = 0;
		*ring_write_addr = NULL;
	} else {
		if (st->ring_write_addr >= st->ring_read_addr) {
			*write_size = st->ring_end_addr - st->ring_write_addr;
		} else {
			*write_size = *total_write_size;
		}
		*ring_write_addr = st->ring_write_addr;
	}
	return;
}

/*******************************************************************
y@@\z													J֐
	Đ^
	Oobt@ւ̏݃TCY̕(݈ʒuXV)
	[Uf[^ʂCuɒm点B
y@z
	hn@		()@nh
	write_size 	()  ݃TCY [byte]
y߂lz
	Ȃ
*******************************************************************/
void PCM_MeRenewRingWrite(PcmHn hn, Sint32 write_size)
{
	PcmWork		*work 	= *(PcmWork **)hn;
	PcmPara		*para 	= &work->para;
	PcmStatus	*st 	= &work->status;

	if (write_size <= 0) {
		return;
	}

/*	if (st->play == PCM_STAT_PLAY_END) {
		PCM_MeSetErrCode(PCM_ERR_RING_SUPPLY);
	}
*/

	st->ring_write_offset += write_size;
	st->ring_write_addr += write_size;

	if (st->ring_write_addr >= st->ring_end_addr) {
		st->ring_write_addr -= para->ring_size;
	}
	return;
}

/* ǂݎʒuXV */
void pcm_RenewRingRead(PcmHn hn, Sint32 read_size)
{
	PcmWork		*work = *(PcmWork **)hn;
	PcmPara		*para 	= &work->para;
	PcmStatus	*st = &work->status;

	st->ring_read_offset += read_size;
	st->ring_read_addr += read_size;
	if (st->ring_read_addr >= st->ring_end_addr) {
		st->ring_read_addr -= para->ring_size;
	}

	return;
}

/* ǂݎʒuXV(ׂۗꍇ́AXVۗɂ) */
void pcm_RenewRingRead2(PcmHn hn, Sint32 size_sample)
{
	PcmWork		*work = *(PcmWork **)hn;
	PcmStatus	*st = &work->status;

	if (st->dma_hold == PCM_OFF) {
		/* ǂݎʒuXV */
		pcm_RenewRingRead(hn, size_sample);
	} else {
		/* XVۗ */
		st->buf_renew_size += size_sample;
	}
	return;
}


/*******************************************************************
y@@\z													J֐
	Đ^\̃|C^擾 : Np[^
y@z
	hn@		()@nh
y߂lz
	Np[^\̃|C^
*******************************************************************/
PcmPara *PCM_MeGetPara(PcmHn hn)
{
	PcmWork 	*work = *(PcmWork **)hn;

	return &work->para;
}

/*******************************************************************
y@@\z													J֐
	Đ^\̃|C^擾 : Xe[^X
y@z
	hn@		()@nh
y߂lz
	Xe[^X\̃|C^
*******************************************************************/
PcmStatus *PCM_MeGetStatus(PcmHn hn)
{
	PcmWork 	*work = *(PcmWork **)hn;

	return &work->status;
}

/*******************************************************************
y@@\z													J֐
	Đ^ĐJn
y@z
	hn			()@nh
y߂lz
	Ȃ
*******************************************************************/
void PCM_MeStart(PcmHn hn)
{
	PcmWork		*work = *(PcmWork **)hn;
	PcmStatus	*st = &work->status;

	st->play = PCM_STAT_PLAY_START;
	return;
}

/*******************************************************************
y@@\z													J֐
	Đ^Đ~
y@z
	hn			()@nh
y߂lz
	Ȃ
*******************************************************************/
void PCM_MeStop(PcmHn hn)
{
	PcmWork		*work = *(PcmWork **)hn;
	PcmStatus	*st = &work->status;

	if (st->play == PCM_STAT_PLAY_TIME) {
		PCM_DrvStopPcm(hn); 	/* PCMĐ~ */
	}
	st->play = PCM_STAT_PLAY_END;
	st->cnt_loop = 0;	/* ~ */
	return;
}

/*******************************************************************
y@@\z
	Đ^ꎞ~
y@z
	hn			()@nh
y߂lz
	Ȃ
*******************************************************************/
STATIC void pcm_PauseOn(PcmHn hn)
{
	PcmWork		*work 	= *(PcmWork **)hn;
	PcmPara		*para 	= &work->para;
	PcmStatus	*st 	= &work->status;
#if	0
	/*
	**1995-07-27	q
	**	gĂȂ̂ō폜
	*/
	Sint32		write_to_pause, offset_rotate, size_flop;
#else
	Sint32		write_to_pause, offset_rotate;
#endif

	if (pcm_pwork_addr == NULL) {
		PCM_MeSetErrCode(PCM_ERR_PAUSE_WORK_NULL);
		return;
	}
	if (pcm_pwork_size == 0) {
		PCM_MeSetErrCode(PCM_ERR_PAUSE_WORK_SIZE);
		return;
	}

	st->vbl_pause = pcm_cnt_vbl_in;

	PCM_DrvStopPcm(hn); 	/* PCMĐ~ */

	/* |[YTv[sample]̍XV 				*/
	/* oblX^[g猻݂܂ł̌oߎԂZ 	*/
	st->sample_pause += pcm_GetTimePcm(hn);

	/* ݈ʒu|[Yʒu܂ł̖߂[sample] */
	write_to_pause = st->sample_write - st->sample_pause;

	/* ][byte]߂ */
	offset_rotate = st->pcm_write_offset 
					- PCM_SAMPLE2BSIZE(st, write_to_pause);
	offset_rotate += 256 * st->pcm_bsize;
	offset_rotate %= st->pcm_bsize;

	/* ] */
	if (PCM_IS_MONORAL(st)) {
		pcm_RotatePcmbuf((Uint32)pcm_pwork_addr, pcm_pwork_size, 
						(Uint32)para->pcm_addr, 
						st->pcm_bsize, offset_rotate);
	} else {
		pcm_RotatePcmbuf((Uint32)pcm_pwork_addr, pcm_pwork_size, 
						(Uint32)para->pcm_addr, 
						st->pcm_bsize, offset_rotate);
		pcm_RotatePcmbuf((Uint32)pcm_pwork_addr, pcm_pwork_size, 
						(Uint32)st->pcm2_addr, 
						st->pcm_bsize, offset_rotate);
	}

	/* ]A݈ʒu𒲐 */
	st->pcm_write_offset -= offset_rotate;
	if (st->pcm_write_offset < 0) {
		st->pcm_write_offset += st->pcm_bsize;
	}

	st->play = PCM_STAT_PLAY_PAUSE;
}

/*******************************************************************
y@@\z
	Đ^ꎞ~
y@z
	hn			()@nh
y߂lz
	Ȃ
*******************************************************************/
STATIC void pcm_PauseOff(PcmHn hn)
{
	PcmWork		*work 	= *(PcmWork **)hn;
#if	0
	/*
	**1995-07-27	q
	**	gĂȂ̂ō폜
	*/
	PcmPara		*para 	= &work->para;
#endif
	PcmStatus	*st 	= &work->status;
	int			imask;

    imask = get_imask();
    set_imask(15);

	st->clock_scale = PCM_CLOCK_SCALE;

	PCM_DrvStartPcm(hn); 	/* PCMĐĊJ */

	/* ^C}[X^[g */
	pcm_StartClock(hn);
	st->play = PCM_STAT_PLAY_TIME;
	st->cnt_4ksample = 0;
	st->vbl_pcm_start = pcm_cnt_vbl_in;
	st->vbl_film_start += st->vbl_pcm_start - st->vbl_pause;

    set_imask(imask);
}

/*******************************************************************
y@@\z													J֐
	Đ^Đ̈ꎞ~
y@z
	hn			()@nh
	cmd			()@ꎞ~̐R}h
						PCM_PAUSE_ON_AT_ONCE	: ꎞ~
						PCM_PAUSE_OFF			: ꎞ~
y߂lz
	Ȃ
*******************************************************************/
void PCM_MePause(PcmHn hn, PcmPauseCmd cmd)
{
	PcmWork		*work 	= *(PcmWork **)hn;
	PcmStatus	*st 	= &work->status;

	switch (st->play) {
	case PCM_STAT_PLAY_TIME:
		if (cmd == PCM_PAUSE_ON_AT_ONCE) {
			pcm_PauseOn(hn);	/* ꎞ~ */
		} /* else Đ́u|[Yneev͖BG[ɂȂB */
		break;
	case PCM_STAT_PLAY_PAUSE:
		if (cmd == PCM_PAUSE_OFF) {
			pcm_PauseOff(hn);	/* ꎞ~ */
		} /* else |[Ýu|[Ynmv͖BG[ɂȂB */
		break;
	default:
		/* PCM_MeSetErrCode(PCM_ERR_PAUSE_STATUS); */
		break;
	}
	return;
}

/* ^XN̂PFwb_ */
STATIC Sint32 pcm_HeaderProcess(PcmHn hn)
{
	PcmWork		*work 	= *(PcmWork **)hn;
	PcmPara		*para 	= &work->para;
	PcmStatus	*st 	= &work->status;
	Uint32		ch_id;

	if (st->info.file_type == PCM_FILE_TYPE_NO_HEADER) {
		/* wb_ȂBvȂ΃wb_ς݂ƂB */
		if (st->need_ci == PCM_OFF) {
			st->play = PCM_STAT_PLAY_HEADER;
			return 0;
		} else {
			return -1;
		}
	}

	/* 擪̎ʎqSoCgAobt@ɂ邩H */
	if (st->ring_write_offset < 4) {
		return -1;
	}

	ch_id = *(Sint32 *)para->ring_addr;
	if (ch_id == PCM_ID_FORM) {
		if (pcm_AifHeaderProcess(hn)) {
			return -1;
		}
	} else {
		/* Ver1.00 őΉ̂́AAIFFCAFIC tH[}bĝ */
		PCM_MeSetErrCode(PCM_ERR_HEADER_DATA);
		return -1;
	}

	st->pcm_bsize = PCM_SAMPLE2BSIZE(st, para->pcm_size);
	st->pcm2_addr = para->pcm_addr + st->pcm_bsize;

	/* Oobt@ǂݎʒuXV */
	pcm_RenewRingRead(hn, st->media_offset);

	/* P̃^XNŏʂ̏[byte/1ch]	*/
	st->onetask_size = PCM_SAMPLE2BSIZE(st, st->onetask_sample);

	st->play = PCM_STAT_PLAY_HEADER;

	return 0;
}

/*******************************************************************
y@@\z
	^XN̂QF^C}[X^[g
	JnAPCMĐJnA^C}[X^[gs
	JnPDOobt@ɃgKTCYȏf[^~ꂽB
	JnQDoblobt@ɃgKTCYȏf[^~ꂽB
y@z
*******************************************************************/
STATIC void pcm_StartTimer(PcmHn hn)
{
	PcmWork		*work 	= *(PcmWork **)hn;
#if	0
	/*
	**1995-07-27	q
	**	gĂȂ̂ō폜
	*/
	PcmPara		*para 	= &work->para;
#endif
	PcmStatus	*st 	= &work->status;
	int			imask;

	if (st->ring_write_offset < PCM_HN_START_TRG_SIZE(hn)) {
		return;
	}

	if (st->sample_write < PCM_HN_START_TRG_SAMPLE(hn)) {
		return;
	}

    imask = get_imask();
    set_imask(15);

	st->clock_scale = PCM_CLOCK_SCALE;

	PCM_DrvStartPcm(hn); 	/* PCMĐJn */

	/* ^C}[X^[g */
	pcm_StartClock(hn);
	st->play = PCM_STAT_PLAY_TIME;
	st->cnt_4ksample = 0;
	st->vbl_film_start = st->vbl_pcm_start = pcm_cnt_vbl_in;

    set_imask(imask);
}

Sint32 PCM_MeIsNotSetCi(PcmHn hn)
{
	PcmWork		*work 	= *(PcmWork **)hn;
	PcmStatus	*st 	= &work->status;

	if (st->need_ci == PCM_ON) {
		return 1;
	} else {
		return 0;
	}
}

/* 
	hn			()@nh
	ci 			()@R[fBOrl	
*/
void PCM_MeSetCi(PcmHn hn, Uint8 ci)
{
	PcmWork		*work 	= *(PcmWork **)hn;
	PcmStatus	*st 	= &work->status;

	if ((ci & 1) == 0) {
		PCM_INFO_CHANNEL(&st->info) = 1;		/* monoral */
	} else {
		PCM_INFO_CHANNEL(&st->info) = 2;		/* stereo */
	}
	if ((ci & 4) == 0) {
		PCM_INFO_SAMPLING_RATE(&st->info) = PCM_FREQ_37800;	/* 37.8 [kHz] */
	} else {
		PCM_INFO_SAMPLING_RATE(&st->info) = PCM_FREQ_18900;	/* 18.9 [kHz] */
	}
	st->need_ci = PCM_OFF;
}

/*******************************************************************
y@@\z													J֐
	Đ^o`m̎w
y@z
	hn			()@nh
	pan			()@o`m 0..31 (RQiK)
						Ӗ̓TEhhCo̎dlƓB
y߂lz
	Ȃ
y@lz
	oblĐJnAĐĂrłwłB
*******************************************************************/
void PCM_MeSetPan(PcmHn hn, Uint32 pan)
{
	PcmWork		*work 	= *(PcmWork **)hn;
	PcmPara		*para 	= &work->para;

	para->pcm_pan = pan;
}

/*******************************************************************
y@@\z													J֐
	Đ^{[̎w
y@z
	hn			()@nh
	level		()@x 0..7 (WiK)
						Ӗ̓TEhhCo̎dlƓB
y߂lz
	Ȃ
y@lz
	oblĐJnAĐĂrłwłB
*******************************************************************/
void PCM_MeSetVolume(PcmHn hn, Uint32 level)
{
	PcmWork		*work 	= *(PcmWork **)hn;
	PcmPara		*para 	= &work->para;

	para->pcm_level = level;
}

/*******************************************************************
y@@\z													J֐
	Đ^oblĐp[^̕ύX
y@z
	hn			()@nh
y߂lz
	Ȃ
y@lz
	oblĐɕύXꍇɃR[B
*******************************************************************/
void PCM_MeChangePcmPara(PcmHn hn)
{
	PcmWork		*work 	= *(PcmWork **)hn;
#if	0
	/*
	**1995-07-27	q
	**	gĂȂ̂ō폜
	*/
	PcmPara		*para 	= &work->para;
#endif
	PcmStatus	*st 	= &work->status;

	if (st->play == PCM_STAT_PLAY_TIME) {
		PCM_DrvChangePcmPara(hn, -1, -1);
	}
}

/*******************************************************************
y@@\z
	I[fBIf[^̏r
	KF
		EPCMذэĐԍ(ײޗp)
		EPCMޯ̧(ڽA)
		Eِ(ڵA)
		EݸޯĐ
		Eݸގg
y}N]lz
	1			FI[fBIf[^̏KȂB
	0			FI[fBIf[^̏KĂB
*******************************************************************/
#define NOT_EQUAL_AUDIO(para_e, st_e, para_s, st_s)						\
	(	((para_e)->pcm_stream_no 		!= (para_s)->pcm_stream_no)		\
	  ||((para_e)->pcm_addr 			!= (para_s)->pcm_addr)			\
	  ||((para_e)->pcm_size 			!= (para_s)->pcm_size)			\
	  ||((st_e)->info.channel 			!= (st_s)->info.channel)		\
	  ||((st_e)->info.sampling_bit 		!= (st_s)->info.sampling_bit)	\
	  ||((st_e)->info.sampling_rate 	!= (st_s)->info.sampling_rate)	\
	)

/*******************************************************************
y@@\z
	Đ^AĐ[r[̃X^[g
y@z
	hn_e			()@ĐI郀[r[̃nh
	hn_s			()@ĐJn郀[r[̃nh
y߂lz
	0			FAĐłB
	-1			FAĐłȂB
y@Ӂz
*******************************************************************/
Sint32 pcm_StartNext(PcmHn hn_e, PcmHn hn_s)
{
	PcmWork		*work_e = *(PcmWork **)hn_e;
	PcmPara		*para_e = &work_e->para;
	PcmStatus	*st_e 	= &work_e->status;
	PcmWork		*work_s = *(PcmWork **)hn_s;
	PcmPara		*para_s = &work_s->para;
	PcmStatus	*st_s 	= &work_s->status;
#if	0
	/*
	**1995-07-27	q
	**	gĂȂ̂ō폜
	*/
	Sint32		finish_vbl, finish_time, finish_read;
#endif

	if (st_s->play != PCM_STAT_PLAY_CREATE) {
		/* AĐ̊Jn郀[r[͏ԂłȂ΂ȂȂ */
		PCM_MeSetErrCode(PCM_ERR_NEXT_HN_STATUS);
		return -1;
	}

	/* AĐ̊Jn郀[r[JnԂɂ */
	PCM_MeStart(hn_s);

	if (pcm_HeaderProcess(hn_s)) {
		/* ܂wb_̃f[^Ȃ */
		VTV_PRINTF((VTV_s, "P:Seamless NG\n"));
		return -1;
	}

	if (NOT_EQUAL_AUDIO(para_e, st_e, para_s, st_s)) {
		/* I[fBIf[^̏vĂȂ */
		PCM_MeSetErrCode(PCM_ERR_NEXT_HN_AUDIO);
		return -1;
	}

	VTV_PRINTF((VTV_s, "P:Seamless OK\n"));

	/********************************************************************
		`FbNBȂX[YAĐłB
	********************************************************************/

	/* AĐ̊Jn郀[r[ PAN, LEVEL lɕύX */
	/* PCM_DrvChangePcmPara(hn_e, -1, -1); */
	/* AĐ̃[r[ PAN, LEVEL lp */
	para_s->pcm_pan = para_e->pcm_pan;
	para_s->pcm_level = para_e->pcm_level;

	/* ݍĐ̃I[fBI݃AhXp */
	st_s->pcm_write_offset = st_e->pcm_write_offset;

	/* Tv[sample]p */
	st_s->sample_write = st_e->sample_write;

	/* |[YTv[sample]p */
	st_s->sample_pause = st_e->sample_pause;

	/* tBJnTv[sample]ݒ肷 */
	st_s->sample_film_start = st_s->sample_write;

	/* tBJn[vbl]ݒ肷
	 * (Jn郀[r[̓I[fBItA̒ĺA
	 *  pȂ͂B܂Ȓlݒ肵ĂB        )
	 */
	st_s->vbl_film_start = pcm_cnt_vbl_in;

	/* PCMJnp */
	st_s->vbl_pcm_start = st_e->vbl_pcm_start;

	/* 4kْPʍXVp */
	st_s->cnt_4ksample = st_e->cnt_4ksample;

	/* botNbN^C}Jnp */
	st_s->count_start = st_e->count_start;

	/* botNbN^C}̃XP[p */
	st_s->clock_scale = st_e->clock_scale;

	/* ^C}[X^[g */
	st_s->play = PCM_STAT_PLAY_TIME;

	return 0;
}

/*******************************************************************
y@@\z													J֐
	Đ^[v񐔂̎w
y@z
	hn			()@nhB
	cnt_loop	()@[v񐔁B
y߂lz
	Ȃ
*******************************************************************/
void PCM_MeSetLoop(PcmHn hn, Sint32 cnt_loop)
{
	PcmWork		*work 	= *(PcmWork **)hn;
	PcmStatus	*st 	= &work->status;

	st->cnt_loop = cnt_loop;
}

/*******************************************************************
y@@\z													J֐
	Đ^ɍĐ郀[r[̓o^
y@z
	hn			()@nhB
						NULL ̏ꍇ́Ao^LZBA
						ĐJnꂽł́ALZłȂB
y߂lz
	Ȃ
y@Ӂz
	gpnhɂ́APCM_MeStart ͌ĎgpȂƁB
	Đ̃[r[̏IA܂́APCM_MeChange ɂ鋭؂
@ւĐJñgKɂȂB
*******************************************************************/
void PCM_MeEntryNext(PcmHn hn)
{
	pcm_hn_next = hn;
}

/*******************************************************************
y@@\z													J֐
	Đ^o^nh̎擾
y@z
	Ȃ
y߂lz
	o^nh
y@Ӂz
*******************************************************************/
PcmHn PCM_MeGetEntryNext(void)
{
	return pcm_hn_next;
}

/*******************************************************************
y@@\z													J֐
	Đ^؂ւ\̊mF
y@z
	Ȃ
y߂lz
	PCM_CHANGE_OK_AT_ONCE		= 0 F؂ւ\B
	PCM_CHANGE_NO_DATA			= 1 Ff[^sB
	PCM_CHANGE_NO_ENTRY			= 2 FGgB
y@Ӂz
*******************************************************************/
PcmChangeStatus PCM_MeCheckChange(void)
{
	PcmWork		*work;
	PcmPara		*para;
	PcmStatus	*st;

	if (pcm_hn_next == NULL) {
		return PCM_CHANGE_NO_ENTRY;		/* GgB؂ւs	*/
	}

	work 	= *(PcmWork **)pcm_hn_next;
	st 		= &work->status;
	para 	= &work->para;

	if ((st->ring_write_offset <= 0) ||
		(st->ring_write_offset < PCM_HN_START_TRG_SIZE(pcm_hn_next))) {
		/* gKTCY̋܂ȂB*/
		return PCM_CHANGE_NO_DATA;
	} else {
		return PCM_CHANGE_OK_AT_ONCE;
	}
}

/*******************************************************************
y@@\z													J֐
	Đ^Đ[r[̋؂ւ
y@z
	hn_e 		()@ĐI郀[r[̃nh
						NULL ̏ꍇ́Ao^ꂽ[r[ĐJn
y߂lz
	Ȃ
y@Ӂz
	@gpꍇ́A炩 PCM_MeEntryNext gpāA
	؂ւɂĐJn郀[r[o^ĂƁB
	@؂ւX[YɂȂɎB
		PD؂ւ郀[r[ɗpӂĂ邱ƁB
			؂ւ郀[r[̃f[^X[Y؂ւɏ\
			邩mFꍇ́APCM_MeCheckChange gpB
		QDI[fBIf[^̎gArbgȂǂƁB
*******************************************************************/
void PCM_MeChange(PcmHn hn_e)
{
	if (hn_e != NULL) {
		PCM_MeStop(hn_e);
		PCM_MeSetLoop(hn_e, 0);		/* [vh */
	}
	PCM_MeStart(pcm_hn_next);
	pcm_hn_next = NULL;
}

/*******************************************************************
y@@\z
	Đ^Lnh̎擾
y@z
	i			() nhԍB0..31
y߂lz
	NULLȊO	FnhԍɑΉnhlB
	NULL		Fnhԍ̃nh̓NGCgĂȂB
y@Ӂz
*******************************************************************/
PcmHn PCM_MeGetHandle(Uint32 i)
{
	if (pcm_hn_mask & pcm_bit_msk[i]) {
		return (PcmHn)(pcm_hn_tbl + i);
	} else {
		return NULL;
	}
}

/* nhԍ̎擾 */
Sint32 PCM_MeGetHandleNo(PcmHn hn)
{
	return ((Sint32)hn - (Sint32)pcm_hn_tbl) >> 2;
}

/* ĐI */
void pcm_EndProcess(PcmHn hn)
{
	PcmWork		*work 	= *(PcmWork **)hn;
	PcmStatus	*st 	= &work->status;

	if (st->info.sample_file != -1) {
		if (st->info.sample_file > st->sample_write_file) {
			/* ĐTvmAʂɒBĂȂB*/
			VTV_PRINTF((VTV_s, "P:EmptyStop\n full%X > play%X", 
				st->info.sample_file, st->sample_write_file));
		}
	}

	if ((pcm_hn_next == NULL)					/* AĐȂ 	*/
	 || (pcm_StartNext(hn, pcm_hn_next))) {		/* AĐłȂ */
		PCM_DrvStopPcm(hn);/* PCMĐ~ */
	}
	if (pcm_hn_next != NULL) {
		pcm_hn_next = NULL;
		PCM_MeSetLoop(hn, 0);		/* [vh */
	}
	st->play = PCM_STAT_PLAY_END;
}

/* Oobt@ɗLȍ݌ɂȂ΁u^v */
Sint32 PCM_IsRingEmpty(PcmHn hn)
{
	PcmWork		*work 	= *(PcmWork **)hn;
	PcmStatus	*st 	= &work->status;
	Sint32		stock;

	stock = (st)->ring_write_offset - (st)->ring_read_offset;

	if (stock == 0) {
		/* ^ؖ̂ */
		return 1;
	}

	if (st->info.sample_file != -1) {
		if (st->info.sample_file <= st->sample_write_file) {
			/* ĐTvm̏ꍇAʂɒBĂ΁A
			 * Oobt@̍݌ɂ͖łB
			 */
			return 1;
		}
	}

	/* ł͂Ȃ */
	return 0;
}

/*******************************************************************
y@@\z													J֐
	Đ^^XN
y@z
	hn			()@nh
y߂lz
	Ȃ
y@Ӂz
	ȂƂAoblobt@̔̍ĐԂ葽pxŒI
@ɃR[邱ƁB
*******************************************************************/
void PCM_MeTask(PcmHn hn)
{
	PcmWork		*work 	= *(PcmWork **)hn;
#if	0
	/*
	**1995-07-27	q
	**	gĂȂ̂ō폜
	*/
	PcmPara		*para 	= &work->para;
#endif
	PcmStatus	*st 	= &work->status;
	Sint32		sample_now;

	st->cnt_task_call++;	/* ^XNR[JE^̃JEgAbv */

	/* ĐXe[^X`FbN */
	if ((st->play <= PCM_STAT_PLAY_PAUSE)
	  ||(st->play >= PCM_STAT_PLAY_END)) {
		return;
	}

	/* G[ԃ`FbN */
	if (pcm_err_code != PCM_ERR_OK) {
		PCM_MeStop(hn);
		st->play = PCM_STAT_PLAY_ERR_STOP;
		return;
	}

	/* wb_ */
	if (st->play == PCM_STAT_PLAY_START) {
		if (pcm_HeaderProcess(hn)) {
			return;	/* ܂wb_̃f[^Ȃ */
		}
	}

	/* I[fBI */
	(*st->audio_process_fp)(hn);

	/* ĐI */
	if (st->play == PCM_STAT_PLAY_TIME) {
		if (PCM_IsRingEmpty(hn)) {
			PCM_MeGetTimeTotal(hn, &sample_now);
			if (sample_now + PCM_HN_STOP_TRG_SAMPLE(hn) > st->sample_write) {
				/* AĐII */
				pcm_EndProcess(hn);
			}
		}
	}

	/* ^C}X^[gEoblĐX^[g */
	if (st->play == PCM_STAT_PLAY_HEADER) {
		pcm_StartTimer(hn);
	}
	return;
}
