/******************************************************************************
 *	\tgEFACu
 *
 *	Copyright (c) 1994,1995 SEGA
 *
 * Library	:oblE`coblĐCu
 * Module 	:Xg[ANZX
 * File		:pcm_stm.c
 * Date		:1994-10-04
 * Version	:1.00
 * Auther	:Y.T
 *
 ****************************************************************************/
/*-------------------- sCN[ht@Ct --------------------*/
#include <machine.h>
#include <sega_xpt.h>
#include <sega_dma.h>
#include "pcm_stm.h"
#include "pcm_mem.h"
#include "pcm_lib.h"

#if	1
	/*
	**1995-07-27	q
	**	ق̃t@C̊֐QƂĂ̂Œǉ
	*/
	#include	"pcm_msub.h"
#endif
#if	1
	/*
	**1995-07-27	q
	**	CSH_Purge() gĂ̂Œǉ
	*/
	#include	"sega_csh.h"
#endif

/* #define	PCM_DEBUG 1 */

#ifdef PCM_DEBUG
#include "play.h"
#endif

/*------------------------- s}N萔t -------------------------*/
/* P̃^XNœ]őZN^ */
#define		LOAD_SECT_NUM		20

/* PZN^̃oCg */
#define		SECT_SIZE_2048	2048
#define		SECT_SIZE_2324	2324

/*------------------------- s}Nt -------------------------*/

#ifdef PCM_DEBUG
#define		DEBUG_PRINT_CDBUF(num) \
	{ \
	char buf[128];\
	sprintf(buf, "cdbuf %03d", num);\
	PLDSP_String(buf, 100, 160);\
	}
#else

#define		DEBUG_PRINT_CDBUF(num)
#define 	PL_DEBUG_PRINTNUM(a, b, c)
#define		PL_DEBUG_PRINT(a, b, c)
#define		PL_DEBUG_START_TIME()
#define		PL_DEBUG_PRINT_TIME(str)
#endif

/* ZN^(yуZN^TCY)AByteɊZ */
#define PCMSTM_SCT2B(pcm, nsct)	\
			(PCMSTM_SECT_BSIZE(pcm) * (nsct))

/* ZN^(yуZN^TCY)ADwordɊZ */
#define PCMSTM_SCT2D(pcm, nsct)	\
			((PCMSTM_SECT_BSIZE(pcm) >> 2) * (nsct))

/* rsl̃[Jf[^ */
#define	PCMSTM_FILE_PARA(pcm) \
			(PCMLIB_FILEPARA(pcm).data.stm)

/* Xg[nh */
#define	PCMSTM_HANDLE(pcm) \
			(PCMSTM_FILE_PARA(pcm).stm)

/* ]ZN^ */
#define	PCMSTM_LOAD_SECT(pcm) \
			(PCMSTM_FILE_PARA(pcm).load_sect)

/* Ôbcobt@̐ */
#define PCMSTM_OLD_CD_BUFNUM(pcm) \
			(PCMSTM_FILE_PARA(pcm).old_cd_buf_num)

/* cl`]ĂȂ TRUE */
#define PCMSTM_DMA_STATE(pcm) \
			(PCMSTM_FILE_PARA(pcm).dma_state)

/* cl`]ZN^ */
#define PCMSTM_DMA_SECT(pcm) \
			(PCMSTM_FILE_PARA(pcm).dma_sect)

/* ރAhX */
#define	PCMSTM_WRITE_ADDR(pcm) \
			(PCMSTM_FILE_PARA(pcm).write_addr)

/* 󂫃obt@̃oCg */
#define	PCMSTM_BUF_BSIZE(pcm) \
			(PCMSTM_FILE_PARA(pcm).buf_bsize)

/* ]oCg */
#define	PCMSTM_WRITE_BSIZE(pcm) \
			(PCMSTM_FILE_PARA(pcm).write_bsize)

/* PZN^̃oCg */
#define	PCMSTM_SECT_BSIZE(pcm) \
			(PCMSTM_FILE_PARA(pcm).sect_bsize)

/* 擪I[fBIZN^ */
#define	PCMSTM_AUDIO_1ST_SECT(pcm) \
			(PCMSTM_FILE_PARA(pcm).audio_1st_sect)

/* ]֐ */
#define	PCMSTM_LOAD_FUNC(pcm) \
			(PCMSTM_FILE_PARA(pcm).load_func)

/*-------------------------- sf[^^t --------------------------*/
typedef Sint32 (*LoadFunc)(void *obj, StmHn stm, Sint32 nsct);

/*-------------------------- s֐錾t --------------------------*/
static void stmInit(void);
static void dmaCpuMemCopy4(void *dst, void *src, Uint32 cnt);
static Uint32 dmaCpuResult(void);
static void dmaScuMemCopy(void *dst, void *src, Uint32 cnt);
static Uint32 dmaScuResult(void);
STATIC void pcmstm_loadBuf(PcmHn pcm);
STATIC Sint32 pcmstm_loadCpu(void *obj, StmHn stm, Sint32 nsct);
STATIC Sint32 pcmstm_loadDmaCpu(void *obj, StmHn stm, Sint32 nsct);
STATIC Sint32 pcmstm_loadDmaScu(void *obj, StmHn stm2, Sint32 nsct);
STATIC Sint32 pcmstm_loadDummy(void *obj, StmHn stm, Sint32 nsct);
STATIC void pcmstm_waitDma(PcmHn pcm);

/*-------------------------- sϐ`t --------------------------*/
/* cl`]Jn\tO Jn TRUE */
STATIC Bool pcmstm_dma_cpu_start;
STATIC Bool pcmstm_dma_scu_start;

/* STM_ExecServersĂŒ PcmHn  */
STATIC PcmHn pcmstm_exec_pcm;

/*-------------------------- s֐`t --------------------------*/
static void stmInit(void)
{
	/* ϐ̏ */
	pcmstm_dma_cpu_start = OFF;
	pcmstm_dma_scu_start = OFF;
	pcmstm_exec_pcm = NULL;
}

/********************************************************************/
/* nh̍쐬iXg[VXej								*/
/* []															*/
/*    para : 쐬p[^											*/
/*    stm  : Xg[nh										*/
/* [֐l]															*/
/*    nhi쐬łȂꍇ NULL)							*/
/********************************************************************/
PcmHn PCM_CreateStmHandle(PcmCreatePara *para, StmHn stm)
{
	PcmHn   	pcm;

	if (PCM_lib_stm_init == OFF) {
		stmInit();
		PCM_lib_stm_init = ON;
	}

	if (stm == NULL) {
		PCM_MeSetErrCode(PCM_ERR_ILLEGAL_PARA);
		return NULL;
	}

	/* 쐬p[^̃`FbN */
	PCMLIB_CHK_CREATE_PARA(para);

	pcm =  PCM_StmCreate(stm, 
						 (PcmWork *)PCM_PARA_WORK(para), 
						 PCM_PARA_RING_ADDR(para), PCM_PARA_RING_SIZE(para),
						 PCM_PARA_PCM_ADDR(para), PCM_PARA_PCM_SIZE(para));
	if (pcm != NULL) {
		PCMLIB_FACCESS_TYPE(pcm) = PCMLIB_FACCESS_STM;

		/* s֐̐ݒ */
		PCMLIB_SET_START_FUNC(pcm, PCM_StmStart);
		PCMLIB_SET_TASK_FUNC(pcm, PCM_StmTask);
		PCMLIB_SET_PRELOAD_FILE_FUNC(pcm, PCM_StmPreloadFile);
		PCMLIB_SET_SET_LOAD_NUM_FUNC(pcm, PCM_StmSetLoadNum);
		PCMLIB_SET_SET_TRMODE_FUNC(pcm, PCM_StmSetTrMode);

		/* [Jf[^ */
		PCMSTM_OLD_CD_BUFNUM(pcm) = -1;
		PCMSTM_DMA_STATE(pcm) = OFF;
		PCMSTM_DMA_SECT(pcm) = 0;
		PCMSTM_WRITE_ADDR(pcm) = NULL;
		PCMSTM_BUF_BSIZE(pcm) = 0;
		PCMSTM_WRITE_BSIZE(pcm) = 0;
		PCMSTM_SECT_BSIZE(pcm) = SECT_SIZE_2048;
		PCMSTM_AUDIO_1ST_SECT(pcm) = 0;
		PCMSTM_LOAD_FUNC(pcm) = pcmstm_loadDmaCpu;

		/* Xg[nh̐ݒ */
		PCMSTM_HANDLE(pcm) = stm;

		/* ]֐̐ݒ */
		STM_SetTrFunc(PCMSTM_HANDLE(pcm), PCMSTM_LOAD_FUNC(pcm), pcm);

		/* ő]ZN^̐ݒ */
		PCMSTM_LOAD_SECT(pcm) = LOAD_SECT_NUM;
		STM_SetTrPara(PCMSTM_HANDLE(pcm), PCMSTM_LOAD_SECT(pcm));

	}
	return pcm;
}

/********************************************************************/
/* nh̏iXg[VXej								*/
/*   nhj́Anhɂ֐͗pł	*/
/*   Ȃ															*/
/* []															*/
/*    pcm  : nh												*/
/********************************************************************/
void PCM_DestroyStmHandle(PcmHn pcm)
{
	/* nh`FbN */
	PCMLIB_CHK_HANDLE(pcm);

	if (PCMLIB_FACCESS_TYPE(pcm) != PCMLIB_FACCESS_STM) {
		PCM_MeSetErrCode(PCM_ERR_ILL_CREATE_MODE);
	}

	/* cl`]̏I҂ */
	pcmstm_waitDma(pcm);

	/* ]֐̉ */
	STM_SetTrFunc(PCMSTM_HANDLE(pcm), pcmstm_loadDummy, NULL);

	PCM_MeDestroy(pcm);
}



/********************************************************************/
/* nh𐶐												*/
/*   Xg[nh́AXg[VXeɂ\ߎ擾邱	*/
/*																	*/
/* []															*/
/*    stm : Xg[nh										*/
/*    work : [NAhX											*/
/*    buf : obt@AhX										*/
/*    bufsize : obt@̃oCg									*/
/*    pcmbuf:obl̃EF[uq`l̐擪AhX					*/
/*    pcmsize:obl̃EF[uq`l̃oCg						*/
/* [֐l]															*/
/*    nh														*/
/*    NULL ̏ꍇ̓G[											*/
/********************************************************************/
PcmHn PCM_StmCreate(StmHn stm, PcmWork *work , 
							   void *buf, Sint32 bufsize, 
							   void *pcmbuf, Sint32 pcmsize)
{
	PcmPara		para;

	/* Oobt@ */
	para.ring_addr = buf;
	para.ring_size = bufsize;

	/* gKTCY */
	para.start_trg_size 	= PCM_DEFAULT_SIZE_START_TRG;
	para.start_trg_sample 	= PCM_DEFAULT_SAMPLE_START_TRG;
	para.stop_trg_sample 	= PCM_DEFAULT_SAMPLE_STOP_TRG;

	/* TEhhCoR}hubNԍ */
	para.command_blk_no = PCMLIB_COMMAND_BLK_NO;

	/* oblXg[Đԍ */
	para.pcm_stream_no = PCMLIB_PCM_STREAM_NO;

	/* oblobt@ */
	para.pcm_addr = pcmbuf;
	para.pcm_size = pcmsize;

	/* o`mƃ{[ */
	para.pcm_pan = PCMLIB_PCM_PAN;
	para.pcm_level = PCMLIB_PCM_LEVEL;

	/* nh̍쐬 */
	return PCM_MeCreate(work, &para);
}


/********************************************************************/
/* bcobt@̍ő]ZN^ݒ肷						*/
/* []															*/
/*    pcm  : nh												*/
/*    load_sct : ő]ZN^									*/
/********************************************************************/
void PCM_StmSetLoadNum(PcmHn pcm, Sint32 load_sct)
{
	PCMSTM_LOAD_SECT(pcm) = load_sct;

	/* bcobt@̍ő]ZN^ݒ肷 */
	STM_SetTrPara(PCMSTM_HANDLE(pcm), PCMSTM_LOAD_SECT(pcm));
}

/********************************************************************/
/* Đ擪Jn											*/
/*																	*/
/* []															*/
/*    pcm : nh												*/
/********************************************************************/
void PCM_StmStart(PcmHn pcm)
{
	/* ĐJn */
	PCM_MeStart(pcm);
}

/* R[fBO(ci)̎擾Ɛݒ */
void PCM_GetSetCi(PcmHn pcm)
{
	StmSct 			sinfo;

	if (PCM_MeIsNotSetCi(pcm)) {	/* R[fBO(ci)̎擾Kv */
		for (;;) {
			/* ZN^𓾂 */
			if (STM_GetSctInfo(PCMSTM_HANDLE(pcm), PCMSTM_AUDIO_1ST_SECT(pcm), 
								&sinfo) == TRUE) {
				if (STM_SCT_SM(&sinfo) & 0x40) {
					/* R[fBO(ci)瓾ݒ肷 */
					PCM_MeSetCi(pcm, STM_SCT_CI(&sinfo));
				} else {
					PCMSTM_AUDIO_1ST_SECT(pcm)++;
					continue;
				}
			}
			break;
		}
	}
}

/********************************************************************/
/* Đ^XN														*/
/*   Đ͒Iɂ̊֐Ă									*/
/*   ĂԊԊu͂oblobt@̔̍ĐԈȉŒIɌĂ		*/
/*   Kvpx菭ȂƍĐ								*/
/*																	*/
/* []															*/
/*    pcm : nh												*/
/*     NULL w肳ꂽ͌݃I[vĂnh   		*/
/*     ׂĂ̍Đ									*/
/********************************************************************/
void PCM_StmTask(PcmHn pcm)
{
	if (PCM_IsDeath(pcm)) {
		return;
	}

#if 0
	/* R[fBO(ci)̎擾Ɛݒ */
	PCM_GetSetCi(pcm);

	/* bcobt@烊Oobt@փf[^] */
	pcmstm_loadBuf(pcm);
#endif

	/* ^XN */
	PCM_MeTask(pcm);

}

/********************************************************************/
/* bcobt@̃Oobt@Ƀf[^]				*/
/*																	*/
/* []															*/
/*    pcm : nh												*/
/********************************************************************/
STATIC void pcmstm_loadBuf(PcmHn pcm)
{
	Uint32 write_addr32;
	Sint32 write_size;
	Sint32 total_size;
#if	0
	/*
	**1995-07-27	q
	**	gĂȂ̂ō폜
	*/
	PcmPara	*para;
#endif
	Sint32	cd_buf_num;


	/* Oobt@̋󂫃oCg𓾂 */
	PCM_MeGetRingWrite(pcm, (Sint8 **)&write_addr32, &write_size, &total_size);
	PCMSTM_WRITE_ADDR(pcm) = (Uint32 *)write_addr32;
	PCMSTM_BUF_BSIZE(pcm) = write_size;
	PCMSTM_WRITE_BSIZE(pcm) = 0;

	if (write_size >= PCMSTM_SECT_BSIZE(pcm)) {

		/* bc̓ǂݍ񂾃f[^Oobt@ɓ] */
		cd_buf_num = STM_GetNumCdbuf(PCMSTM_HANDLE(pcm));
		DEBUG_PRINT_CDBUF(cd_buf_num);

		/* bcobt@ɂ܂ĂZN^]ZN^ɂȂ */
		/* ۂ̓] */
		/* AŏƍŌ͂܂ĂȂĂ] */
#if 0
		if (PCMSTM_OLD_CD_BUFNUM(pcm) == -1 || 
							PCMSTM_OLD_CD_BUFNUM(pcm) == cd_buf_num ||
							cd_buf_num >= PCMSTM_LOAD_SECT(pcm)) {}
#else
		if (cd_buf_num == 0 || 
			cd_buf_num >= PCMSTM_LOAD_SECT(pcm)) {
#endif
			pcmstm_exec_pcm = pcm;
			STM_ExecServer();
			pcmstm_exec_pcm = NULL;
		}
		PCMSTM_OLD_CD_BUFNUM(pcm) = cd_buf_num;
	}

}

/********************************************************************/
/* cl`]̏I҂											*/
/*																	*/
/* []															*/
/*    pcm : nh												*/
/********************************************************************/
STATIC void pcmstm_waitDma(PcmHn pcm)
{
	if (PCMSTM_DMA_STATE(pcm) == ON) {
		if (PCMSTM_LOAD_FUNC(pcm) == pcmstm_loadDmaCpu) {
			while (dmaCpuResult() == DMA_CPU_BUSY) ;
			pcmstm_dma_cpu_start = OFF;
		} else if (PCMSTM_LOAD_FUNC(pcm) == pcmstm_loadDmaScu) {
			while (dmaScuResult() == DMA_CPU_BUSY) ;
			pcmstm_dma_scu_start = OFF;
		}
		PCMSTM_DMA_STATE(pcm) = OFF;
	}
}

/**************************************************************/
/*  _~[] 												  */
/* ]OԂ										  */
/**************************************************************/
STATIC Sint32 pcmstm_loadDummy(void *obj, StmHn stm, Sint32 nsct)
{
	return 0;
}


/**************************************************************/
/*  bot̂cl`̓]֐ 								  */
/**************************************************************/
STATIC Sint32 pcmstm_loadDmaCpu(void *obj, StmHn stm2, Sint32 nsct)
{
	PcmHn 		pcm;
	Uint32 		*src;
	Sint32 		adlt;
	Sint32		trans_nsct;
	Sint32 		write_addr32, write_size, total_size;

	pcm = (PcmHn)obj;

	_VTV_PRINTF((VTV_s, "P:_loadDmaCpu hn%d\n stm%X sct%d\n", 
		PCM_MeGetHandleNo(pcm), stm2, nsct));

	if (PCM_IsDeath(pcm)) {
		return 0;
	}

	if (PCMSTM_DMA_STATE(pcm) == ON) {
		if (dmaCpuResult() == DMA_CPU_BUSY) {
			return -1;/* ܂A] */
		} else {
			PCMSTM_DMA_STATE(pcm) = OFF;
			PCM_MeRenewRingWrite(pcm, PCMSTM_SCT2B(pcm, PCMSTM_DMA_SECT(pcm)));
			return PCMSTM_DMA_SECT(pcm);
		}
	}

	/* Oobt@̋󂫃oCg𓾂 */
	PCM_MeGetRingWrite(pcm, (Sint8 **)&write_addr32, &write_size, &total_size);

	/* ]ZN^vZ */
	trans_nsct = write_size / PCMSTM_SECT_BSIZE(pcm);
	trans_nsct = MIN(trans_nsct, nsct);

	if (trans_nsct <= 0) {
		return 0;
	}

	/* R[fBO(ci)̎擾Ɛݒ */
	PCM_GetSetCi(pcm);

	/* ] */
	src = STM_StartTrans(stm2, &adlt);
	dmaCpuMemCopy4((Uint32 *)write_addr32, src, PCMSTM_SCT2D(pcm, trans_nsct));
	PCMSTM_DMA_SECT(pcm) = trans_nsct;
	PCMSTM_DMA_STATE(pcm) = ON;

	return -1;/* ] */
}


static void *dma_cpu_dis_adr;                   /* ߰ޑΏިèȰݱڽ */
static Uint32 dma_cpu_cnt;                      /* ߰ޑΏިèȰݶ  */


static void dmaCpuMemCopy4(void *dst, void *src, Uint32 cnt)
{
    DmaCpuComPrm com_prm;                       /* ʓ]p[^        */
    DmaCpuPrm prm;                              /* ]p[^            */
                                                /*****************************/
    DMA_CpuStop(DMA_CPU_CH1);                   /* DMA]~               */

    com_prm.pr = DMA_CPU_FIX;                   /* D揇ʐݒ(׳)   */
    com_prm.dme = DMA_CPU_ENA;                  /* DMAϽȰِݒ()    */
    com_prm.msk = DMA_CPU_M_PR |                /* }XNݒ(ײèӰ)  */
                  DMA_CPU_M_AE |                /* (AhXG[tO)    */
                  DMA_CPU_M_NMIF |              /* (NMItO)               */
                  DMA_CPU_M_DME;                /* (DMA}X^Cl[u)     */

    DMA_CpuSetComPrm(&com_prm);                 /* DMAʓ]p[^ݒ */

    prm.sar = (Uint32)src;                      /* \[XAhXݒ        */
    prm.dar = (Uint32)dst;                      /* ިèȰݱڽݒ      */
    prm.tcr = cnt;                              /* gXt@JEgݒ  */
    prm.dm = DMA_CPU_AM_ADD;                    /* ިèȰݱڽӰސݒ  */
    prm.sm = DMA_CPU_AM_NOM;                    /* ڽӰސݒ  moke    */
    prm.ts = DMA_CPU_4;                         /* ݽ̧ސݒ            */
    prm.ar = DMA_CPU_AUTO;                      /* ظӰސݒ          */
    prm.ie = DMA_CPU_INT_DIS;                   /* ĲȰِݒ         */
    
    prm.msk = DMA_CPU_M_SAR |                   /* }XNݒ                */
              DMA_CPU_M_DAR |
              DMA_CPU_M_TCR |
              DMA_CPU_M_DM  |
              DMA_CPU_M_SM  |
              DMA_CPU_M_TS  |
              DMA_CPU_M_AR  |
              DMA_CPU_M_IE  |
              DMA_CPU_M_TE;                     /* ݽ̧ޯẴNAw*/

    DMA_CpuSetPrm(&prm, DMA_CPU_CH1);           /* DMA]p[^ݒ     */
    
    DMA_CpuStart(DMA_CPU_CH1);                  /* DMA]Jn               */
    dma_cpu_dis_adr = dst;
    dma_cpu_cnt = cnt * 4;
}


static Uint32 dmaCpuResult(void)
{
    DmaCpuComStatus com_status;             /* ʃXe[^X                */
    DmaCpuStatus status;                    /* Xe[^X                    */
                                            /*********************************/
    DMA_CpuGetComStatus(&com_status);       /* ʃXe[^X擾            */
    if(com_status.ae == DMA_CPU_ADR_ERR){   /* ڽװꍇ        */
        return(DMA_CPU_FAIL);               /* ُI^[            */
    }
    status = DMA_CpuGetStatus(DMA_CPU_CH1); /* Xe[^X擾                */
    if(status == DMA_CPU_TE_MV){            /* 쒆łꍇ              */
        return(DMA_CPU_BUSY);               /* s^[              */
    }
    CSH_Purge(dma_cpu_dis_adr, dma_cpu_cnt);
    return(DMA_CPU_END);                    /* I^[            */
}


/**************************************************************/
/*  rbt̂cl`̓]֐ 								  */
/**************************************************************/
STATIC Sint32 pcmstm_loadDmaScu(void *obj, StmHn stm2, Sint32 nsct)
{
	PcmHn		pcm;
	Uint32 		*src;
	Sint32 		adlt;
	Sint32		trans_nsct;
	Sint32 		write_addr32, write_size, total_size;

	pcm = (PcmHn)obj;

	_VTV_PRINTF((VTV_s, "P:_loadDmaScu hn%d\n stm%X sct%d\n", 
		PCM_MeGetHandleNo(pcm), stm2, nsct));

	if (PCM_IsDeath(pcm)) {
		return 0;
	}

	if (PCMSTM_DMA_STATE(pcm) == ON) {
		if (dmaScuResult() == DMA_SCU_BUSY) {
			return -1;/* ܂A] */
		} else {
			PCMSTM_DMA_STATE(pcm) = OFF;
			PCM_MeRenewRingWrite(pcm, PCMSTM_SCT2B(pcm, PCMSTM_DMA_SECT(pcm)));
			return PCMSTM_DMA_SECT(pcm);
		}
	}

	/* Oobt@̋󂫃oCg𓾂 */
	PCM_MeGetRingWrite(pcm, (Sint8 **)&write_addr32, &write_size, &total_size);

	/* ]ZN^vZ */
	trans_nsct = write_size / PCMSTM_SECT_BSIZE(pcm);
	trans_nsct = MIN(trans_nsct, nsct);

	if (trans_nsct <= 0) {
		return 0;
	}

	/* R[fBO(ci)̎擾Ɛݒ */
	PCM_GetSetCi(pcm);

	/* ] */
	src = STM_StartTrans(stm2, &adlt);
	dmaScuMemCopy((Uint32 *)write_addr32, src, PCMSTM_SCT2B(pcm, trans_nsct));
	PCMSTM_DMA_SECT(pcm) = trans_nsct;
	PCMSTM_DMA_STATE(pcm) = ON;

	return -1;/* ] */
}

static void *dma_scu_dis_adr;
static Uint32 dma_scu_cnt;
static Uint8 dma_start_flg;             /* DMÅJnLtO */

static void dmaScuMemCopy(void *dst, void *src, Uint32 cnt)
{
    DmaScuPrm prm;
    Uint32 msk;

    msk = get_imask();
    set_imask(15);

    dma_scu_dis_adr = dst;
    dma_scu_cnt = (Uint32)cnt;

    prm.dxr = (Uint32)src;
    prm.dxw = (Uint32)dst;
    prm.dxc = cnt;
    prm.dxad_r = DMA_SCU_R0;
    prm.dxad_w = DMA_SCU_W4;

    prm.dxmod = DMA_SCU_DIR;
    prm.dxrup = DMA_SCU_KEEP;
    prm.dxwup = DMA_SCU_KEEP;
    prm.dxft = DMA_SCU_F_DMA;
    prm.msk = DMA_SCU_M_DXR    |
              DMA_SCU_M_DXW    ;

    DMA_ScuSetPrm(&prm, DMA_SCU_CH0);
    DMA_ScuStart(DMA_SCU_CH0);
    dma_start_flg = ON;                         /* DMA̓X^[gĂ     */
    set_imask(msk);                                         /* 荞POP   */
}


static Uint32 dmaScuResult(void)
{
    DmaScuStatus status;
    Uint32 msk;

    msk = get_imask();
    set_imask(15);

    if(dma_start_flg == ON){                    /* DMAJnĂ鎞       */
        DMA_ScuGetStatus(&status, DMA_SCU_CH0);
            if(status.dxmv == DMA_SCU_MV){
                set_imask(msk);                             /* 荞POP   */
                return(DMA_SCU_BUSY);
            }
            CSH_Purge(dma_scu_dis_adr, dma_scu_cnt);
            set_imask(msk);                                 /* 荞POP   */
            return(DMA_SCU_END);
    }else{                                      /* DMAJnĂȂ     */
        set_imask(msk);                                     /* 荞POP   */
        return(DMA_SCU_END);
    }
}


/**************************************************************/
/*  \tgEFA]̓]֐								  */
/**************************************************************/
STATIC Sint32 pcmstm_loadCpu(void *obj, StmHn stm, Sint32 nsct)
{
	PcmHn		pcm;
	Uint32 		*src, *dst;
	Sint32 		adlt;
	long		i;
	Sint32		trans_nsct;
	Sint32		trans_size;
	Sint32 		write_addr32, write_size, total_size;

	pcm = (PcmHn)obj;

	_VTV_PRINTF((VTV_s, "P:_loadCpu hn%d\n stm%X sct%d\n", 
		PCM_MeGetHandleNo(pcm), stm2, nsct));

	if (PCM_IsDeath(pcm)) {
		return 0;
	}

	/* Oobt@̋󂫃oCg𓾂 */
	PCM_MeGetRingWrite(pcm, (Sint8 **)&write_addr32, &write_size, &total_size);

	/* ]ZN^vZ */
	trans_nsct = write_size / PCMSTM_SECT_BSIZE(pcm);
	trans_nsct = MIN(trans_nsct, nsct);

	if (trans_nsct <= 0) {
		return 0;
	}

	/* R[fBO(ci)̎擾Ɛݒ */
	PCM_GetSetCi(pcm);

	/* ] */
	src = STM_StartTrans(stm, &adlt);
	dst = (Uint32 *)write_addr32;
	i = trans_size = PCMSTM_SCT2D(pcm, trans_nsct);
	while (--i >= 0) {
		*dst++ = *src;
		src += adlt;
	}

	/* Oobt@ւ̏݃TCY̕ */
	PCM_MeRenewRingWrite(pcm, trans_size << 2);

	return trans_nsct;
}



/********************************************************************/
/* bc烊Oobt@Ƀt@Cǂݍ						*/
/*																	*/
/* []															*/
/*    pcm : nh												*/
/*    size : ǂݍރoCg										*/
/*           Oobt@ǂݍ݃oCg菬			*/
/*           obt@TCYɂȂB									*/
/*           ǂݍރoCg̓ZN^PʁiQOSW̔{jɂȂB	*/
/* [֐l]															*/
/*    ۂɓǂݍ񂾃oCg										*/
/********************************************************************/
Sint32 PCM_StmPreloadFile(PcmHn pcm, Sint32 size)
{
	Uint32		write_addr32;
	Sint32		write_size, total_size;
	PcmPara		*para;
	Sint32		load_sct, load_size;
#if	0
	/*
	**1995-07-27	q
	**	gĂȂ̂ō폜
	*/
	Sint32		ret;
#endif
	para = PCM_MeGetPara(pcm);

	load_size = 0;

	/* Oobt@̋󂫃oCg𓾂 */
	PCM_MeGetRingWrite(pcm, (Sint8 **)&write_addr32, &write_size, &total_size);
	if (write_size >= PCMSTM_SECT_BSIZE(pcm)) {
		/* bc̓ǂݍ񂾃f[^Oobt@ɓ] */
		if (size > write_size) {
			load_size = write_size;
		} else {
			load_size = size;
		}
		load_sct = load_size / PCMSTM_SECT_BSIZE(pcm);
		load_size = load_sct * PCMSTM_SECT_BSIZE(pcm);
		if (load_sct > 0) {
			PCMSTM_WRITE_ADDR(pcm) = (Uint32 *)write_addr32;
			PCMSTM_BUF_BSIZE(pcm) = load_size;
			PCMSTM_WRITE_BSIZE(pcm) = 0;
			pcmstm_exec_pcm = pcm;
			while (STM_ExecServer() != STM_EXEC_COMPLETED) {
				if (PCMSTM_WRITE_BSIZE(pcm) >= PCMSTM_BUF_BSIZE(pcm) &&
					PCMSTM_DMA_STATE(pcm) == OFF) {
					break;
				}
			}
			pcmstm_exec_pcm = NULL;
			load_size = PCMSTM_WRITE_BSIZE(pcm);
		}
	}
	return load_size;
}


/********************************************************************/
/* ]̐ݒ													*/
/* []															*/
/*    pcm   : [rnh										*/
/*    mode  : ]												*/
/*      PCM_TRMODE_CPU : \tgEFA]							*/
/*      PCM_TRMODE_SDMA : cl`TCNX`[					*/
/*      PCM_TRMODE_SCU  : rbt̂cl`							*/
/********************************************************************/
void PCM_StmSetTrMode(PcmHn pcm, PcmTrMode mode)
{

	switch(mode) {
	case PCM_TRMODE_CPU:
	default:
		PCMSTM_LOAD_FUNC(pcm) = pcmstm_loadCpu;
		break;
	case PCM_TRMODE_SDMA:
		PCMSTM_LOAD_FUNC(pcm) = pcmstm_loadDmaCpu;
		break;
	case PCM_TRMODE_SCU:
		PCMSTM_LOAD_FUNC(pcm) = pcmstm_loadDmaScu;
		break;
	}
	/* ]֐̐ݒ */
	STM_SetTrFunc(PCMSTM_HANDLE(pcm), PCMSTM_LOAD_FUNC(pcm), pcm);
}
