/******************************************************************************
 *	\tgEFACu
 *
 *	Copyright (c) 1994,1995 SEGA
 *
 * Library	:oblE`coblĐCu
 * Module 	:ԊǗ
 * File		:pcm_time.c
 * Date		:1994-10-04
 * Version	:1.00
 * Auther	:Y.T
 *
 ****************************************************************************/
#include <machine.h>
#include <string.h>
#include <sega_sys.h>
#include <sega_dma.h>
#include <sega_tim.h>
#include "pcm_msub.h"
#include "pcm_time.h"

/* botNbNɂ^C} */
static Sint32 pcm_count_32;

/* OɎ擾botNbN128l */
static Uint16 pcm_last_count;


/*******************************************************************
y@@\z
	ԊǗ̏
y@z
	Ȃ
y߂lz
	Ȃ
*******************************************************************/
void pcm_InitClock(void)
{
	TIM_FRT_INIT(PCM_TIM_MODE);
	pcm_count_32 = 0L;
	pcm_last_count = 0;
}

/*******************************************************************
y@@\z
	botNbNɂ^C}l𓾂
y@z
	Ȃ
y߂lz
	botNbN128ŕĺA256̂P̒lB
y@Ӂz
	botNbN128l16rbg𒴂ȂpxŃR[Kv
@BSTv̊荞݂ł́A11kHz̏ꍇɖłȂB
	o`kmsrbA𑜃[hۂɂAbotNbN͈ق
@̂ŁAZp}Nl PCM_CLOCK_SCALE gp邱ƁB
*******************************************************************/
Sint32 pcm_GetCount(void)
{
	Sint32		ret;
	Uint16		count;
	int			imask;

    imask = get_imask();
    set_imask(15);

	count = TIM_FRT_GET_16();
	if (count < pcm_last_count) {
		pcm_count_32 += 0x00000100;
	}
	pcm_last_count = count;
	ret = pcm_count_32 + ((count >> 8) & 0x000000FF);

    set_imask(imask);

	return ret;
}

/* STv荞ݖɃX^[g */
void pcm_StartClock(PcmHn hn)
{
	PcmWork		*work 	= *(PcmWork **)hn;
	PcmStatus	*st 	= &work->status;
	int			imask;

    imask = get_imask();
    set_imask(15);

	st->count_start = pcm_GetCount();

    set_imask(imask);
}

/* ŋ߂̂STv荞݂̌oߎԂ𓾂 */
static Sint32 pcm_GetClock(PcmHn hn)
{
	PcmWork		*work 	= *(PcmWork **)hn;
	PcmStatus	*st 	= &work->status;
	Sint32		clock;
	int			imask;

    imask = get_imask();
    set_imask(15);

	clock = pcm_GetCount() - st->count_start;

    set_imask(imask);

	return clock;
}

/*******************************************************************
y@@\z
	oblX^[g猻݂܂ł̌oߎԂ̎擾
y@z
	hn			()@nh
y߂lz
	oblX^[g猻݂܂ł̌oߎ[sample]
*******************************************************************/
Sint32 pcm_GetTimePcm(PcmHn hn)
{
	PcmWork		*work 	= *(PcmWork **)hn;
#if	0
	/*
	**1995-07-27	q
	**	gĂȂ̂ō폜
	*/
	PcmPara		*para 	= &work->para;
#endif
	PcmStatus	*st 	= &work->status;
	Sint32		clock, sample;

	switch (st->play) {
	case PCM_STAT_PLAY_ERR_STOP:
	case PCM_STAT_PLAY_CREATE:
		return -1;
		break;
	case PCM_STAT_PLAY_PAUSE:
		clock = 0;
		break;
	case PCM_STAT_PLAY_START:
	case PCM_STAT_PLAY_HEADER:
	case PCM_STAT_PLAY_TIME:
	case PCM_STAT_PLAY_END:
		clock = pcm_GetClock(hn);
		break;
	default:
		clock = 0;
		break;
	}
	sample = st->cnt_4ksample * 4096 + 
			PCM_CALC_XY_DIVIDE_Z(clock, 
								st->info.sampling_rate, 
								st->clock_scale);
	sample &= 0xFFFFFFFC;

	return sample;
}

/*******************************************************************
y@@\z													J֐
	tB̍ĐJn猻݂܂ł̌oߎԂ̎擾
y@z
	hn			()@nh
	sample_now	(o)@tB̊Jn猻݂܂ł̑Đ[sample]
y߂lz
	Ȃ
y@ӁzԂ͂oblĐʂ}X^NbNƂĊZAꂽl
*******************************************************************/
void PCM_MeGetTime(PcmHn hn, Sint32 *sample_now)
{
	PcmWork		*work 	= *(PcmWork **)hn;
#if	0
	/*
	**1995-07-27	q
	**	gĂȂ̂ō폜
	*/
	PcmPara		*para 	= &work->para;
#endif
	PcmStatus	*st 	= &work->status;

	switch (st->play) {
	case PCM_STAT_PLAY_ERR_STOP:
	case PCM_STAT_PLAY_CREATE:
		*sample_now = -1;
		break;
	case PCM_STAT_PLAY_START:
	case PCM_STAT_PLAY_HEADER:
		*sample_now = 0;
		break;
	case PCM_STAT_PLAY_PAUSE:
		*sample_now = st->sample_pause - st->sample_film_start;

		break;
	case PCM_STAT_PLAY_TIME:
	case PCM_STAT_PLAY_END:
		*sample_now = st->sample_pause + pcm_GetTimePcm(hn) 
						- st->sample_film_start;
		break;
	}
	return;
}

/*******************************************************************
y@@\z													J֐
	AĐ̍ŏ̍ĐJn猻݂܂ł̌oߎԂ̎擾
y@z
	hn			()@nh
	sample_now	(o)@擪̨т݂̌܂ł̑Đ[sample]
y߂lz
	Ȃ
y@Ӂz
*******************************************************************/
void PCM_MeGetTimeTotal(PcmHn hn, Sint32 *sample_now)
{
	PcmWork		*work 	= *(PcmWork **)hn;
#if	0
	/*
	**1995-07-27	q
	**	gĂȂ̂ō폜
	*/
	PcmPara		*para 	= &work->para;
#endif
	PcmStatus	*st 	= &work->status;

	switch (st->play) {
	case PCM_STAT_PLAY_ERR_STOP:
	case PCM_STAT_PLAY_CREATE:
		*sample_now = -1;
		break;
	case PCM_STAT_PLAY_PAUSE:
		*sample_now = st->sample_pause;
		break;
	case PCM_STAT_PLAY_START:
	case PCM_STAT_PLAY_HEADER:
	case PCM_STAT_PLAY_TIME:
	case PCM_STAT_PLAY_END:
		*sample_now = st->sample_pause + pcm_GetTimePcm(hn);
		break;
	}
	return;
}
