/*----------------------------------------------------------------------------
 *  SCL_vblv.c -- SCL Cu VDP W[
 *  Copyright(c) 1994 SEGA
 *  Written by H.E on 1994-02-15 Ver.0.80
 *  Updated by K.M on 1994-11-11 Ver.1.00
 *  Updated by H.E on 1995-02-13 Ver.1.10
 *
 *  ̃Cu͂ucop̂u|ak`mj荞ݏ[`ŁA
 *  ȉ̃[`܂ށB
 *
 *  SCL_SetFrameInterval  -  t[\C^[õZbg
 *  SCL_DisplayFrame      -  XvCgAXN[̕\
 *  SCL_VblInit           -  u|ak`mj荞ݏ[N̏
 *  SCL_VblankStart       -  u|ak`mjJn荞ݏ[`
 *  SCL_VblankEnd         -  u|ak`mjI荞ݏ[`
 *
 *----------------------------------------------------------------------------
 */

/*
 * USER SUPPLIED INCLUDE FILES
 */
#include <machine.h>
#include "sega_xpt.h"
#include "sega_def.h"
#include "sega_mth.h"
#define SEGA_SCL_PROTO
#include "sega_scl.h"
#include "sega_spr.h"

/*
 * STATIC DECLARATIONS
 */
#if	0
static Uint16  SpFrameChgMode    = AUTO_FRAME_CHG; /* Frame Change Mode      */
static Sint32  SpFrameEraseMode  = 1;       /* Frame Erase  Mode             */
static Sint32  VBInterval        = 1;   /* V-Blank Interval for Frame Change */
static Sint32  VBIntervalCounter = 0;   /* V-Blank Interval Counter          */
static Sint32  ReqDisplayFlag    = 0;   /* Display Request flag              */
static Sint32  ReqDisplayFlag2    = 0;   /* Display Request flag              */
static Sint32  VBIntrDisableDepth = 0;  /* V-Blank Disable Depth             */
static Sint32  frameChgFlag;
#endif

#if	0
/*
**1995-07-11
**1995-09-19	q
**	static ƂȂĂ邪Awb_ extern Ă̂ŁA
**	static ͂B
*/
volatile Uint16  SpFrameChgMode    = AUTO_FRAME_CHG; /* Frame Change Mode      */
volatile Sint32  SpFrameEraseMode  = 1;       /* Frame Erase  Mode             */
volatile Sint32  VBInterval        = 1;   /* V-Blank Interval for Frame Change */
static volatile Sint32  VBIntervalCounter = 0;   /* V-Blank Interval Counter          */
static volatile Sint32  ReqDisplayFlag    = 0;   /* Display Request flag              */
static volatile Sint32  ReqDisplayFlag2    = 0;   /* Display Request flag              */
static volatile Sint32  VBIntrDisableDepth = 0;  /* V-Blank Disable Depth             */
static volatile Sint32  frameChgFlag;
#else
volatile Uint16  SpFrameChgMode    = AUTO_FRAME_CHG;/* Frame Change Mode				*/
volatile Sint32  SpFrameEraseMode  = 1;				/* Frame Erase  Mode				*/
volatile Sint32  VBInterval        = 1;				/* V-Blank Interval for Frame Change*/
volatile Sint32  VBIntervalCounter = 0;				/* V-Blank Interval Counter			*/
volatile Sint32  ReqDisplayFlag    = 0;				/* Display Request flag				*/
static volatile Sint32  ReqDisplayFlag2    = 0;		/* Display Request flag				*/
static volatile Sint32  VBIntrDisableDepth = 0;		/* V-Blank Disable Depth			*/
static volatile Sint32  frameChgFlag;
#endif

extern Sint32  SpInitialFlag;
extern void   SCL_ScrollShow(void);
extern void SCL_Memcpyw(void *dest,void *src,Uint32 tcnt);


/*****************************************************************************
 *
 * NAME:  SCL_SetFrameInterval()  - Set Frame Interval Count
 *
 * PARAMETERS :
 *
 *     (1) Uint16  count       - <i> u|ak`mjC^[oJEg
 *                                0      = XvCg̃t[؂ւI[g
 *                                         ɂāAC^[oPɂ
 *                                         SCL_DisplayFrame()ɂ铯Ȃ
 *                                1      = XvCg̃t[؂ւI[g
 *                                         ɂāAC^[oPɂ
 *                                         SCL_DisplayFrame()ɂ铯
 *                                0xffff = C^[o𖳌ɂăt[؂
 *                                         ւvɑ؂ւ
 *                                0xfffe = C^[o𖳌ɂăt[؂
 *                                         ւvɂuuNC[Xs
 *                                         đ؂ւ
 *                                ̑ = wC^[oŃt[؂ւ
 *                                         s
 *                                         b15 = 0 : C[XCgs
 *                                             = 1 : C[XCgsȂ
 *
 * DESCRIPTION:
 *
 *     t[\̂u|ak`mjC^[oJEgݒ肷B
 *
 *
 * POSTCONDITIONS:
 *
 *     No exist.
 *
 * CAVEATS:
 *
 *
 *****************************************************************************
 */
void SCL_SetFrameInterval(Uint16 count)
{
    /** BEGIN ***************************************************************/
    if(count == 0xffff) {
	SpFrameChgMode = NO_INTER_FRAME_CHG;
        SpFrameEraseMode = 0;          /* Frame Erase Mode Off              */
        SPR_WRITE_REG(SPR_W_FBCR, SPR_FBCR_MANUAL | SpFbcrMode);
                                       /* set frame change to manual mode   */
        VBInterval = count;            /* V-Blank Interval for Frame Change */
    } else
    if(count == 0xfffe) {
	SpFrameChgMode = NO_INTER_VBE_FRAME_CHG;
        SpFrameEraseMode = 0;          /* Frame Erase Mode Off              */
        SPR_WRITE_REG(SPR_W_FBCR, SPR_FBCR_MANUAL | SpFbcrMode);
                                       /* set frame change to manual mode   */
        VBInterval = count;            /* V-Blank Interval for Frame Change */
    } else {
        if(count & 0x8000)
            SpFrameEraseMode = 0;      /* Frame Erase Mode Off              */
        else
            SpFrameEraseMode = 1;      /* Frame Erase Mode On               */
        count &= 0x7fff;
        if(count)
            if(count == 1)
	        SpFrameChgMode = AUTO_FRAME_CHG;
	    else
	        SpFrameChgMode = MANUAL_FRAME_CHG;
        else
	    SpFrameChgMode = AUTO_FRAME_CHG;
        VBInterval = count;            /* V-Blank Interval for Frame Change */
        if(SpFrameChgMode == AUTO_FRAME_CHG)
            SPR_WRITE_REG(SPR_W_FBCR, SPR_FBCR_AUTO | SpFbcrMode);
                                       /* set frame change to auto mode     */
        else
            SPR_WRITE_REG(SPR_W_FBCR, SPR_FBCR_MANUAL | SpFbcrMode);
                                       /* set frame change to manual mode   */
    }
}


/*****************************************************************************
 *
 * NAME:  SCL_DisplayFrame()  - Display Frame
 *
 * PARAMETERS :
 *
 *     No exist.
 *
 *
 * DESCRIPTION:
 *
 *     t[\vtOIɂāAu|ak`mj荞݃[`
 *     ɂXvCgуXN[̃t[\҂B
 *
 *
 * POSTCONDITIONS:
 *
 *     No exist.
 *
 * CAVEATS:
 *
 *
 *****************************************************************************
 */
void SCL_DisplayFrame(void)
{

    /** BEGIN ***************************************************************/
    if(VBInterval) {
        ReqDisplayFlag = 1;
        while(ReqDisplayFlag);
        while(ReqDisplayFlag2);
    }
}


/*****************************************************************************
 *
 * NAME:  SCL_VblInit()  - Initial VDP V-Blank Routine
 *
 * PARAMETERS :
 *
 *     No exist.
 *
 * DESCRIPTION:
 *
 *     uco u|ak`mj荞݃[`p[NGȀB
 *
 * POSTCONDITIONS:
 *
 *     No exist.
 *
 * CAVEATS:
 *
 *
 *****************************************************************************
 */
void SCL_VblInit(void)
{

    /** BEGIN ***************************************************************/
	SpFrameChgMode     = AUTO_FRAME_CHG;
	SpFrameEraseMode   = 1;
	VBInterval         = 0;
	VBIntervalCounter  = 0;
	ReqDisplayFlag     = 0;
	ReqDisplayFlag2    = 0;
	VBIntrDisableDepth = 0;
	frameChgFlag       = 0;
}


#ifdef  SPR_SYNC_VB_OUT
/*****************************************************************************
 *
 * NAME:  SCL_VblankStart()  - V-Blank Start Interrupt Routine for VDP
 *
 * PARAMETERS :
 *
 *     No exist.
 *
 *
 * DESCRIPTION:
 *
 *     u|aX^[g荞ݏƂĈȉ̏s
 *     (1) XvCgt[obt@̃C[Y
 *     (2) t[\vtOIłu|aC^[o
 *         ɒBꍇAXN[p[^̓]ƃXvCg̃t[
 *         ؂ւ
 *
 *     [{[`QƁEݒ肷O[oϐ]
 *
 *     (1) IntervalCounter -  u|a荞ݐ̃JE^B
 *                            VBL_SetFrameInterval() і{[`NAB
 *
 *     (2) Interval        -  t[\C^[ou|a
 *                               荞ݐB VBL_SetFrameInterval() ݒB
 *
 *     (3) SpFrameChgMode  -  XvCgt[`FW[h
 *                               VBL_SetFrameInterval() ݒB
 *
 *     (4) ReqDisplayFlag  -  t[\vtOB
 *                               DisplayFrame() ݒB
 *
 *
 * POSTCONDITIONS:
 *
 *     No exist.
 *
 * CAVEATS:
 *
 *     [Uu|a荞݃[`o^ăt[\؂ւ
 *     sꍇA{荞݃[`Qlɍ쐬邱
 *
 *****************************************************************************
 */
void SCL_VblankStart(void)
{
    /** BEGIN ***************************************************************/
    if(SpFrameChgMode == MANUAL_FRAME_CHG) {
        VBIntervalCounter++;
        if(VBInterval <= VBIntervalCounter)
            SCL_ScrollShow();             /* XN[ւ̃p[^ݒ   */
    } else
        SCL_ScrollShow();                /* XN[ւ̃p[^ݒ    */
}


/*****************************************************************************
 *
 * NAME:  SCL_VblankEnd()  - V-Blank End Interrupt Routine for VDP
 *
 * PARAMETERS :
 *
 *     No exist.
 *
 *
 * DESCRIPTION:
 *
 *     ȂB
 *
 *
 * POSTCONDITIONS:
 *
 *     No exist.
 *
 * CAVEATS:
 *
 *
 *****************************************************************************
 */
void SCL_VblankEnd(void)
{
	Uint16  tvStat;
    
	/** BEGIN ***************************************************************/
        if(SpFrameChgMode == NO_INTER_FRAME_CHG) {
            if(ReqDisplayFlag)   frameChgFlag = 2;
        } else
        if(SpFrameChgMode == NO_INTER_VBE_FRAME_CHG) {
            if(ReqDisplayFlag) {              /* set V-Blank Erase ON            */
                SPR_WRITE_REG(SPR_W_TVMR, SpTvMode | 0x0008);
                SPR_WRITE_REG(SPR_W_FBCR, SPR_FBCR_MANUAL | SpFbcrMode);
                frameChgFlag = 3;
            }
        } else
        if(SpFrameChgMode == AUTO_FRAME_CHG) {
            frameChgFlag = 4;          /* add 95-02-13 H.E */
        }else {
            if(SpFrameEraseMode == ON)
                if((VBInterval - 1) <= VBIntervalCounter)
                    SPR_WRITE_REG(SPR_W_FBCR, SPR_FBCR_ERASE | SpFbcrMode);
                                                /* t[C[YI*/
            if(VBInterval <= VBIntervalCounter) {
                if(ReqDisplayFlag) frameChgFlag = 1;
                VBIntervalCounter = 0;
            }
        }

	if(SpDie) {
	    tvStat = SPR_SCLREAD_REG(SPR_R_TVSTAT);
	    if(tvStat & 2)
		SPR_WRITE_REG(SPR_W_FBCR, 0x000c | SpFbcrMode);
	    else
		SPR_WRITE_REG(SPR_W_FBCR, 0x0008 | SpFbcrMode);
            /* XvCg̃t[obt@̐؂ւ */
	    frameChgFlag = 0;
	    ReqDisplayFlag = 0;
	} else
        if(frameChgFlag) {
	    if((frameChgFlag == 2)  &&
               (SpInitialFlag != 0) &&
               ((SPR_READ_REG(SPR_R_EDSR) & 0x0002) == 0) )
                ReqDisplayFlag2 = 1;
	    else {
	        if(frameChgFlag == 3)
                    /* set V-Blank Erase OFF    */
		    SPR_WRITE_REG(SPR_W_TVMR, SpTvMode);
		else
		    if((frameChgFlag == 1) ||   /* add 95-02-13 H.E */
                       (frameChgFlag == 2))     /* add 95-02-13 H.E */
			SPR_WRITE_REG(SPR_W_FBCR, SPR_FBCR_MANUAL | SpFbcrMode);
	                                  /* XvCg̃t[obt@̐؂ւ */
		frameChgFlag = 0;
		ReqDisplayFlag2 = 0;
	    }
	    ReqDisplayFlag = 0;
	}
}


#else
/*****************************************************************************
 *
 * NAME:  SCL_VblankStart()  - V-Blank Start Interrupt Routine for VDP
 *
 * PARAMETERS :
 *
 *     No exist.
 *
 *
 * DESCRIPTION:
 *
 *     u|aX^[g荞ݏƂĈȉ̏s
 *     (1) XvCgt[obt@̃C[Y
 *     (2) t[\vtOIłu|aC^[o
 *         ɒBꍇAXN[p[^̓]ƃXvCg̃t[
 *         ؂ւ
 *
 *     [{[`QƁEݒ肷O[oϐ]
 *
 *     (1) IntervalCounter -  u|a荞ݐ̃JE^B
 *                            VBL_SetFrameInterval() і{[`NAB
 *
 *     (2) Interval        -  t[\C^[ou|a
 *                               荞ݐB VBL_SetFrameInterval() ݒB
 *
 *     (3) SpFrameChgMode  -  XvCgt[`FW[h
 *                               VBL_SetFrameInterval() ݒB
 *
 *     (4) ReqDisplayFlag  -  t[\vtOB
 *                               DisplayFrame() ݒB
 *
 *
 * POSTCONDITIONS:
 *
 *     No exist.
 *
 * CAVEATS:
 *
 *     [Uu|a荞݃[`o^ăt[\؂ւ
 *     sꍇA{荞݃[`Qlɍ쐬邱
 *
 *****************************************************************************
 */
void SCL_VblankStart(void)
{
    /** BEGIN ***************************************************************/
/*    frameChgFlag = 0;*/
    if(SpFrameChgMode == NO_INTER_FRAME_CHG) {
        if(ReqDisplayFlag) {
            SCL_ScrollShow();             /* XN[ւ̃p[^ݒ    */
            frameChgFlag = 2;
        }
    } else  if(SpFrameChgMode == NO_INTER_VBE_FRAME_CHG) {
        if(ReqDisplayFlag) {              /* set V-Blank Erase ON            */
            SPR_WRITE_REG(SPR_W_TVMR, SpTvMode | 0x0008);
            SPR_WRITE_REG(SPR_W_FBCR, SPR_FBCR_MANUAL | SpFbcrMode);
            SCL_ScrollShow();             /* XN[ւ̃p[^ݒ    */
            frameChgFlag = 3;
        }
    } else  if(SpFrameChgMode == AUTO_FRAME_CHG) {
	SCL_ScrollShow();
        frameChgFlag = 4;          /* add 95-02-13 H.E */
        /* ReqDisplayFlag = 0; */  /* del 95-02-13 H.E */
    }else {
        VBIntervalCounter++;
        if(SpFrameEraseMode == ON) {
            if((VBInterval - 1) <= VBIntervalCounter) {
               SPR_WRITE_REG(SPR_W_FBCR, SPR_FBCR_ERASE | SpFbcrMode);
                                                /* t[C[YI*/
            }
        }
        if(VBInterval <= VBIntervalCounter) {
            if(ReqDisplayFlag) {
                SCL_ScrollShow();          /* XN[ւ̃p[^ݒ   */
                frameChgFlag = 1;
            }
            VBIntervalCounter = 0;
        }
    }
}


/*****************************************************************************
 *
 * NAME:  SCL_VblankEnd()  - V-Blank End Interrupt Routine for VDP
 *
 * PARAMETERS :
 *
 *     No exist.
 *
 *
 * DESCRIPTION:
 *
 *     ȂB
 *
 *
 * POSTCONDITIONS:
 *
 *     No exist.
 *
 * CAVEATS:
 *
 *
 *****************************************************************************
 */
void SCL_VblankEnd(void)
{
	Uint16  tvStat;
    
	/** BEGIN ***************************************************************/
	if(SpDie) {
		tvStat = SPR_SCLREAD_REG(SPR_R_TVSTAT);
		if(tvStat & 2)
			SPR_WRITE_REG(SPR_W_FBCR, 0x000c | SpFbcrMode);
	        else
			SPR_WRITE_REG(SPR_W_FBCR, 0x0008 | SpFbcrMode);
                         /* XvCg̃t[obt@̐؂ւ */
			frameChgFlag = 0;
			ReqDisplayFlag = 0;
	} else if(frameChgFlag) {
/*		if((frameChgFlag == 2) && (SpInitialFlag != 0))  SPR_WaitDrawEnd();*/
		if((frameChgFlag == 2) && (SpInitialFlag != 0) 
	       	&& ((SPR_READ_REG(SPR_R_EDSR) & 0x0002) == 0) )	ReqDisplayFlag2 = 1;
		else{
			if(frameChgFlag == 3)
				SPR_WRITE_REG(SPR_W_TVMR, SpTvMode);
				/* set V-Blank Erase OFF    */
			else
			if((frameChgFlag == 1) ||   /* add 95-02-13 H.E */
                           (frameChgFlag == 2))     /* add 95-02-13 H.E */
				SPR_WRITE_REG(SPR_W_FBCR, SPR_FBCR_MANUAL | SpFbcrMode);
	                                  /* XvCg̃t[obt@̐؂ւ */
			frameChgFlag = 0;
			ReqDisplayFlag2 = 0;
		}
		ReqDisplayFlag = 0;
	}
}
#endif

/*  end of file */
