/*----------------------------------------------------------------------------
 *  spr_3dsp.c -- SPR Cu croɂ}gbNX W[
 *  Copyright(c) 1994 SEGA
 *  Written by H.E on 1994-02-20 Ver.1.00
 *  Updated by H.E on 1994-02-29 Ver.1.00
 *
 *  ̃Cu͂croɂRcWϊW[
 *  ȉ̃[`܂ށB
 *
 *  SPR_3MatrixCompoInit     -  }gbNX̏
 *  SPR_3MatrixCompoExec     -  }gbNXs
 *  SPR_3MatrixCompoCheck    -  }gbNX`FbN
 *
 *----------------------------------------------------------------------------
 */

/*
 * USER SUPPLIED INCLUDE FILES
 */
#define  _SPR3_
#include "sega_spr.h"
#include "sega_dsp.h"
#include "sega_csh.h"
#include <machine.h>

#ifdef USE_DSP

static Uint32 dspProgram[] = {
#include "dspmtx.cod"
};

static MthMatrix *outputMatrix;


/*************************************************************************
 *
 * NAME : SPR_3MatrixCompoInit  -  Initialize Matrix Compose by DSP
 *
 * PARAMETERS
 *
 *     No exist.
 *
 * DESCRIPTION
 *
 *	crȍƃ}gbNXvÕ[hB
 *
 * POSTCONDITIONS
 *
 *     No exist.
 *
 * CAVEATS
 *
 *************************************************************************
 */
void    SPR_3MatrixCompoInit(void)
{
    /** BEGIN ************************************************************/
    DSP_LoadProgram(0, dspProgram, 256);
}


/*************************************************************************
 *
 * NAME : SPR_3MatrixCompoExec  -  Execute MatrixCompose by DSP
 *
 * PARAMETERS
 *
 *     (1) SprDspMatrixParm@ *dspMatrixParm  
 *                             - <i/o>  }gbNXp[^e[u
 *
 * DESCRIPTION
 *
 *      ȉ̃}gbNXcroɂčsB
 *
 *      Eo̓}gbNXGÃNA
 *      Ey̕]              
 *      Esړ                  
 *      Ew]ړ                
 *      Ex]ړ                
 *      Ey]ړ                
 *
 * POSTCONDITIONS
 *
 *     No exist.
 *
 * CAVEATS
 * 
 *************************************************************************
 */
void    SPR_3MatrixCompoExec(SprDspMatrixParm *dspMatrixParm)
{
    Uint32 w[2];

    /** BEGIN ************************************************************/
    w[0] = ((Uint32)dspMatrixParm->inputMatrix  ) >> 2;
    w[1] = ((Uint32)dspMatrixParm->outputMatrix ) >> 2;
    outputMatrix = dspMatrixParm->outputMatrix;

    DSP_WriteData(DSP_RAM_0 | 0, w, 2);
    DSP_WriteData(DSP_RAM_0 | 2, (Uint32*)dspMatrixParm->op,
                                              sizeof(SprDspMatrixParm)/4 - 2);
    DSP_Start(0);
}


/*************************************************************************
 *
 * NAME : SPR_3MatrixCompoCheck  -  Check Matrix Compose Complete
 *
 * PARAMETERS
 *
 *     No exist.
 *
 * DESCRIPTION
 *
 *	croɂ}gbNX܂ő҂B
 *
 * POSTCONDITIONS
 *
 *     No exist.
 *
 * CAVEATS
 * 
 *************************************************************************
 */
void    SPR_3MatrixCompoCheck(void)
{
    /** BEGIN ************************************************************/
    while(DSP_CheckEnd() == DSP_NOT_END);
    CSH_Purge(outputMatrix, sizeof(MthMatrix));
}

#else
/*************************************************************************
 *
 * NAME : SPR_3MatrixCompoInit  -  Initialize Matrix Compose by DSP
 *
 * PARAMETERS
 *
 *     No exist.
 *
 * DESCRIPTION
 *
 *	crȍƃ}gbNXvÕ[hB
 *
 * POSTCONDITIONS
 *
 *     No exist.
 *
 * CAVEATS
 *
 *************************************************************************
 */
void    SPR_3MatrixCompoInit(void)
{
    /** BEGIN ************************************************************/
}


/*************************************************************************
 *
 * NAME : SPR_3MatrixCompoExec  -  Execute MatrixCompose by DSP
 *
 * PARAMETERS
 *
 *     (1) SprDspMatrixParm@ *dspMatrixParm  
 *                             - <i/o>  }gbNXp[^e[u
 *
 * DESCRIPTION
 *
 *      ȉ̃}gbNXcroɂčsB
 *
 *      Eo̓}gbNXGÃNA
 *      Ey̕]              
 *      Esړ                  
 *      Ew]ړ                
 *      Ex]ړ                
 *      Ey]ړ                
 *
 * POSTCONDITIONS
 *
 *     No exist.
 *
 * CAVEATS
 * 
 *************************************************************************
 */
void    SPR_3MatrixCompoExec(SprDspMatrixParm *dspMatrixParm)
{
    int  i;
    MthMatrixTbl matrixTbl;

    /** BEGIN ************************************************************/
    matrixTbl.stackSize = 1;
    matrixTbl.current   = dspMatrixParm->outputMatrix;
    matrixTbl.stack     = dspMatrixParm->outputMatrix;
    sprMemCpyL(dspMatrixParm->outputMatrix, dspMatrixParm->inputMatrix, 12);
    for(i=0; i<15; i++) {
        switch(dspMatrixParm->op[i].opCode) {

            case MTX_OP_CLEAR	:    /*@o̓}gbNXGÃNA      */
                 MTH_ClearMatrix(&matrixTbl);
                 break;

            case MTX_OP_REV_Z	:    /*@y̕]                    */
                 MTH_ReverseZ(&matrixTbl);
                 break;

            case MTX_OP_MOV_XYZ	:    /*@sړ                        */
                 MTH_MoveMatrix(&matrixTbl,
                                dspMatrixParm->op[i].x,
                                dspMatrixParm->op[i].y,
                                dspMatrixParm->op[i].z);
                 break;

            case MTX_OP_ROT_X	:    /*@w]ړ                      */
                 MTH_RotateMatrixX(&matrixTbl,
                                   dspMatrixParm->op[i].x);
                 break;

            case MTX_OP_ROT_Y	:    /*@x]ړ                      */
                 MTH_RotateMatrixY(&matrixTbl,
                                   dspMatrixParm->op[i].y);
                 break;

            case MTX_OP_ROT_Z	:    /*@y]ړ                      */
                 MTH_RotateMatrixZ(&matrixTbl,
                                   dspMatrixParm->op[i].z);
                 break;

            case MTX_OP_END	:    /*@I                            */
                 goto exit;
                 break;

        }
    }
exit: ;
}


/*************************************************************************
 *
 * NAME : SPR_3MatrixCompoCheck  -  Check Matrix Compose Complete
 *
 * PARAMETERS
 *
 *     No exist.
 *
 * DESCRIPTION
 *
 *	croɂ}gbNX܂ő҂B
 *
 * POSTCONDITIONS
 *
 *     No exist.
 *
 * CAVEATS
 * 
 *************************************************************************
 */
void    SPR_3MatrixCompoCheck(void)
{
    /** BEGIN ************************************************************/
}
#endif

/*  end of file */
