/****************************************
*			include files				*
****************************************/
#include	"per_x.h"

/****************************************
*		declare private objects			*
****************************************/
static trigger_t	GetTriggerDigital( const SysDevice	*device );
static trigger_t	GetTriggerAnalog( const SysDevice	*device );
static trigger_t	GetTriggerPointer( const SysDevice	*device );
static trigger_t	GetTriggerKeyboard( const SysDevice	*device );
static trigger_t	GetTriggerMD3B( const SysDevice	*device );
static trigger_t	GetTriggerMD6B( const SysDevice	*device );
static trigger_t	GetTriggerMDMouse( const SysDevice	*device );
static trigger_t	GetTriggerUnknown( const SysDevice	*device );

static trigger_handler_t	GetTrigger[] = {
	GetTriggerUnknown, GetTriggerUnknown, GetTriggerDigital, GetTriggerDigital,
	GetTriggerDigital, GetTriggerDigital, GetTriggerDigital, GetTriggerDigital,
	GetTriggerDigital, GetTriggerDigital, GetTriggerDigital, GetTriggerDigital,
	GetTriggerDigital, GetTriggerDigital, GetTriggerDigital, GetTriggerDigital,
	
	GetTriggerUnknown, GetTriggerUnknown, GetTriggerAnalog, GetTriggerAnalog,
	GetTriggerAnalog, GetTriggerAnalog, GetTriggerAnalog, GetTriggerAnalog,
	GetTriggerAnalog, GetTriggerAnalog, GetTriggerAnalog, GetTriggerAnalog,
	GetTriggerAnalog, GetTriggerAnalog, GetTriggerAnalog, GetTriggerAnalog,
	
	GetTriggerUnknown, GetTriggerUnknown, GetTriggerPointer, GetTriggerPointer,
	GetTriggerPointer, GetTriggerPointer, GetTriggerPointer, GetTriggerPointer,
	GetTriggerPointer, GetTriggerPointer, GetTriggerPointer, GetTriggerPointer,
	GetTriggerPointer, GetTriggerPointer, GetTriggerPointer, GetTriggerPointer,
	
	GetTriggerUnknown, GetTriggerUnknown, GetTriggerKeyboard, GetTriggerKeyboard,
	GetTriggerKeyboard, GetTriggerKeyboard, GetTriggerKeyboard, GetTriggerKeyboard,
	GetTriggerKeyboard, GetTriggerKeyboard, GetTriggerKeyboard, GetTriggerKeyboard,
	GetTriggerKeyboard, GetTriggerKeyboard, GetTriggerKeyboard, GetTriggerKeyboard,
	
	GetTriggerUnknown, GetTriggerUnknown, GetTriggerUnknown, GetTriggerUnknown,
	GetTriggerUnknown, GetTriggerUnknown, GetTriggerUnknown, GetTriggerUnknown,
	GetTriggerUnknown, GetTriggerUnknown, GetTriggerUnknown, GetTriggerUnknown,
	GetTriggerUnknown, GetTriggerUnknown, GetTriggerUnknown, GetTriggerUnknown,
	
	GetTriggerUnknown, GetTriggerUnknown, GetTriggerUnknown, GetTriggerUnknown,
	GetTriggerUnknown, GetTriggerUnknown, GetTriggerUnknown, GetTriggerUnknown,
	GetTriggerUnknown, GetTriggerUnknown, GetTriggerUnknown, GetTriggerUnknown,
	GetTriggerUnknown, GetTriggerUnknown, GetTriggerUnknown, GetTriggerUnknown,
	
	GetTriggerUnknown, GetTriggerUnknown, GetTriggerUnknown, GetTriggerUnknown,
	GetTriggerUnknown, GetTriggerUnknown, GetTriggerUnknown, GetTriggerUnknown,
	GetTriggerUnknown, GetTriggerUnknown, GetTriggerUnknown, GetTriggerUnknown,
	GetTriggerUnknown, GetTriggerUnknown, GetTriggerUnknown, GetTriggerUnknown,
	
	GetTriggerUnknown, GetTriggerUnknown, GetTriggerUnknown, GetTriggerUnknown,
	GetTriggerUnknown, GetTriggerUnknown, GetTriggerUnknown, GetTriggerUnknown,
	GetTriggerUnknown, GetTriggerUnknown, GetTriggerUnknown, GetTriggerUnknown,
	GetTriggerUnknown, GetTriggerUnknown, GetTriggerUnknown, GetTriggerUnknown,
	
	GetTriggerUnknown, GetTriggerUnknown, GetTriggerUnknown, GetTriggerUnknown,
	GetTriggerUnknown, GetTriggerUnknown, GetTriggerUnknown, GetTriggerUnknown,
	GetTriggerUnknown, GetTriggerUnknown, GetTriggerUnknown, GetTriggerUnknown,
	GetTriggerUnknown, GetTriggerUnknown, GetTriggerUnknown, GetTriggerUnknown,
	
	GetTriggerUnknown, GetTriggerUnknown, GetTriggerUnknown, GetTriggerUnknown,
	GetTriggerUnknown, GetTriggerUnknown, GetTriggerUnknown, GetTriggerUnknown,
	GetTriggerUnknown, GetTriggerUnknown, GetTriggerUnknown, GetTriggerUnknown,
	GetTriggerUnknown, GetTriggerUnknown, GetTriggerUnknown, GetTriggerUnknown,
	
	GetTriggerUnknown, GetTriggerUnknown, GetTriggerUnknown, GetTriggerUnknown,
	GetTriggerUnknown, GetTriggerUnknown, GetTriggerUnknown, GetTriggerUnknown,
	GetTriggerUnknown, GetTriggerUnknown, GetTriggerUnknown, GetTriggerUnknown,
	GetTriggerUnknown, GetTriggerUnknown, GetTriggerUnknown, GetTriggerUnknown,
	
	GetTriggerUnknown, GetTriggerUnknown, GetTriggerUnknown, GetTriggerUnknown,
	GetTriggerUnknown, GetTriggerUnknown, GetTriggerUnknown, GetTriggerUnknown,
	GetTriggerUnknown, GetTriggerUnknown, GetTriggerUnknown, GetTriggerUnknown,
	GetTriggerUnknown, GetTriggerUnknown, GetTriggerUnknown, GetTriggerUnknown,
	
	GetTriggerUnknown, GetTriggerUnknown, GetTriggerUnknown, GetTriggerUnknown,
	GetTriggerUnknown, GetTriggerUnknown, GetTriggerUnknown, GetTriggerUnknown,
	GetTriggerUnknown, GetTriggerUnknown, GetTriggerUnknown, GetTriggerUnknown,
	GetTriggerUnknown, GetTriggerUnknown, GetTriggerUnknown, GetTriggerUnknown,
	
	GetTriggerUnknown, GetTriggerUnknown, GetTriggerUnknown, GetTriggerUnknown,
	GetTriggerUnknown, GetTriggerUnknown, GetTriggerUnknown, GetTriggerUnknown,
	GetTriggerUnknown, GetTriggerUnknown, GetTriggerUnknown, GetTriggerUnknown,
	GetTriggerUnknown, GetTriggerUnknown, GetTriggerUnknown, GetTriggerUnknown,
	
	GetTriggerUnknown, GetTriggerMD3B, GetTriggerMD6B, GetTriggerMDMouse,
	GetTriggerUnknown, GetTriggerUnknown, GetTriggerUnknown, GetTriggerUnknown,
	GetTriggerUnknown, GetTriggerUnknown, GetTriggerUnknown, GetTriggerUnknown,
	GetTriggerUnknown, GetTriggerUnknown, GetTriggerUnknown, GetTriggerUnknown,
	
	GetTriggerUnknown, GetTriggerUnknown, GetTriggerUnknown, GetTriggerUnknown,
	GetTriggerUnknown, GetTriggerUnknown, GetTriggerUnknown, GetTriggerUnknown,
	GetTriggerUnknown, GetTriggerUnknown, GetTriggerUnknown, GetTriggerUnknown,
	GetTriggerUnknown, GetTriggerUnknown, GetTriggerUnknown, GetTriggerUnknown,
};

/*@*/
/************************************************************************
*																		*
*	ysynopsisz														*
*																		*
*		#include	"per_x.h"											*
*																		*
*		PER_SetTriggerHandler( id, handler );							*
*																		*
*		ŵhcytFp̃gKnhݒ肵܂B	*
*																		*
*				EEEEE												*
*		ł́uŵhcfoCXp̃nhݒ肵Ăv	*
*		ƂƂɒڂĂBuw̃^Cvvł͂܂	*
*		̂ŁAӂĂB										*
*																		*
*		Őݒ肵֐inhj́APER_GetTrigger() Ɏw		*
*		hcfoCX񂪓nꂽƂɁAR[܂B		*
*																		*
*																		*
*	yparametersz														*
*																		*
*		int					id;											*
*		trigger_handler_t	handler;									*
*																		*
*		<id> ́AT^[ytFhc								*
*		<handler> ́AgKnh									*
*																		*
*																		*
*	yreturn valuez													*
*																		*
*		Ȃ															*
*																		*
*																		*
*	yinfluence/reference objectsz										*
*																		*
*		GetTrigger	influence	gKnh̃e[u				*
*																		*
*																		*
************************************************************************/
void	PER_SetTriggerHandler( int	id, trigger_handler_t	handler ){
	GetTrigger[id] = handler;
}

/*@*/
/************************************************************************
*																		*
*	ysynopsisz														*
*																		*
*		#include	"per_x.h"											*
*																		*
*		handler = PER_GetTriggerHandler( id );							*
*																		*
*		ŵhcytFp̃gKnh𓾂܂B		*
*																		*
*																		*
*	yparametersz														*
*																		*
*		int		id;														*
*																		*
*		T^[ytFhc										*
*																		*
*																		*
*	yreturn valuez													*
*																		*
*		trigger_handler_t	handler;									*
*																		*
*		gKnh													*
*																		*
*																		*
*	yinfluence/reference objectsz										*
*																		*
*		GetTrigger	reference	gKnh̃e[u				*
*																		*
*																		*
************************************************************************/
trigger_handler_t	PER_GetTriggerHandler( int	id ){
	return	GetTrigger[id];
}

/*@*/
/************************************************************************
*																		*
*	ysynopsisz														*
*																		*
*		trigger = GetTriggerDigital( &device );							*
*																		*
*		fW^foCXgK𓾂܂B						*
*																		*
*																		*
*	yparametersz														*
*																		*
*		const SysDevice	*device;										*
*																		*
*		foCX													*
*																		*
*																		*
*	yreturn valuez													*
*																		*
*		trigger_t	trigger;											*
*																		*
*		gKԂ܂B											*
*																		*
*																		*
*	yinfluence/reference objectsz										*
*																		*
*		Ȃ															*
*																		*
*																		*
************************************************************************/
static trigger_t	GetTriggerDigital( const SysDevice	*device ){
	const SysDevDigital	*this = ( const SysDevDigital * )device;
	
	trigger_t	data_l = ( trigger_t )( ~this->data[1] ) & 0x00ff;
	trigger_t	data_h = ( trigger_t )( ~this->data[0] ) & 0x00ff;
	
	return	( trigger_t )(( data_h << 8 ) | data_l );
}
/*@*/
/************************************************************************
*																		*
*	ysynopsisz														*
*																		*
*		trigger = GetTriggerAnalog( &device );							*
*																		*
*		AiOfoCXgK𓾂܂B						*
*																		*
*																		*
*	yparametersz														*
*																		*
*		const SysDevice	*device;										*
*																		*
*		foCX													*
*																		*
*																		*
*	yreturn valuez													*
*																		*
*		trigger_t	trigger;											*
*																		*
*		gKԂ܂B											*
*																		*
*																		*
*	yinfluence/reference objectsz										*
*																		*
*		Ȃ															*
*																		*
*																		*
************************************************************************/
static trigger_t	GetTriggerAnalog( const SysDevice	*device ){
	const SysDevAnalog	*this = ( const SysDevAnalog * )device;
	
	trigger_t	data_l = ( trigger_t )( ~this->data[1] ) & 0x00ff;
	trigger_t	data_h = ( trigger_t )( ~this->data[0] ) & 0x00ff;
	
	return	( trigger_t )(( data_h << 8 ) | data_l );
}
/*@*/
/************************************************************************
*																		*
*	ysynopsisz														*
*																		*
*		trigger = GetTriggerPointer( &device );							*
*																		*
*		|CeBOfoCXgK𓾂܂B					*
*																		*
*																		*
*	yparametersz														*
*																		*
*		const SysDevice	*device;										*
*																		*
*		foCX													*
*																		*
*																		*
*	yreturn valuez													*
*																		*
*		trigger_t	trigger;											*
*																		*
*		gKԂ܂B											*
*																		*
*																		*
*	yinfluence/reference objectsz										*
*																		*
*		Ȃ															*
*																		*
*																		*
************************************************************************/
static trigger_t	GetTriggerPointer( const SysDevice	*device ){
	const SysDevPointer	*this = ( const SysDevPointer * )device;
	
	trigger_t	data_h = ( trigger_t )( this->status & PT_TRIGGER );
	
	return	( trigger_t )( data_h << 8 );
}
/*@*/
/************************************************************************
*																		*
*	ysynopsisz														*
*																		*
*		trigger = GetTriggerKeyboard( &device );						*
*																		*
*		L[{[hfoCXgK𓾂܂B						*
*																		*
*																		*
*	yparametersz														*
*																		*
*		const SysDevice	*device;										*
*																		*
*		foCX													*
*																		*
*																		*
*	yreturn valuez													*
*																		*
*		trigger_t	trigger;											*
*																		*
*		gKԂ܂B											*
*																		*
*																		*
*	yinfluence/reference objectsz										*
*																		*
*		Ȃ															*
*																		*
*																		*
************************************************************************/
static trigger_t	GetTriggerKeyboard( const SysDevice	*device ){
	const SysDevKeyboard	*this = ( const SysDevKeyboard * )device;
	
	trigger_t	data_l = ( trigger_t )( ~this->data[1] ) & 0x00ff;
	trigger_t	data_h = ( trigger_t )( ~this->data[0] ) & 0x00ff;
	
	return	( trigger_t )(( data_h << 8 ) | data_l );
}
/*@*/
/************************************************************************
*																		*
*	ysynopsisz														*
*																		*
*		trigger = GetTriggerMD3B( &device );							*
*																		*
*		KhCupR{^pbhgK𓾂܂B			*
*																		*
*																		*
*	yparametersz														*
*																		*
*		const SysDevice	*device;										*
*																		*
*		foCX													*
*																		*
*																		*
*	yreturn valuez													*
*																		*
*		trigger_t	trigger;											*
*																		*
*		gKԂ܂B											*
*																		*
*																		*
*	yinfluence/reference objectsz										*
*																		*
*		Ȃ															*
*																		*
*																		*
************************************************************************/
static trigger_t	GetTriggerMD3B( const SysDevice	*device ){
	const struct DevMD3B	*this = ( const struct DevMD3B * )device;
	
	trigger_t	data_h = ( trigger_t )( ~this->data[0] ) & 0x00ff;
	
	return	( trigger_t )( data_h << 8 );
}
/*@*/
/************************************************************************
*																		*
*	ysynopsisz														*
*																		*
*		trigger = GetTriggerMD6B( &device );							*
*																		*
*		KhCupU{^pbhgK𓾂܂B			*
*																		*
*																		*
*	yparametersz														*
*																		*
*		const SysDevice	*device;										*
*																		*
*		foCX													*
*																		*
*																		*
*	yreturn valuez													*
*																		*
*		trigger_t	trigger;											*
*																		*
*		gKԂ܂B											*
*																		*
*																		*
*	yinfluence/reference objectsz										*
*																		*
*		Ȃ															*
*																		*
*																		*
************************************************************************/
static trigger_t	GetTriggerMD6B( const SysDevice	*device ){
	const struct DevMD6B	*this = ( const struct DevMD6B * )device;
	
	trigger_t	data_l = ( trigger_t )( ~this->data[1] ) & 0x00ff;
	trigger_t	data_h = ( trigger_t )( ~this->data[0] ) & 0x00ff;
	
	return	( trigger_t )(( data_h << 8 ) | data_l );
}
/*@*/
/************************************************************************
*																		*
*	ysynopsisz														*
*																		*
*		trigger = GetTriggerMDMouse( &device );							*
*																		*
*		KhCup}EXiȂAT^[p̃Vg}EXj	*
*		gK𓾂܂B										*
*																		*
*																		*
*	yparametersz														*
*																		*
*		const SysDevice	*device;										*
*																		*
*		foCX													*
*																		*
*																		*
*	yreturn valuez													*
*																		*
*		trigger_t	trigger;											*
*																		*
*		gKԂ܂B											*
*																		*
*																		*
*	yinfluence/reference objectsz										*
*																		*
*		Ȃ															*
*																		*
*																		*
************************************************************************/
static trigger_t	GetTriggerMDMouse( const SysDevice	*device ){
	const struct DevMDMouse	*this = ( const struct DevMDMouse * )device;
	
	trigger_t	data_h = ( trigger_t )( this->status & PT_TRIGGER );
	
	return	( trigger_t )( data_h << 8 );
}
/*@*/
/************************************************************************
*																		*
*	ysynopsisz														*
*																		*
*		trigger = GetTriggerUnknown( &device );							*
*																		*
*		sȃfoCXgK𓾂܂B							*
*																		*
*		 0 Ԃ܂B												*
*																		*
*																		*
*	yparametersz														*
*																		*
*		const SysDevice	*device;										*
*																		*
*		foCX													*
*																		*
*																		*
*	yreturn valuez													*
*																		*
*		trigger_t	trigger;											*
*																		*
*		 0 Ԃ܂B												*
*																		*
*																		*
*	yinfluence/reference objectsz										*
*																		*
*		Ȃ															*
*																		*
*																		*
************************************************************************/
static trigger_t	GetTriggerUnknown( const SysDevice	*device ){
	return	0;
}
/*@*/
/************************************************************************
*																		*
*	ysynopsisz														*
*																		*
*		#include	"per_x.h"											*
*																		*
*		trigger = PER_GetTrigger( device );								*
*																		*
*		foCX̎ނɉăgK𓾂܂B						*
*																		*
*		PER_SetTriggerHandler() ɂēo^Ăhcfo	*
*		CXgKoɂ́A PER_SetTriggerHandler()*
*		ɂēo^Ă֐inhjp܂B	*
*		̂Ȃꍇɂ́AftHgŗpӂĂ֐inhj	*
*		p܂B̏ꍇA\ߑΉĂ̓ytF͉L	*
*		̂̂ł̂ŁAȊO̓̓ytFgK	*
*		𓾂ꍇɂ́APER_SetTriggerHandler() gpĂB	*
*																		*
*		ftHgőΉĂ̓ytF						*
*		fW^foCX												*
*			T^[ytFhcƂ 0x02 - 0x0f Ԃ		*
*		AiOfoCX												*
*			T^[ytFhcƂ 0x12 - 0x1f Ԃ		*
*		|CeBOfoCX											*
*			T^[ytFhcƂ 0x22 - 0x2f Ԃ		*
*		L[{[hfoCX												*
*			T^[ytFhcƂ 0x33 - 0x3f Ԃ		*
*		KhCupRapbh										*
*			T^[ytFhcƂ 0xe1 Ԃ				*
*		KhCupUapbh										*
*			T^[ytFhcƂ 0xe2 Ԃ				*
*		KhCup}EX											*
*			T^[ytFhcƂ 0xe3 Ԃ				*
*																		*
*																		*
*	yparametersz														*
*																		*
*		const SysDevice	*device;										*
*																		*
*		foCX													*
*																		*
*																		*
*	yreturn valuez													*
*																		*
*		trigger_t	trigger;											*
*																		*
*		gKԂ܂B											*
*																		*
*																		*
*	yinfluence/reference objectsz										*
*																		*
*		Ȃ															*
*																		*
*																		*
************************************************************************/
trigger_t	PER_GetTrigger( const SysDevice	*this ){
	trigger_t	trigger = 0;
	
	if( this != NULL ){
		int					id = PER_GetID( this );
		trigger_handler_t	handler = PER_GetTriggerHandler( id );
		
		if( handler != NULL )
			trigger = handler( this );
	}
	
	return	trigger;
}
/*@*/
/************************************************************************
*																		*
*	ysynopsisz														*
*																		*
*		#include	"per_x.h"											*
*																		*
*		edge = PER_GetEdge( t1, t2 );									*
*																		*
*		gK̃GbW𓾂܂B									*
*																		*
*		GbWƂ <t1>  <t2> ̂Q̃^C~Ôŕω	*
*		gK̏̂Ƃ܂B								*
*																		*
*																		*
*	yparametersz														*
*																		*
*		trigger_t	t1;													*
*		trigger_t	t2;													*
*																		*
*		<t1>  <t2> ̓gKB										*
*		<t1>  <t2> ̎ԓIȏ͖₢܂B						*
*																		*
*																		*
*	yreturn valuez													*
*																		*
*		trigger_t	edge;												*
*																		*
*		gK̃GbWԂ܂B									*
*																		*
*																		*
*	yinfluence/reference objectsz										*
*																		*
*		Ȃ															*
*																		*
*																		*
************************************************************************/
trigger_t	PER_GetEdge( trigger_t	t1, trigger_t	t2 ){
	return	( trigger_t )( t1 ^ t2 );
}
/*@*/
/************************************************************************
*																		*
*	ysynopsisz														*
*																		*
*		#include	"per_x.h"											*
*																		*
*		edge = PER_GetPressEdge( prev, current );						*
*																		*
*		gK̃vXGbWiGbWj𓾂܂B				*
*																		*
*		vXGbWƂ <prev>  <current> ̂Q̃^C~O		*
*		̂Ƀ[XԂvXԂɕωgK̏	*
*		Ƃ܂B												*
*																		*
*																		*
*	yparametersz														*
*																		*
*		trigger_t	prev;												*
*		trigger_t	current;											*
*																		*
*		<prev>  <current> ͋ɃgKB							*
*		ԓIɁi <prev>  <current> jƂ֌W҂Ă܂B	*
*																		*
*																		*
*	yreturn valuez													*
*																		*
*		trigger_t	edge;												*
*																		*
*		gK̃vXGbWԂ܂B							*
*																		*
*																		*
*	yinfluence/reference objectsz										*
*																		*
*		Ȃ															*
*																		*
*																		*
************************************************************************/
trigger_t	PER_GetPressEdge( trigger_t	prev, trigger_t	current ){
	trigger_t	edge = PER_GetEdge( prev, current );
	
	return	( trigger_t )( current & edge );
}

/*@*/
/************************************************************************
*																		*
*	ysynopsisz														*
*																		*
*		#include	"per_x.h"											*
*																		*
*		edge = PER_GetReleaseEdge( prev, current );						*
*																		*
*		gK̃[XGbWiGbWj𓾂܂B				*
*																		*
*		[XGbWƂ <prev>  <current> ̂Q̃^C~		*
*		ÔɃvXԂ烊[XԂɕωgK̏	*
*		̂Ƃ܂B												*
*																		*
*																		*
*	yparametersz														*
*																		*
*		trigger_t	prev;												*
*		trigger_t	current;											*
*																		*
*		<prev>  <current> ͋ɃgKB							*
*		ԓIɁi <prev>  <current> jƂ֌W҂Ă܂B	*
*																		*
*																		*
*	yreturn valuez													*
*																		*
*		trigger_t	edge;												*
*																		*
*		gK̃[XGbWԂ܂B							*
*																		*
*																		*
*	yinfluence/reference objectsz										*
*																		*
*		Ȃ															*
*																		*
*																		*
************************************************************************/
trigger_t	PER_GetReleaseEdge( trigger_t	prev, trigger_t	current ){
	trigger_t	edge = PER_GetEdge( prev, current );
	
	return	( trigger_t )( ~current & edge );
}

#define	ANALOG_ILLEGAL	0xff
#define	ANALOG_ORIGIN	0x7f

/*@*/
/************************************************************************
*																		*
*	ysynopsisz														*
*																		*
*		#include	"per_x.h"											*
*																		*
*		PER_GetAnalogXYZ( analog, &x, &y, &z );							*
*																		*
*		AiOfoCXwxŷ`^cRo[^̏o͒l	*
*		܂B															*
*																		*
*																		*
*	yparametersz														*
*																		*
*		const SysDevAnalog	*analog;									*
*		int		*x;														*
*		int		*y;														*
*		int		*z;														*
*																		*
*		<analog> ̓AiOfoCXB								*
*		<x> <y> <z> ͂ꂼwxŷ`^cRo[^̏o͒lB	*
*																		*
*		<x> <y> <z>  NULL nƂɂ͉Ԃ܂B			*
*																		*
*		<x> ɂ́iEj-127 ` +127ijԂ܂B					*
*		<y> ɂ́ij-127 ` +127ijԂ܂B					*
*		<z> ɂ́ij-127 ` +127ijԂ܂B					*
*																		*
*																		*
*	yreturn valuez													*
*																		*
*		Ȃ															*
*																		*
*																		*
*	yinfluence/reference objectsz										*
*																		*
*		Ȃ															*
*																		*
*																		*
************************************************************************/
void	PER_GetAnalogXYZ( const SysDevAnalog	*this, int	*x, int	*y, int	*z ){
	int		ax = 0;
	int		ay = 0;
	int		az = 0;
	
	if( this->ax != ANALOG_ILLEGAL )
		ax = ( int )this->ax - ANALOG_ORIGIN;
	if( this->ay != ANALOG_ILLEGAL )
		ay = ( int )this->ay - ANALOG_ORIGIN;
	if( this->az != ANALOG_ILLEGAL )
		az = ( int )this->az - ANALOG_ORIGIN;
	
	if( x != NULL )
		*x = ax;
	if( y != NULL )
		*y = ay;
	if( z != NULL )
		*z = az;
}

